import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import bcc1
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global bcc1_p
	global shcsm_p

	bcc1.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_bcc1']
	bcc1_p = variables['PARAM_NG_bcc1']
	shcsm_p = variables['PARAM_NG_shcsm']

	## use the following variable to use bcc1  position
	bcc1_pos = bcc1_p['POSITION']
	## use the following variable to use bcc1  direction
	bcc1_dir = bcc1_p['DIRECTION']

	## uncomment following line to disable bcc1 cavity building
	## bcc1_p['BUILD_CAVITY'] = 0
	bcc1.key_name = 'PARAM_NG_bcc1'
	bcc1.Execute(names, dictionaries)
	## use the following line to put bcc1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	
	
	if not params['WITHOUT_FIXING']:
		## use the following variable to use shcsm  position
		shcsm_pos = shcsm_p['POSITION']
		## use the following variable to use shcsm  direction
		shcsm_dir = shcsm_p['DIRECTION']

		## put additional member contraints
		
		y_axis = VISIVector.New()
		y_axis.Set(bcc1_p['REF_DIRECTION'].Cx(), bcc1_p['REF_DIRECTION'].Cy(), bcc1_p['REF_DIRECTION'].Cz())
		x_axis = VISIVector.New()
		VISIGeoLib.naXb(bcc1_p['DIRECTION'], y_axis, x_axis)
		
		
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], y_axis, bcc1_p['DISTANCE_HOLE']+bcc1_p['OFFSET_TO_BODY'], shcsm_p['POSITION'])
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, bcc1_p['WIDTH_HOLES']/2, shcsm_p['POSITION'])
		

		## uncomment following line to disable shcsm cavity building
		## shcsm_p['BUILD_CAVITY'] = 0
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		## use the following line to put shcsm cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
		
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -bcc1_p['WIDTH_HOLES'], shcsm_p['POSITION'])
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)

	return 0
