import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import bgb1
import bc1
import jr3

def Execute (names, dictionaries):
	global variables
	global params
	global bgb1_p
	global bc1_1_p
	global jr3_1_p

	bgb1.variables = variables
	bc1.variables = variables
	jr3.variables = variables
	
	params = variables['PARAM_NG_a_bgb43']
	bgb1_p = variables['PARAM_NG_bgb1']
	bc1_p = variables['PARAM_NG_bc1_1']
	jr3_p = variables['PARAM_NG_jr3_1']
	
	if params['INVERT_SIDE']:
		VISIGeoLib.ProjectPointOntoVector(bgb1_p['POSITION'], bgb1_p['DIRECTION'], bgb1_p['START_PLATE_THICK'], bgb1_p['POSITION'])
		VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bgb1_p['DIRECTION'], bgb1_p['START_PLATE_THICK'], jr3_p['POSITION'])
		VISIGeoLib.ProjectPointOntoVector(bc1_p['POSITION'], bgb1_p['DIRECTION'], bgb1_p['START_PLATE_THICK'], bc1_p['POSITION'])
	
	
	
	if params['CHANGE_DIR']:
		bgb1_p['DIRECTION'].Set(-bgb1_p['DIRECTION'].Cx(),-bgb1_p['DIRECTION'].Cy(),-bgb1_p['DIRECTION'].Cz())
		bc1_p['DIRECTION'].Set(-bc1_p['DIRECTION'].Cx(),-bc1_p['DIRECTION'].Cy(),-bc1_p['DIRECTION'].Cz())
		jr3_p['DIRECTION'].Set(-jr3_p['DIRECTION'].Cx(),-jr3_p['DIRECTION'].Cy(),-jr3_p['DIRECTION'].Cz())


	bgb1.key_name = 'PARAM_NG_bgb1'
	bgb1.Execute(names, dictionaries)

	
	VISIGeoLib.ProjectPointOntoVector(bc1_p['POSITION'], bgb1_p['DIRECTION'], bgb1_p['UPPER_LENGTH'], bc1_p['POSITION'])
	VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bgb1_p['DIRECTION'], bgb1_p['UPPER_LENGTH'], jr3_p['POSITION'])
	if params['CREATE_CAGE']:
		bc1.key_name = 'PARAM_NG_bc1_1'
		bc1.Execute(names, dictionaries)

	if params['CREATE_CLIP']:
		jr3_p['BUILD_CAVITY'] = 0
		jr3.key_name = 'PARAM_NG_jr3_1'
		jr3.Execute(names, dictionaries)


		
	return 0
