import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import bc1_4
import jr3
import bgb1_m

def Execute (names, dictionaries):
	global variables
	global params
	global bc1_4_p
	global jr3_p
	global bgb1_m_p

	bc1_4.variables = variables
	jr3.variables = variables
	bgb1_m.variables = variables

	params = variables['PARAM_NG_a_bgb5_3']
	bc1_4_p = variables['PARAM_NG_bc1_4']
	jr3_p = variables['PARAM_NG_jr3']
	bgb1_m_p = variables['PARAM_NG_bgb1_m']
	
	
	
	
	
	
	bc1_4_p['OFFSET']= bc1_4_p['OFFSET']+bgb1_m_p['UPPER_LENGTH']+bc1_4_p['DISTANCE_GROOVE']

	## use the following variable to use bc1_4  position
	bc1_4_pos = bc1_4_p['POSITION']
	## use the following variable to use bc1_4  direction
	bc1_4_dir = bc1_4_p['DIRECTION']
	
	if params['INVERT_SIDE']:
		VISIGeoLib.ProjectPointOntoVector(bc1_4_p['POSITION'], bc1_4_p['DIRECTION'], -bc1_4_p['PLATE_THICK'], bc1_4_p['POSITION'])
		
	if params['REVERSE_ELEMENT']:
		bc1_4_dir.Set(-bc1_4_p['DIRECTION'].Cx(), -bc1_4_p['DIRECTION'].Cy(), -bc1_4_p['DIRECTION'].Cz())
	
	

	## uncomment following line to disable bc1_4 cavity building
	## bc1_4_p['BUILD_CAVITY'] = 0
	bc1_4.key_name = 'PARAM_NG_bc1_4'
	bc1_4.Execute(names, dictionaries)
	## use the following line to put bc1_4 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	
	
	
	
	
	
	## use the following variable to use jr3  position
	jr3_pos = jr3_p['POSITION']
	## use the following variable to use jr3  direction
	jr3_dir = jr3_p['DIRECTION']
	

	## put additional member contraints
	
	if params['REVERSE_ELEMENT']:
		jr3_dir.Set(-jr3_p['DIRECTION'].Cx(), -jr3_p['DIRECTION'].Cy(), -jr3_p['DIRECTION'].Cz())	
		plate_thick = bc1_4_p['PLATE_THICK']
	else:
		plate_thick = -bc1_4_p['PLATE_THICK']
		
		
		
	
	VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_4_p['DIRECTION'], -bc1_4_p['OFFSET']+bc1_4_p['WIDTH_GROOVE'], jr3_p['POSITION'])
	
	
	
	
	
	if params['INVERT_SIDE']:
		VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_4_p['DIRECTION'], plate_thick, jr3_p['POSITION'])
		
	
	VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_4_p['DIRECTION'], bc1_4_p['DISTANCE_GROOVE']-bc1_4_p['WIDTH_GROOVE'], jr3_p['POSITION'])

	
	# if bc1_4_p['REVERSE_ELEMENT']:
		# VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_4_p['DIRECTION'], bc1_4_p['DISTANCE_GROOVE']-bc1_4_p['WIDTH_GROOVE'], jr3_p['POSITION'])
	# else:
		# VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_4_p['DIRECTION'], bc1_4_p['LENGTH']-bc1_4_p['DISTANCE_GROOVE'], jr3_p['POSITION'])
	# if bc1_4_p['INVERT_ELEMENT']:
		# VISIGeoLib.ProjectPointOntoVector(jr3_p['POSITION'], bc1_4_p['DIRECTION'], bc1_4_p['PLATE_THICK']-bc1_4_p['LENGTH'], jr3_p['POSITION'])
	
		
	
	
	## uncomment following line to disable jr3 cavity building
	## jr3_p['BUILD_CAVITY'] = 0
	jr3.key_name = 'PARAM_NG_jr3'
	jr3.Execute(names, dictionaries)
	## use the following line to put jr3 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use bgb1_m  position
	bgb1_m_pos = bgb1_m_p['POSITION']
	## use the following variable to use bgb1_m  direction
	bgb1_m_dir = bgb1_m_p['DIRECTION']

	## put additional member contraints
	
	VISIGeoLib.ProjectPointOntoVector(bgb1_m_p['POSITION'], bc1_4_p['DIRECTION'], params['OFFSET_BUSH'], bgb1_m_p['POSITION'])
		
	
	
	if params['INVERT_SIDE']:
		VISIGeoLib.ProjectPointOntoVector(bgb1_m_p['POSITION'], bgb1_m_p['DIRECTION'], bc1_4_p['PLATE_THICK'], bgb1_m_p['POSITION'])
	if params['REVERSE_ELEMENT']:
		bgb1_m_dir.Set(-bgb1_m_p['DIRECTION'].Cx(), -bgb1_m_p['DIRECTION'].Cy(), -bgb1_m_p['DIRECTION'].Cz())	
	
	
	## uncomment following line to disable bgb1_m cavity building
	## bgb1_m_p['BUILD_CAVITY'] = 0
	bgb1_m.key_name = 'PARAM_NG_bgb1_m'
	bgb1_m.Execute(names, dictionaries)
	## use the following line to put bgb1_m cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
