import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import btc1
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global btc1_p
	global shcsm_p

	btc1.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_btc1']
	btc1_p = variables['PARAM_NG_btc1']
	shcsm_p = variables['PARAM_NG_shcsm']

	## use the following variable to use btc1  position
	btc1_pos = btc1_p['POSITION']
	## use the following variable to use btc1  direction
	btc1_dir = btc1_p['DIRECTION']

	## uncomment following line to disable btc1 cavity building
	## btc1_p['BUILD_CAVITY'] = 0
	btc1.key_name = 'PARAM_NG_btc1'
	btc1.Execute(names, dictionaries)
	## use the following line to put btc1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm  position
	shcsm_pos = shcsm_p['POSITION']
	## use the following variable to use shcsm  direction
	shcsm_dir = shcsm_p['DIRECTION']

	## put additional member contraints
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(btc1_p['DIRECTION'], x_axis)
	VISIGeoLib.VectorRotate(x_axis, btc1_p['DIRECTION'], x_axis, btc1_p['ROT_ANGLE'])
	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -btc1_p['LENGTH_CUBIC']+btc1_p['DISTANCE_HOLE'], shcsm_p['POSITION'])

	## uncomment following line to disable shcsm cavity building
	## shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	## use the following line to put shcsm cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
