import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import cc1
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global cc1_p
	global shcsm_p

	cc1.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_cc1']
	cc1_p = variables['PARAM_NG_cc1']
	shcsm_p = variables['PARAM_NG_shcsm']
	
	#Set Axis and Directions
	y_axis = VISIVector.New()
	y_axis.Set(cc1_p['REF_DIRECTION'].Cx(), cc1_p['REF_DIRECTION'].Cy(), cc1_p['REF_DIRECTION'].Cz())
	x_axis = VISIVector.New()
	VISIGeoLib.naXb(cc1_p['DIRECTION'],y_axis, x_axis)
	
	inv_dir = VISIVector.New()
	inv_dir.Set(-cc1_p['DIRECTION'].Cx(), -cc1_p['DIRECTION'].Cy(), -cc1_p['DIRECTION'].Cz())
	
	
	## use the following variable to use cc1  position
	cc1_pos = cc1_p['POSITION']
	## use the following variable to use cc1  direction
	cc1_dir = cc1_p['DIRECTION']

	## uncomment following line to disable cc1 cavity building
	## cc1_p['BUILD_CAVITY'] = 0
	cc1.key_name = 'PARAM_NG_cc1'
	cc1.Execute(names, dictionaries)
	## use the following line to put cc1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	#Screw 1
	if params['CREATE_SCREWS'] == 1:
		
		## use the following variable to use shcsm  position
		shcsm_pos = shcsm_p['POSITION']
		## use the following variable to use shcsm  direction
		shcsm_dir = shcsm_p['DIRECTION']
		
		#Set right cavity:
		shcsm_p['CAV_DEL'] = cc1_p['HEIGHT']-cc1_p['DEPTH_SINKING']
		
		#Set right direction
		shcsm_p['DIRECTION'] = inv_dir
		#move in direction
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], cc1_p['DIRECTION'],-cc1_p['DEPTH_SINKING'], shcsm_p['POSITION'])
		#move in y_axis
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'],y_axis, -cc1_p['LENGTH_DIST_SCREWS'], shcsm_p['POSITION'])
		#move in x_axis
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'],x_axis, -cc1_p['DISTANCE_SCREWS']/2, shcsm_p['POSITION'])

		## uncomment following line to disable shcsm cavity building
		## shcsm_p['BUILD_CAVITY'] = 0
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		## use the following line to put shcsm cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
		
		
		#Screw 2
		#move in x_axis
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'],x_axis, cc1_p['DISTANCE_SCREWS'], shcsm_p['POSITION'])

		## uncomment following line to disable shcsm cavity building
		## shcsm_p['BUILD_CAVITY'] = 0
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		## use the following line to put shcsm cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
