import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import cun1
import cun2
import shcsm
import jr7
import jr61

def Execute (names, dictionaries):
	global variables
	global params
	global cun1_p
	global cun2_p
	global shcsm_p
	global shcsm_1_p
	global shcsm_2_p
	global jr61
	global jr7

	cun1.variables = variables
	cun2.variables = variables
	shcsm.variables = variables
	jr61.variables = variables
	jr7.variables = variables

	params = variables['PARAM_NG_a_cun12']
	cun1_p = variables['PARAM_NG_cun1']
	cun2_p = variables['PARAM_NG_cun2']
	shcsm_p = variables['PARAM_NG_shcsm']
	shcsm_1_p = variables['PARAM_NG_shcsm_1']
	shcsm_2_p = variables['PARAM_NG_shcsm_2']
	jr61_p = variables['PARAM_NG_jr61']
	jr7_p = variables['PARAM_NG_jr7']

	## use the following variable to use cu1  position
	cun1_pos = cun1_p['POSITION']
	## use the following variable to use cu1  direction
	cun1_dir = cun1_p['DIRECTION']

	## uncomment following line to disable cu1 cavity building
	## cun1_p['BUILD_CAVITY'] = 0
	cun1.key_name = 'PARAM_NG_cun1'
	cun1.Execute(names, dictionaries)
	## use the following line to put cu1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use cu2  position
	cun2_pos = cun2_p['POSITION']
	## use the following variable to use cu2  direction
	cun2_dir = cun2_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable cu2 cavity building
	#cun2_p['BUILD_CAVITY'] = 0
	cun2.key_name = 'PARAM_NG_cun2'
	cun2.Execute(names, dictionaries)
	## use the following line to put cu2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	
	
	######						######
	###### Screwed from inside	######
	######						######
	
	if params['CREATE_SCREW1_M']:
	
	
		## use the following variable to use shcsm  position
		shcsm_pos = shcsm_p['POSITION']
		## use the following variable to use shcsm  direction
		shcsm_dir = shcsm_p['DIRECTION']

		## uncomment following line to disable shcsm cavity building
		#shcsm_p['BUILD_CAVITY'] = 0
		
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], shcsm_p['DIRECTION'], cun1_p['LENGTH_INSIDE']+cun1_p['GAP'], shcsm_p['POSITION'])	
		
		shcsm_p['CAV_DEL'] = cun1_p['TOTAL_LENGTH'] - cun1_p['LENGTH_INSIDE']
		
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		## use the following line to put shcsm cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
		
	if params['CREATE_SCREW1_W']:	
		if  cun1_p['DIAMETER'] == 10./1000:
			## use the following variable to use shcsm_2  position
			shcsm_2_pos = shcsm_2_p['POSITION']
			## use the following variable to use shcsm_2  direction
			shcsm_2_dir = shcsm_2_p['DIRECTION']

			VISIGeoLib.ProjectPointOntoVector(shcsm_2_p['POSITION'], shcsm_2_p['DIRECTION'],cun2_p['GAP']-cun2_p['LENGTH_CONE']+cun2_p['LENGTH_HEAD_INSIDE'], shcsm_2_p['POSITION'])	
			
			shcsm_2_p['CAV_DEL'] = cun2_p['TOTAL_LENGTH'] - cun2_p['LENGTH_HEAD_INSIDE']
			
			shcsm_2_p['LENGTH'] = shcsm_1_p['LENGTH']

			## uncomment following line to disable shcsm_2 cavity building
			## shcsm_2_p['BUILD_CAVITY'] = 0
			shcsm.key_name = 'PARAM_NG_shcsm_2'
			shcsm.Execute(names, dictionaries)
			## use the following line to put shcsm_2 cavity
			##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
			
		else:
			## use the following variable to use shcsm_1  position
			shcsm_1_pos = shcsm_1_p['POSITION']
			## use the following variable to use shcsm_1  direction
			shcsm_1_dir = shcsm_1_p['DIRECTION']

			VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], shcsm_1_p['DIRECTION'],cun2_p['GAP']-cun2_p['LENGTH_CONE']+cun2_p['LENGTH_HEAD_INSIDE'], shcsm_1_p['POSITION'])	

			shcsm_1_p['CAV_DEL'] = cun2_p['TOTAL_LENGTH'] - cun2_p['LENGTH_HEAD_INSIDE']
			
			## uncomment following line to disable shcsm_1 cavity building
			#shcsm_1_p['BUILD_CAVITY'] = 0
			shcsm.key_name = 'PARAM_NG_shcsm_1'
			shcsm.Execute(names, dictionaries)
			## use the following line to put shcsm_1 cavity
			##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

		
		
		
		
	if params['CREATE_SUPDISK_M']:
		## use the following variable to use shcsm_1  position
		jr7_pos = jr7_p['POSITION']
		## use the following variable to use shcsm_1  direction
		jr7_dir = jr7_p['DIRECTION']
		#jr7_p['DIRECTION'] = params['INV_DIRECTION']
		if params['CREATE_DISK_M']:
			VISIGeoLib.ProjectPointOntoVector(jr7_p['POSITION'], jr7_p['DIRECTION'],cun2_p['TOTAL_LENGTH']-cun2_p['LENGTH_CONE']+cun2_p['GAP']+jr61_p['LENGTH'], jr7_p['POSITION'])	
		else:
			VISIGeoLib.ProjectPointOntoVector(jr7_p['POSITION'], jr7_p['DIRECTION'],cun2_p['TOTAL_LENGTH']-cun2_p['LENGTH_CONE']+cun2_p['GAP'], jr7_p['POSITION'])	

		jr7.key_name = 'PARAM_NG_jr7'
		jr7.Execute(names, dictionaries)
		
		if params['CREATE_DISK_M']:
			VISIGeoLib.ProjectPointOntoVector(jr7_p['POSITION'], jr7_p['DIRECTION'],-(cun2_p['TOTAL_LENGTH']-cun2_p['LENGTH_CONE']+cun2_p['GAP']+jr61_p['LENGTH']), jr7_p['POSITION'])	
		else:
			VISIGeoLib.ProjectPointOntoVector(jr7_p['POSITION'], jr7_p['DIRECTION'],-(cun2_p['TOTAL_LENGTH']-cun2_p['LENGTH_CONE']+cun2_p['GAP']), jr7_p['POSITION'])	
		
	if params['CREATE_SUPDISK_W']:
		## use the following variable to use shcsm_1  position
		jr7_pos = jr7_p['POSITION']
		## use the following variable to use shcsm_1  direction
		jr7_dir = jr7_p['DIRECTION']
		jr7_p['DIRECTION'].Set(-jr7_p['DIRECTION'].Cx(), -jr7_p['DIRECTION'].Cy(), -jr7_p['DIRECTION'].Cz())
		#jr7_p['DIRECTION'] = params['INV_DIRECTION']
		if params['CREATE_DISK_W']:
			VISIGeoLib.ProjectPointOntoVector(jr7_p['POSITION'], jr7_p['DIRECTION'],cun1_p['TOTAL_LENGTH']+cun1_p['GAP']+jr61_p['LENGTH'], jr7_p['POSITION'])	
		else:
			VISIGeoLib.ProjectPointOntoVector(jr7_p['POSITION'], jr7_p['DIRECTION'],cun1_p['TOTAL_LENGTH']+cun1_p['GAP'], jr7_p['POSITION'])	

		jr7.key_name = 'PARAM_NG_jr7'
		jr7.Execute(names, dictionaries)
		
	if params['CREATE_DISK_M']:
		## use the following variable to use shcsm_1  position
		jr61_pos = jr61_p['POSITION']
		## use the following variable to use shcsm_1  direction
		jr61_dir = jr61_p['DIRECTION']
		#jr7_p['DIRECTION'] = params['INV_DIRECTION']
		VISIGeoLib.ProjectPointOntoVector(jr61_p['POSITION'], jr61_p['DIRECTION'],cun2_p['TOTAL_LENGTH']-cun2_p['LENGTH_CONE']+cun2_p['GAP'], jr61_p['POSITION'])	

		jr61.key_name = 'PARAM_NG_jr61'
		jr61.Execute(names, dictionaries)
		VISIGeoLib.ProjectPointOntoVector(jr61_p['POSITION'], jr61_p['DIRECTION'],-(cun2_p['TOTAL_LENGTH']-cun2_p['LENGTH_CONE']+cun2_p['GAP']), jr61_p['POSITION'])	
		
	if params['CREATE_DISK_W']:
		## use the following variable to use shcsm_1  position
		jr61_pos = jr61_p['POSITION']
		## use the following variable to use shcsm_1  direction
		jr61_dir = jr61_p['DIRECTION']
		jr61_p['DIRECTION'].Set(-jr61_p['DIRECTION'].Cx(), -jr61_p['DIRECTION'].Cy(), -jr61_p['DIRECTION'].Cz())
		#jr61_p['DIRECTION'] = params['INV_DIRECTION']
		VISIGeoLib.ProjectPointOntoVector(jr61_p['POSITION'], jr61_p['DIRECTION'],cun1_p['TOTAL_LENGTH']+cun1_p['GAP'], jr61_p['POSITION'])	

		jr61.key_name = 'PARAM_NG_jr61'
		jr61.Execute(names, dictionaries)

	return 0
