import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import fcu3
import fcu4
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global fcu3_p
	global fcu4_p
	global shcs1_p
	global shcs1_1_p

	fcu3.variables = variables
	fcu4.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_fcu34']
	fcu3_p = variables['PARAM_NG_fcu3']
	fcu4_p = variables['PARAM_NG_fcu4']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']
	
	RotateList = []
	UniList = []
	UniList2 = []
	rot_pos = params['TEMP_ROTATION_POSITION']

	#Create Element FCU3
	fcu3.key_name = 'PARAM_NG_fcu3'
	fcu3.Execute(names, dictionaries)

	#Add Element and Cavity to RotateListe
	element_fcu3 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
	cavity_fcu3 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
	RotateList.append(element_fcu3)
	index_cavity_fcu3 = dictionaries.__len__()-1


	#Create Element FCU4
	fcu4.key_name = 'PARAM_NG_fcu4'
	fcu4.Execute(names, dictionaries)
	
	#Add Element and Cavity to RotateListe
	element_fcu4 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
	cavity_fcu4 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
	RotateList.append(element_fcu4)
	index_cavity_fcu4 = dictionaries.__len__()-1
	
	#Create Screws
	##Move
	
	if  params['CREATE_SCREWS_F_OUTSIDE']:
		
		if not fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']:
			if not fcu3_p['INVERT']:
				VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-fcu3_p['END_THICK'], shcs1_p['POSITION'])
			else:
				VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-fcu3_p['START_THICK'], shcs1_p['POSITION'])
			shcs1_p['BUILD_CAVITY'] = 0
		
		else:
			y_axis = VISIVector.New()
			VISIGeoLib.naXb(fcu3_p['DIRECTION'], fcu3_p['REF_DIRECTION'], y_axis)
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis,-fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']/2, shcs1_p['POSITION'])
			if not fcu3_p['INVERT']:
				VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-fcu3_p['END_THICK'], shcs1_p['POSITION'])
			else:
				VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-fcu3_p['START_THICK'], shcs1_p['POSITION'])
			shcs1_p['BUILD_CAVITY'] = 0
			
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		
		index_shcs1 = dictionaries.__len__()-1
		cavity_shcs1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
		dictionaries[index_shcs1]['CAVITY_TAG'] = cavity_shcs1
		
		
		#Add Element and Cavity to RotateListe
		element_shcs1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		
		RotateList.append(element_shcs1)
		RotateList.append(cavity_shcs1)
		

		##Move
		if not fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']:
			if not fcu3_p['INVERT']:
				VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],-fcu3_p['START_THICK'], shcs1_1_p['POSITION'])
			else:
				VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],-fcu3_p['END_THICK'], shcs1_1_p['POSITION'])
			shcs1_1_p['BUILD_CAVITY'] = 0
		
		if fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']:
			y_axis = VISIVector.New()
			VISIGeoLib.naXb(fcu3_p['DIRECTION'], fcu3_p['REF_DIRECTION'], y_axis)
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], y_axis,-fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']/2, shcs1_1_p['POSITION'])
			if not fcu3_p['INVERT']:
				VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],-fcu3_p['START_THICK'], shcs1_1_p['POSITION'])
			else:
				VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],-fcu3_p['END_THICK'], shcs1_1_p['POSITION'])
			shcs1_1_p['BUILD_CAVITY'] = 0
			
		shcs1.key_name = 'PARAM_NG_shcs1_1'
		shcs1.Execute(names, dictionaries)
		
		index_shcs1_1 = dictionaries.__len__()-1
		cavity_shcs1_1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_1]['ELEM_TAG'])
		dictionaries[index_shcs1_1]['CAVITY_TAG'] = cavity_shcs1_1
		
		#Add Element and Cavity to RotateListe
		element_shcs1_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		RotateList.append(element_shcs1_1)
		RotateList.append(cavity_shcs1_1)
		
		if fcu3_p['DISTANCE_BETWEEN_SCREWS']:
			##Move
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], fcu3_p['REF_DIRECTION'],fcu4_p['DISTANCE_BETWEEN_SCREWS'], shcs1_1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1_1'
			shcs1.Execute(names, dictionaries)
		
			index_shcs1 = dictionaries.__len__()-1
			cavity_shcs1_11 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			dictionaries[index_shcs1]['CAVITY_TAG'] = cavity_shcs1_11
			
			#Add Element and Cavity to RotateListe
			element_shcs1_11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs1_11)
			RotateList.append(cavity_shcs1_11)
			
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], fcu3_p['REF_DIRECTION'],fcu4_p['DISTANCE_BETWEEN_SCREWS'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
			

			index_shcs1 = dictionaries.__len__()-1
			cavity_shcs11 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			dictionaries[index_shcs1]['CAVITY_TAG'] = cavity_shcs11
			
			#Add Element and Cavity to RotateListe
			element_shcs11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs11)
			RotateList.append(cavity_shcs11)
			
		if fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']:
			##Move
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], y_axis,fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH'], shcs1_1_p['POSITION'])
			
			shcs1.key_name = 'PARAM_NG_shcs1_1'
			shcs1.Execute(names, dictionaries)
			
			index_shcs1 = dictionaries.__len__()-1
			cavity_shcs1_11 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			dictionaries[index_shcs1]['CAVITY_TAG'] = cavity_shcs1_11
			
			#Add Element and Cavity to RotateListe
			element_shcs1_11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs1_11)
			RotateList.append(cavity_shcs1_11)
			
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis,fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
			
			index_shcs1 = dictionaries.__len__()-1
			cavity_shcs11 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			dictionaries[index_shcs1]['CAVITY_TAG'] = cavity_shcs11
			
			#Add Element and Cavity to RotateListe
			element_shcs11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs11)
			RotateList.append(cavity_shcs11)
	elif params['CREATE_SCREWS']:
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],fcu3_p['HEIGHT_BASE']+fcu4_p['HEIGHT_SINKING'], shcs1_p['POSITION'])		
		if fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']:
			y_axis = VISIVector.New()
			VISIGeoLib.naXb(fcu3_p['DIRECTION'], fcu3_p['REF_DIRECTION'], y_axis)
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis,-fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']/2, shcs1_p['POSITION'])

			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-fcu3_p['HEIGHT_BASE'], shcs1_p['POSITION'])
			
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		

		cavity_shcs1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
		
		
		#Add Element and Cavity to RotateListe
		element_shcs1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		
		RotateList.append(element_shcs1)
		RotateList.append(cavity_shcs1)
		

		##Move
		VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],fcu4_p['HEIGHT_BASE']-fcu4_p['HEIGHT']+fcu4_p['HEIGHT_SINKING'], shcs1_1_p['POSITION'])
		
		if fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']:
			y_axis = VISIVector.New()
			VISIGeoLib.naXb(fcu3_p['DIRECTION'], fcu3_p['REF_DIRECTION'], y_axis)
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], y_axis,-fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']/2, shcs1_1_p['POSITION'])
			
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],fcu4_p['HEIGHT']-fcu4_p['HEIGHT_BASE'], shcs1_1_p['POSITION'])
			
		shcs1.key_name = 'PARAM_NG_shcs1_1'
		shcs1.Execute(names, dictionaries)
		
		cavity_shcs1_1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
		
		#Add Element and Cavity to RotateListe
		element_shcs1_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		RotateList.append(element_shcs1_1)
		RotateList.append(cavity_shcs1_1)
		
		if fcu3_p['DISTANCE_BETWEEN_SCREWS']:
			##Move
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], fcu3_p['REF_DIRECTION'],fcu4_p['DISTANCE_BETWEEN_SCREWS'], shcs1_1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1_1'
			shcs1.Execute(names, dictionaries)
		
			cavity_shcs1_11 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
			
			#Add Element and Cavity to RotateListe
			element_shcs1_11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs1_11)
			RotateList.append(cavity_shcs1_11)
			
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], fcu3_p['REF_DIRECTION'],fcu4_p['DISTANCE_BETWEEN_SCREWS'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
			
			cavity_shcs11 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
			
			#Add Element and Cavity to RotateListe
			element_shcs11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs11)
			RotateList.append(cavity_shcs11)
			
		if fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH']:
			##Move
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], y_axis,fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH'], shcs1_1_p['POSITION'])
			
			shcs1.key_name = 'PARAM_NG_shcs1_1'
			shcs1.Execute(names, dictionaries)
			
			cavity_shcs1_11 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
				
			#Add Element and Cavity to RotateListe
			element_shcs1_11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs1_11)
			RotateList.append(cavity_shcs1_11)
			
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis,fcu3_p['DISTANCE_BETWEEN_SCREWS_WIDTH'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
			
			cavity_shcs11 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
			
			#Add Element and Cavity to RotateListe
			element_shcs11 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			RotateList.append(element_shcs11)
			RotateList.append(cavity_shcs11)	
		
	if not fcu3_p['GAP']:
		UniList.append(cavity_fcu4)
		UniList.append(cavity_fcu3)
		#Unite
		VISISolidFactory.Unite(UniList, UniList2)
		RotateList.append(UniList2[0])
		dictionaries[index_cavity_fcu3]['CAVITY_TAG'] = 0
		#dictionaries[index_cavity_fcu4]['CAVITY_TAG'] = 0
		
	else:
		RotateList.append(cavity_fcu4)
		RotateList.append(cavity_fcu3)
		
	#Rotate All Elements in case of invert
	if fcu3_p['INVERT']:
		VISISolidFactory.RotateBodies(RotateList,rot_pos,fcu3_p['REF_DIRECTION'],math.radians(180))

	return 0
