import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
import fcu3_1
import fcu4_1
import shcs1
import dp1

def Execute (names, dictionaries):
	global variables
	global params
	global fcu3_1_p
	global fcu4_1_p
	global shcs1_p
	global shcs1_1_p
	global dp1_p

	fcu3_1.variables = variables
	fcu4_1.variables = variables
	shcs1.variables = variables
	dp1.variables = variables

	params = variables['PARAM_NG_a_fcu34_1']
	fcu3_1_p = variables['PARAM_NG_fcu3_1']
	fcu4_1_p = variables['PARAM_NG_fcu4_1']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']
	dp1_p = variables['PARAM_NG_dp1']
	
	RotateList = []
	UniList = []
	UniList2 = []
	rot_pos = params['TEMP_ROTATION_POSITION']
	
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(fcu3_1_p['DIRECTION'], x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(fcu3_1_p['DIRECTION'], x_axis, y_axis)
	
	if(fcu3_1_p['ROT_ANGLE'] <> 0):
		VISIGeoLib.VectorRotate(x_axis, fcu3_1_p['DIRECTION'], x_axis, fcu3_1_p['ROT_ANGLE'])
		VISIGeoLib.VectorRotate(y_axis, fcu3_1_p['DIRECTION'], y_axis, fcu3_1_p['ROT_ANGLE'])

	#Create Element FCU3_1
	fcu3_1.key_name = 'PARAM_NG_fcu3_1'
	fcu3_1.Execute(names, dictionaries)

	#Add Element and Cavity to RotateListe
	element_fcu3_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
	cavity_fcu3_1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
	RotateList.append(element_fcu3_1)
	index_cavity_fcu3_1 = dictionaries.__len__()-1


	#Create Element FCU4_1
	fcu4_1.key_name = 'PARAM_NG_fcu4_1'
	fcu4_1.Execute(names, dictionaries)
	
	#Add Element and Cavity to RotateListe
	element_fcu4_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
	cavity_fcu4_1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
	RotateList.append(element_fcu4_1)
	index_cavity_fcu4_1 = dictionaries.__len__()-1
	
	#Create Screws
	##Move
	
	if  params['CREATE_SCREWS_F_OUTSIDE']:
	
		#Correct GAP:
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],fcu3_1_p['DISTANCE_GAP'], shcs1_p['POSITION'])
		VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],fcu3_1_p['DISTANCE_GAP'], shcs1_1_p['POSITION'])
		
		if not fcu3_1_p['INVERT']:
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-fcu3_1_p['END_THICK'], shcs1_p['POSITION'])
			shcs1_p['BUILD_CAVITY'] = 0
		else:
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],-fcu3_1_p['START_THICK'], shcs1_p['POSITION'])
		shcs1_p['BUILD_CAVITY'] = 0
		
			
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		
		index_shcs1 = dictionaries.__len__()-1
		cavity_shcs1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
		dictionaries[index_shcs1]['CAVITY_TAG'] = cavity_shcs1
		
		
		#Add Element and Cavity to RotateListe
		element_shcs1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		
		RotateList.append(element_shcs1)
		RotateList.append(cavity_shcs1)
		

		##Move
		if not fcu3_1_p['INVERT']:
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],-fcu3_1_p['START_THICK'], shcs1_1_p['POSITION'])
		else:
			VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],-fcu3_1_p['END_THICK'], shcs1_1_p['POSITION'])
		shcs1_1_p['BUILD_CAVITY'] = 0
		
			
		shcs1.key_name = 'PARAM_NG_shcs1_1'
		shcs1.Execute(names, dictionaries)
		
		index_shcs1_1 = dictionaries.__len__()-1
		cavity_shcs1_1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1_1]['ELEM_TAG'])
		dictionaries[index_shcs1_1]['CAVITY_TAG'] = cavity_shcs1_1
		
		#Add Element and Cavity to RotateListe
		element_shcs1_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		RotateList.append(element_shcs1_1)
		RotateList.append(cavity_shcs1_1)
		
		if params['CREATE_LOCK']:
			#Create Lock
			dp1_pos = dp1_p['POSITION']
			dp1_dir = dp1_p['DIRECTION']
			
			dp1_p['DIRECTION'] = y_axis
			
			#1
			##Move
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], fcu3_1_p['DIRECTION'],fcu3_1_p['HEIGHT']-fcu3_1_p['DISTANCE_LOCK2']+fcu3_1_p['DISTANCE_GAP'], dp1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], y_axis,-fcu3_1_p['DIAMETER']/2+fcu3_1_p['LENGTH_LOCK2'], dp1_p['POSITION'])

			## uncomment following line to disable dp1 cavity building
			dp1_p['BUILD_CAVITY'] = 0
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			element_dp1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		
			RotateList.append(element_dp1)
			
			#2
			
			##Move
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], fcu3_1_p['DIRECTION'],-fcu3_1_p['HEIGHT']-fcu4_1_p['HEIGHT']+fcu3_1_p['DISTANCE_LOCK2']+fcu4_1_p['DISTANCE_LOCK2']-2*+fcu3_1_p['DISTANCE_GAP'], dp1_p['POSITION'])

			## uncomment following line to disable dp1 cavity building
			dp1_p['BUILD_CAVITY'] = 0
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			element_dp1_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			
			RotateList.append(element_dp1_1)
		
	elif params['CREATE_SCREWS']:
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'],fcu3_1_p['HEIGHT_BASE']+fcu3_1_p['HEIGHT_SINKING'], shcs1_p['POSITION'])		
			
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		

		cavity_shcs1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
		
		
		#Add Element and Cavity to RotateListe
		element_shcs1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		
		RotateList.append(element_shcs1)
		RotateList.append(cavity_shcs1)
		

		##Move
		VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], shcs1_1_p['DIRECTION'],fcu4_1_p['HEIGHT_SINKING']-fcu4_1_p['HEIGHT_BASE'], shcs1_1_p['POSITION'])
	
		shcs1.key_name = 'PARAM_NG_shcs1_1'
		shcs1.Execute(names, dictionaries)
		
		cavity_shcs1_1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
		
		#Add Element and Cavity to RotateListe
		element_shcs1_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
		RotateList.append(element_shcs1_1)
		RotateList.append(cavity_shcs1_1)
		
		if params['CREATE_LOCK']:
			#Create Lock
			dp1_pos = dp1_p['POSITION']
			dp1_dir = dp1_p['DIRECTION']
			
			#1
			##Move
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], fcu3_1_p['DIRECTION'],fcu3_1_p['HEIGHT']-fcu3_1_p['LENGTH_LOCK1']+fcu3_1_p['DISTANCE_GAP'], dp1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], y_axis,-fcu3_1_p['DISTANCE_LOCK1'], dp1_p['POSITION'])

			## uncomment following line to disable dp1 cavity building
			dp1_p['BUILD_CAVITY'] = 0
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			element_dp1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			
			index_dp1 = dictionaries.__len__()-1
			start_cavity = dp1.CreateCavity(dictionaries[index_dp1]['ELEM_TAG'])
			start_cavity = VISIParam.AdaptCavityToPlate(cavity_fcu3_1, start_cavity, 1)
			dictionaries[index_dp1]['CAVITY_TAG'] = start_cavity
			cavity_dp1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
			
			RotateList.append(element_dp1)
			RotateList.append(cavity_dp1)
			
			#2
			dp1_p['DIRECTION'] = fcu4_1_p['DIRECTION']
			##Move
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], fcu3_1_p['DIRECTION'],-fcu3_1_p['HEIGHT']-fcu4_1_p['HEIGHT']+fcu3_1_p['LENGTH_LOCK1']+fcu4_1_p['LENGTH_LOCK1']-2*fcu3_1_p['DISTANCE_GAP'], dp1_p['POSITION'])

			## uncomment following line to disable dp1 cavity building
			dp1_p['BUILD_CAVITY'] = 0
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			element_dp1_1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
			
			index_dp1_1 = dictionaries.__len__()-1
			start_cavity = dp1.CreateCavity(dictionaries[index_dp1_1]['ELEM_TAG'])
			start_cavity = VISIParam.AdaptCavityToPlate(cavity_fcu4_1, start_cavity, 1)
			dictionaries[index_dp1_1]['CAVITY_TAG'] = start_cavity
			cavity_dp1_1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
			
			RotateList.append(element_dp1_1)
			RotateList.append(cavity_dp1_1)
			
		
	if not fcu3_1_p['GAP']:
		UniList.append(cavity_fcu4_1)
		UniList.append(cavity_fcu3_1)
		#Unite
		VISISolidFactory.Unite(UniList, UniList2)
		RotateList.append(UniList2[0])
		dictionaries[index_cavity_fcu3_1]['CAVITY_TAG'] = 0
		#dictionaries[index_cavity_fcu4]['CAVITY_TAG'] = 0
		
	else:
		RotateList.append(cavity_fcu4_1)
		RotateList.append(cavity_fcu3_1)
		
	#Rotate All Elements in case of invert
	if fcu3_1_p['INVERT']:
	
		rot_axis = VISIVector.New()
		VISIGeoLib.ArbitraryNormalAxis(fcu3_1_p['DIRECTION'], rot_axis)
		VISISolidFactory.RotateBodies(RotateList,rot_pos,rot_axis,math.radians(180))
		VISISolidFactory.RotateBodies(RotateList,rot_pos,fcu3_1_p['DIRECTION'],math.radians(180))

	return 0
