import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import flatguide_3_1
import fgui1_3
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global flatguide_3_1_p
	global fgui1_3_p
	global shcs1_p

	flatguide_3_1.variables = variables
	fgui1_3.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_flatguide_31']
	flatguide_3_1_p = variables['PARAM_NG_flatguide_3_1']
	fgui1_3_p = variables['PARAM_NG_fgui1_3']
	shcs1_p = variables['PARAM_NG_shcs1']
	without_fixing = str(params['WITHOUT_FIXING'])
	
	#Create Top element
	##Define Variables
	flatguide_3_1_pos = flatguide_3_1_p['POSITION']
	flatguide_1_dir = flatguide_3_1_p['DIRECTION']
	
	##Correct Position
	flatguide_3_1_p['PLATE_DIRECTION'].Set(-flatguide_3_1_p['PLATE_DIRECTION'].Cx(),-flatguide_3_1_p['PLATE_DIRECTION'].Cy(),-flatguide_3_1_p['PLATE_DIRECTION'].Cz())
	VISIGeoLib.ProjectPointOntoVector(flatguide_3_1_p['POSITION'], flatguide_1_dir, flatguide_3_1_p['START_THICK'] , flatguide_3_1_p['POSITION'])
	
	#Create Element
	flatguide_3_1.key_name = 'PARAM_NG_flatguide_3_1'
	flatguide_3_1.Execute(names, dictionaries)

	#Create Lower element
	##Define Variables
	fgui1_3_pos = fgui1_3_p['POSITION']
	fgui1_1_dir = fgui1_3_p['DIRECTION']

	## put additional member contraints
	fgui1_3_p['PLATE_DIRECTION'].Set(flatguide_3_1_p['PLATE_DIRECTION'].Cx(), flatguide_3_1_p['PLATE_DIRECTION'].Cy(), flatguide_3_1_p['PLATE_DIRECTION'].Cz())
	fgui1_3_p['POSITION'].Set(flatguide_3_1_p['POSITION'].x(),flatguide_3_1_p['POSITION'].y(),flatguide_3_1_p['POSITION'].z())
	
	##Change Position in Case of a Gap between Start and Endplate
	if fgui1_3_p['TOTAL_THICK'] - (fgui1_3_p['START_THICK'] + flatguide_3_1_p['START_THICK'])>0:
		VISIGeoLib.ProjectPointOntoVector(fgui1_3_p['POSITION'], fgui1_1_dir, fgui1_3_p['TOTAL_THICK'] - (fgui1_3_p['START_THICK'] + flatguide_3_1_p['START_THICK']), fgui1_3_p['POSITION'])
		
	##Create Element
	fgui1_3.key_name = 'PARAM_NG_fgui1_3'
	fgui1_3.Execute(names, dictionaries)
	## use the following line to put fgui1_1 cavity

	#Create Screws
	##Set Directions
	plate_direction = VISIVector.New()
	if (flatguide_3_1_p['REV'] == 0):
			plate_direction.Set(flatguide_3_1_p['PLATE_DIRECTION'].Cx(), flatguide_3_1_p['PLATE_DIRECTION'].Cy(), flatguide_3_1_p['PLATE_DIRECTION'].Cz())
	else:
			plate_direction.Set(-flatguide_3_1_p['PLATE_DIRECTION'].Cx(), -flatguide_3_1_p['PLATE_DIRECTION'].Cy(), -flatguide_3_1_p['PLATE_DIRECTION'].Cz())
        
	shcs1_p['DIRECTION'].Set(flatguide_3_1_p['REVERSE_DIRECTION'].Cx(), flatguide_3_1_p['REVERSE_DIRECTION'].Cy(), flatguide_3_1_p['REVERSE_DIRECTION'].Cz())
	
	
	if without_fixing == '0':
		## Create Screws
		for i in range(len(flatguide_3_1.screw_positions)):			
			shcs1_p['POSITION'] = flatguide_3_1.screw_positions[i]
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], plate_direction, -flatguide_3_1_p['INS_DEP'], shcs1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'], flatguide_3_1_p['HEAD_HEIGHT'], shcs1_p['POSITION'])
			shcs1_p['BUILD_CAVITY'] = 0
			shcs1_p['key_name'] = 'shcs1'
			shcs1.Execute(names, dictionaries)
			index_shcs1 = dictionaries.__len__()-1
				
			end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			dictionaries[index_shcs1]['CAVITY_TAG'] = end_screw_cavity
		
		shcs1_p['DIRECTION'].Set(-flatguide_3_1_p['REVERSE_DIRECTION'].Cx(), -flatguide_3_1_p['REVERSE_DIRECTION'].Cy(), -flatguide_3_1_p['REVERSE_DIRECTION'].Cz())
		for i in range(len(fgui1_3.screw_positions)):
			shcs1_p['POSITION'] = fgui1_3.screw_positions[i]
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], plate_direction, -fgui1_3_p['EXTRA_DEPTH'], shcs1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'], fgui1_3_p['HEAD_HEIGHT'], shcs1_p['POSITION'])
			shcs1_p['BUILD_CAVITY'] = 0
			shcs1_p['key_name'] = 'shcs1'
			shcs1.Execute(names, dictionaries)
			index_shcs1_1 = dictionaries.__len__()-1
				
			end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1_1]['ELEM_TAG'])
			dictionaries[index_shcs1_1]['CAVITY_TAG'] = end_screw_cavity
				
	return 0
