import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import gl2
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global gl2_p
	global shcsm_p

	gl2.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_gl2']
	gl2_p = variables['PARAM_NG_gl2']
	shcsm_p = variables['PARAM_NG_shcsm']

	## use the following variable to use gl2  position
	gl2_pos = gl2_p['POSITION']
	## use the following variable to use gl2  direction
	gl2_dir = gl2_p['DIRECTION']

	## uncomment following line to disable gl2 cavity building
	## gl2_p['BUILD_CAVITY'] = 0
	gl2.key_name = 'PARAM_NG_gl2'
	gl2.Execute(names, dictionaries)
	## use the following line to put gl2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm  position
	shcsm_pos = shcsm_p['POSITION']
	## use the following variable to use shcsm  direction
	shcsm_dir = shcsm_p['DIRECTION']
	
	inv_dir = VISIVector.New()
	inv_dir.Set(-shcsm_p['DIRECTION'].Cx(), -shcsm_p['DIRECTION'].Cy(), -shcsm_p['DIRECTION'].Cz())	
	shcsm_p['DIRECTION'] = inv_dir
	
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(shcsm_p['DIRECTION'], x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(shcsm_p['DIRECTION'], x_axis, y_axis)
	
	
	VISIGeoLib.VectorRotate(x_axis, shcsm_p['DIRECTION'], x_axis, math.radians(180))
	VISIGeoLib.VectorRotate(y_axis, shcsm_p['DIRECTION'], y_axis, math.radians(180))
	#Check status of invert option
	if gl2_p['CHECK_INVERT']:
		y_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
		
	if(gl2_p['ROT_ANGLE'] <> 0):
		VISIGeoLib.VectorRotate(x_axis, shcsm_p['DIRECTION'], x_axis, -gl2_p['ROT_ANGLE'])
		VISIGeoLib.VectorRotate(y_axis, shcsm_p['DIRECTION'], y_axis, -gl2_p['ROT_ANGLE'])
	
	#Move Z
	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], shcsm_p['DIRECTION'], gl2_p['INS_DEPTH']-gl2_p['HEIGHT']+gl2_p['HEAD_HEIGHT'], shcsm_p['POSITION'])
	#Move Y
	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], y_axis, -gl2_p['WIDTH_SMALL']+gl2_p['WIDTH_DISTANCE'], shcsm_p['POSITION'])


	#Correct Cavity
	shcsm_p['CAV_DEL'] = gl2_p['HEIGHT']-gl2_p['HEAD_HEIGHT']
	
	if params['CHECK_SCREW'] == 1:
		#Check quantity of screws
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl2_p['LENGTH']/2, shcsm_p['POSITION'])
		if gl2_p['NUMBER_SCREWS'] == 2:
			#Screw 1
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl2_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw2
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl2_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			
		elif gl2_p['NUMBER_SCREWS'] == 3:
			#Screw 1
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 2
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl2_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)		
			#Screw 3
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -2*gl2_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			
		elif gl2_p['NUMBER_SCREWS'] == 4:
			#Screw 1
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl2_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 2
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl2_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 3
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, 2*gl2_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 4
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl2_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
		
	

	return 0
