import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import gl3
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global gl3_p
	global shcsm_p
	global shcsm_1_p

	gl3.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_gl3']
	gl3_p = variables['PARAM_NG_gl3']
	shcsm_p = variables['PARAM_NG_shcsm']
	shcsm_1_p = variables['PARAM_NG_shcsm_1']

	#Guiding rail
	gl3_pos = gl3_p['POSITION']
	gl3_dir = gl3_p['DIRECTION']
	gl3.key_name = 'PARAM_NG_gl3'
	gl3.Execute(names, dictionaries)


	#Screw
	inv_dir = VISIVector.New()
	inv_dir.Set(-shcsm_p['DIRECTION'].Cx(), -shcsm_p['DIRECTION'].Cy(), -shcsm_p['DIRECTION'].Cz())	
	shcsm_p['DIRECTION'] = inv_dir
	
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(shcsm_p['DIRECTION'], x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(shcsm_p['DIRECTION'], x_axis, y_axis)
	
	VISIGeoLib.VectorRotate(x_axis, shcsm_p['DIRECTION'], x_axis, math.radians(180))
	VISIGeoLib.VectorRotate(y_axis, shcsm_p['DIRECTION'], y_axis, math.radians(180))
	
	#Check status of invert option
	if not gl3_p['CHECK_INVERT']:
		y_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
		
	if(gl3_p['ROT_ANGLE'] <> 0):
		VISIGeoLib.VectorRotate(x_axis, shcsm_p['DIRECTION'], x_axis, -gl3_p['ROT_ANGLE'])
		VISIGeoLib.VectorRotate(y_axis, shcsm_p['DIRECTION'], y_axis, -gl3_p['ROT_ANGLE'])
		
	#Move Z
	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], shcsm_p['DIRECTION'], gl3_p['INS_DEPTH']-gl3_p['HEIGHT']+gl3_p['HEAD_HEIGHT'], shcsm_p['POSITION'])
	#Move Y
	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], y_axis, -gl3_p['WIDTH_DISTANCE'], shcsm_p['POSITION'])

	#Correct Cavity
	shcsm_p['CAV_DEL'] = gl3_p['HEIGHT']-gl3_p['HEAD_HEIGHT']	
	
	if params['CHECK_SCREW_2'] == 1:
		if not params['CHECK_SCREW']:
			#Check quantity of screws
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl3_p['LENGTH']/2, shcsm_p['POSITION'])
			if gl3_p['NUMBER_SCREWS'] == 1:
				#Screw 1
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
			if gl3_p['NUMBER_SCREWS'] == 2:
				#Screw 1
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl3_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw2
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl3_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				
			elif gl3_p['NUMBER_SCREWS'] == 3:
				#Screw 1
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 2
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl3_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)		
				#Screw 3
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -2*gl3_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				
			elif gl3_p['NUMBER_SCREWS'] == 4:
				#Screw 1
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl3_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 2
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl3_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 3
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, 2*gl3_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 4
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl3_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
		
		
		
		#Flat screw
		inv_dir = VISIVector.New()
		inv_dir.Set(-shcsm_1_p['DIRECTION'].Cx(), -shcsm_1_p['DIRECTION'].Cy(), -shcsm_1_p['DIRECTION'].Cz())	
		shcsm_1_p['DIRECTION'] = inv_dir
		
		x_axis = VISIVector.New()
		VISIGeoLib.ArbitraryNormalAxis(shcsm_1_p['DIRECTION'], x_axis)
		y_axis = VISIVector.New()
		VISIGeoLib.naXb(shcsm_1_p['DIRECTION'], x_axis, y_axis)
		
		VISIGeoLib.VectorRotate(x_axis, shcsm_1_p['DIRECTION'], x_axis, math.radians(180))
		VISIGeoLib.VectorRotate(y_axis, shcsm_1_p['DIRECTION'], y_axis, math.radians(180))
		
		#Check status of invert option
		if not gl3_p['CHECK_INVERT']:
			y_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
			
		if(gl3_p['ROT_ANGLE'] <> 0):
			VISIGeoLib.VectorRotate(x_axis, shcsm_1_p['DIRECTION'], x_axis, -gl3_p['ROT_ANGLE'])
			VISIGeoLib.VectorRotate(y_axis, shcsm_1_p['DIRECTION'], y_axis, -gl3_p['ROT_ANGLE'])
			
		#Move Z
		VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], shcsm_1_p['DIRECTION'], gl3_p['INS_DEPTH']-gl3_p['HEIGHT']+gl3_p['HEAD_HEIGHT'], shcsm_1_p['POSITION'])
		#Move Y
		VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], y_axis, -gl3_p['WIDTH_DISTANCE'], shcsm_1_p['POSITION'])


		#Correct Cavity
		shcsm_1_p['CAV_DEL'] = gl3_p['HEIGHT']-gl3_p['HEAD_HEIGHT']
		
		if params['CHECK_SCREW']:
			#Check quantity of screws
			VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, gl3_p['LENGTH']/2, shcsm_1_p['POSITION'])
			if gl3_p['NUMBER_SCREWS'] == 1:
				#Screw 1
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)
			if gl3_p['NUMBER_SCREWS'] == 2:
				#Screw 1
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, -gl3_p['SCREW_DISTANCE']/2, shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)
				#Screw2
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, gl3_p['SCREW_DISTANCE'], shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)
				
			elif gl3_p['NUMBER_SCREWS'] == 3:
				#Screw 1
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)
				#Screw 2
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, gl3_p['SCREW_DISTANCE'], shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)		
				#Screw 3
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, -2*gl3_p['SCREW_DISTANCE'], shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)
				
			elif gl3_p['NUMBER_SCREWS'] == 4:
				#Screw 1
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, -gl3_p['SCREW_DISTANCE']/2, shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)
				#Screw 2
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, -gl3_p['SCREW_DISTANCE'], shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1'
				shcsm.Execute(names, dictionaries)
				#Screw 3
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, 2*gl3_p['SCREW_DISTANCE'], shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1_1'
				shcsm.Execute(names, dictionaries)
				#Screw 4
				VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, gl3_p['SCREW_DISTANCE'], shcsm_1_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm_1_1'
				shcsm.Execute(names, dictionaries)


	return 0
