import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import gl7
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global gl7_p
	global shcsm_p

	gl7.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_gl7']
	gl7_p = variables['PARAM_NG_gl7']
	shcsm_p = variables['PARAM_NG_shcsm']

	## use the following variable to use gl7  position
	gl7_pos = gl7_p['POSITION']
	## use the following variable to use gl7  direction
	gl7_dir = gl7_p['DIRECTION']

	## uncomment following line to disable gl7 cavity building
	## gl7_p['BUILD_CAVITY'] = 0
	gl7.key_name = 'PARAM_NG_gl7'
	gl7.Execute(names, dictionaries)
	## use the following line to put gl7 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm  position
	shcsm_pos = shcsm_p['POSITION']
	## use the following variable to use shcsm  direction
	shcsm_dir = shcsm_p['DIRECTION']
	
	inv_dir = VISIVector.New()
	inv_dir.Set(-shcsm_p['DIRECTION'].Cx(), -shcsm_p['DIRECTION'].Cy(), -shcsm_p['DIRECTION'].Cz())	
	shcsm_p['DIRECTION'] = inv_dir
	
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(shcsm_p['DIRECTION'], x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(shcsm_p['DIRECTION'], x_axis, y_axis)
	
	VISIGeoLib.VectorRotate(x_axis, shcsm_p['DIRECTION'], x_axis, -math.radians(180))
	VISIGeoLib.VectorRotate(y_axis, shcsm_p['DIRECTION'], y_axis, -math.radians(180))
	
	#Check status of invert option
	if not gl7_p['CHECK_INVERT']:
		y_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
		
	if(gl7_p['ROT_ANGLE'] <> 0):
		VISIGeoLib.VectorRotate(x_axis, shcsm_p['DIRECTION'], x_axis, -gl7_p['ROT_ANGLE'])
		VISIGeoLib.VectorRotate(y_axis, shcsm_p['DIRECTION'], y_axis, -gl7_p['ROT_ANGLE'])
	
	#Move Z
	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], shcsm_p['DIRECTION'], gl7_p['INS_DEPTH']-gl7_p['HEIGHT']+gl7_p['HEAD_HEIGHT'], shcsm_p['POSITION'])

	#Correct Cavity
	shcsm_p['CAV_DEL'] = gl7_p['HEIGHT']-gl7_p['HEAD_HEIGHT']
	
	#Check quantity of screws
	if params['CHECK_SCREW'] == 1:
		number_screws = gl7_p['NUMBER_SCREWS']
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['LENGTH']/2, shcsm_p['POSITION'])
		if gl7_p['WIDTH_DISTANCE'] <> 0:
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], y_axis, -gl7_p['WIDTH_DISTANCE']/2, shcsm_p['POSITION'])
			number_screws = gl7_p['NUMBER_SCREWS']/2
			
		if number_screws == 2:
			#Screw 1
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw2
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
			
		elif number_screws == 3:
			#Screw 1
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 2
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)		
			#Screw 3
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -2*gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'],shcsm_p['POSITION'])
			
		elif number_screws == 4:
			#Screw 1
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 2
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 3
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, 2*gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			#Screw 4
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
			shcsm.key_name = 'PARAM_NG_shcsm'
			shcsm.Execute(names, dictionaries)
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -1.5*gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
		
		if gl7_p['WIDTH_DISTANCE'] <> 0:
			VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], y_axis, gl7_p['WIDTH_DISTANCE'], shcsm_p['POSITION'])
			if number_screws == 2:
				#Screw 1
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw2
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
				
			elif number_screws == 3:
				#Screw 1
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 2
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)		
				#Screw 3
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -2*gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'],shcsm_p['POSITION'])
				
			elif number_screws == 4:
				#Screw 1
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE']/2, shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 2
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 3
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, 2*gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				#Screw 4
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
				shcsm.key_name = 'PARAM_NG_shcsm'
				shcsm.Execute(names, dictionaries)
				VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis, -1.5*gl7_p['SCREW_DISTANCE'], shcsm_p['POSITION'])
		
	

	return 0
