import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import gp5
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global gp5_p
	global shcsm_p

	gp5.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_gp4']
	gp5_p = variables['PARAM_NG_gp5']
	shcsm_p = variables['PARAM_NG_shcsm']
	
	
	#Set Axis and Directions
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(gp5_p['DIRECTION'], x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(gp5_p['DIRECTION'], x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-gp5_p['DIRECTION'].Cx(), -gp5_p['DIRECTION'].Cy(), -gp5_p['DIRECTION'].Cz())
	
	VISIGeoLib.VectorRotate(x_axis, gp5_p['DIRECTION'], x_axis, gp5_p['ROT_ANGLE'])
	VISIGeoLib.VectorRotate(y_axis, gp5_p['DIRECTION'], y_axis, gp5_p['ROT_ANGLE'])
	


	## use the following variable to use gp5  position
	gp5_pos = gp5_p['POSITION']
	## use the following variable to use gp5  direction
	gp5_dir = gp5_p['DIRECTION']

	## uncomment following line to disable gp5 cavity building
	## gp5_p['BUILD_CAVITY'] = 0
	gp5.key_name = 'PARAM_NG_gp5'
	gp5.Execute(names, dictionaries)
	## use the following line to put gp5 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm  position
	shcsm_pos = shcsm_p['POSITION']
	## use the following variable to use shcsm  direction
	shcsm_dir = shcsm_p['DIRECTION']

	
	
	## put additional member contraints
	
	if not params['WITHOUT_FIXING']:
	
		#Set right cavity:
		shcsm_p['CAV_DEL'] = gp5_p['LENGTH_BIG']-gp5_p['DEPTH_HOLE_BIG']

		#Screw1
		VISIGeoLib.ProjectPointOntoVector(shcsm_pos, inv_dir, gp5_p['LENGTH_BIG']-gp5_p['DEPTH_HOLE_BIG'], shcsm_pos)
		VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, gp5_p['DIAMETER_DISTANCE_HOLES']/2, shcsm_pos)
	
		## uncomment following line to disable shcsm cavity building
		## shcsm_p['BUILD_CAVITY'] = 0
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		## use the following line to put shcsm cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
		
		#Screw2
		VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, -gp5_p['DIAMETER_DISTANCE_HOLES']/2, shcsm_pos)
		VISIGeoLib.VectorRotate(x_axis, shcsm_dir, x_axis, gp5_p['ANGLE_HOLES'])
		VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, gp5_p['DIAMETER_DISTANCE_HOLES']/2, shcsm_pos)
		
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		
		#Screw3
		VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, -gp5_p['DIAMETER_DISTANCE_HOLES']/2, shcsm_pos)
		VISIGeoLib.VectorRotate(x_axis, shcsm_dir, x_axis, gp5_p['ANGLE_HOLES'])
		VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, gp5_p['DIAMETER_DISTANCE_HOLES']/2, shcsm_pos)
		
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		
	

	return 0
