import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import hd1
import shcsm2

def Execute (names, dictionaries):
	global variables
	global params
	global hd1_p
	global shcsm2_p

	hd1.variables = variables
	shcsm2.variables = variables

	params = variables['PARAM_NG_a_hd1']
	hd1_p = variables['PARAM_NG_hd1']
	shcsm2_p = variables['PARAM_NG_shcsm2']

	## use the following variable to use hd1  position
	hd1_pos = hd1_p['POSITION']
	## use the following variable to use hd1  direction
	hd1_dir = hd1_p['DIRECTION']
	
	## uncomment following line to disable hd1 cavity building
	## hd1_p['BUILD_CAVITY'] = 0
	hd1.key_name = 'PARAM_NG_hd1'
	hd1.Execute(names, dictionaries)
	## use the following line to put hd1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm2  position
	shcsm2_pos = shcsm2_p['POSITION']
	shcsm2_dir = shcsm2_p['DIRECTION']
	
	#Define inverse direction
	##shcsm2_inv_dir = VISIVector.New()
	##shcsm2_inv_dir.Set(-shcsm2_dir.Cx(), -shcsm2_dir.Cy(), -shcsm2_dir.Cz())
	
	#sert inverse direction to element
	##shcsm2_p['DIRECTION'] = shcsm2_inv_dir

	#set position
	##screw_head_dia = math.tan(math.radians(45)) * shcsm2_p['HEAD_HEIGHT']+shcsm2_p['DIAMETER']/2	
	##s_diff = hd1_p['INS_DEPTH'] - hd1_p['HEIGHT'] + ((hd1_p['DIAMETER_CONE']/2-screw_head_dia)*math.tan(math.radians(45)))
	##VISIGeoLib.ProjectPointOntoVector(shcsm2_p['POSITION'], shcsm2_inv_dir, s_diff, shcsm2_p['POSITION'])	
	
	#Set del cav
	shcsm2_p['CAV_DEL'] = hd1_p['HEIGHT'] - ((hd1_p['DIAMETER_CONE']/2-params['SCREW_HEAD_DIAMETER'])*math.tan(math.radians(45)))-shcsm2_p['HEAD_HEIGHT']
	
	#Create Cavity of screw
	if hd1_p['CAV_SCREW'] == 0:
		shcsm2_p['BUILD_CAVITY'] = 0
		
	shcsm2.key_name = 'PARAM_NG_shcsm2'
	shcsm2.Execute(names, dictionaries)
	## use the following line to put shcsm2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
