import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import llcp2
import llcp1_1
import llcp1_2
import llcp1_3
import llcp1_4
import llcp1_5
import llcp1_6
import llcp2_7
import shcs1
import dp1

def Execute (names, dictionaries):
	global variables
	global params
	global llcp2_p
	global llcp1_1_p
	global llcp1_4_p
	global llcp1_5_p
	global llcp1_6_p
	global llcp2_7_p
	global shcs1_p
	global dp1_p

	llcp2.variables = variables
	llcp1_1.variables = variables
	llcp1_4.variables = variables
	llcp1_5.variables = variables
	llcp1_6.variables = variables
	llcp2_7.variables = variables
	shcs1.variables = variables
	dp1.variables = variables

	params = variables['PARAM_NG_a_llcp2']
	llcp2_p = variables['PARAM_NG_llcp2']
	llcp1_1_p = variables['PARAM_NG_llcp1_1']
	llcp1_4_p = variables['PARAM_NG_llcp1_4']
	llcp1_5_p = variables['PARAM_NG_llcp1_5']
	llcp1_6_p = variables['PARAM_NG_llcp1_6']
	llcp2_7_p = variables['PARAM_NG_llcp2_7']
	shcs1_p = variables['PARAM_NG_shcs1']
	dp1_p = variables['PARAM_NG_dp1']
	
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(llcp2_p['DIRECTION'], llcp2_p['REF_DIRECTION'], y_axis)

	## use the following variable to use llcp2  position
	llcp1_pos = llcp2_p['POSITION']
	## use the following variable to use llcp2  direction
	llcp1_dir = llcp2_p['DIRECTION']

	
	## uncomment following line to disable llcp2 cavity building
	## llcp2_p['BUILD_CAVITY'] = 0
	llcp2.key_name = 'PARAM_NG_llcp2'
	llcp2.Execute(names, dictionaries)
	## use the following line to put llcp2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
	
	index_llcp1_0 = dictionaries.__len__()-1
	element_llcp1_0 = dictionaries[index_llcp1_0]['ELEM_TAG']

	
	if llcp1_1_p['TYPE'] == llcp2_p['TYPE'] and llcp1_1_p['SUB_TYP'] == llcp2_p['SUB_TYP'] and llcp1_1_p['SUB_SUB_TYP'] == llcp2_p['SUB_SUB_TYP']:
		## use the following variable to use llcp1_1  position
		llcp1_1_pos = llcp1_1_p['POSITION']
		## use the following variable to use llcp1_1  direction
		llcp1_1_dir = llcp1_1_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable llcp1_1 cavity building
		## llcp1_1_p['BUILD_CAVITY'] = 0
		llcp1_1.key_name = 'PARAM_NG_llcp1_1'
		llcp1_1.Execute(names, dictionaries)
		## use the following line to put llcp1_1 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if llcp1_4_p['TYPE'] == llcp2_p['TYPE'] and llcp1_4_p['SUB_TYP'] == llcp2_p['SUB_TYP'] and llcp1_4_p['SUB_SUB_TYP'] == llcp2_p['SUB_SUB_TYP']:
		## use the following variable to use llcp1_4  position
		llcp1_4_pos = llcp1_4_p['POSITION']
		## use the following variable to use llcp1_4  direction
		llcp1_4_dir = llcp1_4_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable llcp1_4 cavity building
		## llcp1_4_p['BUILD_CAVITY'] = 0
		llcp1_4.key_name = 'PARAM_NG_llcp1_4'
		llcp1_4.Execute(names, dictionaries)
		## use the following line to put llcp1_4 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
		
		## put additional member contraints
		VISIGeoLib.ProjectPointOntoVector(llcp1_4_p['POSITION'], y_axis, -llcp1_4_p['LENGTH']-2*0.1/1000-llcp2_7_p['WIDTH5'], llcp1_4_p['POSITION'])
		
		## uncomment following line to disable llcp1_4 cavity building
		## llcp1_4_p['BUILD_CAVITY'] = 0
		llcp1_4.key_name = 'PARAM_NG_llcp1_4'
		llcp1_4.Execute(names, dictionaries)

	if llcp1_5_p['TYPE'] == llcp2_p['TYPE'] and llcp1_5_p['SUB_TYP'] == llcp2_p['SUB_TYP'] and llcp1_5_p['SUB_SUB_TYP'] == llcp2_p['SUB_SUB_TYP']:
		## use the following variable to use llcp1_5  position
		llcp1_5_pos = llcp1_5_p['POSITION']
		## use the following variable to use llcp1_5  direction
		llcp1_5_dir = llcp1_5_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable llcp1_5 cavity building
		## llcp1_5_p['BUILD_CAVITY'] = 0
		llcp1_5.key_name = 'PARAM_NG_llcp1_5'
		llcp1_5.Execute(names, dictionaries)
		## use the following line to put llcp1_5 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if llcp1_6_p['TYPE'] == llcp2_p['TYPE'] and llcp1_6_p['SUB_TYP'] == llcp2_p['SUB_TYP'] and llcp1_6_p['SUB_SUB_TYP'] == llcp2_p['SUB_SUB_TYP']:
		## use the following variable to use llcp1_6  position
		llcp1_6_pos = llcp1_6_p['POSITION']
		## use the following variable to use llcp1_6  direction
		llcp1_6_dir = llcp1_6_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable llcp1_6 cavity building
		## llcp1_6_p['BUILD_CAVITY'] = 0
		llcp1_6.key_name = 'PARAM_NG_llcp1_6'
		llcp1_6.Execute(names, dictionaries)
		## use the following line to put llcp1_6 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if llcp2_7_p['TYPE'] == llcp2_p['TYPE'] and llcp2_7_p['SUB_TYP'] == llcp2_p['SUB_TYP'] and llcp2_7_p['SUB_SUB_TYP'] == llcp2_p['SUB_SUB_TYP']:
		## use the following variable to use llcp2_7  position
		llcp2_7_pos = llcp2_7_p['POSITION']
		## use the following variable to use llcp2_7  direction
		llcp2_7_dir = llcp2_7_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable llcp2_7 cavity building
		## llcp2_7_p['BUILD_CAVITY'] = 0
		llcp2_7.key_name = 'PARAM_NG_llcp2_7'
		llcp2_7.Execute(names, dictionaries)
		## use the following line to put llcp2_7 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcs1  position
	shcs1_pos = shcs1_p['POSITION']
	## use the following variable to use shcs1  direction
	shcs1_dir = shcs1_p['DIRECTION']

	## put additional member contraints

	
	if llcp1_6_p['DIAMETER_SINK1']:
		shcs1_p['START_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK1']
		shcs1_p['END_THICK'] = 100./1000
		shcs1_p['TOTAL_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK1']+100./1000
		# 1
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, llcp1_6_p['LENGTH6']/2, shcs1_p['POSITION'])
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], llcp1_6_p['DIRECTION'], llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_LOW']-llcp1_6_p['HEIGHT_SINK1'], shcs1_p['POSITION'])
		
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		
		#2
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, -llcp1_6_p['LENGTH6'], shcs1_p['POSITION'])
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		
	else:
		if llcp1_6_p['LENGTH4']:
		
			shcs1_p['START_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK2']
			shcs1_p['END_THICK'] = 100./1000
			shcs1_p['TOTAL_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK2']+100./1000
			
			#Sink 1
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, llcp1_6_p['LENGTH4']/2, shcs1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], llcp1_6_p['DIRECTION'], llcp1_6_p['HEIGHT1']- llcp1_6_p['HEIGHT_LOW']-llcp1_6_p['HEIGHT_SINK2'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
			
			#Sink2
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, -llcp1_6_p['LENGTH4'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
			
		else:
		
			shcs1_p['START_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK2']
			shcs1_p['END_THICK'] = 100./1000
			shcs1_p['TOTAL_THICK'] = llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_SINK2']+100./1000
			
			#Sink 1
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis,  llcp1_6_p['LENGTH1']/2, shcs1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], llcp1_6_p['REF_DIRECTION'], -llcp1_6_p['WIDTH1']/2, shcs1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], llcp1_6_p['DIRECTION'], llcp1_6_p['HEIGHT1']-llcp1_6_p['HEIGHT_LOW']-llcp1_6_p['HEIGHT_SINK2'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
			
			#Sink2
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, -llcp1_6_p['LENGTH1'], shcs1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], llcp1_6_p['REF_DIRECTION'], llcp1_6_p['WIDTH1'], shcs1_p['POSITION'])
			shcs1.key_name = 'PARAM_NG_shcs1'
			shcs1.Execute(names, dictionaries)
	
	
	dp1_p['START_PLATE'] = element_llcp1_0
	dp1_p['END_PLATE'] = 0
	
	if not llcp1_6_p['DIAMETER_SINK1']:
		VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], llcp2_p['DIRECTION'], -dp1_p['LENGTH']/2, dp1_p['POSITION'])
		if llcp1_6_p['LENGTH4']:
			#Drill1
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], y_axis, llcp1_6_p['LENGTH1']/2, dp1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], llcp1_6_p['REF_DIRECTION'], llcp1_6_p['WIDTH1']/2, dp1_p['POSITION'])
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			
			index_dp1 = dictionaries.__len__()-1
			cav_dp1 = dictionaries[index_dp1]['CAVITY_TAG']
			
			#Cut Cavity
			Front_Body_List = []
			Back_Body_List = []
			VISISolidFactory.CutWithPlane( llcp2_p['POSITION'], llcp2_p['DIRECTION'], cav_dp1, Front_Body_List, Back_Body_List)
			cav_dp1 = Back_Body_List[0]
			dictionaries[index_dp1]['CAVITY_TAG'] = cav_dp1
			
			#Delete 
			part4 = Front_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)
			
			#Drill2
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], y_axis, -llcp1_6_p['LENGTH1'], dp1_p['POSITION'])
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			
			index_dp1 = dictionaries.__len__()-1
			cav_dp1 = dictionaries[index_dp1]['CAVITY_TAG']
			
			#Cut Cavity
			Front_Body_List = []
			Back_Body_List = []
			VISISolidFactory.CutWithPlane( llcp2_p['POSITION'], llcp2_p['DIRECTION'], cav_dp1, Front_Body_List, Back_Body_List)
			cav_dp1 = Back_Body_List[0]
			dictionaries[index_dp1]['CAVITY_TAG'] = cav_dp1
			
			#Delete 
			part4 = Front_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)
			
			#Drill3
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], llcp1_6_p['REF_DIRECTION'], -llcp1_6_p['WIDTH1'], dp1_p['POSITION'])
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			
			index_dp1 = dictionaries.__len__()-1
			cav_dp1 = dictionaries[index_dp1]['CAVITY_TAG']
			
			#Cut Cavity
			Front_Body_List = []
			Back_Body_List = []
			VISISolidFactory.CutWithPlane( llcp2_p['POSITION'], llcp2_p['DIRECTION'], cav_dp1, Front_Body_List, Back_Body_List)
			cav_dp1 = Back_Body_List[0]
			dictionaries[index_dp1]['CAVITY_TAG'] = cav_dp1
			
			#Delete 
			part4 = Front_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)
			
			#Drill4
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], y_axis, llcp1_6_p['LENGTH1'], dp1_p['POSITION'])
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			
			index_dp1 = dictionaries.__len__()-1
			cav_dp1 = dictionaries[index_dp1]['CAVITY_TAG']
			
			#Cut Cavity
			Front_Body_List = []
			Back_Body_List = []
			VISISolidFactory.CutWithPlane( llcp2_p['POSITION'], llcp2_p['DIRECTION'], cav_dp1, Front_Body_List, Back_Body_List)
			cav_dp1 = Back_Body_List[0]
			dictionaries[index_dp1]['CAVITY_TAG'] = cav_dp1
			
			#Delete 
			part4 = Front_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)
			
		else:
			
			#Drill 1
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], y_axis,  llcp1_6_p['LENGTH1']/2, dp1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], llcp1_6_p['REF_DIRECTION'], llcp1_6_p['WIDTH1']/2, dp1_p['POSITION'])
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			
			index_dp1 = dictionaries.__len__()-1
			cav_dp1 = dictionaries[index_dp1]['CAVITY_TAG']
			
			#Cut Cavity
			Front_Body_List = []
			Back_Body_List = []
			VISISolidFactory.CutWithPlane( llcp2_p['POSITION'], llcp2_p['DIRECTION'], cav_dp1, Front_Body_List, Back_Body_List)
			cav_dp1 = Back_Body_List[0]
			dictionaries[index_dp1]['CAVITY_TAG'] = cav_dp1
			
			#Delete 
			part4 = Front_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)
			
			#Drill 2
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], y_axis, -llcp1_6_p['LENGTH1'], dp1_p['POSITION'])
			VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], llcp1_6_p['REF_DIRECTION'], -llcp1_6_p['WIDTH1'], dp1_p['POSITION'])
			
			dp1.key_name = 'PARAM_NG_dp1'
			dp1.Execute(names, dictionaries)
			
			index_dp1 = dictionaries.__len__()-1
			cav_dp1 = dictionaries[index_dp1]['CAVITY_TAG']
			
			#Cut Cavity
			Front_Body_List = []
			Back_Body_List = []
			VISISolidFactory.CutWithPlane( llcp2_p['POSITION'], llcp2_p['DIRECTION'], cav_dp1, Front_Body_List, Back_Body_List)
			cav_dp1 = Back_Body_List[0]
			dictionaries[index_dp1]['CAVITY_TAG'] = cav_dp1
			
			#Delete 
			part4 = Front_Body_List[0]
			del_list = [part4]
			VISISolidFactory.DeleteBodies(del_list)

	## use the following variable to use dp1  position
	dp1_pos = dp1_p['POSITION']
	## use the following variable to use dp1  direction
	dp1_dir = dp1_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable dp1 cavity building
	## dp1_p['BUILD_CAVITY'] = 0
	#dp1.key_name = 'PARAM_NG_dp1'
	#dp1.Execute(names, dictionaries)
	## use the following line to put dp1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
