import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import ls1_1
import shcs3

def Execute (names, dictionaries):
	global variables
	global params
	global ls1_1_p
	global shcs3_p

	ls1_1.variables = variables
	shcs3.variables = variables

	params = variables['PARAM_NG_a_ls1_1']
	ls1_1_p = variables['PARAM_NG_ls1_1']
	shcs3_p = variables['PARAM_NG_shcs3']
	
	

	## use the following variable to use ls1_1  position
	ls1_1_pos = ls1_1_p['POSITION']
	## use the following variable to use ls1_1  direction
	ls1_1_dir = ls1_1_p['DIRECTION']

	## uncomment following line to disable ls1_1 cavity building
	## ls1_1_p['BUILD_CAVITY'] = 0
	ls1_1.key_name = 'PARAM_NG_ls1_1'
	ls1_1.Execute(names, dictionaries)
	
	index_ls1_1 = dictionaries.__len__()-1
	ls1_1_element = dictionaries[index_ls1_1]['ELEM_TAG']
	
	## use the following line to put ls1_1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcs3  position
	shcs3_pos = shcs3_p['POSITION']
	shcs3_dir = shcs3_p['DIRECTION']
	
	start_pos = VISIPoint.New()
	start_pos.Set(ls1_1_p['POSITION'].x(), ls1_1_p['POSITION'].y(), ls1_1_p['POSITION'].z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(ls1_1_p['DIRECTION'], x_axis)
	
	rot_angle = ls1_1_p['ROT_ANGLE']
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, ls1_1_p['DIRECTION'], x_axis, rot_angle-math.radians(180))
	
	shcs3_p['HEAD_THICK_CLEAR'] = 0.4/1000

	VISIGeoLib.ProjectPointOntoVector(shcs3_p['POSITION'], x_axis, ls1_1_p['DISTANCE_SCREW_HOLES']/2, shcs3_p['POSITION'])

	shcs3_p['BUILD_CAVITY'] = 0
	
	shcs3.key_name = 'PARAM_NG_shcs3'
	shcs3.Execute(names, dictionaries)

	index_shcs3 = dictionaries.__len__()-1
	end_screw_cavity = shcs3.CreateEndPlateHole(dictionaries[index_shcs3]['ELEM_TAG'])
	dictionaries[index_shcs3]['CAVITY_TAG'] = end_screw_cavity
	
	start_screw_cavity = shcs3.CreateStartPlateHole(dictionaries[index_shcs3]['ELEM_TAG'])
	
	VISIGeoLib.ProjectPointOntoVector(shcs3_p['POSITION'], x_axis, -ls1_1_p['DISTANCE_SCREW_HOLES'], shcs3_p['POSITION'])

	shcs3.key_name = 'PARAM_NG_shcs3'
	shcs3.Execute(names, dictionaries)
	
	index_shcs3_1 = dictionaries.__len__()-1
	end_screw_cavity_1 = shcs3.CreateEndPlateHole(dictionaries[index_shcs3_1]['ELEM_TAG'])
	dictionaries[index_shcs3_1]['CAVITY_TAG'] = end_screw_cavity_1
	
	start_screw_cavity_1 = shcs3.CreateStartPlateHole(dictionaries[index_shcs3_1]['ELEM_TAG'])

	Uni_List = []
	Result_List = []
	Uni_List.append(ls1_1_element)
	Uni_List.append(start_screw_cavity)
	Uni_List.append(start_screw_cavity_1)
	
	VISISolidFactory.Subtract(Uni_List, Result_List)
	## Assign the result of subtraction to column tag
	dictionaries[index_ls1_1]['ELEM_TAG'] = Result_List[0]
	
	return 0
