import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import pcylaz7
import shcs1
import pcylaz7_ring

def Execute (names, dictionaries):
	global variables
	global params
	global pcylaz7_p
	global shcs1_p
	global pcylaz7_ring_p

	pcylaz7.variables = variables
	shcs1.variables = variables
	pcylaz7_ring.variables = variables
	pcylaz7_ring_p = variables['PARAM_NG_pcylaz7_ring']
	
	params = variables['PARAM_NG_a_pcylaz3']
	pcylaz7_p = variables['PARAM_NG_pcylaz7']
	shcs1_p = variables['PARAM_NG_shcs1']
	
	without_fixing = params['WITHOUT_FIXING']
	
	pcylaz7_pos = pcylaz7_p['POSITION']
	pcylaz7_dir = pcylaz7_p['DIRECTION']
	pcylaz7.key_name = 'PARAM_NG_pcylaz7'
	pcylaz7.Execute(names, dictionaries)
	index_pcylaz7 = dictionaries.__len__()-1
	pcylaz7_tag = dictionaries[index_pcylaz7]['ELEM_TAG']
	
	
	
	## use the following variable to use pcylaz7_ring  position
	pcylaz7_ring_pos = pcylaz7_ring_p['POSITION']
	## use the following variable to use pcylaz7_ring  direction
	pcylaz7_ring_dir = pcylaz7_ring_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable pcylaz7_ring cavity building
	## pcylaz7_ring_p['BUILD_CAVITY'] = 0
	#Create the ring of it has a colour
	if not pcylaz7_p['COLOUR_RING'] == "-":
		pcylaz7_ring.key_name = 'PARAM_NG_pcylaz7_ring'
		pcylaz7_ring.Execute(names, dictionaries)
	## use the following line to put pcylaz7_ring cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
	
	i=0

	if(not(without_fixing)):
		#Create a screw until the final amount is reached
		while i < pcylaz7_p['NSCREW']:
			shcs1_p['POSITION'] = pcylaz7.screw_positions[i]
			shcs1_p['BUILD_CAVITY'] = 0
			shcs1_p['key_name'] = 'shcs1'
			shcs1.Execute(names, dictionaries)
			index_shcs1 = dictionaries.__len__()-1
			start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			i = i + 1
			dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity
			#Subtract Screws of Spring to get cavities
			bool_list = []
			result_list = []
			bool_list.append(pcylaz7_tag)
			bool_list.append(end_screw_cavity)
			VISISolidFactory.Subtract(bool_list, result_list)
			## Assign the result of subtraction to column tag
			dictionaries[index_pcylaz7]['ELEM_TAG'] = result_list[0]
		else:
			return 0
		
	return 0
