import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import pcylaz8
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global pcylaz8_p
	global shcs1_p

	pcylaz8.variables = variables
	shcs1.variables = variables
	
	params = variables['PARAM_NG_a_pcylaz4']
	pcylaz8_p = variables['PARAM_NG_pcylaz8']
	shcs1_p = variables['PARAM_NG_shcs1']

	without_fixing = params['WITHOUT_FIXING']
	pcylaz8_pos = pcylaz8_p['POSITION']
	pcylaz8_dir = pcylaz8_p['DIRECTION']
	pcylaz8.key_name = 'PARAM_NG_pcylaz8'
	pcylaz8.Execute(names, dictionaries)
	index_pcylaz8 = dictionaries.__len__()-1
	pcylaz8_tag = dictionaries[index_pcylaz8]['ELEM_TAG']
	
	inner_screws = params['INNER_SCREWS']
	outer_screws = params['OUTER_SCREWS']

	i=0
	
	if(not(without_fixing)):
	#Create a screw until the final amount is reached
	#Different Screw- Sets -> NSCREW1 / NSCREW2
		if inner_screws:
			while i < pcylaz8_p['NSCREW1']:
				shcs1_p['POSITION'] = pcylaz8.screw_positions[i]
				shcs1_p['BUILD_CAVITY'] = 0
				shcs1_p['key_name'] = 'shcs1'
				shcs1.Execute(names, dictionaries)
				index_shcs1 = dictionaries.__len__()-1
				start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
				end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
				i = i + 1
				dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity
				#Subtract Screws of Spring to get cavities
				bool_list = []
				result_list = []
				bool_list.append(pcylaz8_tag)
				bool_list.append(end_screw_cavity)
				VISISolidFactory.Subtract(bool_list, result_list)
				## Assign the result of subtraction to column tag
				dictionaries[index_pcylaz8]['ELEM_TAG'] = result_list[0]
		elif outer_screws:
			while i < pcylaz8_p['NSCREW2']: 
				shcs1_p['POSITION'] = pcylaz8.screw_positions_small[i]
				shcs1_p['BUILD_CAVITY'] = 0
				shcs1_p['key_name'] = 'shcs1'
				shcs1.Execute(names, dictionaries)
				index_shcs1 = dictionaries.__len__()-1
				start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
				end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
				i = i + 1
				dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity
				#Subtract Screws of Spring to get cavities
				bool_list = []
				result_list = []
				bool_list.append(pcylaz8_tag)
				bool_list.append(end_screw_cavity)
				VISISolidFactory.Subtract(bool_list, result_list)
				## Assign the result of subtraction to column tag
				dictionaries[index_pcylaz8]['ELEM_TAG'] = result_list[0]
		
	return 0
