import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import pbc11
import jlp3
import shcsm
import pspr6
import r5

def Execute (names, dictionaries):
	global variables
	global params
	global pbc11_p
	global jlp3_p
	global shcsm_p
	global pspr6_p
	global r5_p
	global shcsm_1_p

	pbc11.variables = variables
	jlp3.variables = variables
	shcsm.variables = variables
	pspr6.variables = variables
	r5.variables = variables

	params = variables['PARAM_NG_a_pushgui2']
	pbc11_p = variables['PARAM_NG_pbc11']
	jlp3_p = variables['PARAM_NG_jlp3']
	shcsm_p = variables['PARAM_NG_shcsm']
	pspr6_p = variables['PARAM_NG_pspr6']
	r5_p = variables['PARAM_NG_r5']
	shcsm_1_p = variables['PARAM_NG_shcsm_1']
	
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(pbc11_p['DIRECTION'], x_axis)

	#Create Bush
	pbc11_pos = pbc11_p['POSITION']
	pbc11_dir = pbc11_p['DIRECTION']

	pbc11.key_name = 'PARAM_NG_pbc11'
	pbc11.Execute(names, dictionaries)


	#Create Column
	inv_dir = VISIVector.New()
	inv_dir.Set(-jlp3_p['DIRECTION'].Cx(), -jlp3_p['DIRECTION'].Cy(), -jlp3_p['DIRECTION'].Cz())
	
	jlp3_pos = jlp3_p['POSITION']
	jlp3_p['DIRECTION'] = inv_dir
	VISIGeoLib.ProjectPointOntoVector(jlp3_p['POSITION'], pbc11_p['DIRECTION'], -pbc11_p['LENGTH_OUT']-pspr6_p['TOTAL_LENGTH']+r5_p['HEIGHT_DOWN']+params['PRELOAD_REAL'] , jlp3_p['POSITION'])
	jlp3.key_name = 'PARAM_NG_jlp3'
	jlp3.Execute(names, dictionaries)


	#Create Screw
	#Head Screw
	shcsm_pos = shcsm_p['POSITION']
	shcsm_dir = shcsm_p['DIRECTION']
	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], pbc11_p['DIRECTION'], -pspr6_p['TOTAL_LENGTH'] -r5_p['HEIGHT']+r5_p['HEIGHT_DOWN']+r5_p['HEAD_HEIGHT']+params['PRELOAD_REAL'], shcsm_p['POSITION'])
	shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	
	
	#Bush Screws
	#Screw 1
	

	VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, pbc11_p['SCREW_DISTANCE']/2, shcsm_1_p['POSITION'])
	
	
	shcsm_1_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm_1'
	#shcsm.Execute(names, dictionaries)
	
	#Screw 2
	shcsm_pos = shcsm_p['POSITION']
	shcsm_dir = shcsm_p['DIRECTION']

	VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], x_axis, - pbc11_p['SCREW_DISTANCE'], shcsm_1_p['POSITION'])
	shcsm_1_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm_1'
	#shcsm.Execute(names, dictionaries)
	

	#Create Spring
	pspr6_pos = pspr6_p['POSITION']
	pspr6_dir = pspr6_p['DIRECTION']
	VISIGeoLib.ProjectPointOntoVector(pspr6_p['POSITION'], pbc11_p['DIRECTION'], params['MAIN_DIAMETER']+params['PRELOAD_REAL'], pspr6_p['POSITION'])
	pspr6_p['BUILD_CAVITY'] = 0
	pspr6.key_name = 'PARAM_NG_pspr6'
	pspr6.Execute(names, dictionaries)

	#Create Head
	r5_pos = r5_p['POSITION']
	r5_dir = r5_p['DIRECTION']
	VISIGeoLib.ProjectPointOntoVector(r5_p['POSITION'], pbc11_p['DIRECTION'], -pspr6_p['TOTAL_LENGTH']-r5_p['HEIGHT']+r5_p['HEIGHT_DOWN']+params['PRELOAD_REAL'], r5_p['POSITION'])
	
	r5.key_name = 'PARAM_NG_r5'
	r5.Execute(names, dictionaries)


	return 0
