import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import sd1
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global sd1_p
	global shcsm_p

	sd1.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_sd1']
	sd1_p = variables['PARAM_NG_sd1']
	shcsm_p = variables['PARAM_NG_shcsm']

	## use the following variable to use sd1  position
	sd1_pos = sd1_p['POSITION']
	## use the following variable to use sd1  direction
	sd1_dir = sd1_p['DIRECTION']

	## uncomment following line to disable sd1 cavity building
	## sd1_p['BUILD_CAVITY'] = 0
	sd1.key_name = 'PARAM_NG_sd1'
	sd1.Execute(names, dictionaries)
	## use the following line to put sd1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm  position
	shcsm_pos = shcsm_p['POSITION']
	## use the following variable to use shcsm  direction
	shcsm_dir = shcsm_p['DIRECTION']

	if params['CREATE_SCREW']:
		## put additional member contraints
		VISIGeoLib.ProjectPointOntoVector(shcsm_pos, sd1_dir, sd1_p['LENGTH']-sd1_p['LENGTH_HEAD']-sd1_p['GRINDING'], shcsm_pos)

		## uncomment following line to disable shcsm cavity building
		## shcsm_p['BUILD_CAVITY'] = 0
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)
		## use the following line to put shcsm cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
