import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import sh1
import shcs1
import gs6
import dp1
import shcs4

def Execute (names, dictionaries):
	global variables
	global params
	global sh1_p
	global shcs1_p
	global gs6_p
	global dp1_p
	global shcs4_p
	global gs6_1_p

	sh1.variables = variables
	shcs1.variables = variables
	gs6.variables = variables
	dp1.variables = variables
	shcs4.variables = variables

	params = variables['PARAM_NG_a_sh1']
	sh1_p = variables['PARAM_NG_sh1']
	shcs1_p = variables['PARAM_NG_shcs1']
	gs6_p = variables['PARAM_NG_gs6']
	dp1_p = variables['PARAM_NG_dp1']
	shcs4_p = variables['PARAM_NG_shcs4']
	gs6_1_p = variables['PARAM_NG_gs6_1']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	Result_List2 = []

	## use the following variable to use sh1  position
	sh1_pos = sh1_p['POSITION']
	## use the following variable to use sh1  direction
	sh1_dir = sh1_p['DIRECTION']

	sh1.key_name = 'PARAM_NG_sh1'
	sh1.Execute(names, dictionaries)
	
	cav_sh1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
	Uni_list.append(cav_sh1)
	
	elem_sh1 = dictionaries[dictionaries.__len__()-1]['ELEM_TAG']
	Uni_list2.append(elem_sh1)
	
	#Create Screw in Middle
	#For type 1 and 2: SN3500
	#For type 3: iso 7379
	if not sh1_p['TYPE'] == 3:
		shcs1_pos = shcs1_p['POSITION']
		shcs1_dir = shcs1_p['DIRECTION']

		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], shcs1_p['DIRECTION'], -sh1_p['HEIGHT'], shcs1_p['POSITION'])
		
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
	else:
		shcs4_pos = shcs4_p['POSITION']
		shcs4_dir = shcs4_p['DIRECTION']

		shcs4.key_name = 'PARAM_NG_shcs4'
		shcs4.Execute(names, dictionaries)
	
	if not params['FIXING_W_PINS'] and not sh1_p['TYPE'] == 3:
		#1 Screw
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], sh1_p['X_DIRECTION'], -sh1_p['DISTANCE1'], shcs1_p['POSITION'])
	
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		
		#2 Screw
		VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], sh1_p['X_DIRECTION'], 2*sh1_p['DISTANCE1']+sh1_p['DISTANCE2'], shcs1_p['POSITION'])
	
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		
	else:
		dp1_pos = dp1_p['POSITION']
		dp1_dir = dp1_p['DIRECTION']
		
		#1 Dowel Pin
		VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], sh1_p['X_DIRECTION'], -sh1_p['DISTANCE1'], dp1_p['POSITION'])

		dp1.key_name = 'PARAM_NG_dp1'
		dp1.Execute(names, dictionaries)
		
		#2 Dowel Pin
		VISIGeoLib.ProjectPointOntoVector(dp1_p['POSITION'], sh1_p['X_DIRECTION'], 2*sh1_p['DISTANCE1']+sh1_p['DISTANCE2'], dp1_p['POSITION'])
		
		dp1.key_name = 'PARAM_NG_dp1'
		dp1.Execute(names, dictionaries)
		
	#Create ball catch in start plate only for typ 1 and 2
	#In case of type 3, create element reverse
	if not sh1_p['TYPE'] == 3:
		gs6_pos = gs6_p['POSITION']
		gs6_dir = gs6_p['DIRECTION']
		VISIGeoLib.ProjectPointOntoVector(gs6_p['POSITION'], sh1_p['X_DIRECTION'], sh1_p['DIAMETER_CIRCLE']/2, gs6_p['POSITION'])
		gs6.key_name = 'PARAM_NG_gs6'
		gs6.Execute(names, dictionaries)
	else:
		gs6_1_pos = gs6_1_p['POSITION']
		gs6_1_dir = gs6_1_p['DIRECTION']
		
		if sh1_p['CHECK_OPEN']:
			VISIGeoLib.ProjectPointOntoVector(gs6_1_p['POSITION'], sh1_p['X_DIRECTION'], 10./1000, gs6_1_p['POSITION'])
		else:
			VISIGeoLib.ProjectPointOntoVector(gs6_1_p['POSITION'], sh1_p['X_DIRECTION'], -10./1000, gs6_1_p['POSITION'])
		gs6.key_name = 'PARAM_NG_gs6_1'
		gs6.Execute(names, dictionaries)
		
		cav_gs6 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
		Uni_list2.append(cav_gs6)
		dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = 0
		
		if sh1_p['CHECK_OPEN']:
			VISIGeoLib.ProjectPointOntoVector(gs6_1_p['POSITION'], sh1_p['X_DIRECTION'], -20./1000, gs6_1_p['POSITION'])
			
			
		gs6_1_p['BUILD_ELEM'] = 0
		gs6.key_name = 'PARAM_NG_gs6_1'
		gs6.Execute(names, dictionaries)
		
		cav_gs6_1 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
		Uni_list.append(cav_gs6_1)
		
		
		#Create the second element only as cavity
		y_axis = VISIVector.New()
		VISIGeoLib.naXb(sh1_p['DIRECTION'], sh1_p['X_DIRECTION'], y_axis)
	
		gs6_1_p['BUILD_ELEM'] = 0
		VISIGeoLib.ProjectPointOntoVector(gs6_1_p['POSITION'], sh1_p['X_DIRECTION'], 10./1000, gs6_1_p['POSITION'])
		VISIGeoLib.ProjectPointOntoVector(gs6_1_p['POSITION'], y_axis, -10./1000, gs6_1_p['POSITION'])
		gs6.key_name = 'PARAM_NG_gs6_1'
		gs6.Execute(names, dictionaries)
		
		cav_gs6_2 = dictionaries[dictionaries.__len__()-1]['CAVITY_TAG']
		Uni_list.append(cav_gs6_2)
		
		#Unite
		VISISolidFactory.Unite(Uni_list, Result_List)
		
		#Subtract
		VISISolidFactory.Subtract(Uni_list2, Result_List2)
		
		
		

	return 0
