import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import shim2
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global shim2_p
	global shcsm_p

	shim2.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_shim2']
	shim2_p = variables['PARAM_NG_shim2']
	shcsm_p = variables['PARAM_NG_shcsm']
	
	check_screw = params['CREATE_SCREWS']

	## use the following variable to use shim2  position
	shim2_pos = shim2_p['POSITION']
	## use the following variable to use shim2  direction
	shim2_dir = shim2_p['DIRECTION']

	## uncomment following line to disable shim2 cavity building
	## shim2_p['BUILD_CAVITY'] = 0
	shim2.key_name = 'PARAM_NG_shim2'
	shim2.Execute(names, dictionaries)
	## use the following line to put shim2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if check_screw:
		x_axis = VISIVector.New()
		VISIGeoLib.ArbitraryNormalAxis(shim2_p['DIRECTION'], x_axis)
		y_axis = VISIVector.New()
		VISIGeoLib.naXb(shim2_p['DIRECTION'], x_axis, y_axis)
	
		if(shim2_p['ROT_ANGLE'] <> 0):
			VISIGeoLib.VectorRotate(x_axis, shim2_p['DIRECTION'], x_axis, shim2_p['ROT_ANGLE'])
			VISIGeoLib.VectorRotate(y_axis, shim2_p['DIRECTION'], y_axis, shim2_p['ROT_ANGLE'])
			
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis,shim2_p['DIST_HOLES']/2 , shcsm_p['POSITION'])

		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)

		
		VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], x_axis,-shim2_p['DIST_HOLES'] , shcsm_p['POSITION'])
		
		shcsm.key_name = 'PARAM_NG_shcsm'
		shcsm.Execute(names, dictionaries)

	return 0
