import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import sldguide1_only_screw
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global sldguide1_only_screw_p
	global sldguide1_only_screw_1_p
	global shcs1_p
	global shcs1_1_p

	sldguide1_only_screw.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_sldguide1_only_screw']
	sldguide1_only_screw_p = variables['PARAM_NG_sldguide1_only_screw']
	sldguide1_only_screw_1_p = variables['PARAM_NG_sldguide1_only_screw_1']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']

	left = params['LEFT']
	right = params['RIGHT']
	build_fixing = params['BUILD_FIXING']

	if (left):
		sldguide1_only_screw_pos = sldguide1_only_screw_p['POSITION']
		sldguide1_only_screw_dir = sldguide1_only_screw_p['DIRECTION']
		sldguide1_only_screw.key_name = 'PARAM_NG_sldguide1_only_screw'
		sldguide1_only_screw.Execute(names, dictionaries)

		if (build_fixing):
			shcs1_pos = shcs1_p['POSITION']
			shcs1_dir = shcs1_p['DIRECTION']
			sldguide1_only_screw_ref_dir = sldguide1_only_screw_p['REF_DIRECTION']
			sldguide1_only_screw_screw_distance = sldguide1_only_screw_p['SCREW_DISTANCE']
			sldguide1_only_screw_screw_distance2 = sldguide1_only_screw_p['SCREW_DISTANCE2']
			sldguide1_only_screw_screw_number = sldguide1_only_screw_p['SCREW_NUMBER']
			sldguide1_only_screw_pos_offset = sldguide1_only_screw_p['POS_OFFSET']
			
			if (sldguide1_only_screw_screw_number == 3):
				screw_distance_left= sldguide1_only_screw_screw_distance
			else:
				screw_distance_left= sldguide1_only_screw_screw_distance/2

			tmp_pos = VISIPoint.New()
			center_pos = VISIPoint.New()
			center_pos.Set(shcs1_pos.x(), shcs1_pos.y(), shcs1_pos.z())
			shcs1.key_name = 'PARAM_NG_shcs1'
			
			VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_ref_dir,
							  - screw_distance_left + sldguide1_only_screw_pos_offset, tmp_pos)
			shcs1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
			##create the left screw of the left guide rail
			shcs1.Execute(names, dictionaries)

			if (sldguide1_only_screw_screw_number == 3):
				#shcs1_pos.Set(center_pos.x(), center_pos.y(), center_pos.z())
				VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_ref_dir,
							  sldguide1_only_screw_pos_offset, tmp_pos)
				shcs1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
				##create the center screw of the left guide rail
				shcs1.Execute(names, dictionaries)

			if (sldguide1_only_screw_screw_number == 4):
				VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_ref_dir,
							  - sldguide1_only_screw_screw_distance2 / 2 + sldguide1_only_screw_pos_offset, tmp_pos)
				shcs1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
				shcs1.Execute(names, dictionaries)

				VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_ref_dir,
							  sldguide1_only_screw_screw_distance2 / 2 - sldguide1_only_screw_pos_offset, tmp_pos)
				shcs1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
				shcs1.Execute(names, dictionaries)

			VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_ref_dir,
							  screw_distance_left + sldguide1_only_screw_pos_offset, tmp_pos)
			shcs1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
			##create the left screw of the left guide rail
			shcs1.Execute(names, dictionaries)

	if (right):
		sldguide1_only_screw_1_pos = sldguide1_only_screw_1_p['POSITION']
		sldguide1_only_screw_1_dir = sldguide1_only_screw_1_p['DIRECTION']
		sldguide1_only_screw.key_name = 'PARAM_NG_sldguide1_only_screw_1'
		sldguide1_only_screw.Execute(names, dictionaries)
		
		if (build_fixing):
			shcs1_1_pos = shcs1_1_p['POSITION']
			shcs1_1_dir = shcs1_1_p['DIRECTION']
			sldguide1_only_screw_1_ref_dir = sldguide1_only_screw_1_p['REF_DIRECTION']
			sldguide1_only_screw_1_screw_distance = sldguide1_only_screw_1_p['SCREW_DISTANCE']
			sldguide1_only_screw_1_screw_distance2 = sldguide1_only_screw_1_p['SCREW_DISTANCE2']
			sldguide1_only_screw_1_screw_number = sldguide1_only_screw_1_p['SCREW_NUMBER']
			sldguide1_only_screw_1_pos_offset = sldguide1_only_screw_1_p['POS_OFFSET']
			
			if (sldguide1_only_screw_1_screw_number == 3):
				screw_distance_right= sldguide1_only_screw_1_screw_distance
			else:
				screw_distance_right= sldguide1_only_screw_1_screw_distance/2
			

			tmp_pos = VISIPoint.New()
			center_pos = VISIPoint.New()
			center_pos.Set(shcs1_1_pos.x(), shcs1_1_pos.y(), shcs1_1_pos.z())
			shcs1.key_name = 'PARAM_NG_shcs1_1'

			VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_1_ref_dir,
							  screw_distance_right + sldguide1_only_screw_1_pos_offset, tmp_pos)
			shcs1_1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
			##create the left screw of the right guide rail
			shcs1.Execute(names, dictionaries)

			if (sldguide1_only_screw_1_screw_number == 3):
				#shcs1_1_pos.Set(center_pos.x(), center_pos.y(), center_pos.z())
				VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_ref_dir,
							  sldguide1_only_screw_1_pos_offset, tmp_pos)
				shcs1_1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
				##create the center screw of the right guide rail
				shcs1.Execute(names, dictionaries)

			if (sldguide1_only_screw_1_screw_number == 4):
				VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_1_ref_dir,
							  - sldguide1_only_screw_1_screw_distance2 / 2 + sldguide1_only_screw_1_pos_offset, tmp_pos)
				shcs1_1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
				shcs1.Execute(names, dictionaries)

				VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_1_ref_dir,
							  sldguide1_only_screw_1_screw_distance2 / 2 - sldguide1_only_screw_1_pos_offset, tmp_pos)
				shcs1_1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
				shcs1.Execute(names, dictionaries)

			VISIGeoLib.ProjectPointOntoVector(center_pos, sldguide1_only_screw_1_ref_dir,
							  - screw_distance_right + sldguide1_only_screw_1_pos_offset, tmp_pos)
			shcs1_1_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())
			##create the left screw of the right guide rail
			shcs1.Execute(names, dictionaries)

			
	return 0
