import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import sldp3_1
import shcs1
import gs2

def Execute (names, dictionaries):
	global variables
	global params
	global sldp3_1_p
	global shcs1_p
	global gs2_p

	sldp3_1.variables = variables
	shcs1.variables = variables
	gs2.variables = variables

	params = variables['PARAM_NG_a_sldp4']
	sldp3_1_p = variables['PARAM_NG_sldp3_1']
	shcs1_p = variables['PARAM_NG_shcs1']
	gs2_p = variables['PARAM_NG_gs2']

	sldp3_1_pos = sldp3_1_p['POSITION']
	sldp3_1_dir = sldp3_1_p['DIRECTION']
	sldp3_1.key_name = 'PARAM_NG_sldp3_1'
	sldp3_1.Execute(names, dictionaries)
	index_sldp3_1 = dictionaries.__len__()-1
	sldp3_1_tag = dictionaries[index_sldp3_1]['ELEM_TAG']
	
	if (params['CREATE_PIN']):
		## use the following variable to use gs2  position
		gs2_pos = gs2_p['POSITION']
		## use the following variable to use gs2  direction
		gs2_dir = gs2_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable gs2 cavity building
		## gs2_p['BUILD_CAVITY'] = 0
		gs2.key_name = 'PARAM_NG_gs2'
		gs2.Execute(names, dictionaries)
		index_gs2 = dictionaries.__len__()-1
		gs2_cav_tag = dictionaries[index_gs2]['CAVITY_TAG']
		## use the following line to put gs2 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag
		
		## keep a copy the original GS2 cavity; we'll need this to make the hole in the column
		gs2_cav_copy = VISISolidFactory.Copy(gs2_cav_tag)
		
		## make a copy of the column to get only the cavity that we need for the GS2
		sldp3_1_copy = VISISolidFactory.Copy(sldp3_1_tag)
		
		## now let's subtract the column copy from the cavity
		bool_list       = []
		result_list     = []
		bool_list.append(gs2_cav_tag)
		bool_list.append(sldp3_1_copy)
		VISISolidFactory.Subtract(bool_list, result_list)

		## Assign the result of subtraction to GS2 cavity
		dictionaries[index_gs2]['CAVITY_TAG'] = result_list[0]

		## now let's subtract the cavity copy from the column
		bool_list       = []
		result_list     = []
		bool_list.append(sldp3_1_tag)
		bool_list.append(gs2_cav_copy)
		VISISolidFactory.Subtract(bool_list, result_list)
		
		## Assign the result of subtraction to column tag
		dictionaries[index_sldp3_1]['ELEM_TAG'] = result_list[0]

	if (params['CREATE_FIXING']):
	
		shcs1_pos = shcs1_p['POSITION']
		shcs1_dir = shcs1_p['DIRECTION']
		shcs1_p['BUILD_CAVITY'] = 0
		shcs1.key_name = 'PARAM_NG_shcs1'

		if (not params['CREATE_FIXING']):
			shcs1_p['BUILD_ELEM'] = 0
		
		else:
			shcs1_p['BUILD_ELEM'] = 1
					
			shcs1.Execute(names, dictionaries)
			index_shcs1 = dictionaries.__len__()-1

		if (params['CREATE_FIXING']):
			start_screw_cavity = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
			## Screw cavity only in start plate
			dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity
			
		end_screw_cavity = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
		
		bool_list = []
		result_list = []
		bool_list.append(sldp3_1_tag)
		bool_list.append(end_screw_cavity)
		VISISolidFactory.Subtract(bool_list, result_list)
		## Assign the result of subtraction to column tag
		dictionaries[index_sldp3_1]['ELEM_TAG'] = result_list[0]

	return 0
