import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import slfg1
import slfg2
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global slfg1_p
	global slfg2_p
	global shcs1_p
	global shcs1_1_p

	slfg1.variables = variables
	slfg2.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_slfg_2']
	slfg1_p = variables['PARAM_NG_slfg1']
	slfg2_p = variables['PARAM_NG_slfg2']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']

	#tmp_point = params['TMP_POINT']

	slfg1_pos = slfg1_p['POSITION']
	slfg1_dir = slfg1_p['DIRECTION']
	slfg1_ref_dir = slfg1_p['REF_DIRECTION']
	screw_distance_width = slfg1_p['SCREW_DISTANCE_WIDTH']
	start_thick = slfg1_p['START_THICK']
	slfg1_rotation_angle = slfg1_p['ROTATION_ANGLE']
	slfg1_length = slfg1_p['LENGTH']
	#VISIGeoLib.ProjectPointOntoVector(slfg1_p['POSITION'], slfg1_ref_dir, -slfg1_length/2, slfg1_p['POSITION'])
	#slfg1_p['POSITION'] = tmp_point
	slfg1.key_name = 'PARAM_NG_slfg1'
	slfg1.Execute(names, dictionaries)
	index_slfg1 = dictionaries.__len__()-1
	slfg1_tag = dictionaries[index_slfg1]['ELEM_TAG']
	#VISIGeoLib.ProjectPointOntoVector(slfg1_p['POSITION'], slfg1_ref_dir, -slfg1_length/2, slfg1_p['POSITION'])
	
	
	shcs1_pos = shcs1_p['POSITION']
	#shcs1_p['POSITION'] = tmp_point
	shcs1_p['POSITION'] = slfg1_p['POSITION']
	shcs1_dir = shcs1_p['DIRECTION']
	shcs1_p['BUILD_CAVITY'] = 0
        y_axis = VISIVector.New()
	VISIGeoLib.naXb(slfg1_dir, slfg1_ref_dir, y_axis)
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], slfg1_dir, start_thick, shcs1_p['POSITION'])
	#VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], slfg1_dir, -slfg1_p['DISTANCE_BTW_PLATES'], shcs1_p['POSITION'])
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], y_axis, screw_distance_width/2, shcs1_p['POSITION'])
	VISIGeoLib.ProjectPointOntoVector(shcs1_p['POSITION'], slfg1_ref_dir, slfg1_length/2, shcs1_p['POSITION'])
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	index_shcs1 = dictionaries.__len__()-1
	shcs1_tag = dictionaries[index_shcs1]['ELEM_TAG']
	start_screw_cavity1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
	end_screw_cavity1 = shcs1.CreateEndPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
	## Screw cavity only in start plate
	dictionaries[index_shcs1]['CAVITY_TAG'] = end_screw_cavity1

	shcs1_pos = shcs1_p['POSITION']
	shcs1_dir = shcs1_p['DIRECTION']
	shcs1_p['BUILD_CAVITY'] = 0
	VISIGeoLib.ProjectPointOntoVector(shcs1_pos, y_axis, -screw_distance_width, shcs1_pos)
	shcs1.key_name = 'PARAM_NG_shcs1'
	shcs1.Execute(names, dictionaries)
	index_shcs2 = dictionaries.__len__()-1
	shcs2_tag = dictionaries[index_shcs2]['ELEM_TAG']
	start_screw_cavity2 = shcs1.CreateStartPlateHole(dictionaries[index_shcs2]['ELEM_TAG'])
	end_screw_cavity2 = shcs1.CreateEndPlateHole(dictionaries[index_shcs2]['ELEM_TAG'])
	## Screw cavity only in start plate
	dictionaries[index_shcs2]['CAVITY_TAG'] = end_screw_cavity2
	
	
	if not params['CREATE_SCREWS']:
		Input_list=[shcs2_tag,end_screw_cavity2,shcs1_tag,end_screw_cavity1]
		VISISolidFactory.DeleteBodies(Input_list)

	bool_list = []
	result_list = []
	bool_list.append(slfg1_tag)
	bool_list.append(start_screw_cavity1)
	bool_list.append(start_screw_cavity2)
	VISISolidFactory.Subtract(bool_list, result_list)
	## Assign the result of subtraction to column tag
	dictionaries[index_slfg1]['ELEM_TAG'] = result_list[0]

	return 0
