import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import slfg1
import slfg2
import shcs1

def Execute (names, dictionaries):
	global variables
	global params
	global slfg1_p
	global slfg2_p
	global shcs1_p
	global shcs1_1_p

	slfg1.variables = variables
	slfg2.variables = variables
	shcs1.variables = variables

	params = variables['PARAM_NG_a_slfg_3']
	slfg1_p = variables['PARAM_NG_slfg1']
	slfg2_p = variables['PARAM_NG_slfg2']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']

	#tmp_point = params['TMP_POINT']

	slfg1_p['POCKET_MALE_HEIGHT'] = slfg2_p['POCKET_MALE_HEIGHT']
	slfg1_p['POCKET_FEMALE_HEIGHT'] = slfg2_p['POCKET_FEMALE_HEIGHT']
	slfg1_p['CLEARANCE_BODY'] = slfg2_p['CLEARANCE_BODY']
	# # slfg1_pos = slfg1_p['POSITION']
	slfg1_dir = slfg1_p['DIRECTION']
	slfg1_ref_dir = slfg1_p['REF_DIRECTION']
	screw_distance_width = slfg1_p['SCREW_DISTANCE_WIDTH']
	start_thick = slfg1_p['START_THICK']
	# slfg1_rotation_angle = slfg1_p['ROTATION_ANGLE']
	slfg1_length = slfg1_p['LENGTH']
	# #VISIGeoLib.ProjectPointOntoVector(slfg1_p['POSITION'], slfg1_ref_dir, -slfg1_length/2, slfg1_p['POSITION'])
	# #slfg1_p['POSITION'] = tmp_point
	slfg1.key_name = 'PARAM_NG_slfg1'
	slfg1.Execute(names, dictionaries)
	index_slfg1 = dictionaries.__len__()-1
	slfg1_tag = dictionaries[index_slfg1]['ELEM_TAG']
	slfg1_cavtag = dictionaries[index_slfg1]['CAVITY_TAG']
	Input_list=[slfg1_tag]
	VISISolidFactory.DeleteBodies(Input_list)
	#VISIGeoLib.ProjectPointOntoVector(slfg1_p['POSITION'], slfg1_ref_dir, -slfg1_length/2, slfg1_p['POSITION'])
	
	slfg2_pos = slfg2_p['POSITION']
	#slfg2_p['POSITION'] = tmp_point
	slfg2_p['POSITION'] = slfg1_p['POSITION']
	slfg2_dir = slfg2_p['DIRECTION']
	slfg2_ref_dir = slfg2_p['REF_DIRECTION']
	VISIGeoLib.ProjectPointOntoVector(slfg2_p['POSITION'], slfg2_dir, slfg1_p['DISTANCE_BTW_PLATES'], slfg2_p['POSITION'])
	slfg2.key_name = 'PARAM_NG_slfg2'
	slfg2.Execute(names, dictionaries)
	index_slfg2 = dictionaries.__len__()-1
	slfg2_tag = dictionaries[index_slfg2]['ELEM_TAG']
	
	shcs1_1_pos = shcs1_1_p['POSITION']
	#shcs1_1_p['POSITION'] = tmp_point
	shcs1_1_p['POSITION'] = slfg2_p['POSITION']
	shcs1_1_dir = shcs1_1_p['DIRECTION']
	shcs1_1_p['BUILD_CAVITY'] = 0
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(slfg2_dir, slfg2_ref_dir, y_axis)
	
	
	
	VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], slfg2_dir, slfg2_p['START_THICK'], shcs1_1_p['POSITION'])
	VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], y_axis, -slfg2_p['SCREW_DISTANCE_WIDTH']/2, shcs1_1_p['POSITION'])
	VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], slfg2_p['REF_DIRECTION'], slfg2_p['LENGTH']/2, shcs1_1_p['POSITION'])
	
	
	
	
	#VISIGeoLib.ProjectPointOntoVector(shcs1_1_p['POSITION'], slfg1_dir, slfg1_p['DISTANCE_BTW_PLATES'], shcs1_1_p['POSITION'])
	shcs1.key_name = 'PARAM_NG_shcs1_1'
	shcs1.Execute(names, dictionaries)
	index_shcs11 = dictionaries.__len__()-1
	shcs11_tag = dictionaries[index_shcs11]['ELEM_TAG']
	start_screw_cavity11 = shcs1.CreateStartPlateHole(dictionaries[index_shcs11]['ELEM_TAG'])
	end_screw_cavity11 = shcs1.CreateEndPlateHole(dictionaries[index_shcs11]['ELEM_TAG'])
	## Screw cavity only in start plate
	dictionaries[index_shcs11]['CAVITY_TAG'] = end_screw_cavity11

	shcs1_1_pos = shcs1_1_p['POSITION']
	shcs1_1_dir = shcs1_1_p['DIRECTION']
	shcs1_1_p['BUILD_CAVITY'] = 0
	VISIGeoLib.ProjectPointOntoVector(shcs1_1_pos, y_axis, slfg2_p['SCREW_DISTANCE_WIDTH'], shcs1_1_pos)
	shcs1.key_name = 'PARAM_NG_shcs1_1'
	shcs1.Execute(names, dictionaries)
	index_shcs12 = dictionaries.__len__()-1
	shcs12_tag = dictionaries[index_shcs12]['ELEM_TAG']
	start_screw_cavity12 = shcs1.CreateStartPlateHole(dictionaries[index_shcs12]['ELEM_TAG'])
	end_screw_cavity12 = shcs1.CreateEndPlateHole(dictionaries[index_shcs12]['ELEM_TAG'])
	## Screw cavity only in start plate
	dictionaries[index_shcs12]['CAVITY_TAG'] = end_screw_cavity12
	
	
	
	if not params['CREATE_SCREWS']:
		Input_list=[shcs12_tag,end_screw_cavity12,shcs11_tag,end_screw_cavity11]
		VISISolidFactory.DeleteBodies(Input_list)

	bool_list = []
	result_list = []
	bool_list.append(slfg2_tag)
	bool_list.append(start_screw_cavity11)
	bool_list.append(start_screw_cavity12)
	VISISolidFactory.Subtract(bool_list, result_list)
	## Assign the result of subtraction to column tag
	dictionaries[index_slfg2]['ELEM_TAG'] = result_list[0]
	dictionaries[index_slfg2]['CAVITY_TAG'] = slfg1_cavtag

	return 0
