import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import slide5
import sldplate1

def Execute (names, dictionaries):
	global variables
	global params
	global slide5_p
	global sldplate1_p
	global sldplate1_1_p

	slide5.variables = variables
	sldplate1.variables = variables

	params = variables['PARAM_NG_a_slide5']
	slide5_p = variables['PARAM_NG_slide5']
	sldplate1_p = variables['PARAM_NG_sldplate1']
	sldplate1_1_p = variables['PARAM_NG_sldplate1_1']

	one_plate = params['ONE_PLATE']
	two_plates = params['TWO_PLATES']
	
	## use the following variable to use slide5  position
	slide5_pos = slide5_p['POSITION']
	## use the following variable to use slide5  direction
	slide5_dir = slide5_p['DIRECTION']
	slide5_base_width = slide5_p['BASE_WIDTH']
	slide5_inserting_depth = slide5_p['INSERTING_DEPTH']
	slide5_offset = slide5_p['OFFSET']
	
	## uncomment following line to disable slide5 cavity building
	## slide5_p['BUILD_CAVITY'] = 0
	slide5.key_name = 'PARAM_NG_slide5'
	slide5.Execute(names, dictionaries)
	## use the following line to put slide5 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	y_axis = VISIVector.New()
	
	if (one_plate or two_plates):
		## use the following variable to use sldplate1  position
		sldplate1_pos = sldplate1_p['POSITION']
		## use the following variable to use sldplate1  direction
		sldplate1_dir = sldplate1_p['DIRECTION']
		## use the following variable to use sldplate1  reference direction
		sldplate1_ref_dir = sldplate1_p['REF_DIRECTION']
		sldplate1_height = sldplate1_p['HEIGHT']
				
		
		VISIGeoLib.naXb(sldplate1_dir, sldplate1_ref_dir, y_axis)
		VISIGeoLib.ProjectPointOntoVector(sldplate1_pos, sldplate1_dir,
						  - (slide5_inserting_depth + sldplate1_height), sldplate1_pos)
		VISIGeoLib.ProjectPointOntoVector(sldplate1_pos, y_axis, slide5_offset, sldplate1_pos)

		if (two_plates):
			VISIGeoLib.ProjectPointOntoVector(sldplate1_pos, y_axis, - slide5_base_width / 4, sldplate1_pos)

		if (two_plates):
			if(sldplate1_p['WIDTH'] + sldplate1_1_p['WIDTH'] > slide5_base_width):
				VISIGeoLib.ProjectPointOntoVector(sldplate1_pos, y_axis,
						  - (((sldplate1_p['WIDTH'] + sldplate1_1_p['WIDTH']) - slide5_base_width)/4)
						     , sldplate1_pos)
			
		## uncomment following line to disable sldplate1 cavity building
		## sldplate1_p['BUILD_CAVITY'] = 0
		sldplate1.key_name = 'PARAM_NG_sldplate1'
		sldplate1.Execute(names, dictionaries)
		## use the following line to put sldplate1 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if (two_plates):
		
		## use the following variable to use sldplate1_1  position
		sldplate1_1_pos = sldplate1_1_p['POSITION']
		## use the following variable to use sldplate1_1  direction
		sldplate1_1_dir = sldplate1_1_p['DIRECTION']
		## use the following variable to use sldplate1  reference direction
		sldplate1_1_ref_dir = sldplate1_1_p['REF_DIRECTION']
		sldplate1_1_height = sldplate1_1_p['HEIGHT']

		## put additional member contraints

		VISIGeoLib.naXb(sldplate1_1_dir, sldplate1_1_ref_dir, y_axis)
		VISIGeoLib.ProjectPointOntoVector(sldplate1_1_pos, sldplate1_1_dir,
						  - (slide5_inserting_depth + sldplate1_1_height), sldplate1_1_pos)
		VISIGeoLib.ProjectPointOntoVector(sldplate1_1_pos, y_axis,
						  slide5_offset + slide5_base_width / 4, sldplate1_1_pos)

		if(sldplate1_p['WIDTH'] + sldplate1_1_p['WIDTH'] > slide5_base_width):
			VISIGeoLib.ProjectPointOntoVector(sldplate1_1_pos, y_axis,
				(((sldplate1_p['WIDTH'] + sldplate1_1_p['WIDTH']) - slide5_base_width)/4)
				, sldplate1_1_pos)
			
		## uncomment following line to disable sldplate1_1 cavity building
		## sldplate1_1_p['BUILD_CAVITY'] = 0
		sldplate1.key_name = 'PARAM_NG_sldplate1_1'
		sldplate1.Execute(names, dictionaries)
		## use the following line to put sldplate1_1 cavity
		##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	return 0
