import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib,VISIParam
variables = 0
params = 0
import su1_0
import su1_1
import su1_2
import shcs1
import lock5

def Execute (names, dictionaries):
	global variables
	global params
	global su1_0_p
	global su1_1_p
	global su1_2_p
	global shcs1_p
	global shcs1_1_p
	global lock5_p

	su1_0.variables = variables
	su1_1.variables = variables
	su1_2.variables = variables
	shcs1.variables = variables
	lock5.variables = variables

	params = variables['PARAM_NG_a_su1']
	su1_0_p = variables['PARAM_NG_su1_0']
	su1_1_p = variables['PARAM_NG_su1_1']
	su1_2_p = variables['PARAM_NG_su1_2']
	shcs1_p = variables['PARAM_NG_shcs1']
	shcs1_1_p = variables['PARAM_NG_shcs1_1']
	lock5_p = variables['PARAM_NG_lock5']

	## use the following variable to use su1_0  position
	su1_0_pos = su1_0_p['POSITION']
	## use the following variable to use su1_0  direction
	su1_0_dir = su1_0_p['DIRECTION']

	## uncomment following line to disable su1_0 cavity building
	## su1_0_p['BUILD_CAVITY'] = 0
	su1_0.key_name = 'PARAM_NG_su1_0'
	su1_0.Execute(names, dictionaries)
	
	index_su1_0 = dictionaries.__len__()-1
	su1_0_cavity = (dictionaries[index_su1_0]['CAVITY_TAG'])
	## use the following line to put su1_0 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use su1_1  position
	su1_1_pos = su1_1_p['POSITION']
	## use the following variable to use su1_1  direction
	su1_1_dir = su1_1_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable su1_1 cavity building
	## su1_1_p['BUILD_CAVITY'] = 0
	su1_1.key_name = 'PARAM_NG_su1_1'
	su1_1.Execute(names, dictionaries)
	## use the following line to put su1_1 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use su1_2  position
	su1_2_pos = su1_2_p['POSITION']
	## use the following variable to use su1_2  direction
	su1_2_dir = su1_2_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable su1_2 cavity building
	## su1_2_p['BUILD_CAVITY'] = 0
	su1_2.key_name = 'PARAM_NG_su1_2'
	su1_2.Execute(names, dictionaries)
	index_su1_2 = dictionaries.__len__()-1
	## use the following line to put su1_2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	if params['CREATE_SCREWS']:
		## use the following variable to use shcs1  position
		shcs1_pos = shcs1_p['POSITION']
		## use the following variable to use shcs1  direction
		shcs1_dir = shcs1_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable shcs1 cavity building
		shcs1_p['BUILD_CAVITY'] = 0
		shcs1.key_name = 'PARAM_NG_shcs1'
		shcs1.Execute(names, dictionaries)
		index_shcs1 = dictionaries.__len__()-1
		## use the following line to put shcs1 cavity
		start_screw_cavity1 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
		dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity1

		## use the following variable to use shcs1_1  position
		shcs1_1_pos = shcs1_1_p['POSITION']
		## use the following variable to use shcs1_1  direction
		shcs1_1_dir = shcs1_1_p['DIRECTION']

		## put additional member contraints

		## uncomment following line to disable shcs1_1 cavity building
		shcs1_1_p['BUILD_CAVITY'] = 0
		shcs1.key_name = 'PARAM_NG_shcs1_1'
		shcs1.Execute(names, dictionaries)
		index_shcs1 = dictionaries.__len__()-1
		## use the following line to put shcs1 cavity
		start_screw_cavity2 = shcs1.CreateStartPlateHole(dictionaries[index_shcs1]['ELEM_TAG'])
		dictionaries[index_shcs1]['CAVITY_TAG'] = start_screw_cavity2

	
	if ( params['EXCL_1'] == 'LOCK5'):
		#SU1_0
	
		lock5_p['MASTER_CAVITY'] = dictionaries[index_su1_0]['CAVITY_TAG']
	
		lock5.key_name = 'PARAM_NG_lock5'
		lock5.Execute(names, dictionaries)
		
		#SU1_2
		lock5_p['DIRECTION'].Set(-su1_0_p['DIRECTION'].Cx(), -su1_0_p['DIRECTION'].Cy(), -su1_0_p['DIRECTION'].Cz())
		lock5_p['LOCK_HEIGHT'] = lock5_p['LOCK_HEIGHT']-su1_0_p['GAP']
		lock5_p['MASTER_CAVITY'] = dictionaries[index_su1_2]['CAVITY_TAG']
	
		lock5.key_name = 'PARAM_NG_lock5'
		lock5.Execute(names, dictionaries)
		

	return 0
