import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	length = params['LENGTH']
	thickness = params['THICKNESS']
	diam_head = params['DIAM_HEAD']
	length_head = params['LENGTH_HEAD']
	diam_sink = params['DIAM_SINK']
	diam_sink_core = params['DIAM_SINK_CORE']
	length_sink = params['LENGTH_SINK']
	length_sink_core = params['LENGTH_SINK_CORE']
	width_cut_in = params['WIDTH_CUT_IN']
	depth_cut_in = params['DEPTH_CUT_IN']
	length_cone = params['LENGTH_CONE']
	length_head_cav = params['LENGTH_HEAD_CAV']
	length_cav = params['LENGTH_CAV']
	rot_angle = params['ROT_ANGLE']
	thread_pitch = params['THREAD_PITCH']
	dist_tor1 = params['DIST_TOR1']
	dist_tor2 = params['DIST_TOR2']
	diam_tor = params['DIAM_TOR']
	depth_tor = params['DEPTH_TOR']
	width_tor = params['WIDTH_TOR']
	use_length = params['USE_LENGTH']

	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
	length = use_length

	#Create Head
	
	cyl = VISISolidFactory.CreateCylinder(diam_head/2, length_head, start_pos, x_axis, direction)	
	Uni_list.append(cyl)
	
	#Create Body
	block = VISISolidFactory.CreateBlock(thickness,width,length_head+length, start_pos, x_axis, direction)	
	Uni_list.append(block)
	
	
	#Create Torus 1
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, dist_tor1+(width_tor/2), start_pos)
	torus1 = VISISolidFactory.CreateTorus (diam_head/2-depth_tor+diam_tor/2, diam_tor/2,  start_pos, x_axis, direction)
	Uni_list.append(torus1)
	
	#Create Torus 2
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, dist_tor2-dist_tor1, start_pos)
	torus2 = VISISolidFactory.CreateTorus (diam_head/2-depth_tor+diam_tor/2, diam_tor/2,  start_pos, x_axis, direction)
	Uni_list.append(torus2)
		
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, dist_tor1+width_tor/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, dist_tor2-dist_tor1, start_pos)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Subtractions
	cyl2 = VISISolidFactory.CreateCylinder(diam_sink/2, depth_cut_in, start_pos, x_axis, direction)	
	Uni_list2.append(cyl2)

	#create slot
	block2 = VISISolidFactory.CreateBlock(width_cut_in,diam_head,depth_cut_in, start_pos, x_axis, direction)	
	Uni_list2.append(block2)
	
	#create thread
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, depth_cut_in, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(diam_sink_core/2, length_sink_core-depth_cut_in, start_pos, x_axis, direction)	
	Uni_list2.append(cyl3)
	
	cam_list = [diam_sink_core, length_sink_core-depth_cut_in, diam_sink, length_sink-depth_cut_in, thread_pitch]
	VISI.AttachCamAttributes(cyl3,cam_list,"BAFFLE3_1",0,params["BUILDER_UNIT"])
	
	#Create Cone
	h_cone = (diam_sink_core/2*1000)/(math.tan(math.radians(60)))
	h_cone = h_cone/1000
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_sink_core-depth_cut_in+h_cone, start_pos)
	cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
	Uni_list2.append(cone)
	
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	#Change Color of faces
	faces = [190,193]
	VISISolidFactory.SetFacesColorById(Result_List[0], faces, 19)
	
	return Result_List[0]


def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	length = params['LENGTH']
	thickness = params['THICKNESS']
	diam_head = params['DIAM_HEAD']
	length_head = params['LENGTH_HEAD']
	diam_sink = params['DIAM_SINK']
	diam_sink_core = params['DIAM_SINK_CORE']
	length_sink = params['LENGTH_SINK']
	length_sink_core = params['LENGTH_SINK_CORE']
	width_cut_in = params['WIDTH_CUT_IN']
	depth_cut_in = params['DEPTH_CUT_IN']
	length_cone = params['LENGTH_CONE']
	length_head_cav = params['LENGTH_HEAD_CAV']
	length_cav = params['LENGTH_CAV']
	rot_angle = params['ROT_ANGLE']
	use_length = params['USE_LENGTH']

	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
	length = use_length
		
		
	#Create Head	
	cyl = VISISolidFactory.CreateCylinder(diam_head/2, length_head_cav+length_head, start_pos, x_axis, direction)	
	#Uni_list.append(cyl)
	
	
	if (start_plate):
		cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl, start_pos)
		hole = VISIParam.ExtendFaceToSolid(start_plate, cavity_face, direction)
		hole= VISIParam.AdaptCavityToPlate(start_plate, hole, 0)
		Uni_list.append(hole)
	else:
		Uni_list.append(cyl)
	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(width/2, length_head_cav+length_head+length_cav+length, start_pos, x_axis, direction)	
	Uni_list.append(cyl1)
	
	#Create Cone for head
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,length_cone, start_pos)
	cone = VISISolidFactory.CreateCone(diam_head/2, length_cone, math.radians(30), start_pos, x_axis, inv_dir)
	Uni_list.append(cone)
	
	#Create Cone for body
	h_cone = (width/2*1000)/(math.tan(math.radians(60)))
	h_cone = h_cone/1000
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,length_head_cav+length_head+length_cav-length_cone+h_cone+length, start_pos)
	cone2 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
	Uni_list.append(cone2)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_baffle3_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
