import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	length = params['LENGTH']
	hexagon = params['HEXAGON']
	length_thread = params['LENGTH_THREAD']
	width = params['WIDTH']
	depth = params['DEPTH']
	diameter_mm = params['DIAMETER_MM']
	diameter_core = params['DIAMETER_CORE']
	length_hexagon = params['LENGTH_HEXAGON']
	cav_diameter = params['CAV_DIAMETER']
	cav_add_length = params['CAV_ADD_LENGTH']
	cav_add_length_head = params['CAV_ADD_LENGTH_HEAD']
	real_length = params['REAL_LENGTH']
	thread_pitch = params['THREAD_PITCH']
	thread_add_length = params['THREAD_ADD_LENGTH']
	rot_angle = params['ROT_ANGLE']
	ins_depth = params['INS_DEPTH']
	start_twist = params['START_TWIST']
	
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)

	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ins_depth, start_pos)
	#Create Head
	cyl1 = VISISolidFactory.CreateCylinder(diameter_mm/2, length_thread, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	## attach Thread attribute
	VISI.AttachThreadAttributes(cyl1, thread_pitch)
	
	#Create Body
	block1 = VISISolidFactory.CreateBlock(depth,width, start_twist, start_pos, x_axis, direction)
	Uni_list.append(block1)
	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_twist, start_pos)
	angular_inc = (math.radians(360))
	body = VISISolidFactory.MakeHelicalScrewBody(start_pos, x_axis, direction, 0, angular_inc, length-start_twist, 0, depth, width)
	Uni_list.append(body)
	#return body
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Creare hexagon
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, start_twist, start_pos)
	hex1 = VISISolidFactory.CreatePrism ((hexagon/2)/(math.cos(math.radians(30))), length_hexagon, 6, start_pos, x_axis, direction)
	Uni_list2.append(hex1)
	
	#Cut element
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, real_length, start_pos)
	cyl21 = VISISolidFactory.CreateCylinder(diameter_mm/2, length, start_pos, x_axis, direction)
	Uni_list2.append(cyl21)

	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	length = params['LENGTH']
	hexagon = params['HEXAGON']
	length_thread = params['LENGTH_THREAD']
	width = params['WIDTH']
	depth = params['DEPTH']
	diameter_mm = params['DIAMETER_MM']
	diameter_core = params['DIAMETER_CORE']
	length_hexagon = params['LENGTH_HEXAGON']
	cav_diameter = params['CAV_DIAMETER']
	cav_add_length = params['CAV_ADD_LENGTH']
	cav_add_length_head = params['CAV_ADD_LENGTH_HEAD']
	real_length = params['REAL_LENGTH']
	thread_pitch = params['THREAD_PITCH']
	thread_add_length = params['THREAD_ADD_LENGTH']
	rot_angle = params['ROT_ANGLE']
	ins_depth = params['INS_DEPTH']
	start_twist = params['START_TWIST']
	
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		

	#Create Head
	cyl1 = VISISolidFactory.CreateCylinder(diameter_core/2, length_thread+cav_add_length_head+ins_depth, start_pos, x_axis, direction)
		
	if (start_plate):
		cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl1, start_pos)
		hole = VISIParam.ExtendFaceToSolid(start_plate, cavity_face, direction)
		hole= VISIParam.AdaptCavityToPlate(start_plate, hole, 0)
		Uni_list.append(hole)
	else:
		Uni_list.append(cyl1)
		
	
	cam_list = [diameter_core, length_thread+cav_add_length_head+ins_depth, diameter_mm, length_thread+thread_add_length+cav_add_length_head+ins_depth-(3*thread_pitch), thread_pitch]
	
	#Differentiate between metric and inch thread
	if diameter[0] == "M":
		VISI.AttachCamAttributes(cyl1, cam_list, "BAFFLE5_11", diameter, elem_tag, params["BUILDER_UNIT"])
	else:
		VISI.AttachCamAttributes(cyl1, cam_list, "BAFFLE5_12", diameter, elem_tag, params["BUILDER_UNIT"])
	
	#Create Body
	cyl2 = VISISolidFactory.CreateCylinder(cav_diameter/2, real_length+cav_add_length+ins_depth, start_pos, x_axis, direction)
	Uni_list.append(cyl2)
	
	#Create Cone
	h_cone = (cav_diameter/2*1000)/(math.tan(math.radians(60)))
	h_cone = h_cone/1000
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, real_length+cav_add_length + h_cone+ins_depth, start_pos)	
	cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
	Uni_list.append(cone)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_baffle5_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
