import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	lower_length = params['LOWER_LENGTH']
	upper_length = params['UPPER_LENGTH']
	diameter_ext = params['DIAMETER_EXT']
	diameter_collar = params['DIAMETER_COLLAR']
	diameter_inner = params['DIAMETER_INNER']
	diameter_ext_upper = params['DIAMETER_EXT_UPPER']
	length_collar = params['LENGTH_COLLAR']
	total_length = params['TOTAL_LENGTH']
	diameter_restriction = params['DIAMETER_RESTRICTION']
	length_restriction = params['LENGTH_RESTRICTION']
	angle = params['ANGLE']
	angle4 = params['ANGLE4']
	angle7 = params['ANGLE7']
	chamfer1 = params['CHAMFER1']
	chamfer2 = params['CHAMFER2']
	chamfer3 = params['CHAMFER3']
	chamfer4 = params['CHAMFER4']
	length_cav = params['LENGTH_CAV']

	Uni_List        = []
	Result_List     = []
	start_pos       = VISIPoint.New()
        x_axis          = VISIVector.New()
        inv_dir         = VISIVector.New()
        
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	inv_dir.Set(- direction.Cx(), - direction.Cy(), - direction.Cz())
	
	#Create Body
	#Cerate Lower Part
	cyl1 = VISISolidFactory.CreateCylinder(diameter_ext / 2, lower_length, start_pos, x_axis, inv_dir)
	Uni_List.append(cyl1)
	
	#Create Collar
	cyl2 = VISISolidFactory.CreateCylinder(diameter_collar / 2, length_collar, start_pos, x_axis, direction)
	Uni_List.append(cyl2)

	#Move Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_collar, start_pos)
	if (length_restriction <> 0):
		#Create Restriction
		#Creat Cylinder
		cyl3 = VISISolidFactory.CreateCylinder(diameter_restriction / 2, length_restriction, start_pos, x_axis, direction)
		Uni_List.append(cyl3)
		
		#Create Upper Part
		#Move Position
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_restriction, start_pos)
	
		#Create Cylinder
		cyl4 = VISISolidFactory.CreateCylinder(diameter_ext_upper / 2, upper_length-length_collar - length_restriction, start_pos, x_axis, direction)
		Uni_List.append(cyl4)
		#Move Position
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, upper_length - length_collar - length_restriction, start_pos)
	else:
		#Create Cylinder
		cyl4 = VISISolidFactory.CreateCylinder(diameter_restriction / 2, upper_length - length_collar, start_pos, x_axis, direction)
		Uni_List.append(cyl4)
		#Move Position
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, upper_length - length_collar, start_pos)
	
	#Unite
	VISISolidFactory.Unite(Uni_List, Result_List)
	
        Uni_List = []
        Uni_List.append(Result_List[0])
        Result_List = []
		
	#Create Hole
	cyl5 = VISISolidFactory.CreateCylinder(diameter_inner / 2, total_length, start_pos, x_axis, inv_dir)
	Uni_List.append(cyl5)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_List, Result_List)

	Uni_List = []
        Uni_List.append(Result_List[0])
        
	#Chamfer
	
	if (length_restriction <> 0):
		#inner chamfer
		edges = [77, 76]
		chamfer_up = math.tan(angle4) * chamfer4
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, chamfer4, 1)
		#chamfer ext. at end
		#Lower
		edges = [12]
		chamfer_up = math.tan(angle)*chamfer2
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, chamfer2, 1)
		#Upper
		edges = [25]
		chamfer_up = math.tan(angle)*chamfer1
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, chamfer1, 1)
		#Collar
		edges = [21, 22]
		chamfer_up = math.tan(angle)*chamfer3
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, chamfer3, 1)
		#Restriction
		edges = [26]
		chamfer_up = (diameter_ext_upper / 2 - diameter_restriction / 2) / (math.tan(angle7))
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, (diameter_ext_upper / 2 - diameter_restriction / 2), 1)
	else:
		#inner chamfer
		edges = [65, 64]
		chamfer_up = math.tan(angle) * chamfer2
		VISISolidFactory.ChamferEdges(Result_List[0], edges,chamfer_up, chamfer2, 1)
		#chamfer ext. at end
		#Lower
		edges = [12]
		chamfer_up = math.tan(angle) * chamfer2
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, chamfer2, 1)
		#Upper
		edges = [23]
		chamfer_up = math.tan(angle) * chamfer1
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, chamfer1, 1)
		#Collar
		edges = [21, 22]
		chamfer_up = math.tan(angle) * chamfer3
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer_up, chamfer3, 1)

	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	lower_length = params['LOWER_LENGTH']
	upper_length = params['UPPER_LENGTH']
	diameter_ext = params['DIAMETER_EXT']
	diameter_collar = params['DIAMETER_COLLAR']
	diameter_inner = params['DIAMETER_INNER']
	diameter_ext_upper = params['DIAMETER_EXT_UPPER']
	length_collar = params['LENGTH_COLLAR']
	total_length = params['TOTAL_LENGTH']
	diameter_restriction = params['DIAMETER_RESTRICTION']
	length_restriction = params['LENGTH_RESTRICTION']
	angle = params['ANGLE']
	angle4 = params['ANGLE4']
	angle7 = params['ANGLE7']
	chamfer1 = params['CHAMFER1']
	chamfer2 = params['CHAMFER2']
	chamfer3 = params['CHAMFER3']
	chamfer4 = params['CHAMFER4']
	length_cav = params['LENGTH_CAV']
	clearance_guide_diameter = params['CLEARANCE_GUIDE_DIAMETER']
	insertion_depth = params['INSERTION_DEPTH']
	clearance_collar_diameter = params['CLEARANCE_COLLAR_DIAMETER']
	
	
	
	start_pos       = VISIPoint.New()
 	start_pos.Set(position.x(), position.y(), position.z())
	x_axis  = VISIVector.New()
	inv_dir = VISIVector.New()
	Uni_List=[]
	Result_List=[]
	
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	if insertion_depth:
		length_cav= length_cav-insertion_depth
		cyl2 = VISISolidFactory.CreateCylinder((diameter_collar + clearance_collar_diameter)/ 2, insertion_depth, start_pos, x_axis, direction)
		cam_list2 = [diameter_collar + clearance_collar_diameter, insertion_depth]
		VISI.AttachCamAttributes(cyl2,cam_list2,"BGB1_M_2",elem_tag,params["BUILDER_UNIT"])
		Uni_List.append(cyl2)
	
	
	#Create Body
	#Cerate Lower Part
	cyl1 = VISISolidFactory.CreateCylinder((diameter_ext + clearance_guide_diameter)/ 2, length_cav, start_pos, x_axis, inv_dir)
	cam_list = [diameter_ext + clearance_guide_diameter, length_cav]
	VISI.AttachCamAttributes(cyl1,cam_list,"BGB1_M_1",elem_tag,params["BUILDER_UNIT"])
	Uni_List.append(cyl1)
	
	

	
	VISISolidFactory.Unite(Uni_List, Result_List)
	

	
	
	
	
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_bgb1_m'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
