import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_dowel = params['DIAMETER_DOWEL']
	length_dowel = params['LENGTH_DOWEL']
	length_cabel = params['LENGTH_CABEL']
	diameter_big = params['DIAMETER_BIG']
	diameter_small = params['DIAMETER_SMALL']
	diameter_hole = params['DIAMETER_HOLE']
	width = params['WIDTH']
	height_section = params['HEIGHT_SECTION']
	length_big = params['LENGTH_BIG']
	length_small = params['LENGTH_SMALL']
	distance_dowel = params['DISTANCE_DOWEL']
	distance_hole = params['DISTANCE_HOLE']
	length_cubic = params['LENGTH_CUBIC']
	length_section = params['LENGTH_SECTION']
	rot_angle = params['ROT_ANGLE']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_x_axis = VISIVector.New()
	inv_x_axis.Set(-x_axis.Cx(), -x_axis.Cy(), -x_axis.Cz())
	
	#Rotate axis
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
	VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	VISIGeoLib.VectorRotate(inv_x_axis, direction, inv_x_axis, rot_angle)
	
	##Create Dowel
	#Moving to correct position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_x_axis, length_cubic - distance_dowel, start_pos)
	#Create body
	cyl1 = VISISolidFactory.CreateCylinder(diameter_dowel/2, length_dowel - diameter_dowel/2, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	##Create Sphere on top of the dowel
	#Move to position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_dowel - diameter_dowel/2, start_pos)
	#Create body
	sph1 = VISISolidFactory.CreateSphere(diameter_dowel/2, start_pos, inv_dir, x_axis)
	Uni_list.append(sph1)
	##Create big cylinders
	#Reset Position + move to new position 
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length_cubic - distance_dowel, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, width/2 +length_dowel - diameter_dowel/2, start_pos)
	#Create cylinder1
	cyl2 = VISISolidFactory.CreateCylinder(diameter_big/2, length_big, start_pos, direction, x_axis)
	Uni_list.append(cyl2)
	#Create cylinder 2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length_big, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(diameter_small/2, length_small, start_pos, direction, x_axis)
	Uni_list.append(cyl3)
	#relocate position for block
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_x_axis, length_big, start_pos)
	#create big block
	bl1 = VISISolidFactory.CreateBlock(width, width, length_cubic, start_pos, direction, inv_x_axis)
	Uni_list.append(bl1)
	#Unite all bodies to create main body
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	#move to position for section
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height_section - width/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_x_axis, length_cubic - length_section/2, start_pos)
	#create section
	bl2 = VISISolidFactory.CreateBlock(length_section, width, width-height_section, start_pos, x_axis, direction)
	Uni_list2.append(bl2)
	#Create cylinder for hole
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_x_axis, length_section/2 - distance_hole, start_pos)
	cyl4 = VISISolidFactory.CreateCylinder(diameter_hole/2, height_section, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl4)
	#Subtract everything from the main body
	VISISolidFactory.Subtract(Uni_list2, Result_List)

	## return the tag of created element, 0 if no element
	
	return Result_List [0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_dowel = params['DIAMETER_DOWEL']
	length_dowel = params['LENGTH_DOWEL']
	length_cabel = params['LENGTH_CABEL']
	diameter_big = params['DIAMETER_BIG']
	diameter_small = params['DIAMETER_SMALL']
	diameter_hole = params['DIAMETER_HOLE']
	width = params['WIDTH']
	height_section = params['HEIGHT_SECTION']
	length_big = params['LENGTH_BIG']
	length_small = params['LENGTH_SMALL']
	distance_dowel = params['DISTANCE_DOWEL']
	distance_hole = params['DISTANCE_HOLE']
	length_cubic = params['LENGTH_CUBIC']
	length_section = params['LENGTH_SECTION']
	rot_angle = params['ROT_ANGLE']
	clearence_diameter = params['CLEARENCE_DIAMETER']
	clearence_drilling_depth = params['CLEARENCE_DRILLING_DEPTH']
	chamfer = params['CHAMFER']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_x_axis = VISIVector.New()
	inv_x_axis.Set(-x_axis.Cx(), -x_axis.Cy(), -x_axis.Cz())
	
	#Rotate axis
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
	VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	VISIGeoLib.VectorRotate(inv_x_axis, direction, inv_x_axis, rot_angle)
	
	##Create Dowel
	#Moving to correct position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_x_axis, length_cubic - distance_dowel, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,chamfer , start_pos)
	con2 = VISISolidFactory.CreateCone((diameter_dowel/2+clearence_diameter/2), chamfer, math.radians(45), start_pos, x_axis, direction)
	
	Uni_list.append(con2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,chamfer , start_pos)
	#Create body
	h_step= (diameter_dowel/2+clearence_diameter/2)/math.tan(math.radians(60))
	cyl1 = VISISolidFactory.CreateCylinder(diameter_dowel/2+clearence_diameter/2, length_dowel+clearence_drilling_depth-h_step, start_pos, x_axis, inv_dir)
	
	cam_list = [diameter_dowel+clearence_diameter,length_dowel+clearence_drilling_depth-h_step]
	VISI.AttachCamAttributes(cyl1,cam_list,"BTC1_1",elem_tag,params["BUILDER_UNIT"])
	
	Uni_list.append(cyl1)
	##Create tip of the dowel
	#Move to position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_dowel+clearence_drilling_depth, start_pos)
	#Create body
	con1 = VISISolidFactory.CreateCone(0, h_step, math.radians(60), start_pos, x_axis, direction)
	Uni_list.append(con1)
	##Create big cylinders
	#Reset Position + move to new position 
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length_cubic - distance_dowel, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, width/2 +length_dowel+clearence_drilling_depth , start_pos)
	#Create cylinder1
	cyl2 = VISISolidFactory.CreateCylinder(diameter_big/2, length_big, start_pos, direction, x_axis)
	Uni_list.append(cyl2)
	#Create cylinder 2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length_big, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(diameter_small/2, length_small, start_pos, direction, x_axis)
	Uni_list.append(cyl3)
	#relocate position for block
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_x_axis, length_big, start_pos)
	#create big block
	bl1 = VISISolidFactory.CreateBlock(width, width, length_cubic, start_pos, direction, inv_x_axis)
	Uni_list.append(bl1)
	#Unite all bodies to create main body
	VISISolidFactory.Unite(Uni_list, Result_List)
	

	## return the tag of created element, 0 if no element
	
	return Result_List [0]
	
	

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_btc1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
