import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	length = params['LENGTH']
	height = params['HEIGHT']
	distance_screws = params['DISTANCE_SCREWS']
	length_dist_screws = params['LENGTH_DIST_SCREWS']
	diameter_pin = params['DIAMETER_PIN']
	length_pin = params['LENGTH_PIN']
	distance_pin = params['DISTANCE_PIN']
	radius = params['RADIUS']
	diameter_drilling = params['DIAMETER_DRILLING']
	diameter_sinking = params['DIAMETER_SINKING']
	depth_sinking = params['DEPTH_SINKING']
	ins_depth = params['INS_DEPTH']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	y_axis = VISIVector.New()
	y_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	x_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, y_axis, x_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, ins_depth, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -length/2, start_pos)
	#Create Body
	block1 = VISISolidFactory.CreateBlock(width,length,height,  start_pos, x_axis, direction)
	Uni_list.append(block1)
	
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, distance_pin, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, length/2, start_pos)
	#Create Pin
	cyl1 = VISISolidFactory.CreateCylinder(diameter_pin/2, length_pin, start_pos, inv_dir, y_axis)
	Uni_list.append(cyl1)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Screw Holes
	#Hole 1
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height-distance_pin, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -length_dist_screws, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_screws/2, start_pos)
	
	#Drilling
	cyl20 = VISISolidFactory.CreateCylinder(diameter_drilling/2, height, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl20)
	
	#Sinking
	cyl21 = VISISolidFactory.CreateCylinder(diameter_sinking/2, depth_sinking, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl21)
	
	#Hole 2
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_screws, start_pos)
	
	#Drilling
	cyl30 = VISISolidFactory.CreateCylinder(diameter_drilling/2, height, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl30)
	
	#Sinking
	cyl31 = VISISolidFactory.CreateCylinder(diameter_sinking/2, depth_sinking, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl31)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	#Blend
	edges = [20,22]
	VISISolidFactory.BlendEdges(Result_List[0], edges,  radius, 1)
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	length = params['LENGTH']
	height = params['HEIGHT']
	distance_screws = params['DISTANCE_SCREWS']
	length_dist_screws = params['LENGTH_DIST_SCREWS']
	diameter_pin = params['DIAMETER_PIN']
	length_pin = params['LENGTH_PIN']
	distance_pin = params['DISTANCE_PIN']
	radius = params['RADIUS']
	diameter_drilling = params['DIAMETER_DRILLING']
	diameter_sinking = params['DIAMETER_SINKING']
	depth_sinking = params['DEPTH_SINKING']
	ins_depth = params['INS_DEPTH']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	y_axis = VISIVector.New()
	y_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	x_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, y_axis, x_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, ins_depth, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -length/2, start_pos)
	#Create Body
	block1 = VISISolidFactory.CreateBlock(width,length,height,  start_pos, x_axis, direction)
	Uni_list.append(block1)
	
	#Blend
	edges = [20,22]
	VISISolidFactory.BlendEdges(block1, edges,  radius, 1)
	
	return block1

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_cc1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
