import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	type = params['TYPE']
	display = params['DISPLAY']
	year = params['YEAR']
	length = params['LENGTH']
	guide_length = params['GUIDE_LENGTH']
	start_thick = params['START_THICK']
	diameter_body = params['DIAMETER_BODY']

	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
			
	
	#Create Head
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, guide_length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, guide_length, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder(diameter_body/2, length-guide_length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl2)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	type = params['TYPE']
	display = params['DISPLAY']
	year = params['YEAR']
	length = params['LENGTH']
	guide_length = params['GUIDE_LENGTH']
	diameter_body = params['DIAMETER_BODY']
	start_thick = params['START_THICK']
	play_body = params['PLAY_BODY']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
			
	
	#Create Head
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, guide_length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, guide_length, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder(diameter_body/2+play_body/2, start_thick-guide_length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl2)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_date_kw'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
