import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	diameter = params['DIAMETER']
	hole_length = params['HOLE_LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	total_height = params['TOTAL_HEIGHT']
	housing_height = params['HOUSING_HEIGHT']
	follow_housing = params['FOLLOW_HOUSING']
	rotation_angle = params['ROTATION_ANGLE']
	ref_diameter = params['REF_DIAMETER']
	start_plate = params['START_PLATE']
	clearance = params['CLEARANCE']
	reverse = params['REVERSE']
	diameter_counterboring = params['DIAMETER_COUNTERBORING']
	diameter_ring = params['DIAMETER_RING']
	inner_diameter_ring = params['INNER_DIAMETER_RING']
	depth_small_ring = params['DEPTH_SMALL_RING']
	depth_big_ring = params['DEPTH_BIG_RING']
	cut_ring = params['CUT_RING']
	

	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	body_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rotation_angle)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()

	if(reverse):
            inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	else:
            inv_dir.Set(direction.Cx(), direction.Cy(), direction.Cz())

	if (follow_housing):
			VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, housing_height, start_pos)
			
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, hole_length/2, start_pos)
	
	body1 = VISISolidFactory.CreateBlock(width, hole_length, height-depth_big_ring, start_pos, x_axis, inv_dir)
	body_list.append(body1)
	body2 = VISISolidFactory.CreateBlock(inner_diameter_ring, hole_length, height, start_pos, x_axis, inv_dir)
	body_list.append(body2)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -hole_length/2, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder(width/2, height-depth_big_ring, start_pos, x_axis, inv_dir)
	body_list.append(cyl1)
	cyl2 = VISISolidFactory.CreateCylinder(inner_diameter_ring/2, height, start_pos, x_axis, inv_dir)
	body_list.append(cyl2)
	
	hole1 = VISISolidFactory.CreateCylinder(diameter/2, height, start_pos, x_axis, inv_dir)
	hole1_1 = VISISolidFactory.CreateCylinder(diameter_counterboring/2, depth_small_ring, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, hole_length, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(width/2, height-depth_big_ring, start_pos, x_axis, inv_dir)
	body_list.append(cyl3)
	cyl4 = VISISolidFactory.CreateCylinder(inner_diameter_ring/2, height, start_pos, x_axis, inv_dir)
	body_list.append(cyl4)

	hole2 = VISISolidFactory.CreateCylinder(diameter/2, height, start_pos, x_axis, inv_dir)
	hole2_1 = VISISolidFactory.CreateCylinder(diameter_counterboring/2, depth_small_ring, start_pos, x_axis, inv_dir)
	
	VISISolidFactory.Unite(body_list, Result_List)

	body_list = []
	body_list.append(Result_List[0])
	body_list.append(hole1)
	body_list.append(hole2)
	body_list.append(hole1_1)
	body_list.append(hole2_1)
	Uni_List = []
	VISISolidFactory.Subtract(body_list, Uni_List)
	

	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, depth_small_ring-diameter_ring/2, start_pos)
	tor1 = VISISolidFactory.CreateTorus((diameter_counterboring-diameter_ring)/2, (diameter_ring+0.0001/1000)/2, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -hole_length, start_pos)
	tor2 = VISISolidFactory.CreateTorus((diameter_counterboring-diameter_ring)/2, (diameter_ring+0.0001/1000)/2, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, -(depth_small_ring-diameter_ring/2), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, -depth_big_ring+diameter_ring/2, start_pos)
	tor3 = VISISolidFactory.CreateTorus((inner_diameter_ring+diameter_ring)/2, (diameter_ring+0.0001/1000)/2, start_pos, x_axis, inv_dir)
	
	front_bodies_list = []
	back_bodies_list = []
	VISISolidFactory.CutWithPlane(start_pos, y_axis, tor3, front_bodies_list, back_bodies_list)
	VISISolidFactory.TranslateBodiesByVector(front_bodies_list, y_axis, hole_length)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (inner_diameter_ring+diameter_ring)/2, start_pos)
	cyl5 = VISISolidFactory.CreateCylinder((diameter_ring+0.0001/1000)/2, hole_length, start_pos, x_axis, y_axis)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(inner_diameter_ring+diameter_ring), start_pos)
	cyl6 = VISISolidFactory.CreateCylinder((diameter_ring+0.0001/1000)/2, hole_length, start_pos, x_axis, y_axis)
	
	faces=[2]
	VISISolidFactory.SetFacesColorById(tor1, faces, 31)
	VISISolidFactory.SetFacesColorById(tor2, faces, 31)
	VISISolidFactory.SetFacesColorById(front_bodies_list[0], faces, 31)
	VISISolidFactory.SetFacesColorById(cyl5, faces, 31)
	VISISolidFactory.SetFacesColorById(cyl6, faces, 31)
	faces=[9]
	VISISolidFactory.SetFacesColorById(back_bodies_list[0], faces, 31)
	
	
	Uni_List.append(tor1)
	Uni_List.append(tor2)
	Uni_List.append(front_bodies_list[0])
	Uni_List.append(back_bodies_list[0])
	Uni_List.append(cyl5)
	Uni_List.append(cyl6)
	
	VISISolidFactory.Unite(Uni_List, Result_List)
	
	
	if cut_ring:
		Uni_List=[]
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, hole_length/2, start_pos)
		front_bodies_list = []
		back_bodies_list = []
		VISISolidFactory.CutWithPlane(start_pos, inv_dir, Result_List[0], front_bodies_list, back_bodies_list)
		VISISolidFactory.DeleteBodies(back_bodies_list)
		Uni_List.append(front_bodies_list[0])
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height, start_pos)
		front_bodies_list = []
		back_bodies_list = []
		VISISolidFactory.CutWithPlane(start_pos, inv_dir, Uni_List[0], front_bodies_list, back_bodies_list)
		VISISolidFactory.DeleteBodies(front_bodies_list)
		faces=[182, 185, 188]
		VISISolidFactory.SetFacesColorById(back_bodies_list[0], faces, 31)
		return back_bodies_list[0]
	
		#182, 185 ,188
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	diameter = params['DIAMETER']
	hole_length = params['HOLE_LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	total_height = params['TOTAL_HEIGHT']
	housing_height = params['HOUSING_HEIGHT']
	follow_housing = params['FOLLOW_HOUSING']
	rotation_angle = params['ROTATION_ANGLE']
	ref_diameter = params['REF_DIAMETER']
	start_plate = params['START_PLATE']
	clearance = params['CLEARANCE']
	reverse = params['REVERSE']
	diameter_counterboring = params['DIAMETER_COUNTERBORING']
	diameter_ring = params['DIAMETER_RING']
	inner_diameter_ring = params['INNER_DIAMETER_RING']
	depth_small_ring = params['DEPTH_SMALL_RING']
	depth_big_ring = params['DEPTH_BIG_RING']

	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	body_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rotation_angle)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()

	if(reverse):
            inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	else:
            inv_dir.Set(direction.Cx(), direction.Cy(), direction.Cz())

	pos = VISIPoint.New()
	pos.Set(position.x(), position.y(), position.z())

	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, hole_length/2, start_pos)
	
	body1 = VISISolidFactory.CreateBlock(width + (2 * clearance), hole_length, height + housing_height, start_pos, x_axis, inv_dir)
	body_list.append(body1)

	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -hole_length/2, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder(((width/2) + clearance), height + housing_height, start_pos, x_axis, inv_dir)
	body_list.append(cyl1)
	# cam_list = [width, height + housing_height]
        # VISI.AttachCamAttributes(cyl1,cam_list,"DEFLECT_1",elem_tag,params["BUILDER_UNIT"])

	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, hole_length, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder(((width/2) + clearance), height + housing_height, start_pos, x_axis, inv_dir)
	body_list.append(cyl2)

        if (follow_housing):
                VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height + housing_height, start_pos)
        else:
                VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height, start_pos)
                
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -hole_length + hole_length/2, start_pos)
	body3 = VISISolidFactory.CreateBlock(diameter, hole_length, total_height - height, start_pos, x_axis, inv_dir)
	body_list.append(body3)

	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -hole_length/2, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(diameter/2, total_height - height, start_pos, x_axis, inv_dir)
	body_list.append(cyl3)

	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, hole_length, start_pos)
	cyl4 = VISISolidFactory.CreateCylinder(diameter/2, total_height - height, start_pos, x_axis, inv_dir)
	body_list.append(cyl4)
	# cam_list = [diameter, total_height - height]
        # VISI.AttachCamAttributes(cyl4,cam_list,"DEFLECT_2",elem_tag,params["BUILDER_UNIT"])

	VISISolidFactory.Unite(body_list, Result_List)

	if (start_plate)and not(reverse):
                cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(Result_List[0], pos)
                hole = VISIParam.ExtendFaceToSolid(start_plate, cavity_face, inv_dir)
                hole= VISIParam.AdaptCavityToPlate(start_plate, hole, 0)
                return hole
        else:
                return Result_List[0]

	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_deflect_2'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, Xaxis)

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
