import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_stamp = params['DIAMETER_STAMP']
	length = params['LENGTH']
	outer_diameter = params['OUTER_DIAMETER']
	diameter_hole = params['DIAMETER_HOLE']
	length_hole = params['LENGTH_HOLE']
	compression = params['COMPRESSION']
	diameter_punch = params['DIAMETER_PUNCH']
	punch_hole = params['PUNCH_HOLE']
	diameter_cut = params['DIAMETER_CUT']
	

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length-compression, start_pos)
	
	
	cyl1 = VISISolidFactory.CreateCylinder(outer_diameter/2, length-compression, start_pos, x_axis, inv_dir)
	
	
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_stamp/2, length-length_hole-compression, start_pos, x_axis, inv_dir)
	
	cyl3 = VISISolidFactory.CreateCylinder(diameter_hole/2, length-compression, start_pos, x_axis, inv_dir)
	
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	Uni_list.append(cyl3)
	
	if punch_hole:
		cyl4 = VISISolidFactory.CreateCylinder(diameter_cut/2, length-compression,start_pos ,x_axis, inv_dir)
		Uni_list.append(cyl4)
		
	
	VISISolidFactory.Subtract(Uni_list, Result_List)
	
	
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_stamp = params['DIAMETER_STAMP']
	length = params['LENGTH']
	outer_diameter = params['OUTER_DIAMETER']
	diameter_hole = params['DIAMETER_HOLE']
	length_hole = params['LENGTH_HOLE']
	compression = params['COMPRESSION']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	
	
	
	cyl1 = VISISolidFactory.CreateCylinder(outer_diameter/2, length-compression, start_pos, x_axis, direction)
		
	
	## return the tag of created cavity, 0 if no cavity
	return cyl1

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_es4'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
