import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	width_nose = params['WIDTH_NOSE']
	width2 = params['WIDTH2']
	height_nose = params['HEIGHT_NOSE']
	height = params['HEIGHT']
	diameter = params['DIAMETER']
	screw_diameter = params['SCREW_DIAMETER']
	core_diameter = params['CORE_DIAMETER']
	diameter_sinking = params['DIAMETER_SINKING']
	depth_sinking = params['DEPTH_SINKING']
	chamfer = params['CHAMFER']
	angle = params['ANGLE']
	rot_angle = params['ROT_ANGLE']
	thread_pitch = params['THREAD_PITCH']
	cav_radius = params['CAV_RADIUS']
	invert = params['INVERT']
	gap = params['GAP']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if invert:
		direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
		inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
		
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,height_nose, start_pos)
	
	#Move
	if not invert:
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction,-gap, start_pos)


	#Create Nose
	bl2 = VISISolidFactory.CreateBlock (width_nose, width2, height+height_nose, start_pos, x_axis, inv_dir)
	Uni_list.append(bl2)
	
	#Create Body
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,height_nose, start_pos)
	#Create
	#cyl0 = VISISolidFactory.CreateCylinder(width, height, start_pos, x_axis, inv_dir)
	cyl0 = VISISolidFactory.CreateBlock (width, width, height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl0)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Screw Hole
	#Create Sinking
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,height_nose, start_pos)
	#Sinking
	cyl1 = VISISolidFactory.CreateCylinder(diameter_sinking/2, depth_sinking, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl1)
	
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,depth_sinking, start_pos)
	#Hole
	cyl2 = VISISolidFactory.CreateCylinder(core_diameter/2, height+height_nose-depth_sinking, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl2)
	
	#Attach CAM attributes
	cam_list = [core_diameter,  height+height_nose-depth_sinking, screw_diameter,  height+height_nose-depth_sinking, thread_pitch]
	VISI.AttachCamAttributes(cyl2,cam_list,"FCU1_1",0,params["BUILDER_UNIT"])
	
	#Create Subtraction blocks
	#Move in Z
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,depth_sinking-height_nose, start_pos)
	#Move in Y
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,width/2+diameter/2, start_pos)
	#Block1
	bl11 = VISISolidFactory.CreateBlock (diameter, diameter, height, start_pos, x_axis, inv_dir)
	Uni_list2.append(bl11)
	
	#Move in Y
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,-(width/2+diameter/2)-(width/2+diameter/2), start_pos)
	#Block1
	bl12 = VISISolidFactory.CreateBlock (diameter, diameter, height, start_pos, x_axis, inv_dir)
	Uni_list2.append(bl12)
	
	#Move in Y
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,width/2+diameter/2, start_pos)
	#Move in X
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,width/2+diameter/2, start_pos)
	#Block3
	bl13 = VISISolidFactory.CreateBlock (diameter, diameter, height, start_pos, x_axis, inv_dir)
	Uni_list2.append(bl13)
	
	#Move in X
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,-2*(width/2+diameter/2), start_pos)
	#Block3
	bl14 = VISISolidFactory.CreateBlock (diameter, diameter, height, start_pos, x_axis, inv_dir)
	Uni_list2.append(bl14)

	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)

	#Chamfer
	edges = [6,14]
	chamfer2 = chamfer*math.tan(angle)
	VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer, chamfer2, 1)

	edges = [93,96,99,107]
	VISISolidFactory.BlendEdges(Result_List[0], edges, cav_radius, 1)	
	
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	width_nose = params['WIDTH_NOSE']
	width2 = params['WIDTH2']
	height_nose = params['HEIGHT_NOSE']
	height = params['HEIGHT']
	diameter = params['DIAMETER']
	screw_diameter = params['SCREW_DIAMETER']
	core_diameter = params['CORE_DIAMETER']
	diameter_sinking = params['DIAMETER_SINKING']
	depth_sinking = params['DEPTH_SINKING']
	chamfer = params['CHAMFER']
	angle = params['ANGLE']
	rot_angle = params['ROT_ANGLE']
	
	play_width = params['PLAY_WIDTH']
	play_length = params['PLAY_LENGTH']
	play_height = params['PLAY_HEIGHT']
	cav_radius = params['CAV_RADIUS']
	
	invert = params['INVERT']
	gap = params['GAP']
	

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Move
	if not invert:
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction,-gap, start_pos)
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
		
	#Create Nose
	bl2 = VISISolidFactory.CreateBlock (width+play_width, width+play_length, height+play_height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl2)
		
	#Blend
	edges = [18,20,22,24]
	VISISolidFactory.BlendEdges(bl2, edges, cav_radius, 1)
	
	return bl2
	

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_fcu1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
