import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	height_base = params['HEIGHT_BASE']
	width_base = params['WIDTH_BASE']
	distance_screw_end = params['DISTANCE_SCREW_END']
	distance_between_screws = params['DISTANCE_BETWEEN_SCREWS']
	radius = params['RADIUS']
	diameter_sinking = params['DIAMETER_SINKING']
	height_sinking = params['HEIGHT_SINKING']
	diameter_screw = params['DIAMETER_SCREW']
	diameter_through = params['DIAMETER_THROUGH']
	invert = params['INVERT']
	gap = params['GAP']
	distance_between_screws_width = params['DISTANCE_BETWEEN_SCREWS_WIDTH']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	end_pos = VISIPoint.New()
	end_pos.Set(position.x(), position.y(), position.z())
	rot_pos = VISIPoint.New()
	rot_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Set Position
	##Move
	VISIGeoLib.ProjectPointOntoVector(end_pos, direction,height/2, end_pos)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,-gap, start_pos)
	
	#Create Body
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,length/2, start_pos)
	##Create
	block1 = VISISolidFactory.CreateBlock (length,width,height, start_pos, x_axis, direction)
	Uni_list.append(block1)
	
	#Chamfer/Blend
	edges = [18,20]
	if radius > 0:
		VISISolidFactory.BlendEdges(block1, edges, radius, 1)
	else:
		VISISolidFactory.ChamferEdges(block1, edges, width/30, width/30, 1)
		
	
	#Create Groove
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,height, start_pos)
	##Create
	block2 = VISISolidFactory.CreateBlock (length,width_base,height_base, start_pos, x_axis, inv_dir)
	Uni_list.append(block2)
	
	#Create Drilling
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,-length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,distance_screw_end, start_pos)
	
	
	if not distance_between_screws_width > 0:
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,height_base, start_pos)
		#1	
		#Head
		cyl01 = VISISolidFactory.CreateCylinder (diameter_sinking/2,height_sinking, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl01)
		#Body
		cyl02 = VISISolidFactory.CreateCylinder (diameter_through/2,height, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl02)
		
		
		#2
		if distance_between_screws > 0:
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,distance_between_screws, start_pos)
			cyl03 = VISISolidFactory.CreateCylinder (diameter_sinking/2,height_sinking, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl03)
			#Body
			cyl04 = VISISolidFactory.CreateCylinder (diameter_through/2,height, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl04)
	else:
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,-distance_between_screws_width/2, start_pos)
		#1	
		#Head
		cyl01 = VISISolidFactory.CreateCylinder (diameter_sinking/2,height_sinking, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl01)
		#Body
		cyl02 = VISISolidFactory.CreateCylinder (diameter_through/2,height, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl02)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,distance_between_screws_width, start_pos)
		cyl03 = VISISolidFactory.CreateCylinder (diameter_sinking/2,height_sinking, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl03)
		#Body
		cyl04 = VISISolidFactory.CreateCylinder (diameter_through/2,height, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl04)

	
		
		
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list, Result_List)
	
	VISISolidFactory.RotateBody(Result_List[0],end_pos,x_axis,math.radians(180))
	
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	height_base = params['HEIGHT_BASE']
	width_base = params['WIDTH_BASE']
	distance_screw_end = params['DISTANCE_SCREW_END']
	distance_between_screws = params['DISTANCE_BETWEEN_SCREWS']
	radius = params['RADIUS']
	diameter_sinking = params['DIAMETER_SINKING']
	height_sinking = params['HEIGHT_SINKING']
	diameter_screw = params['DIAMETER_SCREW']
	diameter_through = params['DIAMETER_THROUGH']
	invert = params['INVERT']
	gap = params['GAP']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	end_pos = VISIPoint.New()
	end_pos.Set(position.x(), position.y(), position.z())
	rot_pos = VISIPoint.New()
	rot_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Set Position
	##Move
	VISIGeoLib.ProjectPointOntoVector(end_pos, direction,height/2, end_pos)
	

	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,gap, start_pos)
	
	#Create Body
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,length/2, start_pos)
	##Create
	block1 = VISISolidFactory.CreateBlock (length,width,height, start_pos, x_axis, direction)
	Uni_list.append(block1)
	
	#Chamfer/Blend
	edges = [18,20]
	if radius > 0:
		VISISolidFactory.BlendEdges(block1, edges, radius, 1)
		
		
	return block1

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_fcu3'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
