import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	height = params['HEIGHT']
	height_base = params['HEIGHT_BASE']
	width_base = params['WIDTH_BASE']
	diameter_sinking = params['DIAMETER_SINKING']
	height_sinking = params['HEIGHT_SINKING']
	diameter_screw = params['DIAMETER_SCREW']
	diameter_through = params['DIAMETER_THROUGH']
	invert = params['INVERT']
	diameter_lock = params['DIAMETER_LOCK']
	distance_lock1 = params['DISTANCE_LOCK1']
	length_lock1 = params['LENGTH_LOCK1']
	distance_lock2 = params['DISTANCE_LOCK2']
	length_lock2 = params['LENGTH_LOCK2']
	rot_angle = params['ROT_ANGLE']
	distance_gap = params['DISTANCE_GAP']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	rot_pos = VISIPoint.New()
	rot_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	#x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	y_inv_axis = VISIVector.New()
	y_inv_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	#Set Position
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,height+distance_gap, start_pos)
	
	#Create Body
	##Move
	##Create
	cyl1 = VISISolidFactory.CreateCylinder (diameter/2,height, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	
	#Chamfer
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl1, edges, diameter/30, diameter/30, 1)
	edges = [6]
	VISISolidFactory.ChamferEdges(cyl1, edges, diameter/15, diameter/15, 1)
	
	#Create Nose
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,height, start_pos)
	
	##Create
	cyl2 = VISISolidFactory.CreateCylinder (diameter/2-diameter/30 ,height_base, start_pos, x_axis, direction)
	
	
	front_bodies_list = []
	back_bodies_list = []
	
	##Cut Groove
	#Cut 1
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,width_base/2, start_pos)
	VISISolidFactory.CutWithPlane(start_pos, y_axis, cyl2, front_bodies_list, back_bodies_list)

	cyl2 = back_bodies_list[0]
	VISISolidFactory.DeleteBodies(front_bodies_list)
	back_bodies_list = []
	front_bodies_list = []
		
	#Cut 2
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,-width_base, start_pos)
	VISISolidFactory.CutWithPlane(start_pos, y_axis, cyl2, front_bodies_list, back_bodies_list)
	
	VISISolidFactory.DeleteBodies(back_bodies_list)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,width_base/2, start_pos)
	
	Uni_list.append(front_bodies_list[0])
	
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Chamfer
	edges = [99,102]
	VISISolidFactory.ChamferEdges(Uni_list2[0], edges, diameter/30, diameter/20, 1)
	
	
	#Create Drilling
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,height_base, start_pos)
	#1
	#Head
	cyl01 = VISISolidFactory.CreateCylinder (diameter_sinking/2,height_sinking, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl01)
	#Body
	cyl02 = VISISolidFactory.CreateCylinder (diameter_through/2,height+height_base, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl02)
	
	
	#Create Drilling
	##Move

	#Create Drillings for Locks
	#Bottom
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,height_base+height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,-distance_lock1, start_pos)
	cyl03 = VISISolidFactory.CreateCylinder (diameter_lock/2,length_lock1, start_pos, x_axis, direction)
	Uni_list2.append(cyl03)
	
	#Create Cone
	h_cone = (diameter_lock/2)/(math.tan(math.radians(60)))
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+length_lock1, start_pos)
	cone03 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
	Uni_list2.append(cone03)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+length_lock1, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,distance_lock1, start_pos)
	
	#Side
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,distance_lock2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis,-diameter/2, start_pos)
	cyl04 = VISISolidFactory.CreateCylinder (diameter_lock/2,length_lock2, start_pos, direction, y_axis)
	Uni_list2.append(cyl04)

	#Create Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, h_cone+length_lock2, start_pos)
	cone04 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, direction, y_inv_axis)
	Uni_list2.append(cone04)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)

	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	height = params['HEIGHT']
	height_base = params['HEIGHT_BASE']
	width_base = params['WIDTH_BASE']
	diameter_sinking = params['DIAMETER_SINKING']
	height_sinking = params['HEIGHT_SINKING']
	diameter_screw = params['DIAMETER_SCREW']
	diameter_through = params['DIAMETER_THROUGH']
	invert = params['INVERT']
	distance_gap = params['DISTANCE_GAP']
	depth_cavity_lock2 = params['DEPTH_CAVITY_LOCK2']
	length_cavity_lock2 = params['LENGTH_CAVITY_LOCK2']
	diameter_lock = params['DIAMETER_LOCK']
	create_extra_cavity = params['CREATE_EXTRA_CAVITY']
	rot_angle = params['ROT_ANGLE']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	rot_pos = VISIPoint.New()
	rot_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	#Set Position
	##Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,height+distance_gap, start_pos)
	
	#Create Body
	##Create
	cyl1 = VISISolidFactory.CreateCylinder (diameter/2, height+distance_gap, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
		
	if create_extra_cavity:
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction,height+distance_gap, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -diameter/2, start_pos)
		block02 = VISISolidFactory.CreateBlock(length_cavity_lock2*2,diameter_lock, depth_cavity_lock2+distance_gap, start_pos, y_axis, inv_dir)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -length_cavity_lock2, start_pos)
		cyl02 = VISISolidFactory.CreateCylinder(diameter_lock/2, depth_cavity_lock2+distance_gap, start_pos, y_axis, inv_dir)
		Uni_list.append(block02)
		Uni_list.append(cyl02)

		#Unite
		VISISolidFactory.Unite(Uni_list, Result_List)
		return Result_List[0]
	
	else:
		return cyl1

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_fcu4_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
