import VISI, VISIParam, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	pos_orig = params['POS_ORIG']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	eje_max_dim = params['EJE_MAX_DIM']
	pin_diameter = params['PIN_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	head_height = params['HEAD_HEIGHT']
	under_head_rad = params['UNDER_HEAD_RAD']
	eje_min_dim = params['EJE_MIN_DIM']
	guiding_length = params['GUIDING_LENGTH']
	min_length = params['MIN_LENGTH']
	length = params['LENGTH']
	head_clearance = params['HEAD_CLEARANCE']
	body_clearance = params['BODY_CLEARANCE']
	clearance_firstplate = params['CLEARANCE_FIRSTPLATE']
	clearance_under_head = params['CLEARANCE_UNDER_HEAD']
	guide_factor = params['GUIDE_FACTOR']
	guidide_length = params['GUIDIDE_LENGTH']
	rotation_angle = params['ROTATION_ANGLE']
	head_without_housing = params['HEAD_WITHOUT_HOUSING']
	follow_uhclearance = params['FOLLOW_UHCLEARANCE']
	body_rad = params['BODY_RAD']
	face_end = params['FACE_END']
	adapt_to_face = params['ADAPT_TO_FACE']
	adapt_to_body = params['ADAPT_TO_BODY']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	x_axis = VISIVector.New()
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	x_axis = ref_direction
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)

	if ( length >= min_length ):
		extra_thick = length - min_length
	else:
		extra_thick = min_length - length
	## Creating Head
	if(head_without_housing):
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -head_height, start_pos)
		head = VISISolidFactory.CreateCylinder(head_diameter / 2, head_height, start_pos, ref_direction, direction)
		Uni_list.append(head)
	else:
		if(follow_uhclearance):
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction, clearance_under_head, start_pos)
		head = VISISolidFactory.CreateCylinder(head_diameter / 2, head_height, start_pos, ref_direction, direction)
		Uni_list.append(head)
		
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_height, start_pos)
	
	
	#Versatz = 	10./1000 * math.sin(math.acos((10./1000-(3./1000-0.5/1000)/2)/(10./1000)))
		
	## Creating Body 
	body1 = VISISolidFactory.CreateCylinder(pin_diameter / 2, guiding_length - head_height,
						start_pos, ref_direction, direction)
	Uni_list.append(body1)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, guiding_length - head_height, start_pos)

	body2 = VISISolidFactory.CreateBlock(eje_max_dim, eje_min_dim, min_length - guiding_length - end_thick, 
						     start_pos, ref_direction, direction)
	body3 = VISISolidFactory.CreateBlock(eje_max_dim, eje_min_dim, min_length + extra_thick - guiding_length, 
						     start_pos, ref_direction, direction)

	body3 = VISIParam.AdaptCavityToPlate(end_plate, body3, 0)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, min_length + extra_thick - guiding_length, start_pos)
	
	if (adapt_to_face):
		face_start = VISISolidFactory.GetFaceInBodyFromPoint(body3,start_pos)
		VISISolidFactory.ReplaceFaceSurface(face_start,face_end)
	elif (adapt_to_body):
		body3 = VISIParam.AdaptCavityToPlate(end_plate, body3, 0)
	else:
		front_list =[]
		end_list =[]
		VISISolidFactory.CutWithPlane(pos_orig, direction, body3, front_list,end_list)
		VISISolidFactory.DeleteBodies(front_list)
		if len(end_list)>0:
			body3 = end_list[0]
		else:
			body3 = body3
	
	#Reset Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -(min_length + extra_thick - guiding_length), start_pos)
	
	
	
	
	
	if ( body2):
		Uni_list.append(body2)
	
	## Unite The Ejectors Parts 
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, body_rad+eje_min_dim/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -pin_diameter/2, start_pos)
	
	rad = VISISolidFactory.CreateCylinder(body_rad, pin_diameter, start_pos, y_axis, x_axis)

	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -2*body_rad-eje_min_dim, start_pos)
	
	rad2 = VISISolidFactory.CreateCylinder(body_rad, pin_diameter, start_pos, y_axis, x_axis)
	

	Uni_list2.append(rad)
	Uni_list2.append(rad2)	
	## Subtract The Ejectors Parts 
	VISISolidFactory.Subtract(Uni_list2, Result_List)

        if(under_head_rad > 0):
            ## Blend
            edges = [19]
            VISISolidFactory.BlendEdges(Result_List[0], edges, under_head_rad, 1)

	Uni_list = []
	Uni_list.append(Result_List[0])
	Uni_list.append(body3)
	Result_List = []
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	pos_orig = params['POS_ORIG']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	eje_max_dim = params['EJE_MAX_DIM']
	pin_diameter = params['PIN_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	head_height = params['HEAD_HEIGHT']
	under_head_rad = params['UNDER_HEAD_RAD']
	eje_min_dim = params['EJE_MIN_DIM']
	guiding_length = params['GUIDING_LENGTH']
	length = params['LENGTH']
	min_length = params['MIN_LENGTH']
	head_clearance = params['HEAD_CLEARANCE']
	body_clearance = params['BODY_CLEARANCE']
	clearance_firstplate = params['CLEARANCE_FIRSTPLATE']
	clearance_under_head = params['CLEARANCE_UNDER_HEAD']
	guide_factor = params['GUIDE_FACTOR']
	guidide_length = params['GUIDIDE_LENGTH']
	rotation_angle = params['ROTATION_ANGLE']
	head_without_housing = params['HEAD_WITHOUT_HOUSING']
	follow_uhclearance = params['FOLLOW_UHCLEARANCE']
	calc_guided_length = params['CALC_GUIDED_LENGHT']
	face_end = params['FACE_END']
	adapt_to_face = params['ADAPT_TO_FACE']
	adapt_to_body = params['ADAPT_TO_BODY']
	
	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	if ( length >= min_length ):
		extra_thick = length - min_length
	else:
		extra_thick = min_length - length
		
		
		
	if(head_without_housing):
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, head_height, start_pos)
		clearance_under_head = 0
	else:

		cav1 = VISISolidFactory.CreateCylinder((head_diameter + head_clearance)/2,
						       head_height + clearance_under_head,
						       start_pos, ref_direction, direction)
		cam_list = [(head_diameter + head_clearance), (head_height + clearance_under_head)]
		VISI.AttachCamAttributes(cav1,cam_list,"FEP11_1",elem_tag,params["BUILDER_UNIT"])
		Uni_list.append(cav1)

        VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_height + clearance_under_head + under_head_rad,
                                          start_pos)
        if(under_head_rad > 0):
            ##Cone
            cone_angle = math.atan( (((pin_diameter + clearance_firstplate)/2 + under_head_rad) -
                                     (pin_diameter + clearance_firstplate)/2) / under_head_rad)
            cone = VISISolidFactory.CreateCone((pin_diameter + clearance_firstplate)/2, under_head_rad, cone_angle,
                                               start_pos, ref_direction, inv_dir)
            Uni_list.append(cone)

	if(start_plate <> end_plate):
		if(head_without_housing):
			cav2 = VISISolidFactory.CreateCylinder((pin_diameter + clearance_firstplate)/2
							       , start_thick - (clearance_under_head + under_head_rad),
							       start_pos, ref_direction, direction)
			cam_list = [(pin_diameter + clearance_firstplate),
				    start_thick - (clearance_under_head + under_head_rad)]
			VISI.AttachCamAttributes(cav2,cam_list,"FEP11_2",elem_tag,params["BUILDER_UNIT"])
			Uni_list.append(cav2)
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction
							  , start_thick -(clearance_under_head + under_head_rad), start_pos)

		else:
			cav2 = VISISolidFactory.CreateCylinder((pin_diameter + clearance_firstplate)/2
							       , start_thick - (clearance_under_head + head_height + under_head_rad),
							       start_pos, ref_direction, direction)
			cam_list = [(pin_diameter + clearance_firstplate), start_thick - (clearance_under_head + head_height + under_head_rad)]
			VISI.AttachCamAttributes(cav2,cam_list,"FEP11_2",elem_tag,params["BUILDER_UNIT"])
			Uni_list.append(cav2)
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction
							  , start_thick - (clearance_under_head + head_height + under_head_rad)
							  , start_pos)
		
		cav3 = VISISolidFactory.CreateCylinder((pin_diameter + body_clearance)/2
					       , total_thick - (start_thick + calc_guided_length), start_pos, ref_direction, direction)
		cam_list = [(pin_diameter + body_clearance), total_thick - (start_thick + calc_guided_length)]
		VISI.AttachCamAttributes(cav3,cam_list,"FEP11_3",elem_tag,params["BUILDER_UNIT"])
		Uni_list.append(cav3)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction
						  , total_thick - (start_thick + calc_guided_length), start_pos)

		cav4  = VISISolidFactory.CreateBlock(eje_max_dim, eje_min_dim, calc_guided_length + extra_thick,
						     start_pos , ref_direction, direction)
		
		cav4 = VISIParam.AdaptCavityToPlate(end_plate, cav4, 0)
		Uni_list.append(cav4)
		
		## Adapt
		if (adapt_to_face) or (adapt_to_body):
			cav4 = VISIParam.AdaptCavityToPlate(end_plate, cav4, 0)
		else:
			front_list =[]
			end_list =[]
			VISISolidFactory.CutWithPlane(pos_orig, direction, cav4, front_list,end_list)
			VISISolidFactory.DeleteBodies(front_list)
			if len(end_list)>0:
				cav4 = end_list[0]
			else:
				cav4 = cav4
	else:
		if(head_without_housing):
			cav2 = VISISolidFactory.CreateCylinder((pin_diameter + clearance_firstplate)/2
							, total_thick - (clearance_under_head + under_head_rad + calc_guided_length),
							start_pos, ref_direction, direction)
			cam_list = [(pin_diameter + clearance_firstplate), total_thick - (clearance_under_head + under_head_rad + calc_guided_length)]
			VISI.AttachCamAttributes(cav2,cam_list,"FEP11_2",elem_tag,params["BUILDER_UNIT"])
			Uni_list.append(cav2)
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction
							  , total_thick - (clearance_under_head + under_head_rad + calc_guided_length), start_pos)
		else:
			cav2 = VISISolidFactory.CreateCylinder((pin_diameter + clearance_firstplate)/2
							, total_thick - (head_height + clearance_under_head + under_head_rad + calc_guided_length),
							start_pos, ref_direction, direction)
			cam_list = [(pin_diameter + clearance_firstplate), total_thick - (head_height + clearance_under_head + under_head_rad + calc_guided_length)]
			VISI.AttachCamAttributes(cav2,cam_list,"FEP11_2",elem_tag,params["BUILDER_UNIT"])
			Uni_list.append(cav2)
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction
							  , total_thick - (head_height + clearance_under_head + under_head_rad + calc_guided_length), start_pos)

		cav3  = VISISolidFactory.CreateBlock(eje_max_dim, eje_min_dim, calc_guided_length + extra_thick,start_pos , ref_direction, direction)

		cav3 = VISIParam.AdaptCavityToPlate(end_plate, cav3, 0)
			
		## Adapt
		if (adapt_to_face) or (adapt_to_body):
			cav3 = VISIParam.AdaptCavityToPlate(end_plate, cav3, 0)
		else:
			front_list =[]
			end_list =[]
			VISISolidFactory.CutWithPlane(pos_orig, direction, cav3, front_list,end_list)
			VISISolidFactory.DeleteBodies(front_list)
			if len(end_list)>0:
				cav3 = end_list[0]
			else:
				cav3 = cav3
					
		Uni_list.append(cav3)
	##Unite The Sprue Bushing Parts 
	VISISolidFactory.Unite(Uni_list, Result_List,0)
	
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_fep11'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())


	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
