import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	diameter = params['DIAMETER']
	ext_diameter = params['EXT_DIAMETER']
	key_diameter = params['KEY_DIAMETER']
	key_height = params['KEY_HEIGHT']
	hole_diameter = params['HOLE_DIAMETER']
	hole_diameter2 = params['HOLE_DIAMETER2']
	ext_height = params['EXT_HEIGHT']
	length = params['LENGTH']
	free_length = params['FREE_LENGTH']
	hex_clear = params['HEX_CLEAR']
	housing_height = params['HOUSING_HEIGHT']
	
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	Front_Body_List = []
	Back_Body_List = []
	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	if(housing_height):
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, housing_height, start_pos)

	cyl1 = VISISolidFactory.CreateCylinder(ext_diameter/2, ext_height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)

	cyl2 = VISISolidFactory.CreateCylinder(diameter/2, free_length - ext_height, start_pos, x_axis, direction)
	Uni_list.append(cyl2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, free_length - ext_height, start_pos)

	hole1 = VISISolidFactory.CreateCylinder(hole_diameter/2, free_length - key_height - ext_height/2, start_pos, x_axis, inv_dir)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, free_length - key_height - ext_height/2, start_pos)
	hole2 = VISISolidFactory.CreatePrism(key_diameter * math.tan(math.pi/6.), key_height, 6, start_pos, x_axis, inv_dir)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, key_height, start_pos)
	hole3 = VISISolidFactory.CreateCylinder(hole_diameter2/2, ext_height/2, start_pos, x_axis, inv_dir)

	VISISolidFactory.Unite(Uni_list, Result_List)

	body_list = []
	body_list.append(Result_List[0])
	body_list.append(hole1)
	body_list.append(hole2)
	body_list.append(hole3)
	Result_List = []
	VISISolidFactory.Subtract(body_list, Result_List)

	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, ext_height/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, 0.003, start_pos)

	VISISolidFactory.CutWithPlane(start_pos, inv_dir, Result_List[0], Front_Body_List, Back_Body_List)
	part1 = Front_Body_List[0]
	part2 = Back_Body_List[0]

        edges = [12, 205]      
	VISISolidFactory.ChamferEdges(part1, edges, 0.001, 0.001, 1)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, 0.001, start_pos)
	Front_Body_List = []
	Back_Body_List = []
	VISISolidFactory.CutWithPlane(start_pos, inv_dir, part2, Front_Body_List, Back_Body_List)
	part3 = Front_Body_List[0]
	part4 = Back_Body_List[0]

	del_list = []
	del_list.append(part3)
	VISISolidFactory.DeleteBodies(del_list)

        edges = [6]      
	VISISolidFactory.ChamferEdges(part4, edges, 0.001, 0.001, 1)

	cyl1 = VISISolidFactory.CreateCylinder(ext_diameter/2 - (0.001 * math.tan(math.radians(45))), 0.001, start_pos, x_axis, inv_dir)
	hole1 = VISISolidFactory.CreateCylinder(hole_diameter2/2, 0.001, start_pos, x_axis, inv_dir)

	Uni_list = []
	Result_List = []
	Uni_list.append(part1)
	Uni_list.append(part4)
	Uni_list.append(cyl1)
	VISISolidFactory.Unite(Uni_list, Result_List)

	body_list = []
	body_list.append(Result_List[0])
	body_list.append(hole1)
	Result_List = []
	VISISolidFactory.Subtract(body_list, Result_List)

	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	diameter = params['DIAMETER']
	ext_diameter = params['EXT_DIAMETER']
	key_diameter = params['KEY_DIAMETER']
	key_height = params['KEY_HEIGHT']
	hole_diameter = params['HOLE_DIAMETER']
	ext_height = params['EXT_HEIGHT']
	length = params['LENGTH']
	free_length = params['FREE_LENGTH']
	hex_clear = params['HEX_CLEAR']
	housing_height = params['HOUSING_HEIGHT']
	start_plate = params['START_PLATE']
	hex_cav_diam = params['HEX_CAV_DIAM']
	
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	Front_Body_List = []
	Back_Body_List = []
	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	pos = VISIPoint.New()
	pos.Set(position.x(), position.y(), position.z())

	if(housing_height):
                #if(key_diameter>0):
                        #used_diam = round((key_diameter/2 / math.cos(math.radians(30))), 4) + hex_clear
                #else:
                        #used_diam = (ext_diameter + hex_clear)/2

                used_diam = hex_cav_diam/2
                
		cyl1 = VISISolidFactory.CreateCylinder(used_diam, housing_height, start_pos, x_axis, direction)
		#Uni_list.append(cyl1)
		cam_list = [used_diam, housing_height]
		VISI.AttachCamAttributes(cyl1,cam_list,"FITWE2_1",elem_tag,params["BUILDER_UNIT"])
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, housing_height, start_pos)

		if (start_plate):
                        cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl1, pos)
                        hole = VISIParam.ExtendFaceToSolid(start_plate, cavity_face, direction)
                        hole= VISIParam.AdaptCavityToPlate(start_plate, hole, 0)
                        Uni_list.append(hole)
                else:
                        Uni_list.append(cyl1)

	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, free_length - ext_height, start_pos, x_axis, direction)
	#Uni_list.append(cyl1)
	cam_list = [diameter, free_length - housing_height - ext_height]
	VISI.AttachCamAttributes(cyl1,cam_list,"FITWE2_2",elem_tag,params["BUILDER_UNIT"])

	if (start_plate) and not(housing_height):
                cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl1, pos)
                hole = VISIParam.ExtendFaceToSolid(start_plate, cavity_face, direction)
                hole= VISIParam.AdaptCavityToPlate(start_plate, hole, 0)
                Uni_list.append(hole)
        else:
                Uni_list.append(cyl1)

	VISISolidFactory.Unite(Uni_list, Result_List,0)
		
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_fitwe2_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
