import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def LoadGlobals ():
	global screw_positions
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	width2 = params['WIDTH2']
	length = params['LENGTH']
	depth = params['DEPTH']
	depth1 = params['DEPTH1']
	screw_body = params['SCREW_BODY']
	screw_head = params['SCREW_HEAD']
	head_height = params['HEAD_HEIGHT']
	screw_st =	params['SCREW_ST']
	screw_dist = params['SCREW_DIST']
	offset_length = params['OFFSET_LENGTH']
	screw_diam = params['SCREW_DIAM']
	ins_dep = params['INS_DEP']
	rev = params['REV']
	flat = params['FLAT']
	radius = params['RADIUS']
	rotation_angle = params['ROTATION_ANGLE']
	plate_direction = params['PLATE_DIRECTION']
	rotation_angle*=1000
	rotation_angle = math.radians(rotation_angle)
	
	#screw_head = screw_head - 0.0000001

	screw_positions = []
	start_pos = VISIPoint.New()
	start_pos1 = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	rev_direction = VISIVector.New()
	rev_direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	####################
	x_axis.Set(plate_direction.Cx(), plate_direction.Cy(), plate_direction.Cz())
	if ((math.fabs(math.fabs(plate_direction.Cx()) - math.fabs(rev_direction.Cx())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cy()) - math.fabs(rev_direction.Cy())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cz()) - math.fabs(rev_direction.Cz())) <0.0000001)):
		VISIGeoLib.ArbitraryNormalAxis(rev_direction, x_axis)
	else:
		VISIGeoLib.naXb(rev_direction, plate_direction, x_axis)

	VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, rotation_angle)	
	####################	
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(rev_direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-rev_direction.Cx(), -rev_direction.Cy(), -rev_direction.Cz())
	yy_axis = VISIVector.New()
	yy_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	if(rev <> 0):
		VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, math.radians(180))
		VISIGeoLib.VectorRotate(y_axis, rev_direction, y_axis, math.radians(180))
		VISIGeoLib.VectorRotate(yy_axis, rev_direction, yy_axis, math.radians(180))

	
	#Project Start Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, offset_length/2, start_pos)
	#VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ins_dep, start_pos)
	
	#Project Start Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -offset_length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (-length+offset_length)/2, start_pos)
	start_pos1 = VISIPoint.New()
	start_pos1.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos1, rev_direction, -depth1, start_pos1)
	VISIGeoLib.ProjectPointOntoVector(start_pos1, y_axis, -(length-offset_length)/2, start_pos1)	
	
	VISIGeoLib.ProjectPointOntoVector(position, y_axis, screw_st, start_pos)	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, flat/2, start_pos)
	
	tmp_pos = VISIPoint.New()
	tmp_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	screw_positions.append(tmp_pos)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -flat, start_pos)
	screw_positions.append(start_pos)


def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	width2 = params['WIDTH2']
	length = params['LENGTH']
	depth = params['DEPTH']
	depth1 = params['DEPTH1']
	screw_body = params['SCREW_BODY']
	screw_head = params['SCREW_HEAD']
	head_height = params['HEAD_HEIGHT']
	screw_st =	params['SCREW_ST']
	screw_dist = params['SCREW_DIST']
	offset_length = params['OFFSET_LENGTH']
	screw_diam = params['SCREW_DIAM']
	ins_dep = params['INS_DEP']
	rev = params['REV']
	flat = params['FLAT']
	radius = params['RADIUS']
	rotation_angle = params['ROTATION_ANGLE']
	plate_direction = params['PLATE_DIRECTION']
	rotation_angle*=1000
	rotation_angle = math.radians(rotation_angle)
	
	length = length + offset_length
	
	#screw_head = screw_head - 0.0000001

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos1 = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	rev_direction = VISIVector.New()
	rev_direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	####################
	x_axis.Set(plate_direction.Cx(), plate_direction.Cy(), plate_direction.Cz())
	if ((math.fabs(math.fabs(plate_direction.Cx()) - math.fabs(rev_direction.Cx())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cy()) - math.fabs(rev_direction.Cy())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cz()) - math.fabs(rev_direction.Cz())) <0.0000001)):
		VISIGeoLib.ArbitraryNormalAxis(rev_direction, x_axis)
	else:
		VISIGeoLib.naXb(rev_direction, plate_direction, x_axis)

	VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, rotation_angle)	
	####################	
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(rev_direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-rev_direction.Cx(), -rev_direction.Cy(), -rev_direction.Cz())
	yy_axis = VISIVector.New()
	yy_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	if(rev <> 0):
		VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, math.radians(180))
		VISIGeoLib.VectorRotate(y_axis, rev_direction, y_axis, math.radians(180))
		VISIGeoLib.VectorRotate(yy_axis, rev_direction, yy_axis, math.radians(180))

	
	#Project Start Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, offset_length/2, start_pos)
	#VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ins_dep, start_pos)

	#Create Body
	bl1 = VISISolidFactory.CreateBlock (width2, offset_length, depth, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	
	
	#Project Start Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -offset_length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (-length+offset_length)/2, start_pos)
	start_pos1 = VISIPoint.New()
	start_pos1.Set(position.x(), position.y(), position.z())
	#cyl2 = VISISolidFactory.CreateCylinder(screw_head/2, head_height, start_pos1, direction, yy_axis)
	VISIGeoLib.ProjectPointOntoVector(start_pos1, rev_direction, -depth1, start_pos1)
	VISIGeoLib.ProjectPointOntoVector(start_pos1, y_axis, -(length-offset_length)/2, start_pos1)	
	#Create Body
	bl2 = VISISolidFactory.CreateBlock (width, length-offset_length, depth1, start_pos1, x_axis, rev_direction)
	Uni_list.append(bl2)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	VISISolidFactory.RotateBody(Uni_list2[0], position, x_axis, math.radians(90))
	
	#flat = flat - 0.01
	chamfer = width/10
	chamfer2 = math.tan(math.radians(10))*chamfer
	edges = [85,88]
	#edges = [25,31]
	VISISolidFactory.ChamferEdges(Uni_list2[0], edges, chamfer2, chamfer, 1)

	VISIGeoLib.ProjectPointOntoVector(position, y_axis, screw_st, start_pos)	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, flat/2, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder(screw_head/2, head_height, start_pos, yy_axis, rev_direction)
	cyl2 = VISISolidFactory.CreateCylinder(screw_body/2, offset_length, start_pos, yy_axis, rev_direction)
	Uni_list2.append(cyl1)
	Uni_list2.append(cyl2)
	
	tmp_pos = VISIPoint.New()
	tmp_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -flat, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(screw_head/2, head_height, start_pos, yy_axis, rev_direction)
	cyl4 = VISISolidFactory.CreateCylinder(screw_body/2, offset_length, start_pos, yy_axis, rev_direction)
	
	Uni_list2.append(cyl3)
	Uni_list2.append(cyl4)
		
	
	r = VISISolidFactory.Subtract(Uni_list2, Result_List)
	#VISI.MessageBox("", str(depth-depth1))	
	#Rotate
	#VISISolidFactory.RotateBody (Result_List[0], start_pos, y_axis, math.radians(180))	
	#Blend Edges
	#edgess = [6, 14]
	edgess = [25, 31]
	VISISolidFactory.BlendEdges (Result_List[0], edgess, radius, 1)

	#VISI.MessageBox("", str(Result_List[0]))	
	#VISI.MessageBox("", str(str(plate_direction.Cx()) + " " + str(plate_direction.Cy()) + " "+ str(plate_direction.Cz())))
	
	VISISolidFactory.TranslateBodyByVector(Result_List[0], y_axis, ins_dep)
		
	return Result_List[0]


def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	width2 = params['WIDTH2']
	length = params['LENGTH']
	depth = params['DEPTH']
	depth1 = params['DEPTH1']
	screw_body = params['SCREW_BODY']
	screw_head = params['SCREW_HEAD']
	head_height = params['HEAD_HEIGHT']
	screw_dist = params['SCREW_DIST']
	offset_length = params['OFFSET_LENGTH']
	screw_diam = params['SCREW_DIAM']
	ins_dep = params['INS_DEP']
	rev = params['REV']
	clear = params['CLEAR']
	flat = params['FLAT']
	clear_w = params['CLEAR_W']
	milling = params['MILLING']
	offset_milling = params['OFFSET_MILLING']
	milling_check = params['MILLING_CHECK']
	rounding_check = params['ROUNDING_CHECK']
	milling_inferior = params['MILLING_INFERIOR']
	screw_check = params['SCREW_CHECK']
	#core_diameter = params['CORE_DIAMETER']
	#core_length = params['CAV_LENGTH']
	extra_length = params['EXTRA_LENGTH']
	extra_thread = params['EXTRA_THREAD']
	#thread_length = params['THREAD_LENGTH']
	#thread_pitch = params['THREAD_PITCH']
	radius = params['RADIUS']
	plate_direction = params['PLATE_DIRECTION']
	
	length = length + offset_length
	
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
		
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Result_List = []

	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	rev_direction = VISIVector.New()
	rev_direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	##########################
	x_axis.Set(plate_direction.Cx(), plate_direction.Cy(), plate_direction.Cz())
	if ((math.fabs(math.fabs(plate_direction.Cx()) - math.fabs(rev_direction.Cx())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cy()) - math.fabs(rev_direction.Cy())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cz()) - math.fabs(rev_direction.Cz())) <0.0000001)):
		VISIGeoLib.ArbitraryNormalAxis(rev_direction, x_axis)
	else:
		VISIGeoLib.naXb(rev_direction, plate_direction, x_axis)

	#####################
	
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(rev_direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-rev_direction.Cx(), -rev_direction.Cy(), -rev_direction.Cz())

	if(rev <> 0):
		VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, math.radians(180))
		VISIGeoLib.VectorRotate(y_axis, rev_direction, y_axis, math.radians(180))

	#Project Start Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, offset_length/2, start_pos)
	

	start_pos2 = VISIPoint.New()
	start_pos2.Set(start_pos.x(), start_pos.y(), start_pos.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos2, inv_dir, depth + ins_dep, start_pos2)
	#Create Body
	bl1 = VISISolidFactory.CreateBlock (width2, offset_length, depth+ins_dep, start_pos2, x_axis, rev_direction)
	Uni_list.append(bl1)
	
	#Project Start Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -offset_length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (-length+offset_length)/2, start_pos)
	
	start_pos1 = VISIPoint.New()
	start_pos1.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos1, rev_direction, -depth1 - ins_dep, start_pos1)
	VISIGeoLib.ProjectPointOntoVector(start_pos1, y_axis, -(length-offset_length)/2, start_pos1)	
	#Create Body
	bl2 = VISISolidFactory.CreateBlock (width+clear_w, length-offset_length, depth1+ins_dep, start_pos1, x_axis, rev_direction)
	Uni_list.append(bl2)
	
	#Project Start Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(-length+offset_length)/2-offset_length-(length-offset_length*2)/2-clear/2, start_pos)
	
	#Create Body
	#bl3 = VISISolidFactory.CreateBlock (width+clear_w, length-2*offset_length+clear, depth1+offset+ins_dep, start_pos, x_axis, inv_dir)
	#Uni_list.append(bl3)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Rotate
	#VISISolidFactory.RotateBody (Uni_list2[0], start_pos, y_axis, math.radians(180))

	if milling_inferior == 1:
	
		#Create Milling
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, offset_length, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, milling/2-width/2, start_pos)
		bl4 = VISISolidFactory.CreateBlock (milling, 2*offset_milling, depth+ins_dep, start_pos, x_axis, rev_direction)
		Uni_list2.append(bl4)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, offset_milling, start_pos)
		cyl1 = VISISolidFactory.CreateCylinder (milling/2, depth+ins_dep, start_pos, x_axis, rev_direction)
		Uni_list2.append(cyl1)
	
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -offset_milling, start_pos)	
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, width-milling, start_pos)
		bl5 = VISISolidFactory.CreateBlock (milling, 2*offset_milling, depth+ins_dep, start_pos, x_axis, rev_direction)
		Uni_list2.append(bl5)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, offset_milling, start_pos)
		cyl2 = VISISolidFactory.CreateCylinder (milling/2, depth+ins_dep, start_pos, x_axis, rev_direction)
		Uni_list2.append(cyl2)
	
	#Unite
	VISISolidFactory.Unite(Uni_list2, Uni_list3)
	
	chamfer = width/10
	chamfer2 = (math.tan(math.radians(15))*(chamfer))
	
	if rounding_check > 0 and clear == 0 and chamfer2 >= milling:
		edges = [82,74]
		VISISolidFactory.BlendEdges(Uni_list3[0], edges, rounding_check, 1)
	if rounding_check > 0 and clear > 0:
		edges = [88,94]
		VISISolidFactory.BlendEdges(Uni_list3[0], edges, rounding_check, 1)
	if rounding_check > 0 and clear > 0 and clear_w > 0:
		edges = [90,96]
		VISISolidFactory.BlendEdges(Uni_list3[0], edges, rounding_check, 1)
	if rounding_check > 0 and clear_w > 0:
		edges = [84,74]
		VISISolidFactory.BlendEdges(Uni_list3[0], edges, rounding_check, 1)
		
	#Create Screw Holes
	if screw_check == 1:
		#SCREW Hole 1
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, depth+ins_dep, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, offset_length-screw_st, start_pos)
		cyls1 = VISISolidFactory.CreateCylinder(core_diameter/2, core_length+extra_length+extra_thread, start_pos, x_axis, rev_direction)
		Uni_list3.append(cyls1)
		
		#Create Cone 1
		h_cone = (core_diameter/2)/(math.tan(math.radians(60)))
		VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, core_length+extra_length+ h_cone+extra_thread, start_pos)	
		cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
		Uni_list3.append(cone)
		VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, -(core_length+extra_length+ h_cone+extra_thread), start_pos)
		
		
		#SCREW Hole 2
		#VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -screw_dist, start_pos)
		cyls2 = VISISolidFactory.CreateCylinder(core_diameter/2, core_length+extra_length+extra_thread, start_pos, x_axis, rev_direction)
		Uni_list3.append(cyls2)
		
		#Create Cone 1
		VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, core_length+extra_length+ h_cone+extra_thread, start_pos)	
		cone2 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
		Uni_list3.append(cone2)
		VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, -(core_length+extra_length+ h_cone+extra_thread), start_pos)
		
		#Attach Cam attributes for thread
		cam_list = [core_diameter, core_length+extra_length+extra_thread, screw_diam, thread_length + extra_thread, thread_pitch]
		VISI.AttachCamAttributes(cyls1,cam_list,"FLATGUIDE_3_1_1",elem_tag,params["BUILDER_UNIT"])
		VISI.AttachCamAttributes(cyls2,cam_list,"FLATGUIDE_3_1_1",elem_tag,params["BUILDER_UNIT"])	


	#Unite
	VISISolidFactory.Unite(Uni_list3, Result_List)
	VISISolidFactory.RotateBody(Result_List[0], position, x_axis, math.radians(90))
	
	edges = [6,14]
	VISISolidFactory.BlendEdges (Result_List[0], edges, radius, 1)
	
	#VISISolidFactory.TranslateBodyByVector(Result_List[0], plate_direction, -ins_dep)

	return Result_List[0]


def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_flatguide_3_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	LoadGlobals()
	
	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
