import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	total_length = params['TOTAL_LENGTH']
	chamfer2 = params['CHAMFER2']
	radius = params['RADIUS']
	angle0 = params['ANGLE0']
	angle2 = params['ANGLE2']
	angle3 = params['ANGLE3']
	distance_chamfer = params['DISTANCE_CHAMFER']
	core_diameter = params['CORE_DIAMETER']
	core_length = params['CORE_LENGTH']
	thread_diameter = params['THREAD_DIAMETER']
	thread_length = params['THREAD_LENGTH']
	hole_diameter = params['HOLE_DIAMETER']
	hole_length = params['HOLE_LENGTH']
	thread_pitch = params['THREAD_PITCH']
	length6 = params['LENGTH6']
	length8 = params['LENGTH8']
	length_cavity = params['LENGTH_CAVITY']
	length_cavity2 = params['LENGTH_CAVITY2']
	inv_direction = params['INV_DIRECTION']
	ins_depth = params['INS_DEPTH']
	support = params['SUPPORT']
	thickness_startplate = params['THICKNESS_STARTPLATE']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	Result_List2 = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	# if inv_direction == 1:
		# direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	#set right position
	if support:
		VISIGeoLib.ProjectPointOntoVector(start_pos,direction,thickness_startplate,start_pos)
	else:
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ins_depth, start_pos)
	
	#Body
	cyl2 = VISISolidFactory.CreateCylinder(diameter/2, total_length, start_pos, x_axis, direction)
	Result_List.append(cyl2)
		
	#Chamfer
	edges = [6]
	chamfer_up = math.tan(angle2)*chamfer2
	VISISolidFactory.ChamferEdges(cyl2, edges, chamfer2, chamfer_up, 1)
	edges = [12]
	chamfer_up = math.tan(angle3)*distance_chamfer
	VISISolidFactory.ChamferEdges(cyl2, edges, distance_chamfer,chamfer_up, 1)	
	
	#Blend Edges
	edges = [49]
	VISISolidFactory.BlendEdges(cyl2, edges, radius, 1)
	
	#Create lower drilling
	#Core diameter
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, total_length, start_pos)
	cyl10 = VISISolidFactory.CreateCylinder(core_diameter/2, core_length, start_pos, x_axis, inv_dir)
	Result_List.append(cyl10)
	#diameter 7
	cyl11	= VISISolidFactory.CreateCylinder(hole_diameter/2, hole_length, start_pos, x_axis, inv_dir)
	Result_List.append(cyl11)
	#Create Cone
	#Cone from start
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length6, start_pos)
	cone10 = VISISolidFactory.CreateCone(hole_diameter/2, length6, angle0, start_pos, x_axis, direction)
	Result_List.append(cone10)
	#Cone in middle
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length8-length6, start_pos)
	cone11 = VISISolidFactory.CreateCone(core_diameter/2, length8-hole_length, angle0, start_pos, x_axis, direction)	
	Result_List.append(cone11)
	#Cone in End
	h_cone = (core_diameter/2)/(math.tan(math.radians(60)))
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, core_length-length8 +h_cone, start_pos)
	cone12 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Result_List.append(cone12)
	
	#Add thread
	cam_list = [core_diameter, core_length, thread_diameter, thread_length, thread_pitch]
	VISI.AttachCamAttributes(cyl10,cam_list,"GP2_1",0,params["BUILDER_UNIT"])
	
	#reset position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, total_length-core_length-h_cone, start_pos)
	
	#Create upper drilling
	#Core diameter
	cyl20 = VISISolidFactory.CreateCylinder(core_diameter/2, core_length, start_pos, x_axis, direction)
	Result_List.append(cyl20)
	#diameter 7
	cyl21	= VISISolidFactory.CreateCylinder(hole_diameter/2, hole_length, start_pos, x_axis, direction)
	Result_List.append(cyl21)
	#Create Cone
	#Cone from start
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length6, start_pos)
	cone20 = VISISolidFactory.CreateCone(hole_diameter/2, length6, angle0, start_pos, x_axis, inv_dir)
	Result_List.append(cone20)
	#Cone in middle
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length8-length6, start_pos)
	cone21 = VISISolidFactory.CreateCone(core_diameter/2, length8-hole_length, angle0, start_pos, x_axis, inv_dir)	
	Result_List.append(cone21)
	#Cone in End
	h_cone = (core_diameter/2)/(math.tan(math.radians(60)))
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, core_length-length8 +h_cone, start_pos)
	cone22 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
	Result_List.append(cone22)
	
	#Add thread
	cam_list = [core_diameter, core_length, thread_diameter, thread_length, thread_pitch]
	VISI.AttachCamAttributes(cyl20,cam_list,"GP2_1",0,params["BUILDER_UNIT"])
	
	#Subtract
	VISISolidFactory.Subtract(Result_List, Result_List2)

	return Result_List2[0]

	
def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	total_length = params['TOTAL_LENGTH']
	chamfer2 = params['CHAMFER2']
	radius = params['RADIUS']
	angle0 = params['ANGLE0']
	angle2 = params['ANGLE2']
	angle3 = params['ANGLE3']
	distance_chamfer = params['DISTANCE_CHAMFER']
	core_diameter = params['CORE_DIAMETER']
	core_length = params['CORE_LENGTH']
	thread_diameter = params['THREAD_DIAMETER']
	thread_length = params['THREAD_LENGTH']
	hole_diameter = params['HOLE_DIAMETER']
	hole_length = params['HOLE_LENGTH']
	thread_pitch = params['THREAD_PITCH']
	length6 = params['LENGTH6']
	length8 = params['LENGTH8']
	length_cavity = params['LENGTH_CAVITY']
	length_cavity2 = params['LENGTH_CAVITY2']
	inv_direction = params['INV_DIRECTION']
	clearance_guide_diameter = params['CLEARANCE_GUIDE_DIAMETER']
	clearance_body_diameter = params['CLEARANCE_BODY_DIAMETER']
	ins_depth = params['INS_DEPTH']
	thickness_startplate = params['THICKNESS_STARTPLATE']
	thickness_endplate = params['THICKNESS_ENDPLATE']
	distance_between_plates = params['DISTANCE_BETWEEN_PLATES']
	support = params['SUPPORT']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	Result_List2 = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#set right position
	#VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ins_depth, start_pos)
	
	if not support:
		# upper Body
		cyl1 = VISISolidFactory.CreateCylinder((diameter + clearance_guide_diameter)/2,thickness_startplate, start_pos, x_axis, direction)
		Result_List.append(cyl1)
		cam_list = [diameter + clearance_guide_diameter, thickness_startplate]
		VISI.AttachCamAttributes(cyl1,cam_list,"GP2_4",elem_tag,params["BUILDER_UNIT"])
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, thickness_startplate, start_pos)
	
	#Body
	cyl2 = VISISolidFactory.CreateCylinder((diameter + clearance_body_diameter)/2,thickness_endplate+distance_between_plates, start_pos, x_axis, direction)
	Result_List.append(cyl2)
	cam_list = [diameter + clearance_body_diameter, thickness_endplate+distance_between_plates]
	VISI.AttachCamAttributes(cyl2,cam_list,"GP2_3",elem_tag,params["BUILDER_UNIT"])
	
	
	#Unite
	VISISolidFactory.Unite(Result_List, Result_List2, 0)
	
	return Result_List2[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_gp2'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
