import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_top = params['DIAMETER_TOP']
	total_length = params['TOTAL_LENGTH']
	diameter_bottom = params['DIAMETER_BOTTOM']
	diameter_hole = params['DIAMETER_HOLE']
	distance_thread = params['DISTANCE_THREAD']
	diameter_drilling = params['DIAMETER_DRILLING']
	diameter_thread = params['DIAMETER_THREAD']
	length_top = params['LENGTH_TOP']
	length_blend_bottom = params['LENGTH_BLEND_BOTTOM']
	length_inner_chamfer = params['LENGTH_INNER_CHAMFER']
	depth_thread = params['DEPTH_THREAD']
	depth_drilling = params['DEPTH_DRILLING']
	thread_pitch = params['THREAD_PITCH']
	radius_top = params['RADIUS_TOP']
	radius_bottom = params['RADIUS_BOTTOM']
	type = params['TYPE']
	length_cavity_top = params['LENGTH_CAVITY_TOP']
	length_cavity_bottom = params['LENGTH_CAVITY_BOTTOM']
	rot_angle = params['ROT_ANGLE']
	ins_depth = params['INS_DEPTH']
	inv_direction = params['INV_DIRECTION']
	support = params['SUPPORT']
	thickness_startplate = params['THICKNESS_STARTPLATE']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Check which startposition
	if support: 
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, thickness_startplate, start_pos)
	else:
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ins_depth, start_pos)
	#Create Cylinder	
	cyl1 = VISISolidFactory.CreateCylinder(diameter_top/2, length_top+length_inner_chamfer, start_pos, x_axis, direction)
	#Create Chamfers
	edges=[12]
	VISISolidFactory.ChamferEdges(cyl1, edges,length_inner_chamfer, math.tan(math.radians(4))*length_inner_chamfer, 1)
	edges=[6]
	VISISolidFactory.BlendEdges(cyl1, edges, radius_top, 1)
	#move to end of the cylinder
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_top+length_inner_chamfer, start_pos)
	#create second cylinder
	cyl2 = VISISolidFactory.CreateCylinder(diameter_bottom/2, total_length-length_top-length_inner_chamfer, start_pos, x_axis, direction)
	#move back
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, total_length-length_top-length_inner_chamfer, start_pos)
	#create chamfer + blend
	edges=[12]
	VISISolidFactory.ChamferEdges(cyl2, edges,length_blend_bottom, math.tan(math.radians(15))*length_blend_bottom, 1)
	edges=[25]
	VISISolidFactory.BlendEdges(cyl2, edges, radius_bottom, 1)
	#Add to list1
	Uni_list.append (cyl1)
	Uni_list.append (cyl2)
	
	if diameter_thread:
		#if threads check which type of the element
		VISISolidFactory.Unite(Uni_list, Uni_list2)
		if type == 1:
			#create hole
			cyl3 = VISISolidFactory.CreateCylinder(diameter_drilling/2, depth_drilling, start_pos, x_axis, inv_dir)
			#Create tip
			VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,depth_drilling+(diameter_drilling/2)/math.tan(math.radians(60)), start_pos)
			con1 = VISISolidFactory.CreateCone(0, (diameter_drilling/2)/math.tan(math.radians(60)), math.radians(60), start_pos, x_axis, direction)
			#Attach thread attribute
			cam_list = [diameter_drilling, depth_drilling, diameter_thread, depth_thread, thread_pitch]
			VISI.AttachCamAttributes(cyl3,cam_list,"GP4_1",0,params["BUILDER_UNIT"])
			#Subtract body to get hole
			Uni_list2.append (cyl3)
			Uni_list2.append (con1)
			VISISolidFactory.Subtract(Uni_list2, Result_List)
			
			
		if type == 2:
			#Create inner hole
			cyl3 = VISISolidFactory.CreateCylinder(diameter_hole/2, total_length, start_pos, x_axis, inv_dir)
			#move to position for threads
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_thread/2, start_pos)
			#create first drilling hole
			cyl4 = VISISolidFactory.CreateCylinder(diameter_drilling/2, depth_drilling, start_pos, x_axis, inv_dir)
			VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,depth_drilling+(diameter_drilling/2)/math.tan(math.radians(60)), start_pos)
			con1 = VISISolidFactory.CreateCone(0, (diameter_drilling/2)/math.tan(math.radians(60)), math.radians(60), start_pos, x_axis, direction)
			#move to position for threads
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction,depth_drilling+(diameter_drilling/2)/math.tan(math.radians(60)), start_pos)
			#create second drilling hole
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_thread, start_pos)
			cyl5 = VISISolidFactory.CreateCylinder(diameter_drilling/2, depth_drilling, start_pos, x_axis, inv_dir)
			VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,depth_drilling+(diameter_drilling/2)/math.tan(math.radians(60)), start_pos)
			con2 = VISISolidFactory.CreateCone(0, (diameter_drilling/2)/math.tan(math.radians(60)), math.radians(60), start_pos, x_axis, direction)
			#Attach thread attributes
			cam_list = [diameter_drilling, depth_drilling, diameter_thread, depth_thread, thread_pitch]
			VISI.AttachCamAttributes(cyl4,cam_list,"GP4_1",0,params["BUILDER_UNIT"])
			VISI.AttachCamAttributes(cyl5,cam_list,"GP4_1",0,params["BUILDER_UNIT"])
			#Subtract bodies to get holes
			Uni_list2.append (cyl3)
			Uni_list2.append (cyl4)
			Uni_list2.append (cyl5)
			Uni_list2.append (con1)
			Uni_list2.append (con2)
			VISISolidFactory.Subtract(Uni_list2, Result_List)
	else:
		#if no threads skip to next step
		VISISolidFactory.Unite(Uni_list, Result_List)
	#Rotate Element
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ins_depth, start_pos)
	VISISolidFactory.RotateBody( Result_List[0], start_pos, direction, rot_angle )
		
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_top = params['DIAMETER_TOP']
	total_length = params['TOTAL_LENGTH']
	diameter_bottom = params['DIAMETER_BOTTOM']
	diameter_hole = params['DIAMETER_HOLE']
	distance_thread = params['DISTANCE_THREAD']
	diameter_drilling = params['DIAMETER_DRILLING']
	diameter_thread = params['DIAMETER_THREAD']
	length_top = params['LENGTH_TOP']
	length_blend_bottom = params['LENGTH_BLEND_BOTTOM']
	length_inner_chamfer = params['LENGTH_INNER_CHAMFER']
	depth_thread = params['DEPTH_THREAD']
	depth_drilling = params['DEPTH_DRILLING']
	thread_pitch = params['THREAD_PITCH']
	radius_top = params['RADIUS_TOP']
	radius_bottom = params['RADIUS_BOTTOM']
	type = params['TYPE']
	length_cavity_top = params['LENGTH_CAVITY_TOP']
	length_cavity_bottom = params['LENGTH_CAVITY_BOTTOM']
	ins_depth = params['INS_DEPTH']
	inv_direction = params['INV_DIRECTION']
	thickness_startplate = params['THICKNESS_STARTPLATE']
	thickness_endplate = params['THICKNESS_ENDPLATE']
	distance_between_plates = params['DISTANCE_BETWEEN_PLATES']
	clearence_guide = params['CLEARENCE_GUIDE']
	support = params['SUPPORT']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create Cavity 1
	if not support:
		cyl1 = VISISolidFactory.CreateCylinder(diameter_top/2, thickness_startplate , start_pos, x_axis, direction)
		Uni_list.append (cyl1)
		cam_list = [diameter_top, thickness_startplate]
		VISI.AttachCamAttributes(cyl1,cam_list,"GP4_2",elem_tag,params["BUILDER_UNIT"])
	#Create Cavity 2
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, thickness_startplate, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder(diameter_top/2+clearence_guide/2, distance_between_plates + thickness_endplate, start_pos, x_axis, direction)
	cam_list = [diameter_top+clearence_guide, thickness_startplate]
	VISI.AttachCamAttributes(cyl2,cam_list,"GP4_3",elem_tag,params["BUILDER_UNIT"])
	#Unite cavities
	Uni_list.append (cyl2)
	VISISolidFactory.Unite(Uni_list, Result_List,0)
	
	## return the tag of created cavity, 0 if no cavity
	return Result_List [0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_gp4'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
