import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	upper_length = params['UPPER_LENGTH']
	lower_length = params['LOWER_LENGTH']
	total_length = params['TOTAL_LENGTH']
	small_diameter = params['SMALL_DIAMETER']
	length_small = params['LENGTH_SMALL']
	angle_holes = params['ANGLE_HOLES']
	diameter_big = params['DIAMETER_BIG']
	length_big = params['LENGTH_BIG']
	angle_chamfer = params['ANGLE_CHAMFER']
	diameter_distance_holes = params['DIAMETER_DISTANCE_HOLES']
	length_chamfer = params['LENGTH_CHAMFER']
	diameter_hole_big = params['DIAMETER_HOLE_BIG']
	depth_hole_big = params['DEPTH_HOLE_BIG']
	diameter_hole_small = params['DIAMETER_HOLE_SMALL']
	radius = params['RADIUS']
	diameter_lower_cavity = params['DIAMETER_LOWER_CAVITY']
	rot_angle = params['ROT_ANGLE']
	
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create Upper Body + Edges
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, upper_length, start_pos, x_axis, direction)
	edges=[12]
	VISISolidFactory.ChamferEdges(cyl1, edges,length_chamfer, length_chamfer*math.tan(angle_chamfer), 1)
	edges=[25]
	VISISolidFactory.BlendEdges(cyl1, edges, radius, 1)
	#Create lower body + Edges
	cyl2 = VISISolidFactory.CreateCylinder(diameter/2, lower_length, start_pos, x_axis, inv_dir)
	edges=[12]
	VISISolidFactory.ChamferEdges(cyl2, edges,length_chamfer, length_chamfer*math.tan(angle_chamfer), 1)
	edges=[25]
	VISISolidFactory.BlendEdges(cyl2, edges, radius, 1)
	#Creat bodies (middle)
	cyl3 = VISISolidFactory.CreateCylinder(small_diameter/2, length_small, start_pos, x_axis, direction)
	cyl4 = VISISolidFactory.CreateCylinder(diameter_big/2, length_big, start_pos, x_axis, inv_dir)
	#Unite bodies
	Uni_list.append (cyl1)
	Uni_list.append (cyl2)
	Uni_list.append (cyl3)
	Uni_list.append (cyl4)
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	#Step1
	#Move to new Position	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_big, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, diameter_distance_holes/2, start_pos)
	#Create body for hole
	cyl5 = VISISolidFactory.CreateCylinder(diameter_hole_big/2, depth_hole_big, start_pos, x_axis, direction)
	cyl6 = VISISolidFactory.CreateCylinder(diameter_hole_small/2, length_big, start_pos, x_axis, direction)
	#Step2
	#Move to new Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -diameter_distance_holes/2, start_pos)
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, angle_holes)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, diameter_distance_holes/2, start_pos)
	#Create body for hole
	cyl7 = VISISolidFactory.CreateCylinder(diameter_hole_big/2, depth_hole_big, start_pos, x_axis, direction)
	cyl8 = VISISolidFactory.CreateCylinder(diameter_hole_small/2, length_big, start_pos, x_axis, direction)
	#Step2
	#Move to new Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -diameter_distance_holes/2, start_pos)
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, angle_holes)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, diameter_distance_holes/2, start_pos)
	#Create body for hole
	cyl9 = VISISolidFactory.CreateCylinder(diameter_hole_big/2, depth_hole_big, start_pos, x_axis, direction)
	cyl10 = VISISolidFactory.CreateCylinder(diameter_hole_small/2, length_big, start_pos, x_axis, direction)
	#Subtract to get hole for screws
	Uni_list2.append (cyl5)
	Uni_list2.append (cyl6)
	Uni_list2.append (cyl7)
	Uni_list2.append (cyl8)
	Uni_list2.append (cyl9)
	Uni_list2.append (cyl10)
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	#Rotate body
	start_pos.Set(position.x(), position.y(), position.z())
	VISISolidFactory.RotateBody( Result_List[0], start_pos, direction, rot_angle )
	

	## return the tag of created element, 0 if no element
	return Result_List [0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	upper_length = params['UPPER_LENGTH']
	lower_length = params['LOWER_LENGTH']
	total_length = params['TOTAL_LENGTH']
	small_diameter = params['SMALL_DIAMETER']
	length_small = params['LENGTH_SMALL']
	angle_holes = params['ANGLE_HOLES']
	diameter_big = params['DIAMETER_BIG']
	length_big = params['LENGTH_BIG']
	angle_chamfer = params['ANGLE_CHAMFER']
	diameter_distance_holes = params['DIAMETER_DISTANCE_HOLES']
	length_chamfer = params['LENGTH_CHAMFER']
	diameter_hole_big = params['DIAMETER_HOLE_BIG']
	depth_hole_big = params['DEPTH_HOLE_BIG']
	diameter_hole_small = params['DIAMETER_HOLE_SMALL']
	radius = params['RADIUS']
	diameter_lower_cavity = params['DIAMETER_LOWER_CAVITY']
	rot_angle = params['ROT_ANGLE']
	thickness_startplate = params['THICKNESS_STARTPLATE']
	thickness_endplate = params['THICKNESS_ENDPLATE']
	thickness_supportplate = params['THICKNESS_SUPPORTPLATE']
	distance_start_support = params['DISTANCE_START_SUPPORT']
	distance_support_end = params['DISTANCE_SUPPORT_END']
	clearence_upper_cavity = params['CLEARENCE_UPPER_CAVITY']
	clearence_lower_cavity = params['CLEARENCE_LOWER_CAVITY']
	
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create lower cavity
	cyl_l_1 = VISISolidFactory.CreateCylinder(diameter_lower_cavity/2, length_big, start_pos, x_axis, inv_dir)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_big, start_pos)
	cyl_l_2 = VISISolidFactory.CreateCylinder((diameter+clearence_lower_cavity)/2,distance_start_support-length_big +thickness_startplate, start_pos, x_axis, inv_dir)
	#reset position
	start_pos.Set(position.x(), position.y(), position.z())
	#Create upper cavity
	cyl_u_1 = VISISolidFactory.CreateCylinder(small_diameter/2, thickness_supportplate, start_pos, x_axis, direction)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, thickness_supportplate, start_pos)
	cyl_u_2 = VISISolidFactory.CreateCylinder((diameter+clearence_upper_cavity)/2, thickness_endplate+distance_support_end, start_pos, x_axis, direction)
	#Unite Cavities
	Uni_list.append (cyl_l_1)
	Uni_list.append (cyl_l_2)
	Uni_list.append (cyl_u_1)
	Uni_list.append (cyl_u_2)
	VISISolidFactory.Unite(Uni_list, Result_List,0)
	
	## return the tag of created cavity, 0 if no cavity
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_gp5'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
