import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	length = params['LENGTH']
	ball_height = params['BALL_HEIGHT']
	length2 = params['LENGTH2']
	ball_diameter = params['BALL_DIAMETER']
	diameter2 = params['DIAMETER2']
	radius = params['RADIUS']
	extra_length = params['EXTRA_LENGTH']
	collar_clear_height = params['COLLAR_CLEAR_HEIGHT']
	collar_play = params['COLLAR_PLAY']
	start_thick = params['START_THICK']
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, -collar_clear_height, start_pos)
	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, length, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
		
	#Blend Edges
	edges = [12]
	VISISolidFactory.BlendEdges (Uni_list[0], edges, radius, 1)
	
	#Create collar
	cyl2 = VISISolidFactory.CreateCylinder(diameter2/2, length2, start_pos, x_axis, direction)
	Uni_list.append(cyl2)
	
	
	#Create Ball
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ball_diameter/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, ball_height, start_pos)
	ball=VISISolidFactory.CreateSphere (ball_diameter/2, start_pos, x_axis, direction)
	Uni_list.append(ball)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	length = params['LENGTH']
	ball_height = params['BALL_HEIGHT']
	length2 = params['LENGTH2']
	ball_diameter = params['BALL_DIAMETER']
	diameter2 = params['DIAMETER2']
	radius = params['RADIUS']
	extra_length = params['EXTRA_LENGTH']
	collar_clear_height = params['COLLAR_CLEAR_HEIGHT']
	collar_play = params['COLLAR_PLAY']
	angle_height = params['ANGLE_HEIGHT']
	start_thick = params['START_THICK']
	clear_collar_top = params['CLEAR_COLLAR_TOP']
	check_cav_ball = params['CHECK_CAV_BALL']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick, start_pos)
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, length+extra_length+collar_clear_height, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
		
	#Create collar
	if collar_clear_height > 0:
		VISIGeoLib.ProjectPointOntoVector (start_pos, direction, -clear_collar_top, start_pos)
		cyl2 = VISISolidFactory.CreateCylinder((diameter2+collar_play)/2, length2+collar_clear_height+clear_collar_top, start_pos, x_axis, direction)
		VISIGeoLib.ProjectPointOntoVector (start_pos, direction, clear_collar_top, start_pos)
	else:
		VISIGeoLib.ProjectPointOntoVector (start_pos, direction, collar_clear_height, start_pos)	
		cyl2 = VISISolidFactory.CreateCylinder((diameter2+collar_play)/2, length2-collar_clear_height, start_pos, x_axis, direction)
		VISIGeoLib.ProjectPointOntoVector (start_pos, direction, -collar_clear_height, start_pos)	
	Uni_list.append(cyl2)
		
	#Create Cone
	h_cone = (diameter/2)/(math.tan(math.radians(60)))
	VISIGeoLib.ProjectPointOntoVector (start_pos, direction, length + extra_length + h_cone+collar_clear_height, start_pos)	
	cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
	Uni_list.append(cone)
	
	
	#Create Cone for Ball
	if not check_cav_ball:
		cone_angle = math.atan((diameter/2)/angle_height)
		VISIGeoLib.ProjectPointOntoVector (start_pos, inv_dir, length + extra_length + h_cone + angle_height, start_pos)
		cone2 = VISISolidFactory.CreateCone(0, angle_height, cone_angle, start_pos, x_axis, direction)
		Uni_list.append(cone2)
	else:
		VISIGeoLib.ProjectPointOntoVector (start_pos, inv_dir, length + extra_length + h_cone+collar_clear_height, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ball_diameter/2-ball_height+collar_clear_height, start_pos)
		ball=VISISolidFactory.CreateSphere (ball_diameter/2, start_pos, x_axis, direction)
		Uni_list.append(ball)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_gs6'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
