import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_reception = params['DIAMETER_RECEPTION']
	diameter_tap = params['DIAMETER_TAP']
	diameter_main = params['DIAMETER_MAIN']
	diameter_hole = params['DIAMETER_HOLE']
	diameter_outer_reception = params['DIAMETER_OUTER_RECEPTION']
	diameter_middle = params['DIAMETER_MIDDLE']
	diameter_big = params['DIAMETER_BIG']
	diameter_spout_big = params['DIAMETER_SPOUT_BIG']
	diameter_spout_small = params['DIAMETER_SPOUT_SMALL']
	length_big = params['LENGTH_BIG']
	length_tap = params['LENGTH_TAP']
	length_outer_reception = params['LENGTH_OUTER_RECEPTION']
	length_bottom = params['LENGTH_BOTTOM']
	length_ring = params['LENGTH_RING']
	length_between_rings = params['LENGTH_BETWEEN_RINGS']
	length_tip = params['LENGTH_TIP']
	length_small_tip = params['LENGTH_SMALL_TIP']
	depth_reception = params['DEPTH_RECEPTION']
	amount_small_tips = params['AMOUNT_SMALL_TIPS']
	z_off = params['Z_OFF']
	x_off = params['X_OFF']
	housing_height = params['HOUSING_HEIGHT']
	master_direction = params['MASTER_DIRECTION']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, master_direction, z_off - housing_height , start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, x_off + depth_reception + 1./1000, start_pos)
	
	cyl1 = VISISolidFactory.CreateCylinder(diameter_outer_reception/2, depth_reception, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, depth_reception-length_outer_reception, start_pos)
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_main/2, length_bottom, start_pos, x_axis, direction)
	cyl3 = VISISolidFactory.CreateCylinder(diameter_middle/2, length_big-length_outer_reception, start_pos, x_axis, direction)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_bottom, start_pos)
	
	cyl4 = VISISolidFactory.CreateCylinder(diameter_big/2, length_ring, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_between_rings+length_ring, start_pos)
	
	cyl5 = VISISolidFactory.CreateCylinder(diameter_big/2, length_ring, start_pos, x_axis, inv_dir)
	
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, master_direction, z_off - housing_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, x_off + depth_reception + 1./1000, start_pos)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_big-depth_reception, start_pos)
	
	cyl6 = VISISolidFactory.CreateCylinder(diameter_tap/2, length_tap, start_pos, x_axis, direction)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_tap, start_pos)
	
	
	angle1= math.atan2(((diameter_spout_big-diameter_tap)/2),length_tip)
	
	con1 = VISISolidFactory.CreateCone(diameter_tap/2, length_tip, angle1, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_tip, start_pos)
	
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	Uni_list.append(cyl3)
	Uni_list.append(cyl4)
	Uni_list.append(cyl5)
	Uni_list.append(cyl6)
	Uni_list.append(con1)
	
	
	x=0
	while x<amount_small_tips:
		angle2= math.atan2(((diameter_spout_small-diameter_tap)/2),length_tip)
		con = VISISolidFactory.CreateCone(diameter_tap/2, length_small_tip, angle2, start_pos, x_axis, inv_dir)
		Uni_list.append(con)
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_small_tip, start_pos)
		x=x+1
	
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, master_direction, z_off - housing_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, x_off + depth_reception + 1./1000, start_pos)
	cyl7 = VISISolidFactory.CreateCylinder(diameter_reception/2, depth_reception, start_pos, x_axis, inv_dir)
	cyl8 = VISISolidFactory.CreateCylinder(diameter_hole/2, length_big+length_tap-depth_reception, start_pos, x_axis, direction)
	Uni_list2.append(cyl7)
	Uni_list2.append(cyl8)
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	
	
	
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_reception = params['DIAMETER_RECEPTION']
	diameter_tap = params['DIAMETER_TAP']
	diameter_main = params['DIAMETER_MAIN']
	diameter_hole = params['DIAMETER_HOLE']
	diameter_outer_reception = params['DIAMETER_OUTER_RECEPTION']
	diameter_middle = params['DIAMETER_MIDDLE']
	diameter_big = params['DIAMETER_BIG']
	diameter_spout_big = params['DIAMETER_SPOUT_BIG']
	diameter_spout_small = params['DIAMETER_SPOUT_SMALL']
	length_big = params['LENGTH_BIG']
	length_tap = params['LENGTH_TAP']
	length_outer_reception = params['LENGTH_OUTER_RECEPTION']
	length_bottom = params['LENGTH_BOTTOM']
	length_ring = params['LENGTH_RING']
	length_between_rings = params['LENGTH_BETWEEN_RINGS']
	length_tip = params['LENGTH_TIP']
	length_small_tip = params['LENGTH_SMALL_TIP']
	depth_reception = params['DEPTH_RECEPTION']
	amount_small_tips = params['AMOUNT_SMALL_TIPS']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_hc1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
