import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_reception = params['DIAMETER_RECEPTION']
	diameter_tap = params['DIAMETER_TAP']
	diameter_main = params['DIAMETER_MAIN']
	diameter_hole = params['DIAMETER_HOLE']
	diameter_outer_reception = params['DIAMETER_OUTER_RECEPTION']
	diameter_middle = params['DIAMETER_MIDDLE']
	diameter_big = params['DIAMETER_BIG']
	diameter_spout = params['DIAMETER_SPOUT']
	diameter_inner_cap = params['DIAMETER_INNER_CAP']
	diameter_outer_cap = params['DIAMETER_OUTER_CAP']
	length_big = params['LENGTH_BIG']
	length_tap = params['LENGTH_TAP']
	length_outer_reception = params['LENGTH_OUTER_RECEPTION']
	length_bottom = params['LENGTH_BOTTOM']
	length_ring = params['LENGTH_RING']
	length_between_rings = params['LENGTH_BETWEEN_RINGS']
	length_second_tip = params['LENGTH_SECOND_TIP']
	length_tip = params['LENGTH_TIP']
	length_inner_cap = params['LENGTH_INNER_CAP']
	length_outer_cap = params['LENGTH_OUTER_CAP']
	depth_reception = params['DEPTH_RECEPTION']
	master_direction = params['MASTER_DIRECTION']
	z_off = params['Z_OFF']
	x_off = params['X_OFF']
	housing_height = params['HOUSING_HEIGHT']
	elem_diam = params['ELEM_DIAM']
	length_tip_to_cap = params['LENGTH_TIP_TO_CAP']
	diameter_section = params['DIAMETER_SECTION']
	length_section = params['LENGTH_SECTION']
	depth_drilling = params['DEPTH_DRILLING']
	
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, master_direction, z_off - housing_height , start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, x_off + depth_reception + 1./1000, start_pos)
	
	cyl1 = VISISolidFactory.CreateCylinder(diameter_outer_reception/2, depth_reception, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, depth_reception-length_outer_reception, start_pos)
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_main/2, length_bottom, start_pos, x_axis, direction)
	cyl3 = VISISolidFactory.CreateCylinder(diameter_middle/2, length_big-length_outer_reception, start_pos, x_axis, direction)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_bottom, start_pos)
	
	cyl4 = VISISolidFactory.CreateCylinder(diameter_big/2, length_ring, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_between_rings+length_ring, start_pos)
	
	cyl5 = VISISolidFactory.CreateCylinder(diameter_big/2, length_ring, start_pos, x_axis, inv_dir)
	
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, master_direction, z_off - housing_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, x_off + depth_reception + 1./1000, start_pos)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_big-depth_reception, start_pos)
	
	direction_angle = VISIVector.New()
	VISIGeoLib.VectorRotate(direction, x_axis, direction_angle, math.radians(-45))
	inv_direction_angle = VISIVector.New()
	inv_direction_angle.Set(-direction_angle.Cx(), -direction_angle.Cy(), -direction_angle.Cz())
	
	front_bodies_list=[]
	back_bodies_list=[]
	VISISolidFactory.CutWithPlane(start_pos, direction_angle, cyl3, front_bodies_list, back_bodies_list)
	
	VISISolidFactory.DeleteBodies(front_bodies_list)
	cyl3=back_bodies_list[0]
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, diameter_middle/4, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, diameter_middle/4, start_pos)
	
	# return 0
	
	
	
	
	
	
	
	cyl6 = VISISolidFactory.CreateCylinder(diameter_tap/2, length_tap, start_pos, x_axis, direction_angle)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction_angle, length_tap, start_pos)
	
	
	# angle1= math.atan2(((diameter_spout-diameter_tap)/2),length_tip)
	height_tip= ((diameter_spout-diameter_tap)/2)/ math.tan(math.radians(15))
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_direction_angle, length_tip-height_tip, start_pos)
	
	con1 = VISISolidFactory.CreateCone(diameter_tap/2,height_tip , math.radians(15), start_pos, x_axis, inv_direction_angle)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_direction_angle, length_second_tip, start_pos)
	con2 = VISISolidFactory.CreateCone(diameter_tap/2,height_tip , math.radians(15), start_pos, x_axis, inv_direction_angle)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction_angle, length_second_tip + length_tip - height_tip, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_direction_angle, length_tip_to_cap-length_inner_cap-height_tip, start_pos)
	con3 = VISISolidFactory.CreateCone(diameter_tap/2,height_tip , math.radians(15), start_pos, x_axis, inv_direction_angle)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_direction_angle, length_inner_cap+height_tip-length_outer_cap, start_pos)
	
	
	
	cyl7 = VISISolidFactory.CreateCylinder(diameter_outer_cap/2, length_outer_cap, start_pos, x_axis, inv_direction_angle)
	cyl8 = VISISolidFactory.CreateCylinder(diameter_inner_cap/2, length_outer_cap-length_inner_cap, start_pos, x_axis, inv_direction_angle)
	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_direction_angle,length_outer_cap , start_pos)
	cyl11 = VISISolidFactory.CreateCylinder(diameter_section/2, length_tap- length_tip_to_cap, start_pos, x_axis, inv_direction_angle)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction_angle,length_tip_to_cap , start_pos)
	cyl12 = VISISolidFactory.CreateCylinder(diameter_hole/2, length_tap+ (math.sqrt(2)*diameter_middle/4), start_pos, x_axis, inv_direction_angle)
	
	
	
	Uni_list3.append(cyl7)
	Uni_list3.append(cyl8)
	VISISolidFactory.Subtract(Uni_list3, Uni_list)
	
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	Uni_list.append(cyl3)
	Uni_list.append(cyl4)
	Uni_list.append(cyl5)
	Uni_list.append(cyl6)
	Uni_list.append(cyl11)
	Uni_list.append(con1)
	Uni_list.append(con2)
	Uni_list.append(con3)
	

	
	

	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	
	
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, master_direction, z_off - housing_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, x_off + depth_reception + 1./1000, start_pos)
	cyl9 = VISISolidFactory.CreateCylinder(diameter_reception/2, depth_reception, start_pos, x_axis, inv_dir)
	cyl10 = VISISolidFactory.CreateCylinder(diameter_hole/2,depth_drilling - depth_reception, start_pos, x_axis, direction)
	Uni_list2.append(cyl9)
	Uni_list2.append(cyl10)
	Uni_list2.append(cyl12)
	
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	
	
	
	## return the tag of created element, 0 if no element
	return Result_List[0]

	## return the tag of created element, 0 if no element
	

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_reception = params['DIAMETER_RECEPTION']
	diameter_tap = params['DIAMETER_TAP']
	diameter_main = params['DIAMETER_MAIN']
	diameter_hole = params['DIAMETER_HOLE']
	diameter_outer_reception = params['DIAMETER_OUTER_RECEPTION']
	diameter_middle = params['DIAMETER_MIDDLE']
	diameter_big = params['DIAMETER_BIG']
	diameter_spout = params['DIAMETER_SPOUT']
	diameter_inner_cap = params['DIAMETER_INNER_CAP']
	diameter_outer_cap = params['DIAMETER_OUTER_CAP']
	length_big = params['LENGTH_BIG']
	length_tap = params['LENGTH_TAP']
	length_outer_reception = params['LENGTH_OUTER_RECEPTION']
	length_bottom = params['LENGTH_BOTTOM']
	length_ring = params['LENGTH_RING']
	length_between_rings = params['LENGTH_BETWEEN_RINGS']
	length_second_tip = params['LENGTH_SECOND_TIP']
	length_tip = params['LENGTH_TIP']
	length_inner_cap = params['LENGTH_INNER_CAP']
	length_outer_cap = params['LENGTH_OUTER_CAP']
	depth_reception = params['DEPTH_RECEPTION']
	master_direction = params['MASTER_DIRECTION']
	z_off = params['Z_OFF']
	x_off = params['X_OFF']
	housing_height = params['HOUSING_HEIGHT']
	elem_diam = params['ELEM_DIAM']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_hc2_45'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
