import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	total_height = params['TOTAL_HEIGHT']
	outer_diameter = params['OUTER_DIAMETER']
	diameter_top = params['DIAMETER_TOP']
	diameter_flange = params['DIAMETER_FLANGE']
	diameter_inner_hole = params['DIAMETER_INNER_HOLE']
	diameter_outer_necking = params['DIAMETER_OUTER_NECKING']
	diameter_inner_front = params['DIAMETER_INNER_FRONT']
	diameter_inner_tip = params['DIAMETER_INNER_TIP']
	height_flange = params['HEIGHT_FLANGE']
	length_lower_necking = params['LENGTH_LOWER_NECKING']
	length_upper_necking = params['LENGTH_UPPER_NECKING']
	length_outer_top = params['LENGTH_OUTER_TOP']
	length_inner_top = params['LENGTH_INNER_TOP']
	length_inner_edge = params['LENGTH_INNER_EDGE']
	length_inner_tip = params['LENGTH_INNER_TIP']
	diameter_thread = params['DIAMETER_THREAD']
	distance_thread = params['DISTANCE_THREAD']
	diameter_drilling = params['DIAMETER_DRILLING']
	depth_drilling = params['DEPTH_DRILLING']
	distance_drilling = params['DISTANCE_DRILLING']
	angle_outer_top = params['ANGLE_OUTER_TOP']
	angle_inner_lower = params['ANGLE_INNER_LOWER']
	angle_inner_upper = params['ANGLE_INNER_UPPER']
	radius_flange = params['RADIUS_FLANGE']
	radius_outer_top = params['RADIUS_OUTER_TOP']
	radius_inner_top = params['RADIUS_INNER_TOP']
	chamfer_width = params['CHAMFER_WIDTH']
	rot_angle = params['ROT_ANGLE']
	insertion_depth = params['INSERTION_DEPTH']
	distance_centre_sphere = params['DISTANCE_CENTRE_SPHERE']
	radius_sphere = params['RADIUS_SPHERE']
	diameter_predrill = params['DIAMETER_PREDRILL']
	thread_pitch = params['THREAD_PITCH']

	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	flange = VISISolidFactory.CreateCylinder(diameter_flange/2, height_flange, start_pos, x_axis, direction)
	
	cyl1 = VISISolidFactory.CreateCylinder(outer_diameter/2, length_lower_necking-height_flange, start_pos, x_axis, inv_dir)
	
	edges1=[12]
	VISISolidFactory.ChamferEdges(cyl1, edges1,chamfer_width, chamfer_width, 1)
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_outer_necking/2, length_upper_necking-height_flange, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_upper_necking-height_flange, start_pos)
	
	cyl3 = VISISolidFactory.CreateCylinder(outer_diameter/2, total_height-length_upper_necking-length_outer_top, start_pos, x_axis, inv_dir)
	
	edges2=[6]
	VISISolidFactory.ChamferEdges(cyl3, edges2,chamfer_width, chamfer_width, 1)
	
	height_chamfer= (outer_diameter/2 - diameter_top/2)/(math.tan(math.radians(180)-angle_outer_top))
	edges3=[12]
	VISISolidFactory.ChamferEdges(cyl3, edges3,height_chamfer, outer_diameter/2 - diameter_top/2, 1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, total_height-length_upper_necking-length_outer_top, start_pos)
	
	cyl4 = VISISolidFactory.CreateCylinder(diameter_top/2, length_outer_top, start_pos, x_axis, inv_dir)
	
	Uni_list.append(flange)
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	Uni_list.append(cyl3)
	Uni_list.append(cyl4)
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	Uni_list=[]
	
	edges4=[19]
	VISISolidFactory.BlendEdges(Uni_list2[0], edges4, radius_flange, 1)
	edges5=[33]
	VISISolidFactory.BlendEdges(Uni_list2[0], edges5, radius_outer_top, 1)
	
	
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height_flange, start_pos)
	
	if diameter_thread:
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_thread/2, start_pos)
		cyl5 = VISISolidFactory.CreateCylinder(diameter_predrill/2, height_flange, start_pos, x_axis, inv_dir)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_thread, start_pos)
		cyl6 = VISISolidFactory.CreateCylinder(diameter_predrill/2, height_flange, start_pos, x_axis, inv_dir)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_thread/2, start_pos)
		
		Uni_list2.append(cyl5)
		Uni_list2.append(cyl6)
		
		cam_list = [diameter_predrill, height_flange, diameter_thread, height_flange, thread_pitch]
		VISI.AttachCamAttributes(cyl5,cam_list,"JLL1_1",0,params["BUILDER_UNIT"])
		VISI.AttachCamAttributes(cyl6,cam_list,"JLL1_1",0,params["BUILDER_UNIT"])
		
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_drilling/2, start_pos)
	cyl7 = VISISolidFactory.CreateCylinder(diameter_drilling/2, depth_drilling, start_pos, x_axis, inv_dir)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_drilling, start_pos)
	cyl8 = VISISolidFactory.CreateCylinder(diameter_drilling/2, depth_drilling, start_pos, x_axis, inv_dir)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_drilling/2, start_pos)
	Uni_list2.append(cyl7)
	Uni_list2.append(cyl8)
	
	cyl9 = VISISolidFactory.CreateCylinder(diameter_inner_hole/2, total_height-length_inner_top, start_pos, x_axis, inv_dir)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, total_height-length_inner_tip, start_pos)
	
	cyl10 = VISISolidFactory.CreateCylinder(diameter_inner_tip/2, length_inner_tip, start_pos, x_axis, inv_dir)
	
	con1 = VISISolidFactory.CreateCone(diameter_inner_tip/2, length_inner_edge-length_inner_tip, angle_inner_upper/2, start_pos, x_axis, direction)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_inner_edge-((diameter_inner_front/2)/math.tan(angle_inner_lower/2))- length_inner_tip, start_pos)
	
	con2 = VISISolidFactory.CreateCone(0, (diameter_inner_front/2)/math.tan(angle_inner_lower/2), angle_inner_lower/2, start_pos, x_axis, direction)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, (diameter_inner_front/2)/math.tan(angle_inner_lower/2), start_pos)
	
	cyl11 = VISISolidFactory.CreateCylinder(diameter_inner_front/2, length_inner_top-length_inner_edge, start_pos, x_axis, direction)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, distance_centre_sphere-length_inner_edge, start_pos)
	sph1 = VISISolidFactory.CreateSphere(radius_sphere, start_pos, x_axis, direction)
	
	Uni_list.append(con2)
	Uni_list.append(cyl11)
	VISISolidFactory.Unite(Uni_list, Uni_list3)
	
	edges6=[18]
	VISISolidFactory.BlendEdges(Uni_list3[0], edges6, radius_inner_top, 1)
	
	Uni_list2.append(cyl9)
	Uni_list2.append(cyl10)
	Uni_list2.append(con1)
	Uni_list2.append(sph1)
	Uni_list2.append(Uni_list3[0])
	
	
	
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	VISISolidFactory.TranslateBodyByVector(Result_List[0], inv_dir, height_flange + insertion_depth)

	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	total_height = params['TOTAL_HEIGHT']
	outer_diameter = params['OUTER_DIAMETER']
	diameter_top = params['DIAMETER_TOP']
	diameter_flange = params['DIAMETER_FLANGE']
	diameter_inner_hole = params['DIAMETER_INNER_HOLE']
	diameter_outer_necking = params['DIAMETER_OUTER_NECKING']
	diameter_inner_front = params['DIAMETER_INNER_FRONT']
	diameter_inner_tip = params['DIAMETER_INNER_TIP']
	height_flange = params['HEIGHT_FLANGE']
	length_lower_necking = params['LENGTH_LOWER_NECKING']
	length_upper_necking = params['LENGTH_UPPER_NECKING']
	length_outer_top = params['LENGTH_OUTER_TOP']
	length_inner_top = params['LENGTH_INNER_TOP']
	length_inner_edge = params['LENGTH_INNER_EDGE']
	length_inner_tip = params['LENGTH_INNER_TIP']
	diameter_thread = params['DIAMETER_THREAD']
	distance_thread = params['DISTANCE_THREAD']
	diameter_drilling = params['DIAMETER_DRILLING']
	depth_drilling = params['DEPTH_DRILLING']
	distance_drilling = params['DISTANCE_DRILLING']
	angle_outer_top = params['ANGLE_OUTER_TOP']
	angle_inner_lower = params['ANGLE_INNER_LOWER']
	angle_inner_upper = params['ANGLE_INNER_UPPER']
	radius_flange = params['RADIUS_FLANGE']
	radius_outer_top = params['RADIUS_OUTER_TOP']
	radius_inner_top = params['RADIUS_INNER_TOP']
	chamfer_width = params['CHAMFER_WIDTH']
	rot_angle = params['ROT_ANGLE']
	insertion_depth = params['INSERTION_DEPTH']
	distance_centre_sphere = params['DISTANCE_CENTRE_SPHERE']
	radius_sphere = params['RADIUS_SPHERE']
	clearence_flange = params['CLEARENCE_FLANGE']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	flange = VISISolidFactory.CreateCylinder(diameter_flange/2 + clearence_flange, height_flange + insertion_depth, start_pos, x_axis, direction)
	
	
	
	height_chamfer= (outer_diameter/2 - diameter_top/2)/(math.tan(math.radians(180)-angle_outer_top))
	
	cyl2 = VISISolidFactory.CreateCylinder(outer_diameter/2, total_height - height_flange - length_outer_top, start_pos, x_axis, inv_dir)
	
	edges1=[12]
	VISISolidFactory.ChamferEdges(cyl2, edges1,height_chamfer, outer_diameter/2 - diameter_top/2, 1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, total_height-length_upper_necking-length_outer_top, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_upper_necking-height_flange, start_pos)
	
	cyl3 = VISISolidFactory.CreateCylinder(diameter_top/2, length_outer_top, start_pos, x_axis, inv_dir)
	
	cam_list2 = [diameter_flange/2 + clearence_flange, height_flange + insertion_depth,]
	VISI.AttachCamAttributes(flange,cam_list2,"JLL1_2",0,params["BUILDER_UNIT"])
	cam_list3 = [outer_diameter/2, total_height - height_flange - length_outer_top]
	VISI.AttachCamAttributes(cyl2,cam_list3,"JLL1_3",0,params["BUILDER_UNIT"])
	cam_list4 = [diameter_top/2, length_outer_top]
	VISI.AttachCamAttributes(cyl3,cam_list4,"JLL1_4",0,params["BUILDER_UNIT"])
	
	Uni_list.append(flange)
	Uni_list.append(cyl2)
	Uni_list.append(cyl3)
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	edges2=[28]
	VISISolidFactory.BlendEdges(Uni_list2[0], edges2, radius_outer_top, 1)
	
	edges3=[19]
	VISISolidFactory.ChamferEdges(Uni_list2[0], edges3, radius_flange, radius_flange, 1)
	
	VISISolidFactory.TranslateBodyByVector(Uni_list2[0], inv_dir, height_flange + insertion_depth)
	
	return Uni_list2[0]
	
	
def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_jll1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
