import VISI, VISIParam, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math

variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	pin_diameter = params['PIN_DIAMETER']
	shoulder_diameter = params['SHOULDER_DIAMETER']
	screw_diameter = params['SCREW_DIAMETER']
	screw_pitch = params['SCREW_PITCH']
	screw_hole = params['SCREW_HOLE']
	cone_length = params['CONE_LENGTH']
	increment_shoulder_length = params['INCREMENT_SHOULDER_LENGTH']
	min_shoulder_length = params['MIN_SHOULDER_LENGTH']
	max_shoulder_length = params['MAX_SHOULDER_LENGTH']
	total_length = params['TOTAL_LENGTH']
	sp_diam_clearance = params['SP_DIAM_CLEARANCE']
	ep_diam_clearance = params['EP_DIAM_CLEARANCE']
	shoulder_diam_clearance = params['SHOULDER_DIAM_CLEARANCE']
	clearance_under_head = params['CLEARANCE_UNDER_HEAD']
	hole_extra_depth = params['HOLE_EXTRA_DEPTH']
	min_clearance = params['MIN_CLEARANCE']
	shoulder_guide = params['SHOULDER_GUIDE']
	blind_hole = params['BLIND_HOLE']
	accuracy_class = params['ACCURACY_CLASS']
	hex_width = params['HEX_WIDTH']
	hex_depth = params['HEX_DEPTH']


	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	Inv_Dir = VISIVector.New()
        Inv_Dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, clearance_under_head, start_pos)
	if(increment_shoulder_length > 0):
		cyl = VISISolidFactory.CreateCylinder(shoulder_diameter/2, increment_shoulder_length, start_pos, x_axis, direction)
		Uni_list.append(cyl)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, increment_shoulder_length, start_pos)

	cyl = VISISolidFactory.CreateCylinder(pin_diameter/2, total_length - increment_shoulder_length - cone_length
					      , start_pos, x_axis, direction)
	Uni_list.append(cyl)
	
	# return 0

	## Creating the Column Chamfer
	if(cone_length > 0):
                VISIGeoLib.ProjectPointOntoVector(start_pos, direction, total_length - increment_shoulder_length, start_pos)
                r_cone = pin_diameter / 2 - (cone_length * math.tan(math.pi/12))
                cone = VISISolidFactory.CreateCone(r_cone, cone_length, math.pi/12, start_pos, x_axis, Inv_Dir)
                Uni_list.append(cone)

        if(increment_shoulder_length > 0) or (cone_length > 0):
                ## Unite The Column Parts 
                VISISolidFactory.Unite(Uni_list, Result_List)

                if hex_width:
                    Uni_list = []
                    Uni_list.append(Result_List[0])
                    Result_List = []
                    pri1 = VISISolidFactory.CreatePrism(math.tan(math.radians(30))*(hex_width), hex_depth, 6, start_pos, x_axis, Inv_Dir)
                    Uni_list.append(pri1)
                    VISISolidFactory.Subtract(Uni_list, Result_List)

                return Result_List[0]
        else:
                return cyl

        return -1
                

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	pin_diameter = params['PIN_DIAMETER']
	shoulder_diameter = params['SHOULDER_DIAMETER']
	screw_diameter = params['SCREW_DIAMETER']
	screw_pitch = params['SCREW_PITCH']
	screw_hole = params['SCREW_HOLE']
	cone_length = params['CONE_LENGTH']
	increment_shoulder_length = params['INCREMENT_SHOULDER_LENGTH']
	min_shoulder_length = params['MIN_SHOULDER_LENGTH']
	max_shoulder_length = params['MAX_SHOULDER_LENGTH']
	total_length = params['TOTAL_LENGTH']
	sp_diam_clearance = params['SP_DIAM_CLEARANCE']
	ep_diam_clearance = params['EP_DIAM_CLEARANCE']
	shoulder_diam_clearance = params['SHOULDER_DIAM_CLEARANCE']
	clearance_under_head = params['CLEARANCE_UNDER_HEAD']
	hole_extra_depth = params['HOLE_EXTRA_DEPTH']
	min_clearance = params['MIN_CLEARANCE']
	shoulder_guide = params['SHOULDER_GUIDE']
	blind_hole = params['BLIND_HOLE']
	special_cav = params['SPECIAL_CAV']
	accuracy_class = params['ACCURACY_CLASS']


	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	Inv_Dir = VISIVector.New()
        Inv_Dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

        VISIGeoLib.ProjectPointOntoVector(start_pos, direction, clearance_under_head, start_pos)
        #if(shoulder_guide > 0):
		#cyl = VISISolidFactory.CreateCylinder((shoulder_diameter + shoulder_diam_clearance)/2,
						      #shoulder_guide, start_pos, x_axis, direction)
		#Uni_list.append(cyl)
		#cam_list = [shoulder_diameter + shoulder_diam_clearance, shoulder_guide]
		#VISI.AttachCamAttributes(cyl,cam_list,"JLP22_1",elem_tag,params["BUILDER_UNIT"])
		#VISIGeoLib.ProjectPointOntoVector(start_pos, direction, shoulder_guide, start_pos)

	if(round(start_thick - (clearance_under_head),3) > 0):
		cyl = VISISolidFactory.CreateCylinder((shoulder_diameter + sp_diam_clearance)/2,
							start_thick - (clearance_under_head)
							, start_pos, x_axis, direction)
		Uni_list.append(cyl)
		cam_list = [shoulder_diameter + sp_diam_clearance, start_thick - (clearance_under_head)]
		VISI.AttachCamAttributes(cyl,cam_list,"JLP22_1",elem_tag,params["BUILDER_UNIT"])
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - (clearance_under_head)
						      , start_pos)
	if(shoulder_guide > 0):
		cyl = VISISolidFactory.CreateCylinder((shoulder_diameter + shoulder_diam_clearance)/2,
						      shoulder_guide, start_pos, x_axis, direction)
		Uni_list.append(cyl)
		cam_list = [shoulder_diameter + shoulder_diam_clearance, shoulder_guide]
		VISI.AttachCamAttributes(cyl,cam_list,"JLP22_2",elem_tag,params["BUILDER_UNIT"])
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, shoulder_guide, start_pos)

	if(blind_hole):
		cyl = VISISolidFactory.CreateCylinder((pin_diameter + ep_diam_clearance)/2
						      ,total_length - (start_thick - clearance_under_head) - shoulder_guide - cone_length + hole_extra_depth
						      , start_pos, x_axis, direction)
		Uni_list.append(cyl)
		cam_list = [pin_diameter + ep_diam_clearance, total_length - (start_thick - clearance_under_head)- shoulder_guide - cone_length + hole_extra_depth]
		VISI.AttachCamAttributes(cyl,cam_list,"JLP22_3",elem_tag,params["BUILDER_UNIT"])

		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, total_length - (start_thick - clearance_under_head) - shoulder_guide - cone_length + hole_extra_depth
						  , start_pos)

		## Creating the Column Chamfer
		r_cone = (pin_diameter + ep_diam_clearance)/2 - (cone_length * math.tan(math.pi/12))
		h_cone = (pin_diameter + ep_diam_clearance)/2. * math.tan(math.pi/6)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone, start_pos)
		cone = VISISolidFactory.CreateCone(0, h_cone, math.pi/3, start_pos, x_axis, Inv_Dir)
		#cone = VISISolidFactory.CreateCone(r_cone, cone_length, math.pi/12, start_pos, x_axis, Inv_Dir)
		Uni_list.append(cone)

	else:
                if(special_cav):
                        cyl = VISISolidFactory.CreateCylinder((pin_diameter + ep_diam_clearance)/2,total_length - (start_thick - clearance_under_head) - shoulder_guide
                                                                , start_pos, x_axis, direction)
                        Uni_list.append(cyl)
                        cam_list = [pin_diameter + ep_diam_clearance, total_length - (start_thick - clearance_under_head) - shoulder_guide]
                        VISI.AttachCamAttributes(cyl,cam_list,"JLP22_3",elem_tag,params["BUILDER_UNIT"])
		else:
                        cyl = VISISolidFactory.CreateCylinder((pin_diameter + ep_diam_clearance)/2,total_thick - start_thick - shoulder_guide
                                                                , start_pos, x_axis, direction)
                        Uni_list.append(cyl)
                        cam_list = [pin_diameter + ep_diam_clearance, total_thick - start_thick]
                        VISI.AttachCamAttributes(cyl,cam_list,"JLP22_3",elem_tag,params["BUILDER_UNIT"])
		

	## Unite The Column Parts 
	VISISolidFactory.Unite(Uni_list, Result_List,0)

	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_jlp22'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, Xaxis)

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
