import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	width = params['WIDTH']
	length = params['LENGTH']
	height = params['HEIGHT']
	rblend = params['RBLEND']
	lifter_base_width = params['LIFTER_BASE_WIDTH']
	lifter_base_height = params['LIFTER_BASE_HEIGHT']
	lifter_final_part_width = params['LIFTER_FINAL_PART_WIDTH']
	lifter_final_part_length = params['LIFTER_FINAL_PART_LENGTH']
	lifter_final_part_height = params['LIFTER_FINAL_PART_HEIGHT']
	lifter_base_radius = params['LIFTER_BASE_RADIUS']
	lifter_incl_angle = params['LIFTER_INCL_ANGLE']
	gib_base_height = params['GIB_BASE_HEIGHT']
	gib_middle_height = params['GIB_MIDDLE_HEIGHT']
	gib_middle_width = params['GIB_MIDDLE_WIDTH']
	gib_top_height = params['GIB_TOP_HEIGHT']
	gib_top_width = params['GIB_TOP_WIDTH']
	acceleration = params['ACCELERATION']
	housing_height = params['HOUSING_HEIGHT']
	x_clear = params['X_CLEAR']
	y_clear = params['Y_CLEAR']
	blend = params['BLEND']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	lifter_height = params['LIFTER_HEIGHT']
	
	width1 = params['WIDTH1']
	width2 = params['WIDTH2']
	height1 = params['HEIGHT1']
	height2 = params['HEIGHT2']
	
	diameter = params['DIAMETER']
	distance_diam = params['DISTANCE_DIAM']
	chamfer = params['CHAMFER']
	lifter_delta = params['LIFTER_DELTA']
	
	

	Front_body_list = []
	Back_body_list = []
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	hole_list = []
	hole_result = []
	special_list1 = []
	special_list2 = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, ref_direction, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	incl_dir = VISIVector.New()
	VISIGeoLib.VectorRotate(direction, y_axis, incl_dir, -lifter_incl_angle)
	

	#trasl_dist1 = ((lifter_height / math.cos(lifter_incl_angle)) + ((lifter_base_height / math.cos(lifter_incl_angle)) +  lifter_final_part_length/2 * math.tan(math.acos((lifter_final_part_length/2)/lifter_base_radius)))) * math.tan(-lifter_incl_angle)
	trasl_dist1 = -(lifter_height+lifter_base_height+lifter_base_radius+lifter_delta) * math.tan(lifter_incl_angle)
	
        VISIGeoLib.ProjectPointOntoVector(start_pos, direction, lifter_height + lifter_base_height/2, start_pos)
        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, trasl_dist1, start_pos)
	block1 = VISISolidFactory.CreateBlock(length, width, height, start_pos, ref_direction, direction)
	Uni_list.append(block1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height, start_pos)
	block2 = VISISolidFactory.CreateBlock(length, width1, height1, start_pos, ref_direction, direction)
	Uni_list.append(block2)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1, start_pos)
	block3 = VISISolidFactory.CreateBlock(length, width2, height2, start_pos, ref_direction, direction)
	Uni_list.append(block3)
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	if chamfer:
		edge_list = [110, 111, 97, 98,103,104,92,91]
		VISISolidFactory.ChamferEdges(Uni_list2[0], edge_list, chamfer,chamfer, 1)
	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -height1-distance_diam, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width/2, start_pos)
	
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, width, start_pos, direction, y_axis)
	Uni_list2.append(cyl1)
	
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	if chamfer:
		edge_list = [664,660]
		VISISolidFactory.BlendEdges(Result_List[0], edge_list, 4*chamfer, 1)
		
	return Result_List[0]
	
	# if(acceleration <> 0):
                # start_pos.Set(position.x(), position.y(), position.z())
                # VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -lifter_final_part_width/2, start_pos)
                # VISIGeoLib.ProjectPointOntoVector(start_pos, incl_dir, (lifter_height / math.cos(lifter_incl_angle)) +
                                                  # (lifter_base_height / math.cos(lifter_incl_angle)) +
                                                  # lifter_final_part_length/2 * math.tan(math.acos((lifter_final_part_length/2)/lifter_base_radius)),
                                                  # start_pos)
                # VISIGeoLib.ProjectPointOntoVector(start_pos, incl_dir, (lifter_final_part_height/math.cos(lifter_incl_angle)), start_pos)
                # VISISolidFactory.RotateBody(coup, start_pos, y_axis, -acceleration)

        # if(rblend > 0):
                # edge_list = [18, 20, 22, 24]
                # VISISolidFactory.BlendEdges(coup, edge_list, rblend, 1)
	
	# return coup

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	width = params['WIDTH']
	length = params['LENGTH']
	height = params['HEIGHT']
	rblend = params['RBLEND']
	lifter_base_width = params['LIFTER_BASE_WIDTH']
	lifter_base_height = params['LIFTER_BASE_HEIGHT']
	lifter_final_part_width = params['LIFTER_FINAL_PART_WIDTH']
	lifter_final_part_length = params['LIFTER_FINAL_PART_LENGTH']
	lifter_final_part_height = params['LIFTER_FINAL_PART_HEIGHT']
	lifter_base_radius = params['LIFTER_BASE_RADIUS']
	lifter_incl_angle = params['LIFTER_INCL_ANGLE']
	gib_base_height = params['GIB_BASE_HEIGHT']
	gib_middle_height = params['GIB_MIDDLE_HEIGHT']
	gib_middle_width = params['GIB_MIDDLE_WIDTH']
	gib_top_height = params['GIB_TOP_HEIGHT']
	gib_top_width = params['GIB_TOP_WIDTH']
	acceleration = params['ACCELERATION']
	housing_height = params['HOUSING_HEIGHT']
	x_clear = params['X_CLEAR']
	y_clear = params['Y_CLEAR']
	blend = params['BLEND']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	lifter_height = params['LIFTER_HEIGHT']

	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_liftercoup7'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
