import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	base_width = params['BASE_WIDTH']
	base_length = params['BASE_LENGTH']
	height = params['HEIGHT']
	base_height = params['BASE_HEIGHT']
	top_height = params['TOP_HEIGHT']
	blend = params['BLEND']
	lifter_base_width = params['LIFTER_BASE_WIDTH']
	lifter_base_height = params['LIFTER_BASE_HEIGHT']
	lifter_final_part_width = params['LIFTER_FINAL_PART_WIDTH']
	lifter_final_part_length = params['LIFTER_FINAL_PART_LENGTH']
	lifter_final_part_height = params['LIFTER_FINAL_PART_HEIGHT']
	lifter_base_radius = params['LIFTER_BASE_RADIUS']
	lifter_incl_angle = params['LIFTER_INCL_ANGLE']
	lifter_height = params['LIFTER_HEIGHT']
	coup_height = params['COUP_HEIGHT']
	coup_acceleration = params['COUP_ACCELERATION']
	lifter_delta = params['LIFTER_DELTA']
	
	width1 = params['WIDTH1']
	width2 = params['WIDTH2']
	height1 = params['HEIGHT1']
	height2 = params['HEIGHT2']
	chamfer = params['CHAMFER']
	

	Front_body_list = []
	Back_body_list = []
	Uni_list = []
	Result_List = []
	hole_list = []
	hole_result = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, ref_direction, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	incl_dir = VISIVector.New()
	VISIGeoLib.VectorRotate(direction, y_axis, incl_dir, -lifter_incl_angle)

	trasl_dist = lifter_height * math.tan(-lifter_incl_angle)
	trasl_dist1 = -(lifter_height+lifter_base_height+lifter_base_radius+lifter_delta) * math.tan(lifter_incl_angle)
	
        VISIGeoLib.ProjectPointOntoVector(start_pos, direction, lifter_height + lifter_base_height/2 + coup_height + base_height, start_pos)
        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, trasl_dist1, start_pos)
	base_block = VISISolidFactory.CreateBlock(base_length, base_width, base_height, start_pos, ref_direction, inv_dir)
	Uni_list.append(base_block)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, base_height, start_pos)
	block1 = VISISolidFactory.CreateBlock(base_length, width1, height1, start_pos, ref_direction, direction)
	Uni_list.append(block1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1, start_pos)
	block2 = VISISolidFactory.CreateBlock(base_length, width2, height2, start_pos, ref_direction, direction)
	Uni_list.append(block2)

	VISISolidFactory.Subtract(Uni_list, Result_List)
	
	if chamfer:
		edge_list = [28, 12, 34, 16,164,170,163,169,183,176,175,182]
		VISISolidFactory.ChamferEdges(Result_List[0], edge_list, chamfer,chamfer, 1)
	
	return Result_List[0]

        VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, base_height, start_pos)
	middle_block = VISISolidFactory.CreateBlock(base_length, lifter_base_width, height - base_height - top_height, start_pos, ref_direction, inv_dir)
	Uni_list.append(middle_block)

	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height - base_height - top_height, start_pos)
	top_block = VISISolidFactory.CreateBlock(base_length, lifter_final_part_width, top_height, start_pos, ref_direction, inv_dir)
	Uni_list.append(top_block)

	VISISolidFactory.Unite(Uni_list, Result_List)

	if(coup_acceleration <> 0):
                start_pos.Set(position.x(), position.y(), position.z())
                VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -lifter_final_part_width/2, start_pos)
                VISIGeoLib.ProjectPointOntoVector(start_pos, incl_dir,
                                                  (lifter_height / math.cos(lifter_incl_angle)) +
                                                  (lifter_base_height / math.cos(lifter_incl_angle)) +
                                                  lifter_final_part_length/2 * math.tan(math.acos((lifter_final_part_length/2)/lifter_base_radius)),
                                                  start_pos)
                VISIGeoLib.ProjectPointOntoVector(start_pos, incl_dir, (lifter_final_part_height/math.cos(lifter_incl_angle)), start_pos)
                VISISolidFactory.RotateBody(Result_List[0], start_pos, y_axis, -coup_acceleration)

        if(blend > 0):
                edge_list = [18, 20, 22, 24]
                VISISolidFactory.BlendEdges(Result_List[0], edge_list, blend, 1)

        if(screw_distance > 0) and (screw_diameter > 0):
            start_pos.Set(position.x(), position.y(), position.z())
            VISIGeoLib.ProjectPointOntoVector(start_pos, direction, lifter_height + lifter_base_height/2-1./1000 + coup_height + base_height, start_pos)
            VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, trasl_dist1 + screw_distance/2, start_pos)
            screw_hole1 = VISISolidFactory.CreateCylinder(screw_diameter/2, height, start_pos, ref_direction, inv_dir)
            VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -screw_distance, start_pos)
            screw_hole2 = VISISolidFactory.CreateCylinder(screw_diameter/2, height, start_pos, ref_direction, inv_dir)

            Uni_list = []
            Uni_list.append(Result_List[0])
            Result_List = []
            Uni_list.append(screw_hole1)
            Uni_list.append(screw_hole2)
            VISISolidFactory.Subtract(Uni_list, Result_List)

	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	base_width = params['BASE_WIDTH']
	base_length = params['BASE_LENGTH']
	height = params['HEIGHT']
	base_height = params['BASE_HEIGHT']
	top_height = params['TOP_HEIGHT']
	blend = params['BLEND']
	lifter_base_width = params['LIFTER_BASE_WIDTH']
	lifter_base_height = params['LIFTER_BASE_HEIGHT']
	lifter_final_part_width = params['LIFTER_FINAL_PART_WIDTH']
	lifter_final_part_length = params['LIFTER_FINAL_PART_LENGTH']
	lifter_final_part_height = params['LIFTER_FINAL_PART_HEIGHT']
	lifter_incl_angle = params['LIFTER_INCL_ANGLE']
	lifter_height = params['LIFTER_HEIGHT']
	lifter_base_radius = params['LIFTER_BASE_RADIUS']
	coup_height = params['COUP_HEIGHT']
	coup_acceleration = params['COUP_ACCELERATION']
	x_clear = params['X_CLEAR']
	y_clear = params['Y_CLEAR']
	blend_clearance = params['BLEND_CLEARANCE']
	lifter_delta = params['LIFTER_DELTA']
	extra_height = params['EXTRA_HEIGHT']

	Front_body_list = []
	Back_body_list = []
	Uni_list = []
	Result_List = []
	hole_list = []
	hole_result = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, ref_direction, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	incl_dir = VISIVector.New()
	VISIGeoLib.VectorRotate(direction, y_axis, incl_dir, -lifter_incl_angle)

	trasl_dist = lifter_height * math.tan(-lifter_incl_angle)
	#trasl_dist1 = ((lifter_height / math.cos(lifter_incl_angle)) + ((lifter_base_height / math.cos(lifter_incl_angle)) +  lifter_final_part_length/2 * math.tan(math.acos((lifter_final_part_length/2)/lifter_base_radius)))) * math.tan(-lifter_incl_angle)
	trasl_dist1 = -(lifter_height+lifter_base_height+lifter_base_radius+lifter_delta) * math.tan(lifter_incl_angle)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, lifter_height + lifter_base_height/2 + coup_height + base_height, start_pos)
        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, trasl_dist1, start_pos)
	cav = VISISolidFactory.CreateBlock(base_length + x_clear, base_width + y_clear, coup_height + base_height+extra_height, start_pos, ref_direction, inv_dir)

	if(coup_acceleration <> 0):
                start_pos.Set(position.x(), position.y(), position.z())
                VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -lifter_final_part_width/2, start_pos)
                VISIGeoLib.ProjectPointOntoVector(start_pos, incl_dir,
                                                  (lifter_height / math.cos(lifter_incl_angle)) +
                                                  (lifter_base_height / math.cos(lifter_incl_angle)) +
                                                  lifter_final_part_length/2 * math.tan(math.acos((lifter_final_part_length/2)/lifter_base_radius)),
                                                  start_pos)
                VISIGeoLib.ProjectPointOntoVector(start_pos, incl_dir, (lifter_final_part_height/math.cos(lifter_incl_angle)), start_pos)
                VISISolidFactory.RotateBody(cav, start_pos, y_axis, -coup_acceleration)

        if(blend_clearance > 0):
                edge_list = [18, 20, 22, 24]
                VISISolidFactory.BlendEdges(cav, edge_list, blend_clearance, 1)
	
	return cav

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_liftergib7'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
