import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	end_face = params['END_FACE']
	cavity_plate = params['CAVITY_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	diameter = params['DIAMETER']
	height = params['HEIGHT']
	base_width = params['BASE_WIDTH']
	base_height = params['BASE_HEIGHT']
	base_final_part_width = params['BASE_FINAL_PART_WIDTH']
	base_final_part_length = params['BASE_FINAL_PART_LENGTH']
	base_final_part_height = params['BASE_FINAL_PART_HEIGHT']
	base_radius = params['BASE_RADIUS']
	inclination_angle = params['INCLINATION_ANGLE']
	tool_stroke = params['TOOL_STROKE']
	lifter_stroke = params['LIFTER_STROKE']
	coup_acceleration = params['COUP_ACCELERATION']
	y_axis = params['Y_AXIS']
	incl_dir = params['INCL_DIR']
	cavity_pos1 = params['CAVITY_POS1']
	cavity_pos2 = params['CAVITY_POS2']
	cavity_plate_thick = params['CAVITY_PLATE_THICK']
	cavity_plate_thick_incl = params['CAVITY_PLATE_THICK_INCL']
	pin_clear = params['PIN_CLEAR']
	x_clear = params['X_CLEAR']
	y_clear = params['Y_CLEAR']
	end_face_pos = params['END_FACE_POS']
	head_penetration = params['HEAD_PENETRATION']
	
	diameter_end = params['DIAMETER_END']
	distance_diameter = params['DISTANCE_DIAMETER']
	clear_length = params['CLEAR_LENGTH']
	clear_angle = params['CLEAR_ANGLE']
	radius = params['RADIUS']
	adapt_element_to_element = params['ADAPT_ELEMENT_TO_ELEMENT']

	Front_body_list = []
	Back_body_list = []
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	hole_list = []
	hole_result = []
	
	special_list1 = []
	special_list2 = []
	
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, ref_direction, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	cut_dir = VISIVector.New()
	cut_dir.Set(direction.Cx(), direction.Cy(), direction.Cz())
	
	
	
	#Rotate Cut Dir
	if not adapt_element_to_element:
		VISIGeoLib.VectorRotate (cut_dir, y_axis, cut_dir, -inclination_angle)
		
	block1 = VISISolidFactory.CreateCylinder(diameter/2, ((height+base_height+base_radius) / math.cos(-inclination_angle))-base_height-base_radius+diameter_end, start_pos, ref_direction, direction)
	block12 = VISISolidFactory.CreateCylinder(diameter/2, ((height+base_height+base_radius) / math.cos(-inclination_angle))-base_height-base_radius + head_penetration, start_pos, ref_direction, inv_dir)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, ((height+base_height+base_radius) / math.cos(-inclination_angle))-base_height-base_radius, start_pos)

	Uni_list.append(block1)
	Uni_list.append(block12)
	VISISolidFactory.Unite(Uni_list, Result_List)
	block1 = Result_List[0]
	Uni_list = []
	Result_List = []
	Uni_list2.append(block1)
	
	
	#Create Sub Block
	VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -diameter/2, start_pos)
	block1 = VISISolidFactory.CreateBlock(diameter,diameter,diameter, start_pos, direction, ref_direction)
	VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, diameter/2, start_pos)
	
	#Create Cylinder
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -diameter/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, 2./1000, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder(diameter_end/2, diameter, start_pos, direction, y_axis)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, diameter/2, start_pos)
	

	#Cut Block
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_diameter, start_pos)
	VISISolidFactory.CutWithPlane(start_pos, direction, block1, Front_body_list, Back_body_list)
	
	Uni_list.append(Front_body_list[0])
	VISISolidFactory.DeleteBodies(Back_body_list)
	Uni_list.append(cyl1)
	
	#Create Nose
	VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -(diameter-2*clear_length)/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, distance_diameter/2, start_pos)
	block2 = VISISolidFactory.CreateBlock(distance_diameter,diameter,diameter-2*clear_length, start_pos, direction, ref_direction)

	#return block2
	
	edge_list = [6,25]
	VISISolidFactory.ChamferEdges(block2, edge_list, distance_diameter*math.tan(clear_angle),distance_diameter, 1)
	Uni_list.append(block2)
	
	
	VISISolidFactory.Subtract(Uni_list, Uni_list2)
	
	edge_list = [222,221]
	VISISolidFactory.BlendEdges(Uni_list2[1], edge_list,radius, 1)
	
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	# return Result_List[0]
	

	# block2 = VISISolidFactory.CreateBlock(base_final_part_length, base_width, base_height , start_pos, ref_direction, direction)

	# VISIGeoLib.ProjectPointOntoVector(start_pos, direction, base_height+base_radius, start_pos)
        # VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -base_final_part_width/2, start_pos)
	# cyl1 = VISISolidFactory.CreateCylinder(base_radius+base_final_part_height, base_final_part_width, start_pos, direction, y_axis)

	# cyl2 = VISISolidFactory.CreateCylinder(base_radius, base_final_part_width, start_pos, direction, y_axis)
	
	
	# VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, base_final_part_width/2, start_pos)
	# block_s1 = VISISolidFactory.CreateBlock(base_radius*2, base_final_part_width, base_radius*2, start_pos, ref_direction, direction)
	# block_s2 = VISISolidFactory.CreateBlock(base_radius*2, base_final_part_width, base_radius*2, start_pos, ref_direction, direction)
		
	# special_list1.append(cyl1)
	# special_list2.append(cyl2)
	# special_list1.append(block_s1)
	# special_list2.append(block_s2)
	# VISISolidFactory.Subtract(special_list1, Uni_list)
	# VISISolidFactory.Subtract(special_list2, Uni_list)
	
	# VISISolidFactory.Subtract(Uni_list, Result_List)
	
	

	# start_pos.Set(position.x(), position.y(), position.z())
	# VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, base_final_part_length/2, start_pos)
	# VISISolidFactory.CutWithPlane(start_pos, ref_direction, Result_List[0], Front_body_list, Back_body_list)
	# VISISolidFactory.DeleteBodies(Front_body_list)
	# pin = Back_body_list[0]
	
	
        # Front_body_list = []
	# Back_body_list = []
        # start_pos.Set(position.x(), position.y(), position.z())
	# VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -base_final_part_length/2, start_pos)
	# VISISolidFactory.CutWithPlane(start_pos, ref_direction, pin, Front_body_list, Back_body_list)
	# VISISolidFactory.DeleteBodies(Back_body_list)
	# pin = Front_body_list[0]
	
	
        # Uni_list = []
	# Result_List = []
	# Uni_list.append(block1)
	# Uni_list.append(block2)
	# Uni_list.append(pin)
	# VISISolidFactory.Unite(Uni_list, Result_List)

	if(inclination_angle <>0):
                start_pos.Set(position.x(), position.y(), position.z())
                VISISolidFactory.RotateBody(Result_List[0], start_pos, y_axis, -inclination_angle)

        Front_body_list = []
	Back_body_list = []
        start_pos.Set(position.x(), position.y(), position.z())
        VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, head_penetration, start_pos)
        VISISolidFactory.CutWithPlane(start_pos, cut_dir, Result_List[0], Front_body_list, Back_body_list)
        VISISolidFactory.DeleteBodies(Back_body_list)
        pin = Front_body_list[0]
	
	return pin

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	end_face = params['END_FACE']
	cavity_plate = params['CAVITY_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	diameter = params['DIAMETER']
	height = params['HEIGHT']
	base_width = params['BASE_WIDTH']
	base_height = params['BASE_HEIGHT']
	base_final_part_width = params['BASE_FINAL_PART_WIDTH']
	base_final_part_length = params['BASE_FINAL_PART_LENGTH']
	base_final_part_height = params['BASE_FINAL_PART_HEIGHT']
	base_radius = params['BASE_RADIUS']
	inclination_angle = params['INCLINATION_ANGLE']
	tool_stroke = params['TOOL_STROKE']
	lifter_stroke = params['LIFTER_STROKE']
	coup_acceleration = params['COUP_ACCELERATION']
	y_axis = params['Y_AXIS']
	incl_dir = params['INCL_DIR']
	cavity_pos1 = params['CAVITY_POS1']
	cavity_pos2 = params['CAVITY_POS2']
	cavity_plate_thick = params['CAVITY_PLATE_THICK']
	cavity_plate_thick_incl = params['CAVITY_PLATE_THICK_INCL']
	pin_clear = params['PIN_CLEAR']
	x_clear = params['X_CLEAR']
	y_clear = params['Y_CLEAR']
	end_face_pos = params['END_FACE_POS']
	head_penetration = params['HEAD_PENETRATION']
	extra_penetration = params['EXTRA_PENETRATION']
	adapt_to_element = params['ADAPT_TO_ELEMENT']

	
	if adapt_to_element:
		extra_penetration = 0
	Front_body_list = []
	Back_body_list = []
	Uni_list = []
	Result_List = []
	hole_list = []
	hole_result = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, ref_direction, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	cut_dir = VISIVector.New()
	cut_dir.Set(direction.Cx(), direction.Cy(), direction.Cz())
	
	#Rotate Cut Dir
	if not adapt_to_element:
		VISIGeoLib.VectorRotate (cut_dir, y_axis, cut_dir, -inclination_angle)
	

	if(cavity_plate > 0):
                start_pos.Set(cavity_pos1.x(), cavity_pos1.y(), cavity_pos1.z())
                dist = abs(position.z() - cavity_pos2.z())
                
                VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -(dist*math.tan(inclination_angle) - dist*math.tan(inclination_angle)/2), start_pos)
                VISIGeoLib.ProjectPointOntoVector(cavity_pos2, ref_direction, -(dist*math.tan(inclination_angle))/2, cavity_pos2)
                part1 = VISISolidFactory.CreateBlock(diameter + pin_clear + x_clear + dist*math.tan(inclination_angle)/2, diameter + pin_clear + y_clear, cavity_plate_thick, start_pos, ref_direction, direction)
                part2 = VISISolidFactory.CreateBlock(diameter + pin_clear + x_clear + dist*math.tan(inclination_angle)/2, diameter + pin_clear + y_clear, cavity_plate_thick, cavity_pos2, ref_direction, inv_dir)
                Uni_list.append(part1)
                Uni_list.append(part2)
                VISISolidFactory.Unite(Uni_list, Result_List)

                if(inclination_angle > 0):
                        start_pos.Set(cavity_pos2.x(), cavity_pos2.y(), cavity_pos2.z())
                        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -(diameter + pin_clear + x_clear + dist*math.tan(inclination_angle)/2)/2, start_pos)
                        cyl1 = VISISolidFactory.CreateCylinder((diameter + pin_clear + y_clear)/2, cavity_plate_thick, start_pos, ref_direction, inv_dir)
                        cam_list = [diameter + pin_clear + y_clear, cavity_plate_thick]
                        VISI.AttachCamAttributes(cyl1,cam_list,"LIFTERPIN7_1",elem_tag,params["BUILDER_UNIT"])

                        start_pos.Set(cavity_pos1.x(), cavity_pos1.y(), cavity_pos1.z())
                        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -(dist*math.tan(inclination_angle) - dist*math.tan(inclination_angle)/2), start_pos)
                        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, (diameter + pin_clear + x_clear + dist*math.tan(inclination_angle)/2)/2, start_pos)
                        cyl2 = VISISolidFactory.CreateCylinder((diameter + pin_clear + y_clear)/2, cavity_plate_thick, start_pos, ref_direction, direction)
                        cam_list = [diameter + pin_clear + y_clear, cavity_plate_thick]
                        VISI.AttachCamAttributes(cyl2,cam_list,"LIFTERPIN7_2",elem_tag,params["BUILDER_UNIT"])
                else:
                        start_pos.Set(cavity_pos1.x(), cavity_pos1.y(), cavity_pos1.z())
                        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, -(diameter + pin_clear + x_clear)/2, start_pos)
                        cyl1 = VISISolidFactory.CreateCylinder((diameter + pin_clear + y_clear)/2, cavity_plate_thick, start_pos, ref_direction, direction)
                        cam_list = [diameter + pin_clear + y_clear, cavity_plate_thick]
                        VISI.AttachCamAttributes(cyl1,cam_list,"LIFTERPIN7_1",elem_tag,params["BUILDER_UNIT"])

                        start_pos.Set(cavity_pos2.x(), cavity_pos2.y(), cavity_pos2.z())
                        VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, (diameter + pin_clear + x_clear)/2, start_pos)
                        cyl2 = VISISolidFactory.CreateCylinder((diameter + pin_clear + y_clear)/2, cavity_plate_thick, start_pos, ref_direction, inv_dir)
                        cam_list = [diameter + pin_clear + y_clear, cavity_plate_thick]
                        VISI.AttachCamAttributes(cyl2,cam_list,"LIFTERPIN7_2",elem_tag,params["BUILDER_UNIT"])

                Uni_list = []
                Uni_list.append(Result_List[0])
                Uni_list.append(cyl1)
                Uni_list.append(cyl2)
                Result_List = []
                VISISolidFactory.Unite(Uni_list, Result_List)
                cav1 = Result_List[0]

        start_pos.Set(position.x(), position.y(), position.z())
	cav = VISISolidFactory.CreateCylinder((diameter + pin_clear)/2, ((height+base_height+base_radius) / math.cos(-inclination_angle))-base_height-base_radius, start_pos, ref_direction, direction)
	cav2 = VISISolidFactory.CreateCylinder((diameter + pin_clear)/2, ((height+base_height+base_radius) / math.cos(-inclination_angle))-base_height-base_radius + head_penetration, start_pos, ref_direction, inv_dir)
	if (head_penetration+extra_penetration)>0:
		cav30 = VISISolidFactory.CreateCylinder(diameter/2, ((height+base_height+base_radius) / math.cos(-inclination_angle))-base_height-base_radius, start_pos, ref_direction, direction)
		cav31 = VISISolidFactory.CreateCylinder(diameter/2, ((height+base_height+base_radius) / math.cos(-inclination_angle))-base_height-base_radius + head_penetration, start_pos, ref_direction, inv_dir)

	Uni_list = []
	Result_List = []
	Uni_list.append(cav)
	Uni_list.append(cav2)
	VISISolidFactory.Unite(Uni_list, Result_List)
	cav = Result_List[0]
	if (head_penetration+extra_penetration)>0:
		Uni_list = []
		Result_List = []
		Uni_list.append(cav30)
		Uni_list.append(cav31)
		VISISolidFactory.Unite(Uni_list, Result_List)
		cav3 = Result_List[0]

	if(inclination_angle <>0):
                start_pos.Set(position.x(), position.y(), position.z())
                VISISolidFactory.RotateBody(cav, start_pos, y_axis, -inclination_angle)
                if (head_penetration+extra_penetration)>0:
					VISISolidFactory.RotateBody(cav3, start_pos, y_axis, -inclination_angle)
        if(cavity_plate > 0):
                Uni_list = []
                Result_List = []
                Uni_list.append(cav1)
                Uni_list.append(cav)
                VISISolidFactory.Unite(Uni_list, Result_List)
                cav = Result_List[0]

        Front_body_list = []
        Back_body_list = []
        start_pos.Set(position.x(), position.y(), position.z())
        #VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, head_penetration+extra_penetration, start_pos)
        VISISolidFactory.CutWithPlane(start_pos, direction, cav, Front_body_list, Back_body_list)
        VISISolidFactory.DeleteBodies(Back_body_list)
        cav = Front_body_list[0]
        #return cav
		
        if (head_penetration+extra_penetration)>0:
			#return cav3
			Front_body_list = []
			Back_body_list = []
			#VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, head_penetration+extra_penetration, start_pos)
			VISISolidFactory.CutWithPlane(start_pos, direction, cav3, Front_body_list, Back_body_list)
			VISISolidFactory.DeleteBodies(Front_body_list)
			cav3 = Back_body_list[0]
			
			Front_body_list = []
			Back_body_list = []
			VISIGeoLib.ProjectPointOntoVector(start_pos, cut_dir, -(head_penetration+extra_penetration), start_pos)
			VISISolidFactory.CutWithPlane(start_pos, cut_dir, cav3, Front_body_list, Back_body_list)
			VISISolidFactory.DeleteBodies(Back_body_list)
			cav3 = Front_body_list[0]
			VISIGeoLib.ProjectPointOntoVector(start_pos, cut_dir, head_penetration+extra_penetration, start_pos)
	   
        if not adapt_to_element and (head_penetration+extra_penetration)>0:
			h_cone = (diameter/2)/(math.tan(math.radians(60)))
			VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+head_penetration+extra_penetration, start_pos)
			cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, ref_direction, direction)
			start_pos.Set(position.x(), position.y(), position.z())
			VISISolidFactory.RotateBody(cone, start_pos, y_axis, -inclination_angle)
			Uni_list = []
			Result_List = []
			Uni_list.append(cone)
			Uni_list.append(cav)
			Uni_list.append(cav3)
			VISISolidFactory.Unite(Uni_list, Result_List)
			cav = Result_List[0]
        else:
			if (head_penetration+extra_penetration)>0:
				Uni_list = []
				Result_List = []
				Uni_list.append(cav)
				Uni_list.append(cav3)
				VISISolidFactory.Unite(Uni_list, Result_List)
				cav = Result_List[0]
	return cav

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_lifterpin7'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
