import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, VISIParam, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	block_length = params['BLOCK_LENGTH']
	block_width = params['BLOCK_WIDTH']
	block_height = params['BLOCK_HEIGHT']
	block_groove_height = params['BLOCK_GROOVE_HEIGHT']
	block_groove_width = params['BLOCK_GROOVE_WIDTH']
	block_dp_diam = params['BLOCK_DP_DIAM']
	block_dp_length = params['BLOCK_DP_LENGTH']
	block_dp_distance_between = params['BLOCK_DP_DISTANCE_BETWEEN']
	block_dp_distance_length = params['BLOCK_DP_DISTANCE_LENGTH']
	block_screw_diam = params['BLOCK_SCREW_DIAM']
	block_screw_length = params['BLOCK_SCREW_LENGTH']
	block_screw_distance = params['BLOCK_SCREW_DISTANCE']
	block_delta = params['BLOCK_DELTA']
	arm_width = params['ARM_WIDTH']
	arm_length = params['ARM_LENGTH']
	arm_height = params['ARM_HEIGHT']
	head_length = params['HEAD_LENGTH']
	head_width = params['HEAD_WIDTH']
	head_height = params['HEAD_HEIGHT']
	head_delta = params['HEAD_DELTA']
	head_dp_diam = params['HEAD_DP_DIAM']
	head_dp_length = params['HEAD_DP_LENGTH']
	head_height_f_dp = params['HEAD_HEIGHT_F_DP']
	head_screw_diam = params['HEAD_SCREW_DIAM']
	head_screw_length = params['HEAD_SCREW_LENGTH']
	stop_length = params['STOP_LENGTH']
	stop_width = params['STOP_WIDTH']
	stop_height = params['STOP_HEIGHT']
	stop_screw_diam = params['STOP_SCREW_DIAM']
	stop_screw_length = params['STOP_SCREW_LENGTH']
	stop_screw_distance = params['STOP_SCREW_DISTANCE']
	stop_screw_distance_width = params['STOP_SCREW_DISTANCE_WIDTH']
	spring_length = params['SPRING_LENGTH']
	spring_height = params['SPRING_HEIGHT']
	cut = params['CUT']
	
	Uni_list_Block = []
	Uni_list_Arm = []
	Uni_list_Spring = []
	Uni_list_Spring2 = []
	Uni_list_Head = []
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = ref_direction
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(block_length+arm_length)+cut, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, block_delta, start_pos)
	
	#Create Block
	##Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, block_length/2, start_pos)
	bl1 = VISISolidFactory.CreateBlock (block_length, block_width, block_height, start_pos, x_axis, direction)
	Uni_list_Block.append(bl1)
	
	##Blend
	edges = [18,24,20,22]
	VISISolidFactory.ChamferEdges(bl1, edges, block_length/50,block_length/50, 1)
	
	##Create Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, block_height, start_pos)
	bl2 = VISISolidFactory.CreateBlock (block_length, block_groove_width, block_groove_height, start_pos, x_axis, inv_dir)
	Uni_list_Block.append(bl2)
	
	##Create Drillings for DowelPins
	###1
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, block_length/2-block_dp_distance_length, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, block_dp_distance_between/2, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder (block_dp_diam/2, block_height, start_pos, x_axis, inv_dir)
	Uni_list_Block.append(cyl1)
	
	###2
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -block_dp_distance_between, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder (block_dp_diam/2, block_height, start_pos, x_axis, inv_dir)
	Uni_list_Block.append(cyl2)
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list_Block, Uni_list)
	
	# Create Arm
	##Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, block_dp_distance_length+arm_length/200, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, block_dp_distance_between/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, block_height-block_delta, start_pos)
	## Create Body1
	bl3 = VISISolidFactory.CreateBlock (arm_length/100, arm_width/3*2, arm_height, start_pos, x_axis, direction)
	Uni_list_Arm.append(bl3)
	
	## Create Body2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, arm_length/2-cut/2, start_pos)
	bl4 = VISISolidFactory.CreateBlock (arm_length-arm_length/100-cut, arm_width, arm_height, start_pos, x_axis, direction)
	Uni_list_Arm.append(bl4)
	
	##Unite
	VISISolidFactory.Unite(Uni_list_Arm, Uni_list)
	
	#Create Spring
	##Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -arm_length/2-arm_length/200-block_length+spring_length/5+cut/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, block_height-block_delta-block_groove_height, start_pos)
	
	##Create Block1
	bl5 = VISISolidFactory.CreateBlock (spring_length/5, block_groove_width, block_groove_height*2, start_pos, x_axis, direction)
	
	##Create Block2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, spring_length/5*3+spring_length/5/2, start_pos)
	bl6 = VISISolidFactory.CreateBlock (spring_length/5, block_groove_width, block_groove_height*2, start_pos, x_axis, direction)
	
	##Blend
	edges = [18,20]
	VISISolidFactory.BlendEdges(bl6, edges,block_groove_width/8, 1)
	
	##Adapt to Body
	bl6= VISIParam.AdaptCavityToPlate(Uni_list[1], bl6, 1)
	
	##Create Cyl Between
	spring_thick = block_groove_height*2
	h = spring_length/4
	p = spring_height
	q = math.pow(h,2)/p
	c = p+q
	
	diam = (h/(math.tan(math.radians(90-math.degrees(math.atan(h/p))))))+h
	#VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -q, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -diam/2+spring_height+block_groove_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -spring_length/10-spring_length/4, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -block_groove_width/2, start_pos)
	
	cyl3 = VISISolidFactory.CreateCylinder (diam/2, block_groove_width, start_pos, direction,y_axis)
	
	##Adapt Bodies to Height
	bl5= VISIParam.AdaptCavityToPlate(cyl3, bl5, 1)
	Uni_list_Spring.append(bl5)
	bl6= VISIParam.AdaptCavityToPlate(cyl3, bl6, 1)
	Uni_list_Spring.append(bl6)
	
	cyl4 = VISISolidFactory.CreateCylinder (diam/2+spring_thick, block_groove_width, start_pos, direction,y_axis)
	
	##Subtract Cyls
	Uni_list_Spring2.append(cyl4)
	Uni_list_Spring2.append(cyl3)
	VISISolidFactory.Subtract(Uni_list_Spring2, Uni_list_Spring)
	cyl = Uni_list_Spring[2]
	
	#Cut
	Front_Body_List = []
	Back_Body_List = []
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, block_groove_width/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, +diam/2-spring_height+block_groove_height, start_pos)
	VISISolidFactory.CutWithPlane(start_pos, direction,  Uni_list_Spring[2], Front_Body_List, Back_Body_List)
	Uni_list_Spring[2] = Front_Body_List[0]
	part2 = Back_Body_List[0]
	del_list = []
	del_list.append(part2)
	VISISolidFactory.DeleteBodies(del_list)
	
	##Unite
	VISISolidFactory.Unite(Uni_list_Spring, Uni_list)
	
	#Create Head
	##Set Position
	start_pos.Set(position.x(), position.y(), position.z())
	#VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -cut, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(block_length+arm_length), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, block_delta, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, block_length+arm_length+head_length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, block_delta-head_delta, start_pos)
	##Create Body
	bl7 = VISISolidFactory.CreateBlock (head_length, head_width, head_height, start_pos, x_axis, direction)
	Uni_list_Head.append(bl7)
	
	##Chamfer Head 1
	edges = [25,31,14,28,34]
	VISISolidFactory.ChamferEdges(bl7, edges, head_length/20,head_length/20, 1)
	
	##Chamfer Head 2
	edges = [6]
	VISISolidFactory.ChamferEdges(bl7, edges, head_length/2.5,head_length/4*3, 1)
	edges = [226]
	VISISolidFactory.ChamferEdges(bl7, edges, head_length/20,head_length/20, 1)
	
	##Create Pin
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_height_f_dp+head_dp_diam/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, head_width/2, start_pos)
	cyl5 = VISISolidFactory.CreateCylinder (head_dp_diam/2, head_dp_length, start_pos, direction,y_axis)
	Uni_list_Head.append(cyl5)
	
	##Blend Pin
	edges = [12]
	VISISolidFactory.BlendEdges(cyl5, edges,head_dp_diam/10, 1)
	
	##Unite
	VISISolidFactory.Unite(Uni_list_Head, Uni_list)
	
	#Create Stop-Plate
	##Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -head_height_f_dp-head_dp_diam/2+head_delta, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -head_width/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -head_length/2-stop_length/2, start_pos)
	
	#Create Body
	bl8 = VISISolidFactory.CreateBlock (stop_length, stop_width, stop_height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl8)
	
	##Blend
	edges = [28,34]
	VISISolidFactory.BlendEdges(bl8, edges,stop_height/5, 1)

	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List,0)

	#Rotate
	start_pos.Set(position.x(), position.y(), position.z())
	VISISolidFactory.RotateBody(Result_List[0],start_pos,x_axis,math.radians(180))
	VISISolidFactory.RotateBody(Result_List[0],start_pos,y_axis,math.radians(90))
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	block_length = params['BLOCK_LENGTH']
	block_width = params['BLOCK_WIDTH']
	block_height = params['BLOCK_HEIGHT']
	block_groove_height = params['BLOCK_GROOVE_HEIGHT']
	block_groove_width = params['BLOCK_GROOVE_WIDTH']
	block_dp_diam = params['BLOCK_DP_DIAM']
	block_dp_length = params['BLOCK_DP_LENGTH']
	block_dp_distance_between = params['BLOCK_DP_DISTANCE_BETWEEN']
	block_dp_distance_length = params['BLOCK_DP_DISTANCE_LENGTH']
	block_screw_diam = params['BLOCK_SCREW_DIAM']
	block_screw_length = params['BLOCK_SCREW_LENGTH']
	block_screw_distance = params['BLOCK_SCREW_DISTANCE']
	block_delta = params['BLOCK_DELTA']
	arm_width = params['ARM_WIDTH']
	arm_length = params['ARM_LENGTH']
	arm_height = params['ARM_HEIGHT']
	head_length = params['HEAD_LENGTH']
	head_width = params['HEAD_WIDTH']
	head_height = params['HEAD_HEIGHT']
	head_delta = params['HEAD_DELTA']
	head_dp_diam = params['HEAD_DP_DIAM']
	head_dp_length = params['HEAD_DP_LENGTH']
	head_height_f_dp = params['HEAD_HEIGHT_F_DP']
	head_screw_diam = params['HEAD_SCREW_DIAM']
	head_screw_length = params['HEAD_SCREW_LENGTH']
	stop_length = params['STOP_LENGTH']
	stop_width = params['STOP_WIDTH']
	stop_height = params['STOP_HEIGHT']
	stop_screw_diam = params['STOP_SCREW_DIAM']
	stop_screw_length = params['STOP_SCREW_LENGTH']
	stop_screw_distance = params['STOP_SCREW_DISTANCE']
	stop_screw_distance_width = params['STOP_SCREW_DISTANCE_WIDTH']
	spring_length = params['SPRING_LENGTH']
	spring_height = params['SPRING_HEIGHT']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_ll1_0'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
