import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, VISIParam, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	block_length = params['BLOCK_LENGTH']
	block_width = params['BLOCK_WIDTH']
	block_height = params['BLOCK_HEIGHT']
	block_screw_diam = params['BLOCK_SCREW_DIAM']
	block_screw_length = params['BLOCK_SCREW_LENGTH']
	block_screw_distance = params['BLOCK_SCREW_DISTANCE']
	block_delta = params['BLOCK_DELTA']
	arm_width = params['ARM_WIDTH']
	arm_length = params['ARM_LENGTH']
	arm_height = params['ARM_HEIGHT']
	head_length = params['HEAD_LENGTH']
	head_width = params['HEAD_WIDTH']
	head_height = params['HEAD_HEIGHT']
	head_delta = params['HEAD_DELTA']
	head_dp_diam = params['HEAD_DP_DIAM']
	head_dp_length = params['HEAD_DP_LENGTH']
	head_height_f_dp = params['HEAD_HEIGHT_F_DP']
	head_screw_diam = params['HEAD_SCREW_DIAM']
	head_screw_length = params['HEAD_SCREW_LENGTH']
	stop_length = params['STOP_LENGTH']
	stop_width = params['STOP_WIDTH']
	stop_height = params['STOP_HEIGHT']
	stop_screw_diam = params['STOP_SCREW_DIAM']
	stop_screw_length = params['STOP_SCREW_LENGTH']
	stop_screw_distance = params['STOP_SCREW_DISTANCE']
	stop_screw_distance_width = params['STOP_SCREW_DISTANCE_WIDTH']
	spring_length = params['SPRING_LENGTH']
	spring_height = params['SPRING_HEIGHT']
	cut = params['CUT']
	stroke = params['STROKE']
	
	Uni_list_Block = []
	Uni_list_Arm = []
	Uni_list_Spring = []
	Uni_list_Spring2 = []
	Uni_list_Head = []
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = ref_direction
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Move
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(block_length+arm_length)+cut, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, block_delta, start_pos)
	
	#Create Block
	##Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, block_length/2, start_pos)
	bl1 = VISISolidFactory.CreateBlock (block_length, block_width, block_height, start_pos, x_axis, direction)
	Uni_list.append(bl1)
	
	##Blend
	edges = [18,24,20,22]
	VISISolidFactory.ChamferEdges(bl1, edges, block_length/50,block_length/50, 1)
		
	# Create Arm
	##Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, block_length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, 3./2000, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, block_delta+2./1000, start_pos)
	
	## Create Body1
	bl3 = VISISolidFactory.CreateBlock (3./1000, arm_width/3*2, arm_height-2./1000, start_pos, x_axis, direction)
	Uni_list.append(bl3)
	
	## Create Body2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, arm_length/2-cut/2, start_pos)
	bl4 = VISISolidFactory.CreateBlock (arm_length-3./1000-cut, arm_width, arm_height-2./1000, start_pos, x_axis, direction)
	Uni_list.append(bl4)
	
	##Create Body3
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(arm_length/2-cut/2)+10./1000-3./1000+28./1000, start_pos)
	bl5 = VISISolidFactory.CreateBlock (20./1000, arm_width, 2./1000, start_pos, x_axis, inv_dir)
	Uni_list.append(bl5)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(-(arm_length/2-cut/2)+10./1000-3./1000+28./1000), start_pos)
	
	#Create Head
	##Set Position
	start_pos.Set(position.x(), position.y(), position.z())
	#VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -cut, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(block_length+arm_length), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, block_delta, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, block_length+arm_length+head_length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, block_delta-head_delta, start_pos)
	##Create Body
	bl7 = VISISolidFactory.CreateBlock (head_length, head_width, head_height, start_pos, x_axis, direction)
	Uni_list_Head.append(bl7)
	
	##Chamfer Head 1
	edges = [25]
	VISISolidFactory.ChamferEdges(bl7, edges, 10./1000,10./1000, 1)
	
	##Chamfer Head 2
	edges = [6]
	VISISolidFactory.ChamferEdges(bl7, edges, 20.5/1000,11.8357/1000, 1)
	edges = [226]
	VISISolidFactory.ChamferEdges(bl7, edges, head_length/20,head_length/20, 1)
	
	edges = [134]
	VISISolidFactory.BlendEdges(bl7, edges, 5./1000, 1)
	
	# ##Create Pin
	# VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_height_f_dp+head_dp_diam/2, start_pos)
	# VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, head_width/2, start_pos)
	
	# if type == 32:
		# VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -head_width-head_dp_length, start_pos)
	
	# VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, head_height_f_dp+head_dp_diam/2-head_height+head_height/4, start_pos)
	# VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, head_length/2-head_length/3, start_pos)
	
	# blockcyl5 = VISISolidFactory.CreateBlock (head_height/2,head_length/3*2, head_dp_length, start_pos, direction,y_axis)
	# Uni_list_Head.append(blockcyl5)
	
	##Chamfer Head 1
	# edges = [20]
	# VISISolidFactory.ChamferEdges(blockcyl5, edges, head_length/20,head_length/20, 1)
	
	# edges = [22]
	# VISISolidFactory.ChamferEdges(blockcyl5, edges, head_height/2-head_length/20,head_length/3*2, 1)

	# edges = [24]
	# VISISolidFactory.BlendEdges(blockcyl5, edges,head_dp_diam/2, 1)
		
	
	#VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_height_f_dp+head_dp_diam/2-head_height+head_height/6, start_pos)
	#VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(head_length/2-head_length/3), start_pos)
		
	##Unite
	VISISolidFactory.Unite(Uni_list_Head, Uni_list)
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Groove
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -head_length/2-(80./1000+stroke)/2+head_length, start_pos)
	
	#Create Groove Body
	bl70 = VISISolidFactory.CreateBlock (80./1000+stroke, 24./1000, head_height, start_pos, x_axis, inv_dir)
	Uni_list2.append(bl70)
	
	edges = [24,22]
	VISISolidFactory.BlendEdges(bl70, edges,6./1000, 1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -head_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(-head_length/2-(80./1000+stroke)/2+head_length), start_pos)
	
	VISISolidFactory.Subtract(Uni_list2, Uni_list3)
	
	#Create Pin for Groove
	
	#Create Groove Body
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -24./2000, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_height-12./1000, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -head_length/2+7.5/1000, start_pos)
	
	bl71 = VISISolidFactory.CreateCylinder (5./1000, 24./1000, start_pos, inv_dir, y_axis )
	Uni_list3.append(bl71)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, 24./2000, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -(head_height-12./1000), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(-head_length/2+7.5/1000), start_pos)
	
	#Create Stop-Plate
	
	##1 
	##Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, head_delta, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -head_width/2+stop_width/2-0.25/1000, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -head_length/2-stop_length/2, start_pos)
	
	#Create Body
	bl8 = VISISolidFactory.CreateBlock (stop_length, stop_width, stop_height, start_pos, x_axis, inv_dir)
	Uni_list3.append(bl8)
	
	##Blend
	edges = [28,34]
	VISISolidFactory.BlendEdges(bl8, edges,5./1000, 1)

	
	##2
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, +head_width-stop_width+0.5/1000, start_pos)
	#Create Body
	bl9 = VISISolidFactory.CreateBlock (stop_length, stop_width, stop_height, start_pos, x_axis, inv_dir)
	Uni_list3.append(bl9)
	
	##Blend
	edges = [28,34]
	VISISolidFactory.BlendEdges(bl9, edges,5./1000, 1)
	
	
	#Unite
	VISISolidFactory.Unite(Uni_list3, Result_List,0)

	#Rotate
	start_pos.Set(position.x(), position.y(), position.z())
	VISISolidFactory.RotateBody(Result_List[0],start_pos,x_axis,math.radians(180))
	VISISolidFactory.RotateBody(Result_List[0],start_pos,y_axis,math.radians(90))
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	block_length = params['BLOCK_LENGTH']
	block_width = params['BLOCK_WIDTH']
	block_height = params['BLOCK_HEIGHT']
	block_screw_diam = params['BLOCK_SCREW_DIAM']
	block_screw_length = params['BLOCK_SCREW_LENGTH']
	block_screw_distance = params['BLOCK_SCREW_DISTANCE']
	block_delta = params['BLOCK_DELTA']
	arm_width = params['ARM_WIDTH']
	arm_length = params['ARM_LENGTH']
	arm_height = params['ARM_HEIGHT']
	head_length = params['HEAD_LENGTH']
	head_width = params['HEAD_WIDTH']
	head_height = params['HEAD_HEIGHT']
	head_delta = params['HEAD_DELTA']
	head_dp_diam = params['HEAD_DP_DIAM']
	head_dp_length = params['HEAD_DP_LENGTH']
	head_height_f_dp = params['HEAD_HEIGHT_F_DP']
	head_screw_diam = params['HEAD_SCREW_DIAM']
	head_screw_length = params['HEAD_SCREW_LENGTH']
	stop_length = params['STOP_LENGTH']
	stop_width = params['STOP_WIDTH']
	stop_height = params['STOP_HEIGHT']
	stop_screw_diam = params['STOP_SCREW_DIAM']
	stop_screw_length = params['STOP_SCREW_LENGTH']
	stop_screw_distance = params['STOP_SCREW_DISTANCE']
	stop_screw_distance_width = params['STOP_SCREW_DISTANCE_WIDTH']
	spring_length = params['SPRING_LENGTH']
	spring_height = params['SPRING_HEIGHT']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_ll21_0'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
