import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	pos_height = params['POS_HEIGHT']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	y_distance = params['Y_DISTANCE']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	width_groove = params['WIDTH_GROOVE']
	length_groove = params['LENGTH_GROOVE']
	height_groove = params['HEIGHT_GROOVE']
	insert_depth = params['INSERT_DEPTH']
	screw_distance = params['SCREW_DISTANCE']
	screw_diameter = params['SCREW_DIAMETER']
	screw_length = params['SCREW_LENGTH']
	special_length = params['SPECIAL_LENGTH']
	special_height = params['SPECIAL_HEIGHT']
	max_cut = params['MAX_CUT']
	cut = params['CUT']
	
	length_groove = length-45./1000
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = ref_direction
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	length = length-cut
	#Create Block
	##Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, y_distance, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length/2, start_pos)
	bl1 = VISISolidFactory.CreateBlock (length, width, height, start_pos, x_axis, direction)
	Uni_list.append(bl1)
	##Chamfer 1s
	edges = [18,20,22,24]
	VISISolidFactory.ChamferEdges(bl1, edges,2./1000,2./1000, 1)
	
	##Chamfer2
	edges = [68,94]
	VISISolidFactory.ChamferEdges(bl1, edges,width/10,width/10, 1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2-special_length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height-special_height, start_pos)
	bl2 = VISISolidFactory.CreateBlock (special_length, width, special_height, start_pos, x_axis, direction)
	Uni_list.append(bl2)
	##Chamfer 1s
	edges = [18,20]
	VISISolidFactory.ChamferEdges(bl2, edges,width/25,width/25, 1)

	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length/2+special_length/2, start_pos)
	
	##Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
		
	##Create Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height-special_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,-(length-length_groove)/2-cut , start_pos)
	bl2 = VISISolidFactory.CreateBlock (length_groove, width_groove, height_groove, start_pos, x_axis, inv_dir)
	Uni_list2.append(bl2)
	
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	#Rotate
	start_pos.Set(position.x(), position.y(), position.z())
	VISISolidFactory.RotateBody(Result_List[0],start_pos,x_axis,math.radians(180))
	VISISolidFactory.RotateBody(Result_List[0],start_pos,y_axis,math.radians(90))
	
	return Result_List[0]


def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	y_distance = params['Y_DISTANCE']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	width_groove = params['WIDTH_GROOVE']
	length_groove = params['LENGTH_GROOVE']
	insert_depth = params['INSERT_DEPTH']
	screw_distance = params['SCREW_DISTANCE']
	screw_diameter = params['SCREW_DIAMETER']
	screw_length = params['SCREW_LENGTH']
	max_cut = params['MAX_CUT']
	cut = params['CUT']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_ll21_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
