import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib,math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	height_base = params['HEIGHT_BASE']
	width_top = params['WIDTH_TOP']
	width_top_between = params['WIDTH_TOP_BETWEEN']
	chamfer1 = params['CHAMFER1']
	chamfer2 = params['CHAMFER2']
	height_top = params['HEIGHT_TOP']
	distance_low = params['DISTANCE_LOW']
	distance_mid_low = params['DISTANCE_MID_LOW']
	width_low = params['WIDTH_LOW']
	height_low = params['HEIGHT_LOW']
	distance_drill_between = params['DISTANCE_DRILL_BETWEEN']
	diameter_drill = params['DIAMETER_DRILL']
	cut = params['CUT']
	is41 = params['IS41']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Set length
	if is41:
		length = cut
	
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2, start_pos)
	
	bl1 = VISISolidFactory.CreateBlock (length, width, height_base, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	
	edges = [18,24,20,22]
	VISISolidFactory.ChamferEdges(bl1, edges, chamfer1,chamfer1, 1)
	
	#Create Top Element #1
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width_top_between/2+(width_top-width_top_between)/4, start_pos)
	
	bl2 = VISISolidFactory.CreateBlock (length, (width_top-width_top_between)/2, height-height_base, start_pos, x_axis, direction)
	Uni_list.append(bl2)
	edges = [25,31]
	VISISolidFactory.ChamferEdges(bl2, edges, chamfer2,chamfer2, 1)
	
	#Create Top Element #2
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(width_top_between/2+(width_top-width_top_between)/4)*2, start_pos)
	
	bl3 = VISISolidFactory.CreateBlock (length, (width_top-width_top_between)/2, height-height_base, start_pos, x_axis, direction)
	Uni_list.append(bl3)
	edges = [25,31]
	VISISolidFactory.ChamferEdges(bl3, edges, chamfer2,chamfer2, 1)
	
	##Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create groove in middle
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height-height_base, start_pos)
	
	bl4 = VISISolidFactory.CreateBlock (length, width_top_between, height_top, start_pos, x_axis, inv_dir)
	Uni_list2.append(bl4)
		
	if not distance_low:
		##Subtract
		VISISolidFactory.Subtract(Uni_list2, Result_List)
	else:
		##Subtract
		VISISolidFactory.Subtract(Uni_list2, Uni_list3)
		
		#Create Add Element in Low Position
		#1
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -height, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_mid_low/2-(width-distance_mid_low)/4, start_pos)
		bl5 = VISISolidFactory.CreateBlock (width_low,(width-distance_mid_low)/2,height_low, start_pos, x_axis, inv_dir)
		Uni_list3.append(bl5)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (width-distance_mid_low)/4, start_pos)
		cyl5 = VISISolidFactory.CreateCylinder (width_low/2,height_low, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl5)
		
		#2
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height-height_base, start_pos)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -height, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_mid_low/2+(width-distance_mid_low)/4, start_pos)
		bl6 = VISISolidFactory.CreateBlock (width_low,(width-distance_mid_low)/2,height_low, start_pos, x_axis, inv_dir)
		Uni_list3.append(bl6)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(width-distance_mid_low)/4, start_pos)
		cyl6 = VISISolidFactory.CreateCylinder (width_low/2,height_low, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl6)

		##Unite
		VISISolidFactory.Unite(Uni_list3, Uni_list4)
		
		
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height-height_base, start_pos)
		
		#Create Drillings
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_drill_between/2, start_pos)
		cyl7 = VISISolidFactory.CreateCylinder (diameter_drill/2,height+height_low, start_pos, x_axis, inv_dir)
		Uni_list4.append(cyl7)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_drill_between, start_pos)
		cyl8 = VISISolidFactory.CreateCylinder (diameter_drill/2,height+height_low, start_pos, x_axis, inv_dir)
		Uni_list4.append(cyl8)
		
		##Subtract
		VISISolidFactory.Subtract(Uni_list4, Result_List)
		
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	height_base = params['HEIGHT_BASE']
	width_top = params['WIDTH_TOP']
	width_top_between = params['WIDTH_TOP_BETWEEN']
	chamfer1 = params['CHAMFER1']
	chamfer2 = params['CHAMFER2']
	height_top = params['HEIGHT_TOP']
	distance_low = params['DISTANCE_LOW']
	distance_mid_low = params['DISTANCE_MID_LOW']
	width_low = params['WIDTH_LOW']
	height_low = params['HEIGHT_LOW']
	distance_drill_between = params['DISTANCE_DRILL_BETWEEN']
	diameter_drill = params['DIAMETER_DRILL']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp1_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
