import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	angle = params['ANGLE']
	diameter_top = params['DIAMETER_TOP']
	diameter_thread = params['DIAMETER_THREAD']
	diameter_core = params['DIAMETER_CORE']
	thread_pitch = params['THREAD_PITCH']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	start_pos2 = VISIPoint.New()
	start_pos2.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	

	#Create Body
	bl1 = VISISolidFactory.CreateBlock (length, width, height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	
	#Create Cone
	h_cone =(diameter_top/2-diameter_core/2)/(math.cos(angle/23))
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -h_cone, start_pos)
	
	cone1 = VISISolidFactory.CreateCone (diameter_core/2, h_cone, angle/2, start_pos, x_axis, direction)
	Uni_list.append(cone1)
	
	#Create Thread
	cyl1 = VISISolidFactory.CreateCylinder (diameter_core/2, height-h_cone, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	cam_list = [diameter_core, height-h_cone, diameter_thread, height-h_cone, thread_pitch]
	VISI.AttachCamAttributes(cyl1,cam_list,"LLCP1_2_1",0,params["BUILDER_UNIT"])
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list, Result_List)
	
	VISISolidFactory.RotateBody (Result_List[0], start_pos2, direction, math.radians(90))
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	angle = params['ANGLE']
	diameter_top = params['DIAMETER_TOP']
	diameter_thread = params['DIAMETER_THREAD']
	diameter_core = params['DIAMETER_CORE']
	thread_pitch = params['THREAD_PITCH']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp1_2'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
