import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	radius = params['RADIUS']
	chamfer4 = params['CHAMFER4']
	chamfer5 = params['CHAMFER5']

	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	start_pos2 = VISIPoint.New()
	start_pos2.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create Body
	bl1 = VISISolidFactory.CreateBlock (length, width, height, start_pos, x_axis, direction)
	Uni_list.append(bl1)
	
	edges = [18,24,20,22]
	VISISolidFactory.BlendEdges(bl1, edges, radius, 1)
	
	edges = [122,136]
	VISISolidFactory.ChamferEdges(bl1, edges, chamfer5,chamfer5, 0)
	
	edges = [68,88]
	VISISolidFactory.ChamferEdges(bl1, edges, chamfer4,chamfer4, 0)
	
	VISISolidFactory.RotateBody (bl1, start_pos2, direction, math.radians(90))
	
	return bl1

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	radius = params['RADIUS']
	chamfer4 = params['CHAMFER4']
	chamfer5 = params['CHAMFER5']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp1_4'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
