import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	chamfer1 = params['CHAMFER1']
	chamfer2 = params['CHAMFER2']
	height1 = params['HEIGHT1']
	width_groove = params['WIDTH_GROOVE']
	radius2 = params['RADIUS2']
	width_low = params['WIDTH_LOW']
	height_low = params['HEIGHT_LOW']
	distance_low = params['DISTANCE_LOW']
	distance_mid_low = params['DISTANCE_MID_LOW']
	radius1 = params['RADIUS1']
	width_cut = params['WIDTH_CUT']
	diameter_drill = params['DIAMETER_DRILL']
	diameter_sink1 = params['DIAMETER_SINK1']
	diameter_sink2 = params['DIAMETER_SINK2']
	height_sink1 = params['HEIGHT_SINK1']
	height_sink2 = params['HEIGHT_SINK2']
	diameter_drill1 = params['DIAMETER_DRILL1']
	diameter_drill2 = params['DIAMETER_DRILL2']
	length1 = params['LENGTH1']
	length2 = params['LENGTH2']
	length_groove = params['LENGTH_GROOVE']
	length3 = params['LENGTH3']
	length4 = params['LENGTH4']
	length6 = params['LENGTH6']
	width1 = params['WIDTH1']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	
	start_pos2 = VISIPoint.New()
	start_pos2.Set(position.x(), position.y(), position.z())
	
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create Body
	bl1 = VISISolidFactory.CreateBlock (length, width, height1-height_low, start_pos, x_axis, direction)
	Uni_list.append(bl1)
	
	edges = [18,24,20,22]
	VISISolidFactory.ChamferEdges(bl1, edges, chamfer1,chamfer1, 1)
	
	#Create Lower Part
	if width_low:
		#Create Add Element in Low Position
		#1
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_mid_low/2-(length-distance_mid_low)/4, start_pos)
		bl5 = VISISolidFactory.CreateBlock ((length-distance_mid_low)/2,width_low,height_low, start_pos, x_axis, inv_dir)
		Uni_list.append(bl5)
		
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length-distance_mid_low)/4, start_pos)
		cyl5 = VISISolidFactory.CreateCylinder (width_low/2,height_low, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl5)
		
		#2
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_mid_low/2+(length-distance_mid_low)/4, start_pos)
		bl6 = VISISolidFactory.CreateBlock ((length-distance_mid_low)/2,width_low,height_low, start_pos, x_axis, inv_dir)
		Uni_list.append(bl6)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length-distance_mid_low)/4, start_pos)
		cyl6 = VISISolidFactory.CreateCylinder (width_low/2,height_low, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl6)
		
		##Unite
		VISISolidFactory.Unite(Uni_list, Uni_list2)
		Uni_list = []
		Uni_list.append(Uni_list2[0])
		Uni_list2 = []

	
	#Create Groove
	start_pos.Set(position.x(), position.y(), position.z())
	bl2 = VISISolidFactory.CreateBlock (length_groove, width_groove, height1-height_low, start_pos, x_axis, direction)
	Uni_list.append(bl2)
	
	edges = [18,24,20,22]
	VISISolidFactory.BlendEdges(bl2, edges, radius1, 1)
	
	#Create Drillings
	if diameter_sink1:
		#Sink 1
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length6/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1-height_low, start_pos)
		cyl01 = VISISolidFactory.CreateCylinder (diameter_sink1/2,height_sink1, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl01)
		cyl011 = VISISolidFactory.CreateCylinder (diameter_drill1/2,height, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl011)
		
		#Sink2
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length6, start_pos)
		cyl02 = VISISolidFactory.CreateCylinder (diameter_sink1/2,height_sink1, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl02)
		cyl021 = VISISolidFactory.CreateCylinder (diameter_drill1/2,height, start_pos, x_axis, inv_dir)
		Uni_list.append(cyl021)
	else:
		if length4:
			#Sink 1
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length4/2, start_pos)
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1-height_low, start_pos)
			cyl01 = VISISolidFactory.CreateCylinder (diameter_sink2/2,height_sink2, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl01)
			cyl011 = VISISolidFactory.CreateCylinder (diameter_drill2/2,height, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl011)
			
			#Sink2
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length4, start_pos)
			cyl02 = VISISolidFactory.CreateCylinder (diameter_sink2/2,height_sink2, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl02)
			cyl021 = VISISolidFactory.CreateCylinder (diameter_drill2/2,height, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl021)
			
			#Drill1
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length4/2, start_pos)
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length1/2, start_pos)
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width1/2, start_pos)
			cyl03 = VISISolidFactory.CreateCylinder (diameter_drill/2,height,start_pos, x_axis, inv_dir)
			Uni_list.append(cyl03)
			
			#Drill2
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length1, start_pos)
			cyl04 = VISISolidFactory.CreateCylinder (diameter_drill/2,height,start_pos, x_axis, inv_dir)
			Uni_list.append(cyl04)
			
			#Drill3
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width1, start_pos)
			cyl05 = VISISolidFactory.CreateCylinder (diameter_drill/2,height,start_pos, x_axis, inv_dir)
			Uni_list.append(cyl05)
			
			#Drill4
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length1, start_pos)
			cyl06 = VISISolidFactory.CreateCylinder (diameter_drill/2,height,start_pos, x_axis, inv_dir)
			Uni_list.append(cyl06)
		else:
			#Sink 1
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length1/2, start_pos)
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width1/2, start_pos)
			VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1-height_low, start_pos)
			cyl01 = VISISolidFactory.CreateCylinder (diameter_sink2/2,height_sink2, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl01)
			cyl011 = VISISolidFactory.CreateCylinder (diameter_drill2/2,height, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl011)
			
			#Sink2
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length1, start_pos)
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width1, start_pos)
			cyl02 = VISISolidFactory.CreateCylinder (diameter_sink2/2,height_sink2, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl02)
			cyl021 = VISISolidFactory.CreateCylinder (diameter_drill2/2,height, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl021)
			
			#Drill 1
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width1, start_pos)
			cyl031 = VISISolidFactory.CreateCylinder (diameter_drill/2,height, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl031)
			
			#Drill 2
			VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length1, start_pos)
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width1, start_pos)
			cyl041 = VISISolidFactory.CreateCylinder (diameter_drill/2,height, start_pos, x_axis, inv_dir)
			Uni_list.append(cyl041)
				
	##Subtract
	VISISolidFactory.Subtract(Uni_list, Uni_list2)
	
	#Create Heels
	#1
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1-height_low, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width/2-(width-width_cut)/4, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length3/2+(length2-length3)/4, start_pos)
	bl10 = VISISolidFactory.CreateBlock ((length2-length3)/2, (width-width_cut)/2, height-height1, start_pos, x_axis, direction)
	Uni_list2.append(bl10)
	
	#2
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1-height_low, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(width/2-(width-width_cut)/4), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length3/2+(length2-length3)/4, start_pos)
	bl11 = VISISolidFactory.CreateBlock ((length2-length3)/2, (width-width_cut)/2, height-height1, start_pos, x_axis, direction)
	Uni_list2.append(bl11)
	
	#3
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1-height_low, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(width/2-(width-width_cut)/4), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length3/2+(length2-length3)/4), start_pos)
	bl13 = VISISolidFactory.CreateBlock ((length2-length3)/2, (width-width_cut)/2, height-height1, start_pos, x_axis, direction)
	Uni_list2.append(bl13)
	
	#4
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1-height_low, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (width/2-(width-width_cut)/4), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length3/2+(length2-length3)/4), start_pos)
	bl14 = VISISolidFactory.CreateBlock ((length2-length3)/2, (width-width_cut)/2, height-height1, start_pos, x_axis, direction)
	Uni_list2.append(bl14)	

	##Unite
	VISISolidFactory.Unite(Uni_list2, Result_List)
	
	VISISolidFactory.RotateBody (Result_List[0], start_pos2, direction, math.radians(90))
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	chamfer1 = params['CHAMFER1']
	chamfer2 = params['CHAMFER2']
	height1 = params['HEIGHT1']
	width_groove = params['WIDTH_GROOVE']
	radius2 = params['RADIUS2']
	width_low = params['WIDTH_LOW']
	height_low = params['HEIGHT_LOW']
	distance_low = params['DISTANCE_LOW']
	distance_mid_low = params['DISTANCE_MID_LOW']
	radius1 = params['RADIUS1']
	width_cut = params['WIDTH_CUT']
	diameter_drill = params['DIAMETER_DRILL']
	diameter_sink1 = params['DIAMETER_SINK1']
	diameter_sink2 = params['DIAMETER_SINK2']
	height_sink1 = params['HEIGHT_SINK1']
	height_sink2 = params['HEIGHT_SINK2']
	diameter_drill1 = params['DIAMETER_DRILL1']
	diameter_drill2 = params['DIAMETER_DRILL2']
	length1 = params['LENGTH1']
	length2 = params['LENGTH2']
	length_groove = params['LENGTH_GROOVE']
	length3 = params['LENGTH3']
	length4 = params['LENGTH4']
	length6 = params['LENGTH6']
	width1 = params['WIDTH1']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp1_6'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
