import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	width_groove = params['WIDTH_GROOVE']
	height_cover = params['HEIGHT_COVER']
	start_height = params['START_HEIGHT']
	length_feet = params['LENGTH_FEET']
	length_feet2 = params['LENGTH_FEET2']
	cut = params['CUT']
	chamfer = params['CHAMFER']
	length3 = params['LENGTH3']
	width3 = params['WIDTH3']
	length8 = params['LENGTH8']
	diameter_sink1 = params['DIAMETER_SINK1']
	height_sink1 = params['HEIGHT_SINK1']
	diameter1 = params['DIAMETER1']
	diameter2 = params['DIAMETER2']
	diameter3 = params['DIAMETER3']
	length9 = params['LENGTH9']
	delta_height = params['DELTA_HEIGHT']
	delta_length = params['DELTA_LENGTH']
	length10 = params['LENGTH10']
	height2 = params['HEIGHT2']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	start_pos2 = VISIPoint.New()
	start_pos2.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#length3
	if not length3:
		length3 = 71./1000
	
	#define length
	length = 28./1000+28./1000+20./1000+length3
	length = length-cut
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_height+delta_height, start_pos)
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2-delta_length, start_pos)
	
	bl1 = VISISolidFactory.CreateBlock (length, width, height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	
	edges = [18,24,20,22]
	VISISolidFactory.ChamferEdges(bl1, edges, chamfer,chamfer, 1)

	#Create Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, start_height-height_cover, start_pos)
	bl2 = VISISolidFactory.CreateBlock (length, width_groove, height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_height-height_cover, start_pos)
			
	#Create Start
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length_feet2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length-length_feet-length_feet2)/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height, start_pos)
	bl3 = VISISolidFactory.CreateBlock (length-length_feet-length_feet2, width, height-start_height, start_pos, x_axis, direction)
	Uni_list.append(bl3)
	
	#Create Sinking
	start_pos.Set(position.x(), position.y(), position.z())
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_height+delta_height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width3/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length8, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -delta_length, start_pos)
	#VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height, start_pos)
	
	##1
	cyl1 = VISISolidFactory.CreateCylinder (diameter_sink1/2, height_sink1, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	cyl2 = VISISolidFactory.CreateCylinder (diameter1/2, height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl2)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width3, start_pos)
	
	##2
	cyl10 = VISISolidFactory.CreateCylinder (diameter_sink1/2, height_sink1, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl10)
	cyl20 = VISISolidFactory.CreateCylinder (diameter1/2, height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl20)
	
	#Create Drilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length8+length9, start_pos)
	##1
	cyl3 = VISISolidFactory.CreateCylinder (diameter3/2, height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl3)
	cyl31 = VISISolidFactory.CreateCylinder (diameter2/2, height2, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl31)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width3, start_pos)
	
	##2
	cyl4 = VISISolidFactory.CreateCylinder (diameter3/2, height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl4)
	cyl41 = VISISolidFactory.CreateCylinder (diameter2/2, height2, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl41)
	
	#Create Drilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length9+length10, start_pos)
	##3
	cyl5 = VISISolidFactory.CreateCylinder (diameter3/2, height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl5)
	cyl51 = VISISolidFactory.CreateCylinder (diameter2/2, height2, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl51)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width3, start_pos)
	
	##4
	cyl6 = VISISolidFactory.CreateCylinder (diameter3/2, height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl6)
	cyl61 = VISISolidFactory.CreateCylinder (diameter2/2, height2, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl61)
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list, Result_List)
	
	VISISolidFactory.RotateBody (Result_List[0], start_pos2, direction, math.radians(180))
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	width_groove = params['WIDTH_GROOVE']
	height_cover = params['HEIGHT_COVER']
	start_height = params['START_HEIGHT']
	length_feet = params['LENGTH_FEET']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp2'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
