import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	width_groove = params['WIDTH_GROOVE']
	height_cover = params['HEIGHT_COVER']
	start_height = params['START_HEIGHT']
	length_feet = params['LENGTH_FEET']
	cut = params['CUT']
	chamfer = params['CHAMFER']
	cutout_distance = params['CUTOUT_DISTANCE']
	cutout_length = params['CUTOUT_LENGTH']
	cutout_height = params['CUTOUT_HEIGHT']
	
	delta_height = params['DELTA_HEIGHT']
	delta_length = params['DELTA_LENGTH']
	
	width00 = params['WIDTH00']
	distance00 = params['DISTANCE00']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	start_pos2 = VISIPoint.New()
	start_pos2.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	
	#define length
	length = length-cut
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_height+delta_height, start_pos)
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2-delta_length, start_pos)
	
	bl1 = VISISolidFactory.CreateBlock (length, width, height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	
	edges = [18,24,20,22]
	VISISolidFactory.ChamferEdges(bl1, edges, chamfer,chamfer, 1)

	#Create Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, start_height-height_cover, start_pos)
	bl2 = VISISolidFactory.CreateBlock (length, width_groove, height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_height-height_cover, start_pos)
	
	#Create Cutout
	if cutout_length:
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length/2-cutout_distance-cutout_length/2), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, start_height-cutout_height, start_pos)
		bl21 = VISISolidFactory.CreateBlock (cutout_length, width, height, start_pos, x_axis, inv_dir)
		Uni_list.append(bl21)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_height-cutout_height, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2-cutout_distance-cutout_length/2, start_pos)
		#return bl21
		
	
	#Create Start
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (length-distance00)/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height, start_pos)
	bl3 = VISISolidFactory.CreateBlock (length-distance00, width, height-start_height, start_pos, x_axis, direction)
	Uni_list.append(bl3)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length-distance00)/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, (distance00-length_feet-width00)/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length-distance00+width00, start_pos)
	bl4 = VISISolidFactory.CreateBlock (distance00-length_feet-width00, width, height-start_height, start_pos, x_axis, direction)
	Uni_list.append(bl4)
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list, Result_List)
	
	VISISolidFactory.RotateBody (Result_List[0], start_pos2, direction, math.radians(180))
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	width_groove = params['WIDTH_GROOVE']
	height_cover = params['HEIGHT_COVER']
	start_height = params['START_HEIGHT']
	length_feet = params['LENGTH_FEET']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp3'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
