import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	distance2 = params['DISTANCE2']
	distance4 = params['DISTANCE4']
	radius1 = params['RADIUS1']
	radius2 = params['RADIUS2']
	distance_drill = params['DISTANCE_DRILL']
	diameter_drill = params['DIAMETER_DRILL']
	head_height = params['HEAD_HEIGHT']
	length_drill = params['LENGTH_DRILL']
	height2 = params['HEIGHT2']
	height3 = params['HEIGHT3']
	height1 = params['HEIGHT1']
	angle = params['ANGLE']
	lenght1 = params['LENGHT1']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	start_pos2 = VISIPoint.New()
	start_pos2.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create Body
	bl1 = VISISolidFactory.CreateBlock (length, width, height1, start_pos, x_axis, direction)
	Uni_list.append(bl1)
	
	edges = [18,24,20,22]
	VISISolidFactory.BlendEdges(bl1, edges, radius2, 1)
	
	#Create Top
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height1, start_pos)
	bl2 = VISISolidFactory.CreateBlock (lenght1, width, height-height1, start_pos, x_axis, direction)
	Uni_list.append(bl2)
	
	##Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Grooves on Top
	#1
	
	depth_radius = 2./1000
	if radius1:
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance4/2+radius1, start_pos)
		cyl31 = VISISolidFactory.CreateCylinder (radius1, depth_radius, start_pos, x_axis, inv_dir)

		Uni_list2.append(cyl31)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -2*(distance4/2+radius1), start_pos)
		cyl32 = VISISolidFactory.CreateCylinder (radius1, depth_radius, start_pos, x_axis, inv_dir)
		Uni_list2.append(cyl32)
	
	#Create Drillings
	start_pos.Set(position.x(), position.y(), position.z())
	#1 Drilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_drill/2, start_pos)
	cyl41 = VISISolidFactory.CreateCylinder (diameter_drill/2, length_drill, start_pos, x_axis, direction)
	Uni_list2.append(cyl41)
	#1 Cone
	h_cone = (diameter_drill/2)/(math.tan(math.radians(60)))
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_drill+h_cone, start_pos)
	cone41 = VISISolidFactory.CreateCone (0, h_cone,math.radians(60), start_pos, x_axis, inv_dir)
	Uni_list2.append(cone41)
	#1 Base Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_drill+h_cone-head_height, start_pos)
	bcone41 = VISISolidFactory.CreateCone (diameter_drill/2, head_height,angle/2, start_pos, x_axis, inv_dir)
	Uni_list2.append(bcone41)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, head_height, start_pos)
	
	#2 Drilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_drill, start_pos)
	cyl42 = VISISolidFactory.CreateCylinder (diameter_drill/2, length_drill, start_pos, x_axis, direction)
	Uni_list2.append(cyl42)
	#2 Cone
	h_cone = (diameter_drill/2)/(math.tan(math.radians(60)))
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_drill+h_cone, start_pos)
	cone42 = VISISolidFactory.CreateCone (0, h_cone,math.radians(60), start_pos, x_axis, inv_dir)
	Uni_list2.append(cone42)
	#2 Base Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_drill+h_cone-head_height, start_pos)
	bcone42 = VISISolidFactory.CreateCone (diameter_drill/2, head_height,angle/2, start_pos, x_axis, inv_dir)
	Uni_list2.append(bcone42)
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	
	
	#Cut Top
	start_pos.Set(position.x(), position.y(), position.z())
	
	#Cut 1
	#Set Pos
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width/2, start_pos)
	
	#Create Axis
	cut_axis1 = VISIVector.New()
	cut_axis1.Set(direction.Cx(), direction.Cy(), direction.Cz())
	VISIGeoLib.VectorRotate (cut_axis1, x_axis, cut_axis1, -angle/2)
	
	#Set Lists
	front_bodies_list  =[]
	back_bodies_list = []
	
	VISISolidFactory.CutWithPlane (start_pos, cut_axis1, Result_List[0], front_bodies_list, back_bodies_list)
	VISISolidFactory.DeleteBodies(front_bodies_list)
	Result_List[0] = back_bodies_list[0]

	
	#Cut 2
	#Set Po
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width, start_pos)
	
	#Create Axis
	cut_axis2 = VISIVector.New()
	cut_axis2.Set(direction.Cx(), direction.Cy(), direction.Cz())
	VISIGeoLib.VectorRotate (cut_axis2, x_axis, cut_axis2, angle/2)
	
	#Set Lists
	front_bodies_list  =[]
	back_bodies_list = []
	
	VISISolidFactory.CutWithPlane (start_pos, cut_axis2, Result_List[0], front_bodies_list, back_bodies_list)
	VISISolidFactory.DeleteBodies(front_bodies_list)
	Result_List[0] = back_bodies_list[0]
	
	VISISolidFactory.RotateBody (Result_List[0], start_pos2, direction, math.radians(90))
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	sub_typ = params['SUB_TYP']
	sub_sub_typ = params['SUB_SUB_TYP']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	distance2 = params['DISTANCE2']
	distance4 = params['DISTANCE4']
	radius1 = params['RADIUS1']
	radius2 = params['RADIUS2']
	distance_drill = params['DISTANCE_DRILL']
	diameter_drill = params['DIAMETER_DRILL']
	head_height = params['HEAD_HEIGHT']
	length_drill = params['LENGTH_DRILL']
	height2 = params['HEIGHT2']
	height3 = params['HEIGHT3']
	height1 = params['HEIGHT1']
	angle = params['ANGLE']
	lenght1 = params['LENGHT1']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_llcp3_5'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
