import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	small_diameter = params['SMALL_DIAMETER']
	diameter_inside = params['DIAMETER_INSIDE']
	diam_screw_head = params['DIAM_SCREW_HEAD']
	diameter_switch = params['DIAMETER_SWITCH']
	length = params['LENGTH']
	distance_screw_holes = params['DISTANCE_SCREW_HOLES']
	length_body = params['LENGTH_BODY']
	width = params['WIDTH']
	distance_width = params['DISTANCE_WIDTH']
	width_switch = params['WIDTH_SWITCH']
	height = params['HEIGHT']
	height_top = params['HEIGHT_TOP']
	height_switch = params['HEIGHT_SWITCH']
	main_gap = params['MAIN_GAP']
	height_cone = params['HEIGHT_CONE']
	angle = params['ANGLE']
	radius = params['RADIUS']
	screw_diameter = params['SCREW_DIAMETER']
	screw_length = params['SCREW_LENGTH']
	clear_height = params['CLEAR_HEIGHT']
	clear_length2 = params['CLEAR_LENGTH2']
	clear_length = params['CLEAR_LENGTH']
	cav_radius = params['CAV_RADIUS']
	rot_angle = params['ROT_ANGLE']
	
	diam_screw_hole = screw_diameter*1.02
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)

	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width/2, start_pos)
	bl1 = VISISolidFactory.CreateBlock (length_body, width, height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	bl2 = VISISolidFactory.CreateBlock (length, width, height_top, start_pos, x_axis, inv_dir)
	Uni_list.append(bl2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width/2, start_pos)
	
	##Blend
	edges = [18,24]
	VISISolidFactory.BlendEdges(bl1, edges, radius, 1)
	VISISolidFactory.BlendEdges(bl2, edges, radius, 1)
	
	##Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	
	#Create Connector
	##Create Hole
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_screw_holes/4, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width/2, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder((width*0.8)/2, height_top, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl1)
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list2, Uni_list4)
	
	
	#Create Switch
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_screw_holes/4, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width/2-width_switch, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -height_switch, start_pos)
	
	cyl8 = VISISolidFactory.CreateCylinder(diameter_switch/2, width_switch, start_pos,inv_dir, y_axis)
	Uni_list4.append(cyl8)
	
	
	##Unite
	VISISolidFactory.Unite(Uni_list4, Result_List)
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	small_diameter = params['SMALL_DIAMETER']
	diameter_inside = params['DIAMETER_INSIDE']
	diam_screw_head = params['DIAM_SCREW_HEAD']
	diameter_switch = params['DIAMETER_SWITCH']
	length = params['LENGTH']
	distance_screw_holes = params['DISTANCE_SCREW_HOLES']
	length_body = params['LENGTH_BODY']
	width = params['WIDTH']
	distance_width = params['DISTANCE_WIDTH']
	width_switch = params['WIDTH_SWITCH']
	height = params['HEIGHT']
	height_top = params['HEIGHT_TOP']
	height_switch = params['HEIGHT_SWITCH']
	main_gap = params['MAIN_GAP']
	height_cone = params['HEIGHT_CONE']
	angle = params['ANGLE']
	radius = params['RADIUS']
	screw_diameter = params['SCREW_DIAMETER']
	screw_length = params['SCREW_LENGTH']
	clear_height = params['CLEAR_HEIGHT']
	clear_length2 = params['CLEAR_LENGTH2']
	clear_length = params['CLEAR_LENGTH']
	cav_radius = params['CAV_RADIUS']
	rot_angle = params['ROT_ANGLE']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width/2, start_pos)
	bl1 = VISISolidFactory.CreateBlock (length_body+clear_length2, width, height+clear_height, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	bl2 = VISISolidFactory.CreateBlock (length+clear_length, width, height_top, start_pos, x_axis, inv_dir)
	Uni_list.append(bl2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width/2, start_pos)
	
	##Blend
	edges = [18,24]
	VISISolidFactory.BlendEdges(bl1, edges, cav_radius, 1)
	VISISolidFactory.BlendEdges(bl2, edges, cav_radius, 1)
	
	##Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)

	## return the tag of created cavity, 0 if no cavity
	return Uni_list2[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_ls1_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
