import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib,math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	radius = params['RADIUS']
	drill_dist = params['DRILL_DIST']
	sensor_dist = params['SENSOR_DIST']
	drill_diam = params['DRILL_DIAM']
	sink_diam = params['SINK_DIAM']
	sink_depth = params['SINK_DEPTH']
	connect_dist_l = params['CONNECT_DIST_L']
	connect_dist_b = params['CONNECT_DIST_B']
	thread = params['THREAD']
	thread_pitch = params['THREAD_PITCH']
	clear_length = params['CLEAR_LENGTH']
	clear_width = params['CLEAR_WIDTH']
	clear_height = params['CLEAR_HEIGHT']
	cav_radius = params['CAV_RADIUS']
	diameter_sensor = params['DIAMETER_SENSOR']
	screw_diameter = params['SCREW_DIAMETER']
	screw_length = params['SCREW_LENGTH']
	height_sensor = params['HEIGHT_SENSOR']
	ins_depth = params['INS_DEPTH']

	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = ref_direction
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_y = VISIVector.New()
	inv_y.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())

	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, ins_depth, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, height/2, start_pos)
	bl1 = VISISolidFactory.CreateBlock (length, height, width, start_pos, x_axis, inv_dir)
	Uni_list.append(bl1)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, height/2, start_pos)
	
	##Blend
	edges = [25,31]
	VISISolidFactory.BlendEdges(bl1, edges, radius, 1)
	
	#Create Sensor
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -height-height_sensor, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, sensor_dist, start_pos)
	
	cyl2 = VISISolidFactory.CreateCylinder (diameter_sensor/2, height_sensor, start_pos, direction, y_axis)
	Uni_list.append(cyl2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, height+height_sensor, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, -sensor_dist, start_pos)
	
	##Unite
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Connector
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -connect_dist_l, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, length/2-connect_dist_b, start_pos)
	
	cyl1 = VISISolidFactory.CreateCylinder (height/3, height/3, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, connect_dist_l, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(length/2-connect_dist_b), start_pos)
	
	#Create Counterboring
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, drill_dist, start_pos)
	
	#Sinking
	cyl3 = VISISolidFactory.CreateCylinder (sink_diam/2, sink_depth, start_pos, direction, y_axis)
	Uni_list2.append(cyl3)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, sink_diam/2, start_pos)
	bl3 = VISISolidFactory.CreateBlock (sink_diam,sink_diam, sink_depth, start_pos, direction, y_axis)
	Uni_list2.append(bl3)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -sink_diam/2, start_pos)
	
	#Drilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, sink_depth, start_pos)
	cyl4 = VISISolidFactory.CreateCylinder (drill_diam/2, height-sink_depth, start_pos, direction, y_axis)
	Uni_list2.append(cyl4)
	
	cam_list = [drill_diam, height-sink_depth, thread, height-sink_depth, thread_pitch]
        
	#Add Thread Information
	VISI.AttachCamAttributes(cyl4, cam_list, "LS3_1", 0, params["BUILDER_UNIT"])
	
	##Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	#Rotate
	start_pos.Set(position.x(), position.y(), position.z())
	VISISolidFactory.RotateBody(Result_List[0],start_pos,direction,-math.radians(90))
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	radius = params['RADIUS']
	drill_dist = params['DRILL_DIST']
	sensor_dist = params['SENSOR_DIST']
	drill_diam = params['DRILL_DIAM']
	sink_diam = params['SINK_DIAM']
	sink_depth = params['SINK_DEPTH']
	connect_dist_l = params['CONNECT_DIST_L']
	connect_dist_b = params['CONNECT_DIST_B']
	thread = params['THREAD']
	thread_pitch = params['THREAD_PITCH']
	clear_length = params['CLEAR_LENGTH']
	clear_width = params['CLEAR_WIDTH']
	clear_height = params['CLEAR_HEIGHT']
	cav_radius = params['CAV_RADIUS']
	diameter_sensor = params['DIAMETER_SENSOR']
	height_sensor = params['HEIGHT_SENSOR']
	screw_diameter = params['SCREW_DIAMETER']
	screw_length = params['SCREW_LENGTH']
	ins_depth = params['INS_DEPTH']

	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Uni_list4 = []
	Uni_list4_1 = []
	Uni_list5 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = ref_direction
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_y = VISIVector.New()
	inv_y.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())

	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, height/2+clear_height/2, start_pos)
	bl1 = VISISolidFactory.CreateBlock (length+clear_length, height+clear_height, width+clear_width+ins_depth, start_pos, x_axis, inv_dir)
	
	##Blend
	edges = [25,31]
	VISISolidFactory.BlendEdges(bl1, edges, cav_radius, 1)
	
	#Rotate
	start_pos.Set(position.x(), position.y(), position.z())
	VISISolidFactory.RotateBody(bl1,start_pos,direction,-math.radians(90))
	
	return bl1

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_ls3'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
