import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def LoadGlobals():
	global screw_positions
        
	screw_positions = []

	nscrew = params['NSCREW']
	position = params['POSITION']
	direction = params['DIRECTION']
	screw_circle = params['SCREW_CIRCLE']
	rot_angle = params['ROT_ANGLE']

	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)

	if(nscrew == 1):
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    screw_positions.append(tmp_screw_pos)
	if(nscrew == 2):
            tmp_screw_pos = VISIPoint.New()
            tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
            VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, screw_circle/2, tmp_screw_pos)
            screw_positions.append(tmp_screw_pos)
            tmp_screw_pos = VISIPoint.New()
            tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
            VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, -screw_circle/2, tmp_screw_pos)
            screw_positions.append(tmp_screw_pos)
	if(nscrew == 4):
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, screw_circle/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, -screw_circle/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, y_axis, screw_circle/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, y_axis, -screw_circle/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)


def CreateElement ():

	position = params['POSITION']
	direction = params['DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	base_diameter = params['BASE_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	hole_height = params['HOLE_HEIGHT']
	bar = params['BAR']
	initial_strenght = params['INITIAL_STRENGHT']
	top_compression_strength = params['TOP_COMPRESSION_STRENGTH']
	nscrew = params['NSCREW']
	screw_diam = params['SCREW_DIAM']
	screw_circle = params['SCREW_CIRCLE']
	max_stroke = params['MAX_STROKE']
	user_stroke = params['USER_STROKE']
	lenght_tot = params['LENGHT_TOT']
	min_lenght = params['MIN_LENGHT']
	clearance_diam = params['CLEARANCE_DIAM']
	stroke = params['STROKE']
	housing_start = params['HOUSING_START']
	housing_end = params['HOUSING_END']
	gap_between_plates = params['GAP_BETWEEN_PLATES']


	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	Inv_Dir = VISIVector.New()
        Inv_Dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	gap_between_plates = total_thick - (start_thick + end_thick)
	## Creating Base
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - housing_start, start_pos)
	cyl = VISISolidFactory.CreateCylinder(base_diameter/2, min_lenght, start_pos, x_axis, direction)
	Uni_list.append(cyl)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, min_lenght, start_pos)
	
	## Creating Head
	cyl = VISISolidFactory.CreateCylinder(head_diameter/2, lenght_tot - min_lenght - user_stroke
					      , start_pos, x_axis, direction)
	Uni_list.append(cyl)

	## Unite The Sprue Bushing Parts 
	VISISolidFactory.Unite(Uni_list, Result_List)

	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	base_diameter = params['BASE_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	hole_height = params['HOLE_HEIGHT']
	bar = params['BAR']
	initial_strenght = params['INITIAL_STRENGHT']
	top_compression_strength = params['TOP_COMPRESSION_STRENGTH']
	nscrew = params['NSCREW']
	screw_diam = params['SCREW_DIAM']
	screw_circle = params['SCREW_CIRCLE']
	max_stroke = params['MAX_STROKE']
	user_stroke = params['USER_STROKE']
	lenght_tot = params['LENGHT_TOT']
	min_lenght = params['MIN_LENGHT']
	clearance_diam = params['CLEARANCE_DIAM']
	stroke = params['STROKE']
	housing_start = params['HOUSING_START']
	housing_end = params['HOUSING_END']
	gap_between_plates = params['GAP_BETWEEN_PLATES']
	start_clear = params['START_CLEAR']
	end_clear = params['END_CLEAR']

	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)

	gap_between_plates = total_thick - (start_thick + end_thick)
	## Creating Cavity
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - housing_start, start_pos)

	cyl = VISISolidFactory.CreateCylinder((base_diameter + start_clear)/2, housing_start + gap_between_plates
					      , start_pos, x_axis, direction)
	cam_list = [(base_diameter + start_clear), housing_start]
        VISI.AttachCamAttributes(cyl,cam_list,"PCYLAZ1_4_1",elem_tag,params["BUILDER_UNIT"])
        VISIGeoLib.ProjectPointOntoVector(start_pos, direction, housing_start + gap_between_plates, start_pos)

        cyl2 = VISISolidFactory.CreateCylinder((base_diameter + end_clear)/2, housing_end
					      , start_pos, x_axis, direction)
	cam_list = [(base_diameter + end_clear), housing_end]
        VISI.AttachCamAttributes(cyl2,cam_list,"PCYLAZ1_4_2",elem_tag,params["BUILDER_UNIT"])
    
        Uni_list.append(cyl)
        Uni_list.append(cyl2)
        VISISolidFactory.Unite(Uni_list, Result_List,0)

        return Result_List[0]
                    
##	cyl = VISISolidFactory.CreateCylinder((base_diameter + clearance_diam)/2, gap_between_plates + housing_start + housing_end
##					      , start_pos, x_axis, direction)
##	cam_list = [base_diameter + clearance_diam, gap_between_plates + housing_start + housing_end]
##        VISI.AttachCamAttributes(cyl,cam_list,"PCYLAZ_1",elem_tag,params["BUILDER_UNIT"])
	
	#return cyl

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_pcylaz1_4'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, Xaxis)

	LoadGlobals()

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
