import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def LoadGlobals():
	global screw_positions
	global screw_positions_small
    
	screw_positions = []	
	screw_positions_small = []

	nscrew1 = params['NSCREW1']
	nscrew2 = params['NSCREW2']
	
	
	position = params['POSITION']
	direction = params['DIRECTION']
	screw_circle1 = params['SCREW_CIRCLE1']
	screw_circle2 = params['SCREW_CIRCLE2']
	rotation = params['ROTATION']

	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	
	rot_angle = rotation
	
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
	VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	
	#Create second set of direction
	x_axis2 = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis2)
	y_axis2 = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis2, y_axis2)
	
	rot_angle = math.radians(135)+rotation
	
	VISIGeoLib.VectorRotate(x_axis2, direction, x_axis2, rot_angle)
	VISIGeoLib.VectorRotate(y_axis2, direction, y_axis2, rot_angle)
		

	
	if (nscrew1 == 1):
		tmp_screw_pos = VISIPoint.New()
		tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
		screw_positions.append(tmp_screw_pos)
	elif (nscrew1 == 2):
		tmp_screw_pos = VISIPoint.New()
		tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
		VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, screw_circle1/2, tmp_screw_pos)
		screw_positions.append(tmp_screw_pos)
		tmp_screw_pos = VISIPoint.New()
		tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
		VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, -screw_circle1/2, tmp_screw_pos)
		screw_positions.append(tmp_screw_pos)
	elif (nscrew1 == 4):
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, screw_circle1/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, x_axis, -screw_circle1/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, y_axis, screw_circle1/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)
	    tmp_screw_pos = VISIPoint.New()
	    tmp_screw_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	    VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos, y_axis, -screw_circle1/2, tmp_screw_pos)
	    screw_positions.append(tmp_screw_pos)
	
	if (nscrew2 == 2):	
		tmp_screw_pos_small = VISIPoint.New()
		tmp_screw_pos_small.Set(start_pos.x(), start_pos.y(), start_pos.z())
		VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos_small, x_axis2, screw_circle2/2, tmp_screw_pos_small)
		screw_positions_small.append(tmp_screw_pos_small)
		tmp_screw_pos_small = VISIPoint.New()
		tmp_screw_pos_small.Set(start_pos.x(), start_pos.y(), start_pos.z())
		VISIGeoLib.ProjectPointOntoVector(tmp_screw_pos_small, x_axis2, -screw_circle2/2, tmp_screw_pos_small)
		screw_positions_small.append(tmp_screw_pos_small)
			
			

	
	
	
def CreateElement ():

	position = params['POSITION']
	direction = params['DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	base_diameter = params['BASE_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	loading_hole = params['LOADING_HOLE']
	hole_height = params['HOLE_HEIGHT']
	bar = params['BAR']
	initial_strenght = params['INITIAL_STRENGHT']
	top_compression_strength = params['TOP_COMPRESSION_STRENGTH']
	nscrew = params['NSCREW']
	screw_diam = params['SCREW_DIAM']
	screw_circle1 = params['SCREW_CIRCLE1']
	max_stroke = params['MAX_STROKE']
	user_stroke = params['USER_STROKE']
	lenght_tot = params['LENGHT_TOT']
	min_lenght = params['MIN_LENGHT']
	clearance_diam = params['CLEARANCE_DIAM']
	stroke = params['STROKE']
	housing_start = params['HOUSING_START']
	housing_end = params['HOUSING_END']
	gap_between_plates = params['GAP_BETWEEN_PLATES']
	diameter_valve = params['DIAMETER_VALVE']
	version = params['VERSION']
	diameter_thread = params['DIAMETER_THREAD']
	diameter_drilling_thread = params['DIAMETER_DRILLING_THREAD']
	depth_thread = params['DEPTH_THREAD']
	depth_drilling_thread = params['DEPTH_DRILLING_THREAD']
	thread_pitch = params['THREAD_PITCH']
	rotation = params['ROTATION']
	diameter_cap_outer = params['DIAMETER_CAP_OUTER']
	diameter_cap_inner = params['DIAMETER_CAP_INNER']
	length_cap_complete = params['LENGTH_CAP_COMPLETE']
	length_cap_top = params['LENGTH_CAP_TOP']
	offset_insertion = params['OFFSET_INSERTION']
	offset_tip = params['OFFSET_TIP']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	Inv_Dir = VISIVector.New()
	Inv_Dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Rotate with Value
	rot_angle = rotation
	VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
	VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	gap_between_plates = total_thick - (start_thick + end_thick)
	## Creating Base
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - housing_start, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder(base_diameter/2, min_lenght-offset_insertion, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, min_lenght-offset_insertion, start_pos)
	
	## Creating Head
	cyl2 = VISISolidFactory.CreateCylinder(head_diameter/2, lenght_tot - min_lenght - user_stroke + offset_insertion, start_pos, x_axis, direction)
	Uni_list.append(cyl2)
	
	
	##Create Cap
	start_pos.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - housing_start, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, min_lenght +(lenght_tot - min_lenght - user_stroke), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, Inv_Dir, length_cap_complete + offset_tip, start_pos)
	cyl5 = VISISolidFactory.CreateCylinder(diameter_cap_outer/2, length_cap_complete, start_pos, x_axis, direction)
	cyl6 = VISISolidFactory.CreateCylinder(diameter_cap_inner/2, length_cap_complete-length_cap_top, start_pos, x_axis, direction)
	Uni_list2.append(cyl5)
	Uni_list2.append(cyl6)
	VISISolidFactory.Subtract(Uni_list2, Uni_list)
	Uni_list2 =[]	
	
	## Unite The Sprue Bushing Parts 
	VISISolidFactory.Unite(Uni_list, Uni_list2)

	#Check which Version is used
	
	if version == 1:
		return Uni_list2[0]
	else:
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - housing_start, start_pos)
		
		
	
		if version == 2:
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, screw_circle1/2, start_pos)
		
		
		if version==3:
			VISIGeoLib.VectorRotate(y_axis, direction, y_axis, math.radians(-30)	)
			VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, screw_circle1/2, start_pos)
		
	
	
		#Create a Edge to show Position of valve
		cyl3 = VISISolidFactory.CreateCylinder(diameter_valve/2, 1./1000, start_pos, x_axis, direction)
		Uni_list2.append(cyl3)
		VISISolidFactory.Unite(Uni_list2, Result_List,0)
		body = Result_List[0]
		Result_List = []
		edge_list= [76]
		VISISolidFactory.MarkRelevantEdges(body, edge_list)
		return body
		
		
		Uni_list = []
		Uni_list.append(body)
		
				
		
		##Create Thread at top
		#Set Position
		start_pos.Set(position.x(), position.y(), position.z())
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - housing_start, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, min_lenght +(lenght_tot - min_lenght - user_stroke), start_pos)
		
		
		#Creat Thread & Tip
		cyl4 = VISISolidFactory.CreateCylinder(diameter_drilling_thread/2, depth_drilling_thread, start_pos, x_axis, Inv_Dir)
		
		length_cone=(diameter_drilling_thread/2)/math.tan(math.radians(60))
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, Inv_Dir, length_cone+depth_drilling_thread, start_pos)
		
		con1 = VISISolidFactory.CreateCone(0, length_cone, math.radians(60), start_pos, x_axis, direction)
		
		
		
		
		#Attach Cam Attributes
		cam_list = [diameter_drilling_thread, depth_drilling_thread, diameter_thread, depth_thread, thread_pitch]
		VISI.AttachCamAttributes(cyl4,cam_list,"PCYLAZ8_3",0,params["BUILDER_UNIT"])
		
		Uni_list.append(cyl4)
		Uni_list.append(con1)
		
		Result_List = []
		
		VISISolidFactory.Subtract(Uni_list, Result_List,0)
		
	
		return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	total_thick = params['TOTAL_THICK']
	base_diameter = params['BASE_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	loading_hole = params['LOADING_HOLE']
	hole_height = params['HOLE_HEIGHT']
	bar = params['BAR']
	initial_strenght = params['INITIAL_STRENGHT']
	top_compression_strength = params['TOP_COMPRESSION_STRENGTH']
	nscrew = params['NSCREW']
	screw_diam = params['SCREW_DIAM']
	screw_circle1 = params['SCREW_CIRCLE1']
	max_stroke = params['MAX_STROKE']
	user_stroke = params['USER_STROKE']
	lenght_tot = params['LENGHT_TOT']
	min_lenght = params['MIN_LENGHT']
	clearance_diam = params['CLEARANCE_DIAM']
	stroke = params['STROKE']
	housing_start = params['HOUSING_START']
	housing_end = params['HOUSING_END']
	gap_between_plates = params['GAP_BETWEEN_PLATES']
	start_clear = params['START_CLEAR']
	end_clear = params['END_CLEAR']
	diameter_cap_outer = params['DIAMETER_CAP_OUTER']
	
	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)

	gap_between_plates = total_thick - (start_thick + end_thick)
	## Creating Cavity
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick - housing_start, start_pos)
	#Create frist Cavity
	cyl = VISISolidFactory.CreateCylinder((diameter_cap_outer + start_clear)/2, housing_start + gap_between_plates, start_pos, x_axis, direction)
	cam_list = [(diameter_cap_outer + start_clear), housing_start + gap_between_plates]
	VISI.AttachCamAttributes(cyl,cam_list,"PCYLAZ8_1",elem_tag,params["BUILDER_UNIT"])
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, housing_start + gap_between_plates, start_pos)
	#Create second Cavity
	cyl2 = VISISolidFactory.CreateCylinder((diameter_cap_outer + end_clear)/2, housing_end, start_pos, x_axis, direction)
	cam_list = [(diameter_cap_outer + end_clear), housing_end]
	VISI.AttachCamAttributes(cyl2,cam_list,"PCYLAZ8_2",elem_tag,params["BUILDER_UNIT"])
	#Unite Cavities
	Uni_list.append(cyl)
	Uni_list.append(cyl2)
	VISISolidFactory.Unite(Uni_list, Result_List,0)

	return Result_List[0]


def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_pcylaz8_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, Xaxis)

	LoadGlobals()

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
