import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	length = params['LENGTH']
	stroke = params['STROKE']
	diameter_ext = params['DIAMETER_EXT']
	spring_wire_diam = params['SPRING_WIRE_DIAM']
	max_stat_dist = params['MAX_STAT_DIST']
	max_stat_load = params['MAX_STAT_LOAD']
	block_length = params['BLOCK_LENGTH']
	length_min_stat = params['LENGTH_MIN_STAT']
	length_min_stat_display = params['LENGTH_MIN_STAT_DISPLAY']
	spring_rate = params['SPRING_RATE']
	spring_rate_calc = params['SPRING_RATE_CALC']
	spring_rate_rnd = params['SPRING_RATE_RND']
	preload_close = params['PRELOAD_CLOSE']
	load_close = params['LOAD_CLOSE']
	preload_open = params['PRELOAD_OPEN']
	load_open = params['LOAD_OPEN']
	spring_length = params['SPRING_LENGTH']
	deflection_percentage = params['DEFLECTION_PERCENTAGE']
	check_calc_stroke_preload_close = params['CHECK_CALC_STROKE_PRELOAD_CLOSE']
	check_calc_stroke_load_close = params['CHECK_CALC_STROKE_LOAD_CLOSE']
	check_calc_stroke_preload_open = params['CHECK_CALC_STROKE_PRELOAD_OPEN']
	check_calc_stroke_load_open = params['CHECK_CALC_STROKE_LOAD_OPEN']
	check_no_compression = params['CHECK_NO_COMPRESSION']
	check_simplimfied = params['CHECK_SIMPLIMFIED']
	create_spring_open = params['CREATE_SPRING_OPEN']
	create_spring_close = params['CREATE_SPRING_CLOSE']
	diam_clear = params['DIAM_CLEAR']
	offset = params['OFFSET']
	round_precision = params['ROUND_PRECISION']
	width = params['WIDTH']
	height = params['HEIGHT']
	radius = params['RADIUS']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	spring_length = round(spring_length*1000,2)/1000
	if check_no_compression:
		spring_length = length
	
	if not check_simplimfied and spring_length > 0:
		spring_length_new = spring_length*1.2
		# ##Calculating Nspire and Gap Between Spire
		A = (diameter_ext - diameter) / 2
		A = A - 0.00025
		B = (3*A) / 5
		Inc_ang = 20
		G = (diameter_ext/2 - A/2) * math.tan(math.radians(Inc_ang)) + B
		nspire = round(((spring_length_new - B) / G) , 0)
		G1 = (spring_length_new - B) / nspire
		angular_inc = (nspire * math.radians(360))
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, spring_wire_diam/2-offset, start_pos)
		
				
		body = VISISolidFactory.MakeHelicalBodyRectSect(start_pos, x_axis, direction, 0, angular_inc, diameter/2, G1, 0, width, height, radius)
				
		
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, spring_wire_diam/2, start_pos)
		Back_List = []
		Front_List = []
		VISISolidFactory.CutWithPlane(start_pos, direction, body, Front_List, Back_List)
		if(len(Front_List) > 0):
                        body = Front_List[0]
		VISISolidFactory.DeleteBodies(Back_List)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, spring_length, start_pos)
		Back_List = []
		Front_List = []
		VISISolidFactory.CutWithPlane(start_pos, direction, body, Front_List, Back_List)
		body = Back_List[0]
		VISISolidFactory.DeleteBodies(Front_List)
	else:
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, -offset, start_pos)
		body = VISISolidFactory.CreateCylinder((diameter_ext)/2, spring_length, start_pos, x_axis, direction)
		hole = VISISolidFactory.CreateCylinder((diameter)/2, spring_length, start_pos, x_axis, direction)
		#Substract SW
		Uni_list.append(body)
		Uni_list.append(hole)
		VISISolidFactory.Subtract(Uni_list, Result_List)
		body = Result_List[0]
		
	return body

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	length = params['LENGTH']
	stroke = params['STROKE']
	diameter_ext = params['DIAMETER_EXT']
	spring_wire_diam = params['SPRING_WIRE_DIAM']
	max_stat_dist = params['MAX_STAT_DIST']
	max_stat_load = params['MAX_STAT_LOAD']
	block_length = params['BLOCK_LENGTH']
	length_min_stat = params['LENGTH_MIN_STAT']
	length_min_stat_display = params['LENGTH_MIN_STAT_DISPLAY']
	spring_rate = params['SPRING_RATE']
	spring_rate_calc = params['SPRING_RATE_CALC']
	spring_rate_rnd = params['SPRING_RATE_RND']
	preload_close = params['PRELOAD_CLOSE']
	load_close = params['LOAD_CLOSE']
	preload_open = params['PRELOAD_OPEN']
	load_open = params['LOAD_OPEN']
	spring_length = params['SPRING_LENGTH']
	deflection_percentage = params['DEFLECTION_PERCENTAGE']
	check_calc_stroke_preload_close = params['CHECK_CALC_STROKE_PRELOAD_CLOSE']
	check_calc_stroke_load_close = params['CHECK_CALC_STROKE_LOAD_CLOSE']
	check_calc_stroke_preload_open = params['CHECK_CALC_STROKE_PRELOAD_OPEN']
	check_calc_stroke_load_open = params['CHECK_CALC_STROKE_LOAD_OPEN']
	check_no_compression = params['CHECK_NO_COMPRESSION']
	check_simplimfied = params['CHECK_SIMPLIMFIED']
	create_spring_open = params['CREATE_SPRING_OPEN']
	create_spring_close = params['CREATE_SPRING_CLOSE']
	diam_clear = params['DIAM_CLEAR']
	offset = params['OFFSET']
	round_precision = params['ROUND_PRECISION']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	
	spring_length = round(spring_length*1000,2)/1000
	if check_no_compression:
		spring_length = length
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, -offset, start_pos)
	body = VISISolidFactory.CreateCylinder((diameter_ext)/2+diam_clear/2 , spring_length, start_pos, x_axis, direction)
	
	cam_list = [diameter_ext+diam_clear, spring_length]
	VISI.AttachCamAttributes(body,cam_list,"PSPR8_1",elem_tag,params["BUILDER_UNIT"])
	
	return body

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_pspr8_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
