import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_big_designation = params['DIAMETER_BIG_DESIGNATION']
	diameter_small_designation = params['DIAMETER_SMALL_DESIGNATION']
	diameter_big = params['DIAMETER_BIG']
	diameter_big_core = params['DIAMETER_BIG_CORE']
	name_thread_big = params['NAME_THREAD_BIG']
	diameter_small = params['DIAMETER_SMALL']
	diameter_small_core = params['DIAMETER_SMALL_CORE']
	name_thread_small = params['NAME_THREAD_SMALL']
	outer_diameter_big = params['OUTER_DIAMETER_BIG']
	inner_diameter_small = params['INNER_DIAMETER_SMALL']
	total_length = params['TOTAL_LENGTH']
	length_thread_big = params['LENGTH_THREAD_BIG']
	length_small = params['LENGTH_SMALL']
	length_big = params['LENGTH_BIG']
	length_hex = params['LENGTH_HEX']
	inner_chamfer = params['INNER_CHAMFER']
	outer_chamfer = params['OUTER_CHAMFER']
	width_hex = params['WIDTH_HEX']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create upper cylinder
	edges1=[6, 12]
	cyl1 = VISISolidFactory.CreateCylinder(outer_diameter_big/2, length_big, start_pos, x_axis, direction)
	VISISolidFactory.ChamferEdges(cyl1, edges1, outer_chamfer, outer_chamfer, 0)
	#Create lower cylinder
	edges2=[12]
	cyl2 = VISISolidFactory.CreateCylinder(diameter_small/2, length_small, start_pos, x_axis, inv_dir)
	VISISolidFactory.ChamferEdges(cyl2, edges2, (diameter_small- diameter_small_core)/2, (diameter_small- diameter_small_core)/2, 0)
	#Unite
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	Uni_list=[]
	#Create inner holes
	cyl3 = VISISolidFactory.CreateCylinder(inner_diameter_small/2, length_small, start_pos, x_axis, inv_dir)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_big, start_pos)
	cyl4 = VISISolidFactory.CreateCylinder(diameter_big_core/2, length_thread_big, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl3)
	Uni_list2.append(cyl4)
	VISISolidFactory.Subtract(Uni_list2, Uni_list)
	edges3=[124]
	VISISolidFactory.ChamferEdges(Uni_list[0], edges3, inner_chamfer, inner_chamfer, 0)
	#Create hex
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_thread_big, start_pos)
	pri1 = VISISolidFactory.CreatePrism(width_hex/math.cos(math.radians(30))/2, length_hex, 6, start_pos, x_axis, inv_dir)
	Uni_list.append(pri1)
	VISISolidFactory.Subtract(Uni_list, Result_List)

	
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter_big_designation = params['DIAMETER_BIG_DESIGNATION']
	diameter_small_designation = params['DIAMETER_SMALL_DESIGNATION']
	diameter_big = params['DIAMETER_BIG']
	diameter_big_core = params['DIAMETER_BIG_CORE']
	name_thread_big = params['NAME_THREAD_BIG']
	diameter_small = params['DIAMETER_SMALL']
	diameter_small_core = params['DIAMETER_SMALL_CORE']
	name_thread_small = params['NAME_THREAD_SMALL']
	outer_diameter_big = params['OUTER_DIAMETER_BIG']
	inner_diameter_small = params['INNER_DIAMETER_SMALL']
	total_length = params['TOTAL_LENGTH']
	length_thread_big = params['LENGTH_THREAD_BIG']
	length_small = params['LENGTH_SMALL']
	length_big = params['LENGTH_BIG']
	length_hex = params['LENGTH_HEX']
	inner_chamfer = params['INNER_CHAMFER']
	outer_chamfer = params['OUTER_CHAMFER']
	width_hex = params['WIDTH_HEX']
	add_thread_depth = params['ADD_THREAD_DEPTH']
	add_drilling_depth = params['ADD_DRILLING_DEPTH']
	thread_big_pitch = params['THREAD_BIG_PITCH']
	thread_small_pitch = params['THREAD_SMALL_PITCH']
	clearence_cavitiy = params['CLEARENCE_CAVITIY']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Standard values
	length_drilling= length_small+ (3*thread_small_pitch)+ add_thread_depth + add_drilling_depth
	height_con= diameter_small_core/2/math.tan(math.radians(60))
	
	#Create Upper cavity
	cyl1 = VISISolidFactory.CreateCylinder(outer_diameter_big/2 + clearence_cavitiy/2, length_big, start_pos, x_axis, direction)
	cam_list = [outer_diameter_big + clearence_cavitiy,length_big]
	VISI.AttachCamAttributes(cyl1,cam_list,"RF1_1",elem_tag,params["BUILDER_UNIT"])
	#Create lower cavity
	cyl2 = VISISolidFactory.CreateCylinder(diameter_small_core/2, length_drilling, start_pos, x_axis, inv_dir)
	cam_list2 = [diameter_small_core, length_drilling, diameter_small, length_small+add_thread_depth, thread_small_pitch]
	VISI.AttachCamAttributes(cyl2,cam_list2,"RF1_2",elem_tag,params["BUILDER_UNIT"])
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_drilling+height_con, start_pos)
	con1 = VISISolidFactory.CreateCone(0, height_con, math.radians(60), start_pos, x_axis, direction)
	#Unite Cavities
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	Uni_list.append(con1)
	VISISolidFactory.Unite(Uni_list, Result_List)

	## return the tag of created cavity, 0 if no cavity
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_rf1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
