import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	max_stroke = params['MAX_STROKE']
	length = params['LENGTH']
	length_body = params['LENGTH_BODY']
	length_end = params['LENGTH_END']
	length_thread = params['LENGTH_THREAD']
	diameter_body = params['DIAMETER_BODY']
	length_front = params['LENGTH_FRONT']
	length_end_fix = params['LENGTH_END_FIX']
	width_column = params['WIDTH_COLUMN']
	height_column = params['HEIGHT_COLUMN']
	distance_between_drillings = params['DISTANCE_BETWEEN_DRILLINGS']
	radius = params['RADIUS']
	drill_diameter = params['DRILL_DIAMETER']
	sink_diameter = params['SINK_DIAMETER']
	sink_depth = params['SINK_DEPTH']
	diam_thread_end = params['DIAM_THREAD_END']
	diam_core_end = params['DIAM_CORE_END']
	thread_pitch_end = params['THREAD_PITCH_END']
	thread_column = params['THREAD_COLUMN']
	core_thread_column = params['CORE_THREAD_COLUMN']
	thread_pitch_colmun = params['THREAD_PITCH_COLMUN']
	rot_angle = params['ROT_ANGLE']
	offset = params['OFFSET']
	offset_z = params['OFFSET_Z']

	
	Uni_list = []
	Uni_list2 = []
	Uni_list21 = []
	Uni_list22 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	#Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, offset_z, start_pos)
	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(diameter_body/2, length_body, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	##Chamfer
	edges = [6,12]
	VISISolidFactory.ChamferEdges(cyl1, edges, diameter_body/40, diameter_body/40, 1)
	
	#Create Hole
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_front, start_pos)
	
	bl1 = VISISolidFactory.CreateBlock(width_column, diameter_body,max_stroke+height_column, start_pos, x_axis, direction)
	Uni_list.append(bl1)
	
	cyl20 = VISISolidFactory.CreateCylinder(diameter_body/2.5, max_stroke+height_column+(length_body-(length_front+max_stroke+height_column))/2, start_pos, x_axis, direction)
	Uni_list.append(cyl20)
	
	cyl21 = VISISolidFactory.CreateCylinder(diameter_body/2.5, length_front, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl21)
	
	#Create Thread
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_body-length_front, start_pos)
	thread_length_end = length_body-(max_stroke+height_column+(length_body-(length_front+max_stroke+height_column))/2)-length_front
	cyl3 = VISISolidFactory.CreateCylinder(diam_core_end/2, thread_length_end, start_pos, x_axis, inv_dir)
	
	
	cam_list = [diam_core_end, thread_length_end, diam_thread_end, thread_length_end, thread_pitch_end]
	VISI.AttachCamAttributes(cyl3,cam_list,"RLL5_0_1",0,params["BUILDER_UNIT"])
	
	Uni_list.append(cyl3)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list, Uni_list2)
	
	#Create Movable Fixing
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -length_body+length_front+height_column, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, offset, start_pos)
	
	##Create Main Body
	cyl4 = VISISolidFactory.CreateCylinder(diameter_body/2.5, height_column, start_pos, x_axis, inv_dir)
	Uni_list21.append(cyl4)
	
	##Create Block Body
	bl2 = VISISolidFactory.CreateBlock(width_column, distance_between_drillings+2*radius,height_column, start_pos, x_axis, inv_dir)
	Uni_list21.append(bl2)
	
	##Blend Ends
	edges = [18,20,22,24]
	VISISolidFactory.BlendEdges(bl2, edges, radius, 1)
	
	
	##Unite Movable Fixing
	VISISolidFactory.Unite(Uni_list21, Uni_list22)
	
	
	##Create Drilling Holes
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_between_drillings/2, start_pos)
	
	if not thread_column:
		cyl50 = VISISolidFactory.CreateCylinder(drill_diameter/2, height_column, start_pos, x_axis, inv_dir)
		Uni_list22.append(cyl50)
		cyl51 = VISISolidFactory.CreateCylinder(sink_diameter/2, sink_depth, start_pos, x_axis, inv_dir)
		Uni_list22.append(cyl51)
	else:
		cyl52 = VISISolidFactory.CreateCylinder(core_thread_column/2, height_column, start_pos, x_axis, inv_dir)
		Uni_list22.append(cyl52)
		cam_list = [core_thread_column, height_column, thread_column, height_column, thread_pitch_colmun]
		VISI.AttachCamAttributes(cyl52,cam_list,"RLL5_0_2",0,params["BUILDER_UNIT"])
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_between_drillings, start_pos)
	
	if not thread_column:
		cyl60 = VISISolidFactory.CreateCylinder(drill_diameter/2, height_column, start_pos, x_axis, inv_dir)
		Uni_list22.append(cyl60)
		cyl61 = VISISolidFactory.CreateCylinder(sink_diameter/2, sink_depth, start_pos, x_axis, inv_dir)
		Uni_list22.append(cyl61)
	else:
		cyl62 = VISISolidFactory.CreateCylinder(core_thread_column/2, height_column, start_pos, x_axis, inv_dir)
		Uni_list22.append(cyl62)
		cam_list = [core_thread_column, height_column, thread_column, height_column, thread_pitch_colmun]
		VISI.AttachCamAttributes(cyl62,cam_list,"RLL5_0_2",0,params["BUILDER_UNIT"])
		
	##Subtract
	VISISolidFactory.Subtract(Uni_list22, Uni_list2)
	
	
	#Unite
	VISISolidFactory.Unite(Uni_list2, Result_List,0)
	
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	max_stroke = params['MAX_STROKE']
	length = params['LENGTH']
	length_body = params['LENGTH_BODY']
	length_end = params['LENGTH_END']
	length_thread = params['LENGTH_THREAD']
	diameter_body = params['DIAMETER_BODY']
	length_front = params['LENGTH_FRONT']
	length_end_fix = params['LENGTH_END_FIX']
	width_column = params['WIDTH_COLUMN']
	height_column = params['HEIGHT_COLUMN']
	distance_between_drillings = params['DISTANCE_BETWEEN_DRILLINGS']
	radius = params['RADIUS']
	drill_diameter = params['DRILL_DIAMETER']
	sink_diameter = params['SINK_DIAMETER']
	sink_depth = params['SINK_DEPTH']
	diam_thread_end = params['DIAM_THREAD_END']
	diam_core_end = params['DIAM_CORE_END']
	thread_pitch_end = params['THREAD_PITCH_END']
	thread_column = params['THREAD_COLUMN']
	core_thread_column = params['CORE_THREAD_COLUMN']
	thread_pitch_colmun = params['THREAD_PITCH_COLMUN']
	clear_diam = params['CLEAR_DIAM']
	offset = params['OFFSET']
	offset_z = params['OFFSET_Z']
	rot_angle = params['ROT_ANGLE']

	Uni_list = []
	Uni_list2 = []
	Uni_list21 = []
	Uni_list22 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
			
	#Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, offset_z, start_pos)
	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(diameter_body/2+clear_diam/2, length_body, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	cam_list = [diameter_body+clear_diam, length_body]
	VISI.AttachCamAttributes(cyl1,cam_list,"RLL5_0_1",elem_tag,params["BUILDER_UNIT"])
		
	#Create Movable Fixing
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_front+height_column, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, offset, start_pos)
	
	##Create Main Body
	cyl4 = VISISolidFactory.CreateCylinder(diameter_body/2.5, height_column, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl4)
	
	##Create Block Body
	bl2 = VISISolidFactory.CreateBlock(width_column, distance_between_drillings+2*radius,height_column, start_pos, x_axis, inv_dir)
	Uni_list.append(bl2)
	
	##Blend Ends
	edges = [18,20,22,24]
	VISISolidFactory.BlendEdges(bl2, edges, radius, 1)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Result_List,0)
	
	## return the tag of created element, 0 if no element
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_rll5_0'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
