import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	max_stroke = params['MAX_STROKE']
	length = params['LENGTH']
	cut = params['CUT']
	diameter = params['DIAMETER']
	length_connector = params['LENGTH_CONNECTOR']
	thread_diameter = params['THREAD_DIAMETER']
	thread_length = params['THREAD_LENGTH']
	thread_core_diam = params['THREAD_CORE_DIAM']
	thread_pitch = params['THREAD_PITCH']
	wrench_size = params['WRENCH_SIZE']
	clear_diam = params['CLEAR_DIAM']
	rot_angle = params['ROT_ANGLE']
	extra_core_length = params['EXTRA_CORE_LENGTH']

	Uni_list = []
	Uni_list2 = []
	Uni_list21 = []
	Uni_list22 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
	offset_int = 0.5/1000
		
	#Set Position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, offset_int, start_pos)
	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, length-cut-offset_int-length_connector, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	##Chamfer
	edges = [6]
	VISISolidFactory.ChamferEdges(cyl1, edges, diameter/10, diameter/10, 1)
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl1, edges, diameter/50, diameter/50, 1)
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter/7, length_connector+offset_int, start_pos, x_axis, direction)
	Uni_list.append(cyl2)
	
	#Create Hex
	hex = VISISolidFactory.CreatePrism(wrench_size/2/(math.cos(math.radians(30))),length_connector/10+offset_int, 6,start_pos, x_axis, direction)
	Uni_list.append(hex)
		
	edges = [73,78,83,58,63,68]
	VISISolidFactory.ChamferEdges(hex, edges, wrench_size/8, wrench_size/8, 1)
	
	#Create Head
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_connector+offset_int, start_pos)
	rad_head = wrench_size/2/(math.cos(math.radians(30)))
	cyl3 = VISISolidFactory.CreateCylinder(rad_head, length_connector/2.5, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl3)
	#Chamfer
	edges = [6,12]
	VISISolidFactory.ChamferEdges(cyl3, edges, rad_head/3.5, rad_head/2, 1)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	if cut < (thread_length+extra_core_length):
		#Create Thread
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -(length_connector+length)+cut+length_connector, start_pos)
		cyl4 = VISISolidFactory.CreateCylinder(thread_core_diam/2, thread_length+extra_core_length-cut, start_pos, x_axis, direction)
		Uni_list2.append(cyl4)
		cam_list = [thread_core_diam, thread_length+extra_core_length-cut, thread_diameter, thread_length-cut, thread_pitch]
		VISI.AttachCamAttributes(cyl4,cam_list,"RLL5_1_0",0,params["BUILDER_UNIT"])
	
	
		#Create Cone
		h_cone = (thread_core_diam/2)/(math.tan(math.radians(60)))
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, thread_length+extra_core_length + h_cone-cut, start_pos)	
		cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
		Uni_list2.append(cone)

	
		#Subtract
		VISISolidFactory.Subtract(Uni_list2, Result_List)
		
		return Result_List[0]
	else:
		return Uni_list2[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	max_stroke = params['MAX_STROKE']
	length = params['LENGTH']
	cut = params['CUT']
	diameter = params['DIAMETER']
	length_connector = params['LENGTH_CONNECTOR']
	thread_diameter = params['THREAD_DIAMETER']
	thread_length = params['THREAD_LENGTH']
	thread_core_diam = params['THREAD_CORE_DIAM']
	thread_pitch = params['THREAD_PITCH']
	wrench_size = params['WRENCH_SIZE']
	clear_diam = params['CLEAR_DIAM']
	rot_angle = params['ROT_ANGLE']

	Uni_list = []
	Uni_list2 = []
	Uni_list21 = []
	Uni_list22 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2+clear_diam/2, length-cut-length_connector, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	cam_list = [diameter+clear_diam, length-cut-length_connector]
	VISI.AttachCamAttributes(cyl1,cam_list,"RLL5_1_1",elem_tag,params["BUILDER_UNIT"])
	
	return cyl1

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_rll5_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
