import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	diameter_start_inside = params['DIAMETER_START_INSIDE']
	length = params['LENGTH']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	min_length = params['MIN_LENGTH']
	length_head = params['LENGTH_HEAD']
	dist_hole_vetrical = params['DIST_HOLE_VETRICAL']
	length_rad_head = params['LENGTH_RAD_HEAD']
	diameter_head = params['DIAMETER_HEAD']
	diameter_end_inside = params['DIAMETER_END_INSIDE']
	diameter_lock = params['DIAMETER_LOCK']
	length_lock = params['LENGTH_LOCK']
	radius1 = params['RADIUS1']
	angle = params['ANGLE']
	radius0 = params['RADIUS0']
	total_length = params['TOTAL_LENGTH']
	chamfer0 = params['CHAMFER0']
	chamfer1 = params['CHAMFER1']
	guided_length_cav = params['GUIDED_LENGTH_CAV']
	dist_under_head = params['DIST_UNDER_HEAD']
	play_diam_head = params['PLAY_DIAM_HEAD']
	play_diam_body = params['PLAY_DIAM_BODY']
	cut = params['CUT']
	rot_angle = params['ROT_ANGLE']
	dist_between = params['DIST_BETWEEN']
	adapt_startplate = params['ADAPT_STARTPLATE']
	adapt_endplate = params['ADAPT_ENDPLATE']
	
	

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	end_pos = VISIPoint.New()
	end_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
		
	inv_y = VISIVector.New()
	inv_y.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	#Move to correct position
	VISIGeoLib.ProjectPointOntoVector(end_pos, direction, start_thick+end_thick, end_pos)	
	
	
	#Move to correct position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, dist_under_head, start_pos)
	
	
	#Use cut
	length = length - cut

	#Create Head
	cyl1 = VISISolidFactory.CreateCylinder(diameter_head/2, length_head, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	# Create Body
	# cyl20 = VISISolidFactory.CreateCylinder(diameter/2, start_thick+dist_between-dist_under_head, start_pos, x_axis, direction)
	# Uni_list.append(cyl20)
	
	if (length+length_head) > (start_thick-dist_under_head + dist_between):
		length_new = start_thick-dist_under_head + dist_between
		if dist_between > 0 and end_thick >= 1./1000:
			length_new = length_new + 1./1000
	else:
		length_new = length+length_head

	if start_plate != end_plate:
		cyl20 = VISISolidFactory.CreateCylinder(diameter/2, length_new, start_pos, x_axis, direction)
		Uni_list.append(cyl20)
	
	cyl21 = VISISolidFactory.CreateCylinder(diameter/2, length+length_head, start_pos, x_axis, direction)
	cyl21= VISIParam.AdaptCavityToPlate(end_plate, cyl21, 0)
	Uni_list.append(cyl21)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	
	#Features
	#Create Radius at Head
	
	#Move to correct position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, radius1-length_rad_head, start_pos)
	
	if radius1 <> 0:
		sph1 = VISISolidFactory.CreateSphere (radius1, start_pos, x_axis, direction)
		Uni_list2.append(sph1)
	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_rad_head-radius1, start_pos)
	
	#Create Cone
	#rad_start_inside_calc = diameter_end_inside/2 - (length+length_head) * math.tan(angle)
	cone = VISISolidFactory.CreateCone(diameter_start_inside/2, length+length_head+10./1000, angle, start_pos, x_axis, direction)
	Uni_list2.append(cone)
	
	#Create Lock vertical
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_head, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, dist_hole_vetrical, start_pos)
	
	#Cylinder
	cyl3 = VISISolidFactory.CreateCylinder(diameter_lock/2, length_lock, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl3)
	
	#Cone
	h_cone = (diameter_lock/2)/(math.tan(math.radians(60))) 
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_lock+h_cone, start_pos)
	cone3 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone3)
	
	
	#Create lock horizontal
	#Move to crrect position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_lock+h_cone-length_head/2, start_pos)
	
	#Create Cylinder
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -dist_hole_vetrical-diameter_head/2, start_pos)
	cyl4 = VISISolidFactory.CreateCylinder(diameter_lock/2, length_lock, start_pos, inv_dir, y_axis)
	Uni_list2.append(cyl4)
	
	#Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, length_lock+h_cone, start_pos)
	cone4 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, direction, inv_y)
	Uni_list2.append(cone4)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	#Chamfer
	if chamfer0 >0:
		edges = [6]
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer0,chamfer0, 1)
	
	if chamfer1 > 0:
		edges = [12]
		VISISolidFactory.ChamferEdges(Result_List[0], edges, chamfer1,chamfer1, 1)
	
	#Blend
	if radius0 > 0:
		edges = [30]
		VISISolidFactory.BlendEdges(Result_List[0], edges, radius0, 1)
	
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	diameter_start_inside = params['DIAMETER_START_INSIDE']
	length = params['LENGTH']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	min_length = params['MIN_LENGTH']
	length_head = params['LENGTH_HEAD']
	dist_hole_vetrical = params['DIST_HOLE_VETRICAL']
	length_rad_head = params['LENGTH_RAD_HEAD']
	diameter_head = params['DIAMETER_HEAD']
	diameter_end_inside = params['DIAMETER_END_INSIDE']
	diameter_lock = params['DIAMETER_LOCK']
	length_lock = params['LENGTH_LOCK']
	radius1 = params['RADIUS1']
	angle = params['ANGLE']
	radius0 = params['RADIUS0']
	total_length = params['TOTAL_LENGTH']
	chamfer0 = params['CHAMFER0']
	chamfer1 = params['CHAMFER1']
	guided_length_cav = params['GUIDED_LENGTH_CAV']
	dist_under_head = params['DIST_UNDER_HEAD']
	play_diam_head = params['PLAY_DIAM_HEAD']
	play_diam_body = params['PLAY_DIAM_BODY']
	cut = params['CUT']
	dist_between = params['DIST_BETWEEN']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_y = VISIVector.New()
	inv_y.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	#Use cut
	length = length - cut
	

	#Create Head
	cyl1 = VISISolidFactory.CreateCylinder(diameter_head/2+play_diam_head/2, length_head+dist_under_head, start_pos, x_axis, direction)
	cavity_face_head = VISISolidFactory.GetFaceInBodyFromPoint(cyl1, start_pos)
	hole_head = VISIParam.ExtendFaceToSolid(start_plate, cavity_face_head, direction)
	hole_head= VISIParam.AdaptCavityToPlate(start_plate, hole_head, 0)
	cam_list = [(diameter_head/2+play_diam_head/2), (length_head+dist_under_head)]
        VISI.AttachCamAttributes(hole_head,cam_list,"SB5_1",elem_tag,params["BUILDER_UNIT"])
	Uni_list.append(hole_head)
	
	if (start_thick) < (length_head+dist_under_head):
		cyl11 = VISISolidFactory.CreateCylinder(diameter_head/2+play_diam_head/2, length_head+dist_under_head, start_pos, x_axis, direction)
		cavity_face_head = VISISolidFactory.GetFaceInBodyFromPoint(cyl11, start_pos)
		hole_head2 = VISIParam.ExtendFaceToSolid(end_plate, cavity_face_head, direction)
		hole_head2= VISIParam.AdaptCavityToPlate(end_plate, hole_head2, 0)
		cam_list = [(diameter_head/2+play_diam_head/2), (length_head+dist_under_head)]
                VISI.AttachCamAttributes(hole_head2,cam_list,"SB5_1",elem_tag,params["BUILDER_UNIT"])
		Uni_list.append(hole_head2)
	
	#Create Chamfer
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_head+dist_under_head+radius0, start_pos)
	cone = VISISolidFactory.CreateCone(diameter/2+play_diam_body/2, radius0, math.radians(45), start_pos, x_axis, inv_dir)
	Uni_list.append(cone)

        if (start_plate == end_plate):
                cyl_length = start_thick-(length_head+dist_under_head + radius0 + guided_length_cav)
        else:
                cyl_length = start_thick-(length_head+dist_under_head)
                
	#Create Body P1
	cyl2 = VISISolidFactory.CreateCylinder(diameter/2+play_diam_body/2, cyl_length, start_pos, x_axis, direction)
	
	cam_list = [(diameter/2+play_diam_body/2), cyl_length]
        VISI.AttachCamAttributes(cyl2,cam_list,"SB5_2",elem_tag,params["BUILDER_UNIT"])
	
	
	if start_plate == end_plate:
                if (guided_length_cav <= 0):
                        cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl2, start_pos)
                        hole = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, direction)
                        hole = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, inv_dir)
                        hole= VISIParam.AdaptCavityToPlate(end_plate, hole, 0)
                        Uni_list.append(hole)
                else:
                        Uni_list.append(cyl2)
	else:
		Uni_list.append(cyl2)
		#Create Body Between
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_head+dist_under_head, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick, start_pos)
		cyl20 = VISISolidFactory.CreateCylinder(diameter/2+play_diam_body/2, dist_between+1./1000, start_pos, x_axis, direction)
                cam_list = [(diameter/2+play_diam_body/2), (dist_between+1./1000)]
                VISI.AttachCamAttributes(cyl20,cam_list,"SB5_2",elem_tag,params["BUILDER_UNIT"])
		
		Uni_list.append(cyl20)
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, start_thick, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_head+dist_under_head, start_pos)
			
		#Create Body P2
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick+dist_between-(length_head+dist_under_head + radius0), start_pos)
		
		if guided_length_cav == 0:
			cyl21 = VISISolidFactory.CreateCylinder(diameter/2+play_diam_body/2, end_thick+10./1000, start_pos, x_axis, direction)
			cam_list = [(diameter/2+play_diam_body/2), (end_thick+10./1000)]
                        VISI.AttachCamAttributes(cyl21,cam_list,"SB5_3",elem_tag,params["BUILDER_UNIT"])
		else:
			cyl21 = VISISolidFactory.CreateCylinder(diameter/2+play_diam_body/2, end_thick-guided_length_cav, start_pos, x_axis, direction)
                        cam_list = [(diameter/2+play_diam_body/2), (end_thick-guided_length_cav)]
                        VISI.AttachCamAttributes(cyl21,cam_list,"SB5_3",elem_tag,params["BUILDER_UNIT"])
		
		cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl21, start_pos)
		hole = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, direction)
		hole = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, inv_dir)
		hole= VISIParam.AdaptCavityToPlate(end_plate, hole, 0)
		Uni_list.append(hole)
	
	
		
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Chamfer

	edges = [19]
	VISISolidFactory.ChamferEdges(Uni_list2[0], edges, radius0,radius0, 1)
	
	
	if guided_length_cav <> 0:
                if (start_plate == end_plate):
                        VISIGeoLib.ProjectPointOntoVector(start_pos, direction, cyl_length, start_pos)
                else:
                        VISIGeoLib.ProjectPointOntoVector(start_pos, direction, end_thick - guided_length_cav, start_pos)

		#Create Body
		cyl3 = VISISolidFactory.CreateCylinder(diameter/2, guided_length_cav+10./1000, start_pos, x_axis, direction)
		cam_list = [(diameter/2), (guided_length_cav+10./1000)]
                VISI.AttachCamAttributes(cyl3,cam_list,"SB5_4",elem_tag,params["BUILDER_UNIT"])
		
		cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl3, start_pos)
		hole = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, direction)
		hole= VISIParam.AdaptCavityToPlate(end_plate, hole, 0)
		Uni_list2.append(hole)
	
		#Unite
		VISISolidFactory.Unite(Uni_list2, Result_List)

		return Result_List[0]
	else:
		return Uni_list2[0]
	

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_sb5'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
