import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	diameter = params['DIAMETER']
	diameter_circle = params['DIAMETER_CIRCLE']
	distance1 = params['DISTANCE1']
	distance2 = params['DISTANCE2']
	force = params['FORCE']
	radius1 = params['RADIUS1']
	diam_sphere = params['DIAM_SPHERE']
	depth_sphere = params['DEPTH_SPHERE']
	radius4 = params['RADIUS4']
	radius_groove = params['RADIUS_GROOVE']
	x_direction = params['X_DIRECTION']
	check_open = params['CHECK_OPEN']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Temp_list = []
	Temp_list2 = []
	Result_List = []
	del_list = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	end_pos = VISIPoint.New()
	end_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	x_axis.Set(x_direction.Cx(), x_direction.Cy(), x_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)

	#Correct direction
	direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	

	Front_Body_List = []
	Back_Body_List = []
	
	
	
	if check_open:
		rot_angle = math.radians(180)
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
	#Move to correct position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -width/2, start_pos)
	
	#Create Body
	block1 = VISISolidFactory.CreateBlock(height,width,length, start_pos, direction, x_axis)
	Uni_list.append(block1)
	
	#Blend Body on both Ends
	edges = [28,12,16,34]
	VISISolidFactory.BlendEdges(block1, edges, width/2, 1)
	
	#Create Hole in middle
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -height/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, width/2, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, height, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	# Create Min Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,distance1+distance2 , start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, width/2, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder(radius1, height, start_pos, x_axis, direction)
	Uni_list.append(cyl2)

	#Blend Body on both Ends
	#Subtract
	VISISolidFactory.Subtract(Uni_list, Uni_list2)
	edges = [273,275]
	VISISolidFactory.BlendEdges(Uni_list2[0], edges, radius4, 1)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis,-(distance1+distance2) , start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -width/2, start_pos)

	#Create 4 Spheres
	if diam_sphere > 0:
		#1
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, diameter_circle/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -diam_sphere+depth_sphere, start_pos)
		sph1 = VISISolidFactory.CreateSphere (diam_sphere, start_pos, x_axis, direction)
		Uni_list2.append(sph1)
		
		#2
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -diameter_circle, start_pos)
		sph2 = VISISolidFactory.CreateSphere (diam_sphere, start_pos, x_axis, direction)
		Uni_list2.append(sph2)
		
		#3
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, diameter_circle/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, diameter_circle/2, start_pos)
		sph3 = VISISolidFactory.CreateSphere (diam_sphere, start_pos, x_axis, direction)
		Uni_list2.append(sph3)
		
		#4
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -diameter_circle, start_pos)
		sph4 = VISISolidFactory.CreateSphere (diam_sphere, start_pos, x_axis, direction)
		Uni_list2.append(sph4)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, diam_sphere-depth_sphere, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, diameter_circle/2, start_pos)
	else:
		#Move to correct position
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -10./1000, start_pos)
		
		#Create hole
		gap = 0.5/1000
		cyl001 = VISISolidFactory.CreateCylinder (6./1000/2, 7./1000+gap, start_pos, x_axis, direction)
		Uni_list2.append(cyl001)
		
		#Create Cone for hole
		h_cone = (6./1000/2)/(math.tan(math.radians(60))) 
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, (h_cone+7./1000+gap), start_pos)
		cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
		Uni_list2.append(cone)
		
		#return position
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -(h_cone+7./1000+gap), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, 10./1000, start_pos)

	#Create Lock 1
	cyl31 = VISISolidFactory.CreateCylinder(distance1+radius1, height, start_pos, x_axis, direction)
	cyl32 = VISISolidFactory.CreateCylinder(distance1-radius1, height, start_pos, x_axis, direction)
	Temp_list.append(cyl31)
	Temp_list.append(cyl32)
	
	
	#Subtract
	VISISolidFactory.Subtract(Temp_list, Temp_list2)

	VISISolidFactory.CutWithPlane(start_pos, y_axis, Temp_list2[0], Front_Body_List, Back_Body_List)
	part1 = Front_Body_List[0]
	part2 = Back_Body_List[0]
	
	del_list.append(part2)
	VISISolidFactory.DeleteBodies(del_list)
	
	Uni_list2.append(Front_Body_List[0])
	Temp_list = []
	Temp_list2 = []
	
	#Create Lock 2
	cyl41 = VISISolidFactory.CreateCylinder(distance1+distance2+radius1, height, start_pos, x_axis, direction)
	cyl42 = VISISolidFactory.CreateCylinder(distance1+distance2-radius1, height, start_pos, x_axis, direction)
	Temp_list.append(cyl41)
	Temp_list.append(cyl42)
	
	#Subtract
	VISISolidFactory.Subtract(Temp_list, Temp_list2)

	VISISolidFactory.CutWithPlane(start_pos, y_axis, Temp_list2[0], Front_Body_List, Back_Body_List)
	part3 = Front_Body_List[1]
	part4 = Back_Body_List[0]
	
	del_list.append(part3)
	VISISolidFactory.DeleteBodies(del_list)
	
	Uni_list2.append(Back_Body_List[1])
	
	#Create End of Grooves
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance1, start_pos)
	cyl33 = VISISolidFactory.CreateCylinder(radius1, height, start_pos, x_axis, direction)
	Uni_list2.append(cyl33)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance2, start_pos)
	cyl43 = VISISolidFactory.CreateCylinder(radius1, height, start_pos, x_axis, direction)
	Uni_list2.append(cyl43)
		
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Uni_list3)
	
	#Blend
	if diam_sphere > 0:
		edges = [513,678,670]
	else:
		edges = [482,647,639]
		
	VISISolidFactory.BlendEdges(Uni_list3[0], edges, radius1, 1)
	
	#Create Sinking for iso screw in case of type 3
	
	if type == 3:
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -(distance1+distance2), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height, start_pos)
		cyl5 = VISISolidFactory.CreateCylinder(8.5/1000, 2./1000, start_pos, x_axis, inv_dir)
		Uni_list3.append(cyl5)
		
		
		#Subtract
		VISISolidFactory.Subtract(Uni_list3, Result_List)
		
		## return the tag of created element, 0 if no element
		return Result_List[0]
	else:
		return Uni_list3[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	type = params['TYPE']
	length = params['LENGTH']
	width = params['WIDTH']
	height = params['HEIGHT']
	diameter = params['DIAMETER']
	diameter_circle = params['DIAMETER_CIRCLE']
	distance1 = params['DISTANCE1']
	distance2 = params['DISTANCE2']
	force = params['FORCE']
	radius1 = params['RADIUS1']
	diam_sphere = params['DIAM_SPHERE']
	depth_sphere = params['DEPTH_SPHERE']
	radius4 = params['RADIUS4']
	radius_groove = params['RADIUS_GROOVE']
	x_direction = params['X_DIRECTION']
	check_open = params['CHECK_OPEN']

	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Temp_list = []
	Temp_list2 = []
	Result_List = []
	del_list = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	end_pos = VISIPoint.New()
	end_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	x_axis.Set(x_direction.Cx(), x_direction.Cy(), x_direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)

	#Correct direction
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	

	Front_Body_List = []
	Back_Body_List = []
	
	if check_open:
		rot_angle = math.radians(180)
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
		
	#Move to correct position
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -width/2, start_pos)
	
	#Create Body
	block1 = VISISolidFactory.CreateBlock(height,width,length, start_pos, direction, x_axis)
	Uni_list.append(block1)
	
	#Blend Body on both Ends
	edges = [28,12,16,34]
	VISISolidFactory.BlendEdges(block1, edges, width/2, 1)
	
	return block1
	
def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_sh1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
