import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	master_elem = params['MASTER_ELEM']
	slide_height = params['SLIDE_HEIGHT']
	width = params['WIDTH']
	height = params['HEIGHT']
	length = params['LENGTH']
	screw_number = params['SCREW_NUMBER']
	base_width = params['BASE_WIDTH']
	base_height = params['BASE_HEIGHT']
	screw_diameter = params['SCREW_DIAMETER']
	screw_hollow_diameter = params['SCREW_HOLLOW_DIAMETER']
	screw_head_diameter = params['SCREW_HEAD_DIAMETER']
	screw_head_height = params['SCREW_HEAD_HEIGHT']
	screw_distance = params['SCREW_DISTANCE']
	screw_distance2 = params['SCREW_DISTANCE2']
	distance_from_border = params['DISTANCE_FROM_BORDER']
	right = params['RIGHT']
	slide_width = params['SLIDE_WIDTH']
	slide_base_width = params['SLIDE_BASE_WIDTH']
	slide_heel_height = params['SLIDE_HEEL_HEIGHT']
	slide_length = params['SLIDE_LENGTH']
	slide_stroke = params['SLIDE_STROKE']
	slide_offset = params['SLIDE_OFFSET']
	slide_inserting_depth = params['SLIDE_INSERTING_DEPTH']
	extra_length = params['EXTRA_LENGTH']
	pos_offset = params['POS_OFFSET']

	tmp_pos = VISIPoint.New()
	calc_pos = VISIPoint.New()
	y_axis = VISIVector.New()
	Bool_List = []
	Result_List = []

	VISIGeoLib.naXb(direction, ref_direction, y_axis)

	if (right):
		y_axis.Set(- y_axis.Cx(), - y_axis.Cy(), - y_axis.Cz())
		slide_offset = - slide_offset

		
		
	
	
	
	if width - base_width < (slide_base_width/2 - slide_width/2):
		offset_y= slide_offset - slide_width / 2 - (slide_base_width/2 - slide_width/2)- base_width / 2
	else:
		offset_y= slide_offset - slide_width / 2 - width + base_width / 2
	
	
	VISIGeoLib.ProjectPointOntoVector(position, direction,
					  - (slide_inserting_depth + base_height - slide_heel_height), tmp_pos)
	VISIGeoLib.ProjectPointOntoVector(tmp_pos, y_axis, offset_y, tmp_pos)
	VISIGeoLib.ProjectPointOntoVector(tmp_pos, ref_direction, length / 2 + pos_offset, tmp_pos)

	calc_pos.Set(tmp_pos.x(), tmp_pos.y(), tmp_pos.z())

	## create the base of the guide rail
	base = VISISolidFactory.CreateBlock(base_width, length, base_height, tmp_pos, y_axis, direction)
	Bool_List.append(base)

	VISIGeoLib.ProjectPointOntoVector(tmp_pos, direction, base_height, tmp_pos)
	VISIGeoLib.ProjectPointOntoVector(tmp_pos, y_axis, (width - base_width) / 2, tmp_pos)

	## create the superior part of the guide rail
	sup_part = VISISolidFactory.CreateBlock(width, length, height - base_height, tmp_pos, y_axis, direction)
	Bool_List.append(sup_part)

	## unite all the guide rail parts
	VISISolidFactory.Unite(Bool_List, Result_List)

	guide_rail = Result_List[0]
	Bool_List = []
	Result_List = []
	Bool_List.append(guide_rail)

	VISIGeoLib.ProjectPointOntoVector(calc_pos, y_axis, width - base_width / 2 - distance_from_border, calc_pos)
	
	if (screw_number == 3):
		VISIGeoLib.ProjectPointOntoVector(calc_pos, ref_direction, - screw_distance, tmp_pos)
	else:
		VISIGeoLib.ProjectPointOntoVector(calc_pos, ref_direction, - screw_distance / 2, tmp_pos)

	## create the left screw hollow
	screw_hole = VISISolidFactory.CreateCylinder(screw_hollow_diameter / 2, height - screw_head_height,
						     tmp_pos, y_axis, direction)
	Bool_List.append(screw_hole)

	VISIGeoLib.ProjectPointOntoVector(tmp_pos, direction, height - screw_head_height, tmp_pos)

	## create the left screw head hollow
	screw_head_hole = VISISolidFactory.CreateCylinder(screw_head_diameter / 2, screw_head_height,
							  tmp_pos, y_axis, direction)
	Bool_List.append(screw_head_hole)

	if (screw_number == 3):
		
		## create the center screw hollow
		screw_hole = VISISolidFactory.CreateCylinder(screw_hollow_diameter / 2, height - screw_head_height,
							     calc_pos, y_axis, direction)
		Bool_List.append(screw_hole)

		VISIGeoLib.ProjectPointOntoVector(calc_pos, direction, height - screw_head_height, tmp_pos)

		## create the center screw head hollow
		screw_head_hole = VISISolidFactory.CreateCylinder(screw_head_diameter / 2, screw_head_height,
								  tmp_pos, y_axis, direction)
		Bool_List.append(screw_head_hole)

	if (screw_number == 4):
		VISIGeoLib.ProjectPointOntoVector(calc_pos, ref_direction, - screw_distance2 / 2, tmp_pos)
		
		## create the center screw hollow
		screw_hole = VISISolidFactory.CreateCylinder(screw_hollow_diameter / 2, height - screw_head_height,
							     tmp_pos, y_axis, direction)
		Bool_List.append(screw_hole)

		VISIGeoLib.ProjectPointOntoVector(tmp_pos, direction, height - screw_head_height, tmp_pos)

		## create the center screw head hollow
		screw_head_hole = VISISolidFactory.CreateCylinder(screw_head_diameter / 2, screw_head_height,
								  tmp_pos, y_axis, direction)
		Bool_List.append(screw_head_hole)

		VISIGeoLib.ProjectPointOntoVector(calc_pos, ref_direction, screw_distance2 / 2, tmp_pos)
		
		## create the center screw hollow
		screw_hole = VISISolidFactory.CreateCylinder(screw_hollow_diameter / 2, height - screw_head_height,
							     tmp_pos, y_axis, direction)
		Bool_List.append(screw_hole)

		VISIGeoLib.ProjectPointOntoVector(tmp_pos, direction, height - screw_head_height, tmp_pos)

		## create the center screw head hollow
		screw_head_hole = VISISolidFactory.CreateCylinder(screw_head_diameter / 2, screw_head_height,
								  tmp_pos, y_axis, direction)
		Bool_List.append(screw_head_hole)

	if (screw_number == 3):
		VISIGeoLib.ProjectPointOntoVector(calc_pos, ref_direction, screw_distance, tmp_pos)
	else:
		VISIGeoLib.ProjectPointOntoVector(calc_pos, ref_direction, screw_distance / 2, tmp_pos)

	## create the right screw hollow
	screw_hole = VISISolidFactory.CreateCylinder(screw_hollow_diameter / 2, height - screw_head_height,
						     tmp_pos, y_axis, direction)
	Bool_List.append(screw_hole)

	VISIGeoLib.ProjectPointOntoVector(tmp_pos, direction, height - screw_head_height, tmp_pos)

	## create the right screw head hollow
	screw_head_hole = VISISolidFactory.CreateCylinder(screw_head_diameter / 2, screw_head_height,
							  tmp_pos, y_axis, direction)
	Bool_List.append(screw_head_hole)
	
	## subtract all the holes from the guide rail
	VISISolidFactory.Subtract(Bool_List, Result_List)
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	master_elem = params['MASTER_ELEM']
	slide_height = params['SLIDE_HEIGHT']
	width = params['WIDTH']
	height = params['HEIGHT']
	length = params['LENGTH']
	screw_number = params['SCREW_NUMBER']
	base_width = params['BASE_WIDTH']
	base_height = params['BASE_HEIGHT']
	screw_diameter = params['SCREW_DIAMETER']
	screw_hollow_diameter = params['SCREW_HOLLOW_DIAMETER']
	screw_head_diameter = params['SCREW_HEAD_DIAMETER']
	screw_head_height = params['SCREW_HEAD_HEIGHT']
	screw_distance = params['SCREW_DISTANCE']
	screw_distance2 = params['SCREW_DISTANCE2']
	distance_from_border = params['DISTANCE_FROM_BORDER']
	right = params['RIGHT']
	slide_width = params['SLIDE_WIDTH']
	slide_base_width = params['SLIDE_BASE_WIDTH']
	slide_heel_height = params['SLIDE_HEEL_HEIGHT']
	slide_length = params['SLIDE_LENGTH']
	slide_stroke = params['SLIDE_STROKE']
	slide_offset = params['SLIDE_OFFSET']
	slide_inserting_depth = params['SLIDE_INSERTING_DEPTH']
	extra_length = params['EXTRA_LENGTH']
	pos_offset = params['POS_OFFSET']

	## calculate the height of the cavity wich penetrate in the supportplate
	cav_height = base_height - slide_heel_height + slide_inserting_depth

	#if (cav_height <= 0):
		#return 0
	
	tmp_pos = VISIPoint.New()
	y_axis = VISIVector.New()

	VISIGeoLib.naXb(direction, ref_direction, y_axis)

	if (right):
	    y_axis.Set(- y_axis.Cx(), - y_axis.Cy(), - y_axis.Cz())
	    slide_offset = - slide_offset
		
	if width - base_width < (slide_base_width/2 - slide_width/2):
		offset_y= slide_offset - slide_width / 2 - (slide_base_width/2 - slide_width/2)- base_width / 2
	else:
		offset_y= slide_offset - slide_width / 2 - width + base_width / 2

	VISIGeoLib.ProjectPointOntoVector(position, direction,
					  - (slide_inserting_depth + base_height - slide_heel_height), tmp_pos)
	VISIGeoLib.ProjectPointOntoVector(tmp_pos, y_axis,offset_y, tmp_pos)
	VISIGeoLib.ProjectPointOntoVector(tmp_pos, ref_direction, (length + extra_length) / 2 + pos_offset, tmp_pos)

	#if (cav_height <= base_height):
		## create the guide rail cavity
		#cav = VISISolidFactory.CreateBlock(base_width, length + extra_length, cav_height,
						   #tmp_pos, y_axis, direction)

		#VISIGeoLib.ProjectPointOntoVector(tmp_pos, direction, cav_height, tmp_pos)
		
	#else:
	Bool_List = []
	Result_List = []
		
	## create the cavity for the guide rail base
	cav = VISISolidFactory.CreateBlock(base_width, length + extra_length, base_height,
					    tmp_pos, y_axis, direction)
	Bool_List.append(cav)

	VISIGeoLib.ProjectPointOntoVector(tmp_pos, direction, base_height, tmp_pos)
	VISIGeoLib.ProjectPointOntoVector(tmp_pos, y_axis, (width - base_width) / 2, tmp_pos)

	## create the cavity for the guide rail superior part
	if(slide_inserting_depth > height):
            ## create the cavity for the guide rail superior part
            cav = VISISolidFactory.CreateBlock(width, length + extra_length, height - base_height + (slide_inserting_depth -(height)),
					       tmp_pos, y_axis, direction)
        else:    
            ## create the cavity for the guide rail superior part
            cav = VISISolidFactory.CreateBlock(width, length + extra_length, height - base_height,
					       tmp_pos, y_axis, direction)
	Bool_List.append(cav)

	## unite all the parts of the guide rail cavity
	VISISolidFactory.Unite(Bool_List, Result_List)

	cav = Result_List[0]
		
	return cav

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_sldguide1_only_screw'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
