import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	width = params['WIDTH']
	length = params['LENGTH']
	sup_part_height = params['SUP_PART_HEIGHT']
	inf_part_height = params['INF_PART_HEIGHT']
	inf_part_width = params['INF_PART_WIDTH']
	screw_diameter = params['SCREW_DIAMETER']
	screw_distance_width = params['SCREW_DISTANCE_WIDTH']
	blend_radius = params['BLEND_RADIUS']
	clearance_body = params['CLEARANCE_BODY']
	female_height = params['FEMALE_HEIGHT']
	male_part_height = params['MALE_PART_HEIGHT']
	rotation_angle = params['ROTATION_ANGLE']
	pocket_female_height = params['POCKET_FEMALE_HEIGHT']
	pocket_male_height = params['POCKET_MALE_HEIGHT']

	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	Inv_Dir = VISIVector.New()
	Inv_Dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)

	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, length/2, start_pos)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -(pocket_male_height-sup_part_height), start_pos)
	
	
	block1 = VISISolidFactory.CreateBlock(length, width, sup_part_height, start_pos, ref_direction, Inv_Dir)
	Uni_list.append(block1)

	block2 = VISISolidFactory.CreateBlock(length, inf_part_width, male_part_height, start_pos, ref_direction, direction)
	Uni_list.append(block2)

	## Unite The Sprue Bushing Parts 
	VISISolidFactory.Unite(Uni_list, Result_List)

	edge_list = [18,20]
	VISISolidFactory.BlendEdges(Result_List[0], edge_list, blend_radius, 1)
		
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	width = params['WIDTH']
	length = params['LENGTH']
	sup_part_height = params['SUP_PART_HEIGHT']
	inf_part_height = params['INF_PART_HEIGHT']
	inf_part_width = params['INF_PART_WIDTH']
	screw_diameter = params['SCREW_DIAMETER']
	screw_distance_width = params['SCREW_DISTANCE_WIDTH']
	blend_radius = params['BLEND_RADIUS']
	clearance_body = params['CLEARANCE_BODY']
	female_height = params['FEMALE_HEIGHT']
	rotation_angle = params['ROTATION_ANGLE']
	male_part_height = params['MALE_PART_HEIGHT']
	pocket_female_height = params['POCKET_FEMALE_HEIGHT']
	pocket_male_height = params['POCKET_MALE_HEIGHT']
	distance_btw_plates = params['DISTANCE_BTW_PLATES']

	Uni_list = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	Inv_Dir = VISIVector.New()
        Inv_Dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

        y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)

	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, length/2, start_pos)
	#VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, length/2, start_pos)
	cav1 = VISISolidFactory.CreateBlock(length + clearance_body, width + clearance_body, pocket_male_height
                                           , start_pos, ref_direction, Inv_Dir)
	Uni_list.append(cav1)

	cav2 = VISISolidFactory.CreateBlock(length + clearance_body, width + clearance_body, pocket_female_height + distance_btw_plates 
					    , start_pos, ref_direction, direction)
	Uni_list.append(cav2)

	## Unite The Sprue Bushing Parts 
	VISISolidFactory.Unite(Uni_list, Result_List,0)

	edge_list = [18,20]
        VISISolidFactory.BlendEdges(Result_List[0], edge_list, blend_radius, 1)
        
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_slfg1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
