import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	width = params['WIDTH']
	length = params['LENGTH']
	height = params['HEIGHT']
	hole_height = params['HOLE_HEIGHT']
	hole_width = params['HOLE_WIDTH']
	screw_diameter = params['SCREW_DIAMETER']
	screw_distance_width = params['SCREW_DISTANCE_WIDTH']
	blend_radius = params['BLEND_RADIUS']
	clearance_body = params['CLEARANCE_BODY']
	rotation_angle = params['ROTATION_ANGLE']
	pocket_female_height = params['POCKET_FEMALE_HEIGHT']

	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	x_axis.Set(ref_direction.Cx(), ref_direction.Cy(), ref_direction.Cz())
	Inv_Dir = VISIVector.New()
        Inv_Dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

        #VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rotation_angle)
        y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)

	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, start_thick + height, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, ref_direction, length/2, start_pos)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, (pocket_female_height-height), start_pos)
	
	block1 = VISISolidFactory.CreateBlock(length, width, height, start_pos, ref_direction, Inv_Dir)

	VISIGeoLib.ProjectPointOntoVector(start_pos, Inv_Dir, height, start_pos)
	hole = VISISolidFactory.CreateBlock(length, hole_width, hole_height, start_pos, ref_direction, direction)

	## Subtract The Sphere
	body_list = []
	body_list.append(block1)
	body_list.append(hole)
	VISISolidFactory.Subtract(body_list, Result_List)
	block1 = Result_List[0]

	edge_list = [18,20]
        VISISolidFactory.BlendEdges(block1, edge_list, blend_radius, 1)
	
	return block1

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_thick = params['START_THICK']
	end_thick = params['END_THICK']
	width = params['WIDTH']
	length = params['LENGTH']
	height = params['HEIGHT']
	hole_height = params['HOLE_HEIGHT']
	hole_width = params['HOLE_WIDTH']
	screw_diameter = params['SCREW_DIAMETER']
	screw_distance_width = params['SCREW_DISTANCE_WIDTH']
	blend_radius = params['BLEND_RADIUS']
	clearance_body = params['CLEARANCE_BODY']
	rotation_angle = params['ROTATION_ANGLE']

	## return the tag of created cavity, 0 if no cavity
	return 0

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_slfg2'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
