import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	thread_drilling = params['THREAD_DRILLING']
	thread_name = params['THREAD_NAME']
	diameter_flange = params['DIAMETER_FLANGE']
	length_pin = params['LENGTH_PIN']
	length_flange = params['LENGTH_FLANGE']
	total_length = params['TOTAL_LENGTH']
	width_hexagon = params['WIDTH_HEXAGON']
	depth_hexagon = params['DEPTH_HEXAGON']
	length_undercut = params['LENGTH_UNDERCUT']
	radius = params['RADIUS']
	insertion_depth = params['INSERTION_DEPTH']
	add_predrilling = params['ADD_PREDRILLING']
	chamfer_on_cavity = params['CHAMFER_ON_CAVITY']
	clearence_diameter = params['CLEARENCE_DIAMETER']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, insertion_depth, start_pos)
	
	
	
	
	

	cyl1 = VISISolidFactory.CreateCylinder(diameter/2, length_pin, start_pos, x_axis, inv_dir)
	edges1=[12]
	VISISolidFactory.ChamferEdges(cyl1, edges1, (diameter-thread_drilling)/2, (diameter-thread_drilling)/2, 1)
	
	
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_flange/2, length_flange, start_pos, x_axis, direction)
	
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length_flange, start_pos)
	
	pri1 = VISISolidFactory.CreatePrism(width_hexagon/2/math.sin(math.radians(60)), depth_hexagon, 6, start_pos, x_axis, inv_dir)
	
	Uni_list2.append(pri1)
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	thread_drilling = params['THREAD_DRILLING']
	thread_name = params['THREAD_NAME']
	diameter_flange = params['DIAMETER_FLANGE']
	length_pin = params['LENGTH_PIN']
	length_flange = params['LENGTH_FLANGE']
	total_length = params['TOTAL_LENGTH']
	width_hexagon = params['WIDTH_HEXAGON']
	depth_hexagon = params['DEPTH_HEXAGON']
	length_undercut = params['LENGTH_UNDERCUT']
	radius = params['RADIUS']
	insertion_depth = params['INSERTION_DEPTH']
	add_predrilling = params['ADD_PREDRILLING']
	chamfer_on_cavity = params['CHAMFER_ON_CAVITY']
	clearence_diameter = params['CLEARENCE_DIAMETER']
	thread_pitch = params['THREAD_PITCH']
	additional_drilling_depth = params['ADDITIONAL_DRILLING_DEPTH']
	through_hole = params['THROUGH_HOLE']
	plate_thick = params['PLATE_THICK']
	not_through_thread = params['NOT_THROUGH_THREAD']
	add_thread_length = params['ADD_THREAD_LENGTH']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, insertion_depth, start_pos)
	
	if insertion_depth>length_flange:
		length_insertion= insertion_depth
	else:
		length_insertion= length_flange
	
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_flange/2 + clearence_diameter/2, length_insertion, start_pos, x_axis, direction)
	Uni_list.append(cyl2)
	
	
	
	#Durchemsser Kernloch, Laenge der Kavitaet, Nenndurchmesser (Gewinde), Laenge des Gewinde (Schraube), Steigung
	if through_hole:
		if not_through_thread:
			length_thread=  length_pin + 3*thread_pitch +add_thread_length
		else:
			length_thread= plate_thick-insertion_depth
		
		cyl1 = VISISolidFactory.CreateCylinder(thread_drilling/2, plate_thick-insertion_depth, start_pos, x_axis, inv_dir)
		cam_list = [thread_drilling, plate_thick-insertion_depth, diameter, length_thread, thread_pitch]
		VISI.AttachCamAttributes(cyl1,cam_list,"SPC1_1",elem_tag,params["BUILDER_UNIT"])
		Uni_list.append(cyl1)
		VISISolidFactory.Unite(Uni_list, Result_List)
		edges1=[19]
		VISISolidFactory.ChamferEdges(Result_List[0], edges1, chamfer_on_cavity, chamfer_on_cavity, 1)
	else:
		length_thread = length_pin + 3*thread_pitch +add_thread_length
		length_drilling= length_thread + add_predrilling + additional_drilling_depth  
		
		cyl1 = VISISolidFactory.CreateCylinder(thread_drilling/2, length_drilling, start_pos, x_axis, inv_dir)
		
		cam_list = [thread_drilling, length_drilling, diameter, length_thread, thread_pitch]
		VISI.AttachCamAttributes(cyl1,cam_list,"SPC1_2",elem_tag,params["BUILDER_UNIT"])
	
	
		Uni_list.append(cyl1)
	
	
	
		VISISolidFactory.Unite(Uni_list, Uni_list2)
		
		edges1=[19]
		VISISolidFactory.ChamferEdges(Uni_list2[0], edges1, chamfer_on_cavity, chamfer_on_cavity, 1)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length_drilling + thread_drilling/2/math.tan(math.radians(60)), start_pos)
		
		con1 = VISISolidFactory.CreateCone(0, thread_drilling/2/math.tan(math.radians(60)) , math.radians(60), start_pos, x_axis, direction)
	
	
	
		Uni_list2.append(con1)
		VISISolidFactory.Unite(Uni_list2, Result_List)
	

	## return the tag of created cavity, 0 if no cavity
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_spc1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
