import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	stroke = params['STROKE']
	diameter_inner = params['DIAMETER_INNER']
	diameter_end = params['DIAMETER_END']
	diameter_fit = params['DIAMETER_FIT']
	diameter_thread = params['DIAMETER_THREAD']
	thread_pitch = params['THREAD_PITCH']
	diameter_top = params['DIAMETER_TOP']
	diameter_under_head = params['DIAMETER_UNDER_HEAD']
	diameter_drill = params['DIAMETER_DRILL']
	length_head_stroke = params['LENGTH_HEAD_STROKE']
	length_top = params['LENGTH_TOP']
	length_under_head = params['LENGTH_UNDER_HEAD']
	distance_groove = params['DISTANCE_GROOVE']
	distance_fit = params['DISTANCE_FIT']
	total_length = params['TOTAL_LENGTH']
	height_top = params['HEIGHT_TOP']
	distance_under_head = params['DISTANCE_UNDER_HEAD']
	length_inner_head = params['LENGTH_INNER_HEAD']
	length_drill = params['LENGTH_DRILL']
	distance_drill = params['DISTANCE_DRILL']
	chamfer = params['CHAMFER']
	top_angle = params['TOP_ANGLE']
	core_diameter = params['CORE_DIAMETER']
	rot_angle = params['ROT_ANGLE']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	# direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	#Create Collar
	cyl1 = VISISolidFactory.CreateCylinder( diameter_top/2, length_top, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	#Create Chamfer
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl1, edges, chamfer, chamfer, 1)
	
	#Create Body
	cyl2 = VISISolidFactory.CreateCylinder( diameter_end/2, total_length-length_top, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl2)
	
	#Create Chamfer
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl2, edges, chamfer, chamfer, 1)
	
	#Create Fit
	##1
	cyl3 = VISISolidFactory.CreateCylinder( diameter_fit/2, distance_groove-length_inner_head/2+(diameter_fit/2-diameter_end/2), start_pos, x_axis, inv_dir)
	Uni_list.append(cyl3)
	
	###Create Chamfer
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl3, edges, (diameter_fit/2-diameter_end/2), (diameter_fit/2-diameter_end/2), 1)

	##2
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,distance_groove+length_inner_head/2-(diameter_fit/2-diameter_end/2), start_pos)
	
	cyl4 = VISISolidFactory.CreateCylinder( diameter_fit/2, (distance_fit-distance_groove)-length_inner_head/2+(diameter_fit/2-diameter_end/2), start_pos, x_axis, inv_dir)
	Uni_list.append(cyl4)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,distance_groove+length_inner_head/2-(diameter_fit/2-diameter_end/2), start_pos)
	
	###Create Chamfer
	edges = [6,12]
	VISISolidFactory.ChamferEdges(cyl4, edges, (diameter_fit/2-diameter_end/2), (diameter_fit/2-diameter_end/2), 1)
	
	#Create Thread
	##Create Thread Body
	cyl5 = VISISolidFactory.CreateCylinder( core_diameter/2, length_under_head, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl5)
	
	##Create Thread
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,distance_under_head-(diameter_thread/2-core_diameter/2), start_pos)
	##Create Thread 
	cyl6 = VISISolidFactory.CreateCylinder( diameter_thread/2, length_under_head-distance_under_head+(diameter_thread/2-core_diameter/2), start_pos, x_axis, inv_dir)
	Uni_list.append(cyl6)
   
	## attach Thread attribute
	VISI.AttachThreadAttributes(cyl6, thread_pitch)
	
	###Create Chamfer
	edges = [6,12]
	VISISolidFactory.ChamferEdges(cyl6, edges, (diameter_thread/2-core_diameter/2), (diameter_thread/2-core_diameter/2), 1)
	
	#Create Cone on Top
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,height_top+distance_under_head-(diameter_thread/2-core_diameter/2)+length_top, start_pos)
	
	cone = VISISolidFactory.CreateCone(diameter_inner/2, height_top, math.radians(90)-top_angle, start_pos, x_axis, inv_dir)
	Uni_list.append(cone)
	
	# unite all parts
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Main Hole
	cyl7 = VISISolidFactory.CreateCylinder( diameter_inner/2, total_length+height_top, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl7)
	
	#Create Hole Head
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,total_length+height_top, start_pos)

  	cyl8 = VISISolidFactory.CreateCylinder( diameter/2, length_head_stroke, start_pos, x_axis, direction)
	Uni_list2.append(cyl8)
	
	#Create Holes on Top Face
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, -total_length, start_pos)
	#1
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_drill/2, start_pos)
	cyl9 = VISISolidFactory.CreateCylinder( diameter_drill/2, length_drill, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl9)
	
	h_cone = (diameter_drill/2)/(math.tan(math.radians(60)))
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,length_drill+h_cone, start_pos)
	cone2 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone2)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,length_drill+h_cone, start_pos)
	
	#2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_drill, start_pos)
	cyl10 = VISISolidFactory.CreateCylinder( diameter_drill/2, length_drill, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl10)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,length_drill+h_cone, start_pos)
	cone3 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone3)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,length_drill+h_cone, start_pos)
	
	# unite all ejector parts
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	return Result_List[0]


def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	stroke = params['STROKE']
	diameter_inner = params['DIAMETER_INNER']
	diameter_end = params['DIAMETER_END']
	diameter_fit = params['DIAMETER_FIT']
	diameter_thread = params['DIAMETER_THREAD']
	thread_pitch = params['THREAD_PITCH']
	diameter_top = params['DIAMETER_TOP']
	diameter_under_head = params['DIAMETER_UNDER_HEAD']
	diameter_drill = params['DIAMETER_DRILL']
	length_head_stroke = params['LENGTH_HEAD_STROKE']
	length_top = params['LENGTH_TOP']
	length_under_head = params['LENGTH_UNDER_HEAD']
	distance_groove = params['DISTANCE_GROOVE']
	distance_fit = params['DISTANCE_FIT']
	total_length = params['TOTAL_LENGTH']
	height_top = params['HEIGHT_TOP']
	distance_under_head = params['DISTANCE_UNDER_HEAD']
	length_inner_head = params['LENGTH_INNER_HEAD']
	length_drill = params['LENGTH_DRILL']
	distance_drill = params['DISTANCE_DRILL']
	chamfer = params['CHAMFER']
	top_angle = params['TOP_ANGLE']
	core_diameter = params['CORE_DIAMETER']
	
	clear_length = params['CLEAR_LENGTH']
	cav_radius = params['CAV_RADIUS']
	create_drill = params['CREATE_DRILL']
	rot_angle_drill = params['ROT_ANGLE_DRILL']
	drill_cav_diam = params['DRILL_CAV_DIAM']
	
	

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	total_length = total_length + clear_length

	#Create Collar
	#VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -length, start_pos)
	cyl1 = VISISolidFactory.CreateCylinder( diameter_top/2, length_top, start_pos, x_axis, direction)
	Uni_list.append(cyl1)
	
	cam_list = [diameter_top, length_top]
	VISI.AttachCamAttributes(cyl1,cam_list,"TBC1_1",elem_tag,params["BUILDER_UNIT"])
		
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,length_under_head+2./1000, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder( diameter_fit/2, total_length-length_top-(length_under_head+2./1000), start_pos, x_axis, inv_dir)
	Uni_list.append(cyl2)
	
	cam_list = [diameter_fit, total_length-length_top-(length_under_head+2./1000)]
	VISI.AttachCamAttributes(cyl2,cam_list,"TBC1_2",elem_tag,params["BUILDER_UNIT"])
	
	#Create Cone
	cone = VISISolidFactory.CreateCone(diameter_fit/2, 2./1000, math.radians(30), start_pos, x_axis, direction)
	Uni_list.append(cone)
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction,length_under_head+2./1000, start_pos)
	
	#Create Blend
	edges = [12]
	VISISolidFactory.BlendEdges(cyl2, edges, cav_radius, 1)
	
	
	#Create Thread
	##Create Thread Body
	cyl5 = VISISolidFactory.CreateCylinder( core_diameter/2, length_under_head, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl5)
	
	cam_list = [core_diameter, length_under_head, diameter_thread, length_under_head, thread_pitch]
	VISI.AttachCamAttributes(cyl5,cam_list,"TBC1_3",elem_tag,params["BUILDER_UNIT"])
	
	if create_drill:
		#create drilling
		
		if(rot_angle_drill <> 0):
			VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle_drill)
			VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle_drill)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir,distance_groove, start_pos)
		cyl10 = VISISolidFactory.CreateCylinder( drill_cav_diam/2, 999999./1000, start_pos, direction , x_axis)
		cyl10= VISIParam.AdaptCavityToPlate(start_plate, cyl10, 0)
		Uni_list.append(cyl10)
	
	# unite all parts
	VISISolidFactory.Unite(Uni_list, Result_List)
	
	return Result_List[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_tbc1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
