import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib
variables = 0
params = 0
import fcu1
import fcu2
import shcsm

def Execute (names, dictionaries):
	global variables
	global params
	global fcu1_p
	global fcu2_p
	global shcsm_p
	global shcsm_1_p

	fcu1.variables = variables
	fcu2.variables = variables
	shcsm.variables = variables

	params = variables['PARAM_NG_a_fcu12']
	fcu1_p = variables['PARAM_NG_fcu1']
	fcu2_p = variables['PARAM_NG_fcu2']
	shcsm_p = variables['PARAM_NG_shcsm']
	shcsm_1_p = variables['PARAM_NG_shcsm_1']
		

	# if not params['INVERT']:
		# VISIGeoLib.ProjectPointOntoVector(fcu1_p['POSITION'], fcu1_p['DIRECTION'], -fcu1_p['GAP'], fcu1_p['POSITION'])
	
	fcu1_pos = fcu1_p['POSITION']
	fcu1_dir = fcu1_p['DIRECTION']

	fcu1.key_name = 'PARAM_NG_fcu1'
	fcu1.Execute(names, dictionaries)


	## use the following variable to use fcu2  position
	fcu2_pos = fcu2_p['POSITION']
	## use the following variable to use fcu2  direction
	fcu2_dir = fcu2_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable fcu2 cavity building
	## fcu2_p['BUILD_CAVITY'] = 0
	fcu2.key_name = 'PARAM_NG_fcu2'
	fcu2.Execute(names, dictionaries)
	## use the following line to put fcu2 cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm  position
	shcsm_pos = shcsm_p['POSITION']
	## use the following variable to use shcsm  direction
	shcsm_dir = shcsm_p['DIRECTION']

	## put additional member contraints

	## uncomment following line to disable shcsm cavity building
	## shcsm_p['BUILD_CAVITY'] = 0

	VISIGeoLib.ProjectPointOntoVector(shcsm_p['POSITION'], fcu1_p['DIRECTION'], fcu1_p['HEIGHT_NOSE']-fcu1_p['DEPTH_SINKING'], shcsm_p['POSITION'])

		
	shcsm_p['CAV_DEL'] = fcu1_p['HEIGHT'] + fcu1_p['HEIGHT_NOSE'] - fcu1_p['DEPTH_SINKING']
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	## use the following line to put shcsm cavity
	##dictionaries[dictionaries.__len__()-1]['CAVITY_TAG'] = local_cav_tag

	## use the following variable to use shcsm_1  position
	shcsm_1_pos = shcsm_1_p['POSITION']
	shcsm_1_dir = shcsm_1_p['DIRECTION']

	VISIGeoLib.ProjectPointOntoVector(shcsm_1_p['POSITION'], fcu1_p['DIRECTION'], fcu2_p['HEIGHT_NOSE']+fcu2_p['DEPTH_SINKING'], shcsm_1_p['POSITION'])
	shcsm_1_p['CAV_DEL'] = fcu2_p['HEIGHT'] - fcu2_p['HEIGHT_NOSE'] - fcu2_p['DEPTH_SINKING']
	shcsm.key_name = 'PARAM_NG_shcsm_1'
	shcsm.Execute(names, dictionaries)


	return 0
