import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
import fgui2
import fgui2_plate
import shcsm
import shcs3
import fgui1
import flatguide

def Execute (names, dictionaries):
	global variables
	global params
	global fgui2_p
	global fgui2_plate_p
	global shcsm_p
	global shcs3_p
	global fgui1_p
	global flatguide_p

	fgui2.variables = variables
	fgui2_plate.variables = variables
	shcsm.variables = variables
	shcs3.variables = variables
	fgui1.variables = variables
	flatguide.variables = variables

	params = variables['PARAM_NG_a_fgui2']
	fgui2_p = variables['PARAM_NG_fgui2']
	fgui2_plate_p = variables['PARAM_NG_fgui2_plate']
	shcsm_p = variables['PARAM_NG_shcsm']
	shcs3_p = variables['PARAM_NG_shcs3']
	fgui1_p = variables['PARAM_NG_fgui1']
	flatguide_p = variables['PARAM_NG_flatguide']
	
	offset = params['OFFSET']
	
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(fgui2_p['DIRECTION'], x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(fgui2_p['DIRECTION'], x_axis, y_axis)
	inv_x = VISIVector.New()
	inv_x.Set(-x_axis.Cx(), -x_axis.Cy(), -x_axis.Cz())
	inv_y = VISIVector.New()
	inv_y.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	shcs3_plate_depth = ((fgui2_plate_p['SINKING_DIAMETER']-fgui2_plate_p['SCREW_HOLE_DIAMETER'])/2)/math.tan(math.radians(45))


	#FGUI2 E1316
	fgui2_pos = fgui2_p['POSITION']
	fgui2_dir = fgui2_p['DIRECTION']
	VISIGeoLib.ProjectPointOntoVector(fgui2_pos, y_axis, - 0.2/1000-offset, fgui2_pos)
	fgui2.key_name = 'PARAM_NG_fgui2'
	fgui2.Execute(names, dictionaries)
	
	#FGUI1 E13151

	fgui1_pos = fgui1_p['POSITION']
	fgui1_dir = fgui1_p['DIRECTION']
	fgui1.key_name = 'PARAM_NG_fgui1'
	fgui1.Execute(names, dictionaries)
	
		
	#FLATGUIDE E1323
	VISIGeoLib.ProjectPointOntoVector(flatguide_p['POSITION'], y_axis, -flatguide_p['OFFSET_LENGTH']+fgui2_p['LENGTH'], flatguide_p['POSITION'])
	flatguide.key_name = 'PARAM_NG_flatguide'
	flatguide.Execute(names, dictionaries)

	
	#FGUI2_Plate E1317
	#Plate 1
	
	fgui2_plate_pos = fgui2_plate_p['POSITION']
	fgui2_plate_dir = fgui2_plate_p['DIRECTION']
	
	VISIGeoLib.ProjectPointOntoVector(fgui2_plate_pos, y_axis, - 0.2/1000 - fgui2_plate_p['LENGTH']/2-offset, fgui2_plate_pos)
	VISIGeoLib.ProjectPointOntoVector(fgui2_plate_pos, x_axis,  fgui2_p['WIDTH_GROOVE']/2, fgui2_plate_pos)
	fgui2_plate.key_name = 'PARAM_NG_fgui2_plate'
	fgui2_plate.Execute(names, dictionaries)
	
	#Plate 2
	
	fgui2_plate_p['ROTATION'] = 1
	VISIGeoLib.ProjectPointOntoVector(fgui2_plate_pos, x_axis,  - fgui2_p['WIDTH_GROOVE'], fgui2_plate_pos)
	fgui2_plate.key_name = 'PARAM_NG_fgui2_plate'
	fgui2_plate.Execute(names, dictionaries)
	

	#SHCSM Screws E1200 for E1316
	
	shcsm_pos = shcsm_p['POSITION']
	shcsm_dir = shcsm_p['DIRECTION']

	base_screw_pos = VISIPoint.New()
	# base_screw_pos.Set(shcsm_pos.x(), shcsm_pos.y(), shcsm_pos.z())
	
	# VISIGeoLib.ProjectPointOntoVector(base_screw_pos, y_axis, - 0.2/1000-offset, shcsm_pos)
	# VISIGeoLib.ProjectPointOntoVector(shcsm_pos, fgui2_p['DIRECTION'], (fgui2_p['DEPTH'] - fgui2_p['DEPTH_SCREW']), shcsm_pos)
	# VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, fgui2_p['SCREW_DISTANCE']/2, shcsm_pos)
	# shcsm_p['BUILD_CAVITY'] = 0
	# shcsm.key_name = 'PARAM_NG_shcsm'
	# shcsm.Execute(names, dictionaries)

	# VISIGeoLib.ProjectPointOntoVector(base_screw_pos, y_axis, - 0.2/1000-offset, shcsm_pos)
	# VISIGeoLib.ProjectPointOntoVector(shcsm_pos, fgui2_p['DIRECTION'], (fgui2_p['DEPTH'] - fgui2_p['DEPTH_SCREW']), shcsm_pos)
	# VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, - fgui2_p['SCREW_DISTANCE']/2, shcsm_pos)
	# shcsm_p['BUILD_CAVITY'] = 0
	# shcsm.key_name = 'PARAM_NG_shcsm'
	# shcsm.Execute(names, dictionaries)
	
	#SHCSM Screws E1200 for E13151

        shcsm_dir.Set(y_axis.Cx(), y_axis.Cy(), y_axis.Cz())
        base_screw_pos.Set(fgui1_pos.x(), fgui1_pos.y(), fgui1_pos.z())
	
	VISIGeoLib.ProjectPointOntoVector(base_screw_pos, y_axis, fgui1_p['HEAD_HEIGHT'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, fgui2_p['DIRECTION'], fgui1_p['DEPTH'] - fgui1_p['DISTANCE'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, fgui1_p['SCREW_DISTANCE']/2, shcsm_pos)
	
	shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)

	VISIGeoLib.ProjectPointOntoVector(base_screw_pos, y_axis, fgui1_p['HEAD_HEIGHT'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, fgui2_p['DIRECTION'], fgui1_p['DEPTH'] - fgui1_p['DISTANCE'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, -fgui1_p['SCREW_DISTANCE']/2, shcsm_pos)
	shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	
	shcsm_dir.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	VISIGeoLib.ProjectPointOntoVector(base_screw_pos, shcsm_dir, fgui1_p['HEAD_HEIGHT'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, fgui2_p['DIRECTION'], fgui1_p['DEPTH'] - fgui1_p['DISTANCE'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, y_axis, -offset, shcsm_pos)	
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, -fgui1_p['SCREW_DISTANCE']/2, shcsm_pos)
	shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	
	VISIGeoLib.ProjectPointOntoVector(base_screw_pos, shcsm_dir, fgui1_p['HEAD_HEIGHT'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, fgui2_p['DIRECTION'], fgui1_p['DEPTH'] - fgui1_p['DISTANCE'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, y_axis, -offset, shcsm_pos)	
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, x_axis, fgui1_p['SCREW_DISTANCE']/2, shcsm_pos)
	shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	
	
	
	
	
	
	
	
	
	
	#SHCSM Screws E1200 for E1323
	#Screw1
	
	shcsm_p['LENGTH'] = params['SCREW_GUIDE_LENGTH']

	shcsm_dir.Set(fgui2_dir.Cx(), fgui2_dir.Cy(), fgui2_dir.Cz())
        base_screw_pos.Set(fgui2_pos.x(), fgui2_pos.y(), fgui2_pos.z())
	
	VISIGeoLib.ProjectPointOntoVector(base_screw_pos, y_axis, -flatguide_p['OFFSET_LENGTH']+fgui2_p['LENGTH'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, fgui2_p['DIRECTION'], flatguide_p['HEAD_HEIGHT'], shcsm_pos)
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, y_axis, flatguide_p['OFFSET_LENGTH']-flatguide_p['GAP'] +0.2/1000+offset, shcsm_pos)
	
	shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	
	#Screw2	
	VISIGeoLib.ProjectPointOntoVector(shcsm_pos, y_axis, -flatguide_p['SCREW_DIST'], shcsm_pos)
	shcsm_p['BUILD_CAVITY'] = 0
	shcsm.key_name = 'PARAM_NG_shcsm'
	shcsm.Execute(names, dictionaries)
	
	
	
	#SHSC3 Screws E1220
	
	shcs3_pos = shcs3_p['POSITION']
	shcs3_dir = shcs3_p['DIRECTION']
	#Screw 1	
	shcs3_dir.Set(x_axis.Cx(), x_axis.Cy(), x_axis.Cz())
	
	VISIGeoLib.ProjectPointOntoVector(shcs3_pos, y_axis, - (fgui2_plate_p['LENGTH']-fgui2_plate_p['SCREW_DISTANCE'])/2, shcs3_pos)
	VISIGeoLib.ProjectPointOntoVector(shcs3_pos, y_axis, - 0.2/1000-offset, shcs3_pos)
	VISIGeoLib.ProjectPointOntoVector(shcs3_pos,fgui2_p['DIRECTION'], fgui2_p['DEPTH']-fgui2_p['DISTANCE_HOLE'], shcs3_pos)
	VISIGeoLib.ProjectPointOntoVector(shcs3_pos, x_axis, fgui2_p['WIDTH_GROOVE']/2-fgui2_plate_p['DEPTH']+shcs3_plate_depth-shcs3_p['HEAD_HEIGHT'], shcs3_pos)	
	shcs3_p['BUILD_CAVITY'] = 0
	shcs3.key_name = 'PARAM_NG_shcs3'
	shcs3.Execute(names, dictionaries)
	
	#Screw 2
	VISIGeoLib.ProjectPointOntoVector(shcs3_pos, y_axis, -fgui2_p['THREAD_DISTANCE'], shcs3_pos)
	shcs3_p['BUILD_CAVITY'] = 0
	shcs3.key_name = 'PARAM_NG_shcs3'
	shcs3.Execute(names, dictionaries)
	
	#Screw 3
	shcs3_dir.Set(inv_x.Cx(), inv_x.Cy(), inv_x.Cz())
	
	VISIGeoLib.ProjectPointOntoVector(shcs3_pos, x_axis,- fgui2_p['WIDTH_GROOVE'] + 2*fgui2_plate_p['DEPTH']-2*shcs3_plate_depth+2*shcs3_p['HEAD_HEIGHT'], shcs3_pos)
	shcs3_p['BUILD_CAVITY'] = 0
	shcs3.key_name = 'PARAM_NG_shcs3'
	shcs3.Execute(names, dictionaries)
	
	#Screw 4
	VISIGeoLib.ProjectPointOntoVector(shcs3_pos, y_axis,  fgui2_p['THREAD_DISTANCE'], shcs3_pos)
	shcs3_p['BUILD_CAVITY'] = 0
	shcs3.key_name = 'PARAM_NG_shcs3'
	shcs3.Execute(names, dictionaries)
	



	return 0
