import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def LoadGlobals ():
	global screw_positions
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	length = params['LENGTH']
	depth = params['DEPTH']
	depth_groove = params['DEPTH_GROOVE']
	width_groove = params['WIDTH_GROOVE']
	screw_distance = params['SCREW_DISTANCE']
	screw_diameter = params['SCREW_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	head_height = params['HEAD_HEIGHT']
	radius = params['RADIUS']
	screw_length1 = params['SCREW_LENGTH1']
	rev = params['REV']
	plate_direction = params['PLATE_DIRECTION']
	extra_depth = params['EXTRA_DEPTH']

	screw_positions = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	xx_axis = VISIVector.New()
	yy_axis = VISIVector.New()
	rev_direction = VISIVector.New()
	rev_direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	xx_axis.Set(rev_direction.Cx(), rev_direction.Cy(), rev_direction.Cz())
	
	#####################
	x_axis.Set(plate_direction.Cx(), plate_direction.Cy(), plate_direction.Cz())
	if ((math.fabs(math.fabs(plate_direction.Cx()) - math.fabs(rev_direction.Cx())) <0.0000001) and (math.fabs(math.fabs(plate_direction.Cy()) - math.fabs(rev_direction.Cy())) <0.0000001) and (math.fabs(math.fabs(plate_direction.Cz()) - math.fabs(rev_direction.Cz())) < 0.0000001)):
		VISIGeoLib.ArbitraryNormalAxis(rev_direction, x_axis)
	else:
		VISIGeoLib.naXb(rev_direction, plate_direction, x_axis)

	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	
	VISIGeoLib.naXb(rev_direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-rev_direction.Cx(), -rev_direction.Cy(), -rev_direction.Cz())
	yy_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	if(rev <> 0):
		VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, math.radians(180))
		VISIGeoLib.VectorRotate(y_axis, rev_direction, y_axis, math.radians(180))
		VISIGeoLib.VectorRotate(yy_axis, rev_direction, yy_axis, math.radians(180))	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, -length, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -depth, start_pos)
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, depth/2, start_pos)	
	
	#Create Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -depth/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, depth_groove/2, start_pos)
	start_pos3 = VISIPoint.New()
	start_pos3.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos3, y_axis, -depth, start_pos3)
	VISIGeoLib.ProjectPointOntoVector(start_pos3, rev_direction, -length, start_pos3)
	VISIGeoLib.ProjectPointOntoVector(start_pos3, rev_direction, length - depth_groove, start_pos3)
	VISIGeoLib.ProjectPointOntoVector(start_pos3, y_axis, depth/2, start_pos3)
	
	
	VISIGeoLib.ProjectPointOntoVector(position, y_axis, screw_length1, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, screw_distance/2, start_pos)
	
	tmp_pos = VISIPoint.New()
	tmp_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	screw_positions.append(tmp_pos)	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -screw_distance, start_pos)
	screw_positions.append(start_pos)

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	length = params['LENGTH']
	depth = params['DEPTH']
	depth_groove = params['DEPTH_GROOVE']
	width_groove = params['WIDTH_GROOVE']
	screw_distance = params['SCREW_DISTANCE']
	screw_diameter = params['SCREW_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	head_height = params['HEAD_HEIGHT']
	radius = params['RADIUS']
	screw_length1 = params['SCREW_LENGTH1']
	rev = params['REV']
	plate_direction = params['PLATE_DIRECTION']
	extra_depth = params['EXTRA_DEPTH']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	xx_axis = VISIVector.New()
	yy_axis = VISIVector.New()
	rev_direction = VISIVector.New()
	rev_direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	xx_axis.Set(rev_direction.Cx(), rev_direction.Cy(), rev_direction.Cz())
	
	#####################
	x_axis.Set(plate_direction.Cx(), plate_direction.Cy(), plate_direction.Cz())
	if ((math.fabs(math.fabs(plate_direction.Cx()) - math.fabs(rev_direction.Cx())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cy()) - math.fabs(rev_direction.Cy())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cz()) - math.fabs(rev_direction.Cz())) <0.0000001)):
		VISIGeoLib.ArbitraryNormalAxis(rev_direction, x_axis)
	else:
		VISIGeoLib.naXb(rev_direction, plate_direction, x_axis)

	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	
	VISIGeoLib.naXb(rev_direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-rev_direction.Cx(), -rev_direction.Cy(), -rev_direction.Cz())
	yy_axis.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	if(rev <> 0):
		VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, math.radians(180))
		VISIGeoLib.VectorRotate(y_axis, rev_direction, y_axis, math.radians(180))
		VISIGeoLib.VectorRotate(yy_axis, rev_direction, yy_axis, math.radians(180))	
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, -length, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -depth, start_pos)
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, depth/2, start_pos)	
	bl1 = VISISolidFactory.CreateBlock(width, depth, length, start_pos, x_axis, rev_direction)
	Uni_list.append(bl1)
	
	
	#Blend Edges
	edges = [6,14]
	VISISolidFactory.BlendEdges (bl1, edges, radius, 1)
	
	
	#Create Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -depth/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, depth_groove/2, start_pos)
	start_pos3 = VISIPoint.New()
	start_pos3.Set(position.x(), position.y(), position.z())
	VISIGeoLib.ProjectPointOntoVector(start_pos3, y_axis, -depth, start_pos3)
	VISIGeoLib.ProjectPointOntoVector(start_pos3, rev_direction, -length, start_pos3)
	VISIGeoLib.ProjectPointOntoVector(start_pos3, rev_direction, length - depth_groove, start_pos3)
	VISIGeoLib.ProjectPointOntoVector(start_pos3, y_axis, depth/2, start_pos3)
	bl2 = VISISolidFactory.CreateBlock(width_groove, length, depth_groove, start_pos3, x_axis, rev_direction)
	#VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -depth_groove/2, start_pos)
	Uni_list.append(bl2)
	
		
	VISISolidFactory.Subtract(Uni_list, Result_List)
	
	Uni_list = []
	Uni_list.append(Result_List[0])
	
	VISISolidFactory.RotateBody(Uni_list[0], position, x_axis, math.radians(90))
	Result_List = []
	
	VISIGeoLib.ProjectPointOntoVector(position, y_axis, screw_length1, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, screw_distance/2, start_pos)

	cyl1 = VISISolidFactory.CreateCylinder(screw_diameter/2, length, start_pos, x_axis, inv_dir)
	cyl2 = VISISolidFactory.CreateCylinder(head_diameter/2, head_height, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	Uni_list.append(cyl2)
	
	
	tmp_pos = VISIPoint.New()
	tmp_pos.Set(start_pos.x(), start_pos.y(), start_pos.z())
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -screw_distance, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(screw_diameter/2, length, start_pos, x_axis, inv_dir)
	cyl4 = VISISolidFactory.CreateCylinder(head_diameter/2, head_height, start_pos, x_axis, inv_dir)	
	Uni_list.append(cyl3)
	Uni_list.append(cyl4)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list, Result_List)	
	
	VISISolidFactory.TranslateBodyByVector(bl1, y_axis, extra_depth)
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	width = params['WIDTH']
	length = params['LENGTH']
	depth = params['DEPTH']
	depth_groove = params['DEPTH_GROOVE']
	width_groove = params['WIDTH_GROOVE']
	screw_distance = params['SCREW_DISTANCE']
	screw_diameter = params['SCREW_DIAMETER']
	head_diameter = params['HEAD_DIAMETER']
	head_height = params['HEAD_HEIGHT']
	radius = params['RADIUS']
	extra_depth = params['EXTRA_DEPTH']
	extra_thread	= params['EXTRA_THREAD']
	screw_diameter_real = params['SCREW_DIAMETER_REAL']
	cav_thread_depth = params['CAV_THREAD_DEPTH']
	rev = params['REV']
	plate_direction = params['PLATE_DIRECTION']
	
	#direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	rev_direction = VISIVector.New()
	rev_direction.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	x_axis = VISIVector.New()
	
	x_axis.Set(plate_direction.Cx(), plate_direction.Cy(), plate_direction.Cz())
	if ((math.fabs(math.fabs(plate_direction.Cx()) - math.fabs(rev_direction.Cx())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cy()) - math.fabs(rev_direction.Cy())) <0.0000001) and
            (math.fabs(math.fabs(plate_direction.Cz()) - math.fabs(rev_direction.Cz())) <0.0000001)):
		VISIGeoLib.ArbitraryNormalAxis(rev_direction, x_axis)
	else:
		VISIGeoLib.naXb(rev_direction, plate_direction, x_axis)

		
	#VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(rev_direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-rev_direction.Cx(), -rev_direction.Cy(), -rev_direction.Cz())

	if(rev <> 0):
		VISIGeoLib.VectorRotate(x_axis, rev_direction, x_axis, math.radians(180))
		VISIGeoLib.VectorRotate(y_axis, rev_direction, y_axis, math.radians(180))
		
	VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, -length - extra_depth, start_pos)
	#VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -depth, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -depth, start_pos)
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, depth/2, start_pos)	
	bl1 = VISISolidFactory.CreateBlock(width, depth, length+extra_depth, start_pos, x_axis, rev_direction)
	#Uni_list.append(bl1)
		
	#Blend Edges
	edges = [6,14]
	VISISolidFactory.BlendEdges (bl1, edges, radius, 1)
	
	#Create Screw Cavity
	VISIGeoLib.ProjectPointOntoVector(start_pos, rev_direction, length, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, screw_distance/2, start_pos)
	
	VISISolidFactory.RotateBody(bl1, position, x_axis, math.radians(90))
	
	#VISI.MessageBox("plate diretion", str(str(plate_direction.Cx()) + " " + str(plate_direction.Cy()) + " "+ str(plate_direction.Cz())))

	return bl1

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_fgui1_3'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	LoadGlobals()
	
	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
