import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	height_part = params['HEIGHT_PART']
	width_part = params['WIDTH_PART']
	width = params['WIDTH']
	length = params['LENGTH']
	diameter_guide = params['DIAMETER_GUIDE']
	distance_guide = params['DISTANCE_GUIDE']
	height_guide = params['HEIGHT_GUIDE']
	distance_sinking = params['DISTANCE_SINKING']
	diameter_sinking = params['DIAMETER_SINKING']
	core_diameter = params['CORE_DIAMETER']
	distance_sinking2 = params['DISTANCE_SINKING2']
	distance_screwholes_x = params['DISTANCE_SCREWHOLES_X']
	length_head = params['LENGTH_HEAD']
	height_step = params['HEIGHT_STEP']
	distance_part = params['DISTANCE_PART']
	radius = params['RADIUS']
	diameter_head = params['DIAMETER_HEAD']
	height_head = params['HEIGHT_HEAD']
	angle1 = params['ANGLE1']
	diameter_head2 = params['DIAMETER_HEAD2']
	height_head2 = params['HEIGHT_HEAD2']
	diameter_screwhole = params['DIAMETER_SCREWHOLE']
	core_diameter2 = params['CORE_DIAMETER2']
	depth_screwhole = params['DEPTH_SCREWHOLE']
	core_depth2 = params['CORE_DEPTH2']
	distance_screwhole = params['DISTANCE_SCREWHOLE']
	angle2 = params['ANGLE2']
	distance_end = params['DISTANCE_END']
	slide_height = params['SLIDE_HEIGHT']
	slide_sup_length = params['SLIDE_SUP_LENGTH']
	slide_ins_dep = params['SLIDE_INS_DEP']
	slide_offset = params['SLIDE_OFFSET']
	thread_pitch1 = params['THREAD_PITCH1']
	thread_pitch2 = params['THREAD_PITCH2']
	create_sphere = params['CREATE_SPHERE']
	
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, ref_direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	inv_y = VISIVector.New()
	inv_y.Set(-y_axis.Cx(), -y_axis.Cy(), -y_axis.Cz())
	
	
	#Height
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, slide_height-slide_ins_dep, start_pos)
	#Offset in x-axis direction
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, slide_offset, start_pos)
	#Distance to front edge
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -slide_sup_length+distance_part-(length_head/2-distance_guide), start_pos)
	
	#Create Head
	block1 = VISISolidFactory.CreateBlock(width, length_head, height_guide,start_pos, x_axis, direction)
	Uni_list.append(block1)
	
	#Step
	edges = [18,20,22,24]
	VISISolidFactory.BlendEdges(block1, edges, radius, 1)	

	#Create Base
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(length-length_head/2)/2, start_pos)
	block2 = VISISolidFactory.CreateBlock(width, length-length_head/2, height_guide-height_step,start_pos, x_axis, direction)
	Uni_list.append(block2)

	#Create lower Parter
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (length-length_head/2)/2+(length_head/2-distance_guide), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_part-(distance_end-distance_part)/2, start_pos)

	block3 = VISISolidFactory.CreateBlock(width_part, distance_end-distance_part, height_part,start_pos, x_axis, inv_dir)
	Uni_list.append(block3)	
	
	#Step
	edges = [34]
	chamfer1 = math.tan(angle2)*height_part
	VISISolidFactory.ChamferEdges(block3, edges, height_part,chamfer1, 1)		
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Holes
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_part+(distance_end-distance_part)/2, start_pos)
	
	if create_sphere:
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height_guide, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, height_guide/(math.tan(math.radians(90)-angle1)), start_pos)
		sph1 = VISISolidFactory.CreateSphere(diameter_guide/2, start_pos, x_axis, direction)
		Uni_list2.append(sph1)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height_guide, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_y, height_guide/(math.tan(math.radians(90)-angle1)), start_pos)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, math.tan(angle1)*height_guide, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height_guide, start_pos)
	else:
		#Main Hole
		cyl1 = VISISolidFactory.CreateCylinder(diameter_guide/2, height_guide, start_pos, x_axis, inv_dir)	
		Uni_list2.append(cyl1)
		VISISolidFactory.RotateBody (cyl1, start_pos, x_axis, -angle1)
		cyl2 = VISISolidFactory.CreateCylinder(diameter_guide/2, 2*height_guide, start_pos, x_axis, direction)	
		Uni_list2.append(cyl2)
		VISISolidFactory.RotateBody (cyl2, start_pos, x_axis, -angle1)
		
		#Create Main Holes Head
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, math.tan(angle1)*height_guide, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, height_guide, start_pos)

		cyl3 = VISISolidFactory.CreateCylinder(diameter_head/2, height_head, start_pos, x_axis, inv_dir)	
		Uni_list2.append(cyl3)
		VISISolidFactory.RotateBody (cyl3, start_pos, x_axis, -angle1)

		cyl4 = VISISolidFactory.CreateCylinder(diameter_head/2, height_head, start_pos, x_axis, direction)	
		Uni_list2.append(cyl4)
		VISISolidFactory.RotateBody (cyl4, start_pos, x_axis, -angle1)
	
	#Create Top Screwholes:
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -math.tan(angle1)*height_guide+distance_guide-distance_sinking2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_sinking/2, start_pos)
	
	#Create Screwhole 1
	cyl5 = VISISolidFactory.CreateCylinder(core_diameter/2, height_guide-height_head2, start_pos, x_axis, inv_dir)	
	Uni_list2.append(cyl5)
	
	#Create Screwhole 2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_sinking, start_pos)
	cyl6 = VISISolidFactory.CreateCylinder(core_diameter/2, height_guide-height_head2, start_pos, x_axis, inv_dir)	
	Uni_list2.append(cyl6)
	
	#Attach Cam Atributes ( Thread!)
	cam_list = [core_diameter, height_guide-height_head2, diameter_sinking, height_guide-height_head2, thread_pitch2]
	VISI.AttachCamAttributes(cyl5,cam_list,"SLDLOOKHEEL4_1",0,params["BUILDER_UNIT"])
	VISI.AttachCamAttributes(cyl6,cam_list,"SLDLOOKHEEL4_1",0,params["BUILDER_UNIT"])
	
	#Create Screwhead
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, height_guide, start_pos)
	
	#Create Screwhole 1
	cyl7 = VISISolidFactory.CreateCylinder(diameter_head2/2, height_head2, start_pos, x_axis, direction)		
	Uni_list2.append(cyl7)


	#Create Screwhole 2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_sinking, start_pos)
	cyl8 = VISISolidFactory.CreateCylinder(diameter_head2/2, height_head2, start_pos, x_axis, direction)	
	Uni_list2.append(cyl8)	
	
	#Create Fix Holes for Plate
	#Case1: b3 = 0 -> 1 hole:
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_sinking/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_sinking2-distance_guide-distance_part, start_pos)
	
	#Move to hole position
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_screwhole*(math.cos(angle2)), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_screwhole*(math.sin(angle2)), start_pos)
	if distance_screwholes_x ==0:
		cyl9 = VISISolidFactory.CreateCylinder(core_diameter2/2, core_depth2, start_pos, x_axis, direction)	
		Uni_list2.append(cyl9)	
		VISISolidFactory.RotateBody (cyl9, start_pos, x_axis, -angle2+math.radians(90))
		
		#Attach Cam Attribute for Thread
		cam_list = [core_diameter2, core_depth2, diameter_screwhole, depth_screwhole, thread_pitch1]
		VISI.AttachCamAttributes(cyl9,cam_list,"SLDLOOKHEEL4_2",0,params["BUILDER_UNIT"])
		
		#Create Cone for Holes
		
		#Move to cone position
		h_cone = ((core_diameter2/2)/(math.tan(math.radians(60))))
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, (h_cone+core_depth2)*math.sin(-angle2), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(h_cone+core_depth2)*math.cos(-angle2), start_pos)
		
		cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
		Uni_list2.append(cone)
		
		VISISolidFactory.RotateBody (cone, start_pos, x_axis, -angle2+math.radians(90))
	#Case 2 b3 <> 0 -> 2 holes	
	else:
		#Hole 1 of 2
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_screwholes_x/2, start_pos)
		cyl9 = VISISolidFactory.CreateCylinder(core_diameter2/2, core_depth2, start_pos, x_axis, direction)	
		Uni_list2.append(cyl9)	
		VISISolidFactory.RotateBody (cyl9, start_pos, x_axis, -angle2+math.radians(90))
		
		#Attach Cam Attribute for Thread
		cam_list = [core_diameter2, core_depth2, diameter_screwhole, depth_screwhole, thread_pitch1]
		VISI.AttachCamAttributes(cyl9,cam_list,"SLDLOOKHEEL4_2",0,params["BUILDER_UNIT"])
		
		#Create Cone for Holes
		
		#Move to cone position
		h_cone = ((core_diameter2/2)/(math.tan(math.radians(60))))
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, (h_cone+core_depth2)*math.sin(-angle2), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(h_cone+core_depth2)*math.cos(-angle2), start_pos)
		
		cone = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
		Uni_list2.append(cone)
		
		VISISolidFactory.RotateBody (cone, start_pos, x_axis, -angle2+math.radians(90))
		
		#Hole 2 of 2
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_screwholes_x, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, (h_cone+core_depth2)*math.sin(-angle2), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (h_cone+core_depth2)*math.cos(-angle2), start_pos)
		
		cyl10 = VISISolidFactory.CreateCylinder(core_diameter2/2, core_depth2, start_pos, x_axis, direction)	
		Uni_list2.append(cyl10)	
		VISISolidFactory.RotateBody (cyl10, start_pos, x_axis, -angle2+math.radians(90))
		
		#Attach Cam Attribute for Thread
		VISI.AttachCamAttributes(cyl10,cam_list,"SLDLOOKHEEL4_2",0,params["BUILDER_UNIT"])
		
		#Create Cone for Holes
		
		#Move to cone position
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, (h_cone+core_depth2)*math.sin(-angle2), start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(h_cone+core_depth2)*math.cos(-angle2), start_pos)
		
		cone2 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, inv_dir)
		Uni_list2.append(cone2)
		
		VISISolidFactory.RotateBody (cone2, start_pos, x_axis, -angle2+math.radians(90))
		
		
		
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	
	
	
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	height_part = params['HEIGHT_PART']
	width_part = params['WIDTH_PART']
	width = params['WIDTH']
	length = params['LENGTH']
	diameter_guide = params['DIAMETER_GUIDE']
	distance_guide = params['DISTANCE_GUIDE']
	height_guide = params['HEIGHT_GUIDE']
	distance_sinking = params['DISTANCE_SINKING']
	diameter_sinking = params['DIAMETER_SINKING']
	core_diameter = params['CORE_DIAMETER']
	distance_sinking2 = params['DISTANCE_SINKING2']
	distance_screwholes_x = params['DISTANCE_SCREWHOLES_X']
	length_head = params['LENGTH_HEAD']
	height_step = params['HEIGHT_STEP']
	distance_part = params['DISTANCE_PART']
	radius = params['RADIUS']
	diameter_head = params['DIAMETER_HEAD']
	height_head = params['HEIGHT_HEAD']
	angle1 = params['ANGLE1']
	diameter_head2 = params['DIAMETER_HEAD2']
	height_head2 = params['HEIGHT_HEAD2']
	diameter_screwhole = params['DIAMETER_SCREWHOLE']
	core_diameter2 = params['CORE_DIAMETER2']
	depth_screwhole = params['DEPTH_SCREWHOLE']
	core_depth2 = params['CORE_DEPTH2']
	distance_screwhole = params['DISTANCE_SCREWHOLE']
	angle2 = params['ANGLE2']
	distance_end = params['DISTANCE_END']
	slide_height = params['SLIDE_HEIGHT']
	slide_sup_length = params['SLIDE_SUP_LENGTH']
	slide_ins_dep = params['SLIDE_INS_DEP']
	slide_offset = params['SLIDE_OFFSET']
	thread_pitch1 = params['THREAD_PITCH1']
	thread_pitch2 = params['THREAD_PITCH2']

	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, ref_direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	
	#Height
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, slide_height-slide_ins_dep, start_pos)
	#Offset in x-axis direction
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, slide_offset, start_pos)
	#Distance to front edge
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -slide_sup_length+distance_part-(length_head/2-distance_guide), start_pos)
	
	#Create Head
	block1 = VISISolidFactory.CreateBlock(width, length_head, height_guide,start_pos, x_axis, direction)
	Uni_list.append(block1)
	
	#Step
	edges = [18,20,22,24]
	VISISolidFactory.BlendEdges(block1, edges, radius, 1)	

	#Create Base
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -(length-length_head/2)/2, start_pos)
	block2 = VISISolidFactory.CreateBlock(width, length-length_head/2, height_guide-height_step,start_pos, x_axis, direction)
	Uni_list.append(block2)

	#Create lower Parter
	
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, (length-length_head/2)/2+(length_head/2-distance_guide), start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_part-(distance_end-distance_part)/2, start_pos)

	block3 = VISISolidFactory.CreateBlock(width_part, distance_end-distance_part, height_part,start_pos, x_axis, inv_dir)
	Uni_list.append(block3)	
	
	#Step
	edges = [34]
	chamfer1 = math.tan(angle2)*height_part
	VISISolidFactory.ChamferEdges(block3, edges, height_part,chamfer1, 1)		
	
	VISISolidFactory.Unite(Uni_list, Uni_list2)
		
	
	
	
	
	return Uni_list2[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_sldlockheel4'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
