import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	stroke_max = params['STROKE_MAX']
	thread = params['THREAD']
	stroke = params['STROKE']
	diameter_body = params['DIAMETER_BODY']
	length = params['LENGTH']
	diameter_drill = params['DIAMETER_DRILL']
	diameter_body_cyl = params['DIAMETER_BODY_CYL']
	distance_drill = params['DISTANCE_DRILL']
	force = params['FORCE']
	thread_diam = params['THREAD_DIAM']
	thread_core_diam = params['THREAD_CORE_DIAM']
	thread_pitch = params['THREAD_PITCH']
	distance_groove = params['DISTANCE_GROOVE']
	diameter_groove = params['DIAMETER_GROOVE']
	depth_groove = params['DEPTH_GROOVE']
	distance_drilling = params['DISTANCE_DRILLING']
	diam_drilling = params['DIAM_DRILLING']
	rot_angle = params['ROT_ANGLE']
	rot_angle2 = params['ROT_ANGLE2']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)

	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(thread_core_diam/2, length/3*2, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	## attach Thread attribute
	VISI.AttachThreadAttributes(cyl1, thread_pitch)
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_body/2, length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl2)
	
	#Chamfer
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl1, edges,(thread_core_diam/2-diameter_body/2), (thread_core_diam/2-diameter_body/2) , 1)
	edges = [6]
	VISISolidFactory.ChamferEdges(cyl1, edges,(thread_core_diam/3-diameter_body/3), (thread_core_diam/3-diameter_body/3) , 1)
	
	#Chamfer
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl2, edges,(thread_core_diam/3-diameter_body/3), (thread_core_diam/3-diameter_body/3) , 1)
	
	#Stroke
	if stroke>0:
		cyl3 = VISISolidFactory.CreateCylinder(diameter/2, stroke, start_pos, x_axis, direction)
		Uni_list.append(cyl3)
		#Chamfer
		edges = [12]
		VISISolidFactory.ChamferEdges(cyl3, edges,diameter/20, diameter/20 , 1)
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Create Drillings
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_drill/2, start_pos)
	h_cone = (diameter_drill/2)/(math.tan(math.radians(60))) 
	
	#1
	cyl40 = VISISolidFactory.CreateCylinder(diameter_drill/2, length/9, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl40)
	
	#1 Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+length/9, start_pos)
	cone40 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone40)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+length/9, start_pos)
	
	#2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_drill, start_pos)
	
	cyl41 = VISISolidFactory.CreateCylinder(diameter_drill/2, length/9, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl41)
	
	#2 Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+length/9, start_pos)
	cone41 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone41)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+length/9, start_pos)
	
	#3
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_drill/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, distance_drill/2, start_pos)
	
	cyl42 = VISISolidFactory.CreateCylinder(diameter_drill/2, length/9, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl42)
	
	#3 Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+length/9, start_pos)
	cone42= VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone42)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+length/9, start_pos)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Result_List)
	
	## return the tag of created element, 0 if no element
	return Uni_list2[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	stroke_max = params['STROKE_MAX']
	thread = params['THREAD']
	stroke = params['STROKE']
	diameter_body = params['DIAMETER_BODY']
	length = params['LENGTH']
	diameter_drill = params['DIAMETER_DRILL']
	diameter_body_cyl = params['DIAMETER_BODY_CYL']
	distance_drill = params['DISTANCE_DRILL']
	force = params['FORCE']
	thread_diam = params['THREAD_DIAM']
	thread_core_diam = params['THREAD_CORE_DIAM']
	thread_pitch = params['THREAD_PITCH']
	distance_groove = params['DISTANCE_GROOVE']
	diameter_groove = params['DIAMETER_GROOVE']
	depth_groove = params['DEPTH_GROOVE']
	distance_drilling = params['DISTANCE_DRILLING']
	diam_drilling = params['DIAM_DRILLING']
	rot_angle = params['ROT_ANGLE']
	rot_angle2 = params['ROT_ANGLE2']
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle2 <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle2)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle2)

	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(thread_core_diam/2, distance_groove-depth_groove, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	## attach Thread attribute
	cam_list = [thread_core_diam,distance_groove-depth_groove, thread_diam, distance_groove-depth_groove, thread_pitch]
	VISI.AttachCamAttributes(cyl1, cam_list, "TBC4_0_1", thread, elem_tag, params["BUILDER_UNIT"])
	
	#Stroke
	if stroke>0:
		cyl6 = VISISolidFactory.CreateCylinder(diameter/2, stroke, start_pos, x_axis, direction)
		Uni_list.append(cyl6)
		cam_list = [diameter, stroke]
		VISI.AttachCamAttributes(cyl1, cam_list, "TBC4_0_2", thread, elem_tag, params["BUILDER_UNIT"])
	
	#Create Groove
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_groove-depth_groove, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder(diameter_groove/2, depth_groove, start_pos, x_axis, inv_dir)
	cam_list = [diameter_groove, depth_groove]
	VISI.AttachCamAttributes(cyl2,cam_list,"TBC4_0_3",elem_tag,params["BUILDER_UNIT"])
	Uni_list.append(cyl2)
	
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, depth_groove, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(diameter_body/2, length-distance_groove, start_pos, x_axis, inv_dir)
	cam_list = [diameter_body, length-distance_groove]
	VISI.AttachCamAttributes(cyl3,cam_list,"TBC4_0_4",elem_tag,params["BUILDER_UNIT"])
	Uni_list.append(cyl3)
	
	#Create Drilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length-distance_groove, start_pos)
	cyl4 = VISISolidFactory.CreateCylinder(diam_drilling/2, distance_drilling-length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl4)
	
	#Create Cone
	h_cone = (diam_drilling/2)/(math.tan(math.radians(60))) 
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+distance_drilling-length, start_pos)
	cone4= VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list.append(cone4)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+distance_drilling-length, start_pos)
	
	
	#Create Counterdrilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_drilling-length, start_pos)
	cyl5 = VISISolidFactory.CreateCylinder(diam_drilling/2, 2, start_pos, inv_dir,x_axis)

	
	cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl5, start_pos)
	hole = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, inv_dir)
	hole= VISIParam.AdaptCavityToPlate(end_plate, hole, 0)
	
	Uni_list.append(hole)
	
	#Create Cone
	h_cone = (diam_drilling/2)/(math.tan(math.radians(60))) 
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -h_cone, start_pos)
	cone5= VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, direction,x_axis)
	Uni_list.append(cone5)
	
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Chamfer
	edges = [25]
	VISISolidFactory.ChamferEdges(Uni_list2[0], edges,(1./1000)/math.tan(math.radians(30)), 1./1000 , 1)

	
	return Uni_list2[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_tbc4_0'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
