import VISI, VISIPoint, VISIVector, VISISolidFactory, VISIGeoLib, math, VISIParam
variables = 0
params = 0
key_name = 0

def CreateElement ():
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	stroke_max = params['STROKE_MAX']
	thread = params['THREAD']
	stroke = params['STROKE']
	diameter_body = params['DIAMETER_BODY']
	length = params['LENGTH']
	diameter_drill = params['DIAMETER_DRILL']
	diameter_body_cyl = params['DIAMETER_BODY_CYL']
	distance_drill = params['DISTANCE_DRILL']
	force = params['FORCE']
	thread_diam = params['THREAD_DIAM']
	thread_core_diam = params['THREAD_CORE_DIAM']
	thread_pitch = params['THREAD_PITCH']
	distance_groove = params['DISTANCE_GROOVE']
	diameter_groove = params['DIAMETER_GROOVE']
	depth_groove = params['DEPTH_GROOVE']
	distance_drilling = params['DISTANCE_DRILLING']
	diam_drilling = params['DIAM_DRILLING']
	rot_angle = params['ROT_ANGLE']
	rot_angle2 = params['ROT_ANGLE2']
	diameter_head = params['DIAMETER_HEAD']
	distance_groove1 = params['DISTANCE_GROOVE1']
	pin_outside = params['PIN_OUTSIDE']
	wrench_size = params['WRENCH_SIZE']
	thread_core_diam1 = params['THREAD_CORE_DIAM1']
	thread_pitch1 = params['THREAD_PITCH1']
	thread_length1 = params['THREAD_LENGTH1']
	thread1 = params['THREAD1']
	diam_stroke_head = params['DIAM_STROKE_HEAD']
	internal_length = params['INTERNAL_LENGTH']
	
	Uni_list = []
	Uni_list2 = []
	Uni_list3 = []
	Stroke_list = []
	Stroke_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())
	
	if(rot_angle <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle)
	
	#Adjust length
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length-internal_length, start_pos)
	
	#Set Stroke-Height
	stroke_orig = stroke
	stroke = stroke + pin_outside

	#Create Head
	cyl0 = VISISolidFactory.CreateCylinder(diameter_head/2, distance_groove1+(length-internal_length), start_pos, x_axis, inv_dir)
	Uni_list.append(cyl0)
	
	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(thread_core_diam/2, length/3*2, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	## attach Thread attribute
	VISI.AttachThreadAttributes(cyl1, thread_pitch)
	
	cyl2 = VISISolidFactory.CreateCylinder(diameter_body/2, length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl2)
	
	#Chamfer Thread
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl1, edges,(thread_core_diam/2-diameter_body/2), (thread_core_diam/2-diameter_body/2) , 1)
	
	#Chamfer Head
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl0, edges,(diameter_head/2-thread_core_diam/2), (diameter_head/2-thread_core_diam/2) , 1)
	edges = [6]
	VISISolidFactory.ChamferEdges(cyl0, edges,(thread_core_diam/3-diameter_body/3), (thread_core_diam/3-diameter_body/3) , 1)
	
	#Chamfer End
	edges = [12]
	VISISolidFactory.ChamferEdges(cyl2, edges,(thread_core_diam/3-diameter_body/3), (thread_core_diam/3-diameter_body/3) , 1)
	
	#Stroke
	if stroke>0:
		#Create Body
		cyl30 = VISISolidFactory.CreateCylinder(diameter/2, stroke-4./1000, start_pos, x_axis, direction)
		Stroke_list.append(cyl30)
		
		#Create Body
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, stroke-4./1000, start_pos)
		cyl31 = VISISolidFactory.CreateCylinder(diam_stroke_head/2, 4./1000, start_pos, x_axis, direction)
		Stroke_list.append(cyl31)
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, stroke-4./1000, start_pos)
		#Chamfer
		edges = [12]
		VISISolidFactory.ChamferEdges(cyl31, edges,diameter/20, diameter/20 , 1)
		
		#Unite
		VISISolidFactory.Unite(Stroke_list, Stroke_list2)
		
		#Chamfer
		edges = [19]
		VISISolidFactory.ChamferEdges(Stroke_list2[0], edges,(diameter-diam_stroke_head)/2, (diameter-diam_stroke_head)/2, 1)
		
		#Create Wrench Size
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, stroke, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, wrench_size/2+diameter/2, start_pos)
		sw1 = VISISolidFactory.CreateBlock(diameter,diameter, 4./1000-(diameter-diam_stroke_head)/2, start_pos, x_axis, inv_dir)
		Stroke_list2.append(sw1)
		
		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -wrench_size-diameter, start_pos)
		sw2 = VISISolidFactory.CreateBlock(diameter,diameter, 4./1000-(diameter-diam_stroke_head)/2, start_pos, x_axis, inv_dir)
		Stroke_list2.append(sw2)

		VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, wrench_size/2+diameter/2, start_pos)
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, stroke, start_pos)

		
		#Subtract
		VISISolidFactory.Subtract(Stroke_list2, Uni_list)
		
		
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	if stroke > 0:
		#Create Drilling
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, stroke, start_pos)
		cyl30 = VISISolidFactory.CreateCylinder(thread_core_diam1/2, thread_length1+2./1000, start_pos, x_axis, inv_dir)
		Uni_list2.append(cyl30)
		
		## attach Thread attribute
		cam_list = [thread_core_diam1, thread_length1+2./1000, thread1, thread_length1, thread_pitch1]
		VISI.AttachCamAttributes(cyl30, cam_list, "TBC4_1_0", 0, params["BUILDER_UNIT"])
	
		#Create Cone
		h_cone = (thread_core_diam1/2)/(math.tan(math.radians(60)))
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+thread_length1+2./1000, start_pos)
		cone30 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
		Uni_list2.append(cone30)
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+thread_length1+2./1000, start_pos)
		#Rest Position
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, stroke, start_pos)
	
	#Create Drillings
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_drill/2, start_pos)
	h_cone = (diameter_drill/2)/(math.tan(math.radians(60))) 
	
	#1
	cyl40 = VISISolidFactory.CreateCylinder(diameter_drill/2, length/9, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl40)
	
	#1 Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+length/9, start_pos)
	cone40 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone40)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+length/9, start_pos)
	
	#2
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -distance_drill, start_pos)
	
	cyl41 = VISISolidFactory.CreateCylinder(diameter_drill/2, length/9, start_pos, x_axis, inv_dir)
	Uni_list2.append(cyl41)
	
	#2 Cone
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+length/9, start_pos)
	cone41 = VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list2.append(cone41)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+length/9, start_pos)
	
	#3 create cody for red dot
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, distance_drill/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, y_axis, -distance_drill/2, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, -length/9, start_pos)
	
	cyl42 = VISISolidFactory.CreateCylinder(diameter_drill/4, length/9, start_pos, x_axis, direction)
	
	#Subtract
	VISISolidFactory.Subtract(Uni_list2, Uni_list3)
	Uni_list3.append(cyl42)
	
	#Unite
	VISISolidFactory.Unite(Uni_list3, Result_List,0)
	
	#Create rot dot
	if stroke > 0:
		faces = [304,288]
	else:
		faces = [173]
	VISISolidFactory.SetFacesColorById(Result_List[0],faces , 27)
		
	## return the tag of created element, 0 if no element
	return Result_List[0]

def CreateCavity (elem_tag):
	position = params['POSITION']
	direction = params['DIRECTION']
	ref_direction = params['REF_DIRECTION']
	start_plate = params['START_PLATE']
	end_plate = params['END_PLATE']
	start_face = params['START_FACE']
	master_elem = params['MASTER_ELEM']
	diameter = params['DIAMETER']
	stroke_max = params['STROKE_MAX']
	thread = params['THREAD']
	stroke = params['STROKE']
	diameter_body = params['DIAMETER_BODY']
	length = params['LENGTH']
	diameter_drill = params['DIAMETER_DRILL']
	diameter_body_cyl = params['DIAMETER_BODY_CYL']
	distance_drill = params['DISTANCE_DRILL']
	force = params['FORCE']
	thread_diam = params['THREAD_DIAM']
	thread_core_diam = params['THREAD_CORE_DIAM']
	thread_pitch = params['THREAD_PITCH']
	distance_groove = params['DISTANCE_GROOVE']
	diameter_groove = params['DIAMETER_GROOVE']
	depth_groove = params['DEPTH_GROOVE']
	distance_drilling = params['DISTANCE_DRILLING']
	diam_drilling = params['DIAM_DRILLING']
	rot_angle = params['ROT_ANGLE']
	rot_angle2 = params['ROT_ANGLE2']
	distance_groove1 = params['DISTANCE_GROOVE1']
	diameter_groove1 = params['DIAMETER_GROOVE1']
	depth_groove1 = params['DEPTH_GROOVE1']
	diameter_head = params['DIAMETER_HEAD']
	pin_outside = params['PIN_OUTSIDE']
	internal_length = params['INTERNAL_LENGTH']
	
	
	Uni_list = []
	Uni_list2 = []
	Result_List = []
	start_pos = VISIPoint.New()
	start_pos.Set(position.x(), position.y(), position.z())
	x_axis = VISIVector.New()
	VISIGeoLib.ArbitraryNormalAxis(direction, x_axis)
	y_axis = VISIVector.New()
	VISIGeoLib.naXb(direction, x_axis, y_axis)
	inv_dir = VISIVector.New()
	inv_dir.Set(-direction.Cx(), -direction.Cy(), -direction.Cz())

	
	if(rot_angle2 <> 0):
		VISIGeoLib.VectorRotate(x_axis, direction, x_axis, rot_angle2)
		VISIGeoLib.VectorRotate(y_axis, direction, y_axis, rot_angle2)
		
	#Adjust length
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, length-internal_length, start_pos)
		
	#Set Stroke-Height
	stroke = stroke + pin_outside
		
	#Create Head
	cyl0 = VISISolidFactory.CreateCylinder(diameter_head/2, distance_groove1-depth_groove1+length-internal_length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl0)
	cam_list = [diameter_head, distance_groove1-depth_groove1]
	VISI.AttachCamAttributes(cyl0, cam_list, "TBC4_1_1", elem_tag, params["BUILDER_UNIT"])
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, length-internal_length, start_pos)
	
	#Create Groove1
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_groove1-depth_groove1, start_pos)
	cyl00 = VISISolidFactory.CreateCylinder(diameter_groove1/2, depth_groove1, start_pos, x_axis, inv_dir)
	cam_list = [diameter_groove1, depth_groove1]
	VISI.AttachCamAttributes(cyl00,cam_list,"TBC4_1_2",elem_tag,params["BUILDER_UNIT"])
	Uni_list.append(cyl00)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, depth_groove1, start_pos)

	#Create Body
	cyl1 = VISISolidFactory.CreateCylinder(thread_core_diam/2, distance_groove-depth_groove-distance_groove1, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl1)
	
	## attach Thread attribute
	cam_list = [thread_core_diam,distance_groove-depth_groove-distance_groove1, thread_diam, distance_groove-depth_groove-distance_groove1, thread_pitch]
	VISI.AttachCamAttributes(cyl1, cam_list, "TBC4_1_3", thread, elem_tag, params["BUILDER_UNIT"])
	
	#Stroke
	if stroke>0:
		VISIGeoLib.ProjectPointOntoVector(start_pos, direction, distance_groove1+length-internal_length, start_pos)
		cyl6 = VISISolidFactory.CreateCylinder(diameter/2, stroke, start_pos, x_axis, direction)
		Uni_list.append(cyl6)
		cam_list = [diameter, stroke]
		VISI.AttachCamAttributes(cyl1, cam_list, "TBC4_1_4",  elem_tag, params["BUILDER_UNIT"])
		VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_groove1+length-internal_length, start_pos)
	
	#Create Groove2
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, distance_groove1, start_pos)
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_groove-depth_groove, start_pos)
	cyl2 = VISISolidFactory.CreateCylinder(diameter_groove/2, depth_groove, start_pos, x_axis, inv_dir)
	cam_list = [diameter_groove, depth_groove]
	VISI.AttachCamAttributes(cyl2,cam_list,"TBC4_1_5",elem_tag,params["BUILDER_UNIT"])
	Uni_list.append(cyl2)
	
	#Create Body
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, depth_groove, start_pos)
	cyl3 = VISISolidFactory.CreateCylinder(diameter_body/2, internal_length-distance_groove, start_pos, x_axis, inv_dir)
	cam_list = [diameter_body, internal_length-distance_groove]
	VISI.AttachCamAttributes(cyl3,cam_list,"TBC4_1_6",elem_tag,params["BUILDER_UNIT"])
	Uni_list.append(cyl3)
	
	#Create Drilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, internal_length-distance_groove, start_pos)
	cyl4 = VISISolidFactory.CreateCylinder(diam_drilling/2, distance_drilling-internal_length, start_pos, x_axis, inv_dir)
	Uni_list.append(cyl4)
	
	#Create Cone
	h_cone = (diam_drilling/2)/(math.tan(math.radians(60))) 
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, h_cone+distance_drilling-internal_length, start_pos)
	cone4= VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, x_axis, direction)
	Uni_list.append(cone4)
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, h_cone+distance_drilling-internal_length, start_pos)
	
	
	#Create Counterdrilling
	VISIGeoLib.ProjectPointOntoVector(start_pos, inv_dir, distance_drilling-internal_length, start_pos)
	cyl5 = VISISolidFactory.CreateCylinder(diam_drilling/2, 2, start_pos, inv_dir,x_axis)

	
	cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl5, start_pos)
	hole = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, inv_dir)
	hole= VISIParam.AdaptCavityToPlate(end_plate, hole, 0)
	
	Uni_list.append(hole)
	
	#Create Cone
	h_cone = (diam_drilling/2)/(math.tan(math.radians(60))) 
	VISIGeoLib.ProjectPointOntoVector(start_pos, x_axis, -h_cone, start_pos)
	cone5= VISISolidFactory.CreateCone(0, h_cone, math.radians(60), start_pos, direction,x_axis)
	Uni_list.append(cone5)
	
	#Create Counterdrilling1
	VISIGeoLib.ProjectPointOntoVector(start_pos, direction, distance_drilling-distance_groove1, start_pos)
	cyl6 = VISISolidFactory.CreateCylinder(diam_drilling/2, 2, start_pos, inv_dir,x_axis)

	cavity_face = VISISolidFactory.GetFaceInBodyFromPoint(cyl6, start_pos)
	hole1 = VISIParam.ExtendFaceToSolid(end_plate, cavity_face, inv_dir)
	hole1= VISIParam.AdaptCavityToPlate(end_plate, hole1, 0)
	Uni_list.append(hole1)
	
	
	#Unite
	VISISolidFactory.Unite(Uni_list, Uni_list2)
	
	#Chamfer
	edges = [31]
	VISISolidFactory.ChamferEdges(Uni_list2[0], edges,thread_diam/2-thread_core_diam/2, thread_diam/2-thread_core_diam/2 , 1)

	#Chamfer
	edges = [40]
	VISISolidFactory.ChamferEdges(Uni_list2[0], edges,(1./1000)/math.tan(math.radians(30)), 1./1000 , 1)
	
	return Uni_list2[0]

def Execute (names, dictionaries):
	global variables
	global params
	global key_name
	param_key = ''
	if(key_name == 0):
		param_key = 'PARAM_NG_tbc4_1'
	else:
		param_key = key_name
	params = variables[param_key]

	position = params['POSITION']
	save_pos = VISIPoint.New()
	save_pos.Set(position.x(),position.y(),position.z())
	direction = params['DIRECTION']
	save_dir = VISIVector.New()
	save_dir.Set(direction.Cx(),direction.Cy(),direction.Cz())
	Xaxis = VISIVector.New()
	ref_direction = params['REF_DIRECTION']
	Xaxis.Set(ref_direction.Cx(),ref_direction.Cy(),ref_direction.Cz())

	elem_tag = 0
	if ( params['BUILD_ELEM'] ):
		elem_tag = CreateElement()
	cavity_tag = 0
	if ( params['BUILD_CAVITY'] ):
		cavity_tag = CreateCavity(elem_tag)

	if(elem_tag or cavity_tag or params['REBUILDING_CAVITY']):
		names.append(param_key)

		elem_info = {}
		elem_info['ELEM_TAG'] = elem_tag
		elem_info['CAVITY_TAG'] = cavity_tag
		elem_info['POSITION'] = save_pos
		elem_info['DIRECTION'] = save_dir
		elem_info['REF_DIRECTION'] = Xaxis

		dictionaries.append(elem_info)
